{
    This file is part of Chentrah,
    Copyright (C) 2004-2008 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************}
{$ifndef cge}
   {$fatal COMPILE WITH -dcge KEY}
{$endif}
{$ifndef cgemodule}
   {$fatal COMPILE WITH -dcgemodule KEY}
{$endif}

{$memory 10000, 10000}   //Both values have no meaning.
  // First one - because DLLs use the host apps's stack,
  // Second one - because the heap can grow dynamically.

{$include mo_globaldefs.h}


{$stackframes on}

library _chentrah_module;

uses
  //chebs_heap_brutal_trace,
  {$ifdef unix}
{***TODO Сейчас вместе с cthreads рекомендуется так же использовать менеджер
памяти из libc (модуль cmem). Здесь у нас устаревшая документация.}

    cthreads,
    cmem, // the c memory manager is on some systems much faster for multi-threading
  {$endif}
  SysUtils,
  mo_hub,
  chepersy,
  mo_module,
  mo_logic,

//ga_basics,

  _my_logic_main;

  //Is called just after loading the module DLL.
  //Validates compatibility with the mother.
  function Initialize(p: PMother): boolean; export; cdecl;
  var
    t, stub: integer;
  begin
    try
      result:=true;
      GrandInitialize(p, MyModuleVersionMajor, MyModuleVersionMinor, MyModuleBuildNumber,
        [MyModuleString, VersionToStr(MyModuleVersionMajor, MyModuleVersionMinor, MyModuleBuildNumber),
          CompileDate, CompileTime, CompilerVersion, CompileTarget], MyModuleSessionSpaceLimit); //Here we go...
//      AddLog(MI_VERSION_INFO,[MyModuleString, VersionToStr(MyModuleVersionMajor, MyModuleVersionMinor, MyModuleBuildNumber), CompileDate, CompileTime, CompilerVersion, CompileTarget]);
      MyLogClass:= MyLogicType;
//addlog(' paths:'#10#13'   %0'#10#13'   %1'#10#13'   %2',[m_selfname, m_sessionpath, m_savepath]);
    except
      Result:=false;
      ScreenDllEntryPointException;
    end;
  end;

  //main thread heartbeat
  //returning false means module suffered a fatal crash,
  //  leads to mother BSODing, i.e. it's insta-death. No saving will be attempted.
  function Pulse(): boolean; export; cdecl;
  begin
    try
      if not Assigned(Module) then Module:= TModule.Create;
      Result:= Module.Pulse;
    except
      Result:=false;
      ScreenDllEntryPointException;
    end;
  end;

{
  //command to initiate shutdown. The mother will keep sending Pulse()
  //  while waiting for the dll to set completion flags
  //  returning false means fatal error occured, saving state failed.
  function Shutdown(): boolean; export; cdecl;
  begin
    if Mother^.Debug.Verbose then AddLog('The module DLL is executing Shutdown()');
    if not Assigned(Module) then Exit(true);
    try
      Result:= Module.CommandShutdown;
    except
      Result:= false;
      ScreenDllEntryPointException;
    end;
    if Mother^.Debug.Verbose then AddLog('The module DLL has finished Shutdown()');
  end;
}
  
  //command to perform final cleanup.
  //Is given just before unloading the module DLL.
  //Will NOT be called without a prior Shutdown().
  function Cleanup(): boolean; export; cdecl;
  begin
    if Mother^.Debug.Verbose then AddLog('The module DLL is executing Cleanup()');
    if not Assigned(Module) then Exit(true);
    try
      Result:= Module.Cleanup;
      if Result then Module.Free;
    except
      Result:= false;
      ScreenDllEntryPointException;
    end;
    try
      Config.Free;
    except end;
    if Mother^.Debug.Verbose then AddLog('The module DLL has finished Cleanup()');
  end;

{$include mo_die1.inc}
{  //moved it to an include to allow ignoring it when call stack report is being built. It checks by source name

procedure PassUnhandledException; export; cdecl;
begin
  DieBySEhHack;
end;
}

exports
  Initialize name 'M_Init', { Initialization.
    Must NOT invoke Chepersy in any way }

  PassUnhandledException name 'M_PassUnhandledException', { From the exception
    filter. The DLL reacts by raising a language exception that its try blocks
    can catch. Is necessary due to SEH in Windows being a major pain }

  Pulse name 'M_Pulse', {main thread heartbeat }

//  Shutdown name 'M_Shutdown',
{initiates shutdown. The mother will keep sending
  Pulse() while waiting for the dll to set completion flags }

  Cleanup name 'M_Cleanup'; {completes shutdown. Is called just before unloading
    the module DLL. Will NOT be called withou a prior Shutdown(). }

begin
 // do nothing.
 // The initialization sections DO NOT WORK in Linux for DLLs. And never will.
end.
