{
    This file is part of Chentrah,
    Copyright (C) 2004-2008 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************}


{$include mo_globaldefs.h}
{$typeinfo on}
 
unit _my_logic_main;
 
interface
 
uses
   SysUtils,
   math,
   typinfo,
   mo_hub,
   chepersy,
   mo_module,
   mo_logic,
   mo_assets,
   mo_texture,
   mo_gui,
   mo_viewport,
   mo_3dbasics,
   mo_camera,
   mo_loba

//, mo_atlas
   ;



type
  { TSkinnerModule }

  TTest20Logic = class (TLogic)
  public
    constructor Create; override;
    procedure RegisterFields; override;
    procedure OnCreate; override;
    destructor Destroy; override;
    procedure AfterLoading; override;
//    function FileManagerPaths: TFileNameStringArray; override;
  end;

  TTest18Scene = class;

  TTest18ViewPort = class (TViewPort)
  public
    scene: TTest18Scene;
    msacc: double;
    a1, a2, a3: integer;
    mscnt, nsval: integer;
    procedure RegisterFields; override;
    procedure OnResize; override;
    constructor Create(_width, _height: float); override;
    function OnKey(Key: TKey): boolean; override;
    destructor Destroy; override;//procedure Scrape; override;
    procedure Cycle; override;
  end;

  TTest18Scene = class (TAbstractScene)
  protected
    crapper,
    sky_up,
    sky_dn,
    sky_ft,
    sky_lf,
    sky_rt,
    sky_bk
      : TTextureFromImage; //TStatic2dTexture;
    mynow: double;
  public
    yaw, pitch: float;
    constructor Create;
    procedure RegisterFields; override;
    procedure Prepare(Camera: TAbstractCamera); override;
    procedure Render(Camera: TAbstractCamera); override;
    procedure Skybox(MyHdr: float);
  end;
  
// *** REQUIRED FOR INIT ROUTINE:

  MyLogicType = TTest20Logic;

const
  MyModuleString = 'Chentrah Test 019';
  MyModuleVersionMajor = 0;
  MyModuleVersionMinor = 19;
  MyModuleBuildNumber = {$include build.h};
  MyInternalModuleBasePath = '_test019'; { the folder name, relative to the
                                           "modules" folder in the install path}
  MyModuleSessionSpaceLimit = 100; //megabytes

  MyModuleHdr = 2.0;//100.0;


implementation

  constructor TTest20Logic.Create;
  begin
    inherited;

    (TBackground.Create()).AddAtBottom(Self.Control);  { missing this
      results in a nice HOM effect since the mother does *not* clear
      the color buffer assuming that the module fills it each frame
     TBackground simply renders a quad filled with standard Chentrah
       background texture thus mimicing the main app to mask the difference
       between it and the module  }

    (TTest18ViewPort.Create(1050,1050)).AddOnTop(Self.Control);
  end;


  procedure TTest20Logic.OnCreate;
  begin
    inherited;

  end;



  procedure TTest20Logic.AfterLoading;
  begin
    inherited;

  end;

  procedure TTest20Logic.RegisterFields;
  begin
    RegClass(TTest18ViewPort);
  	inherited;
    //ListFields(['Bryed', @self.bryed, typeinfo(TBryed)]);
  end;

  destructor TTest20Logic.Destroy;
  begin
    //
    inherited;
  end;

  procedure TTest18ViewPort.RegisterFields;
  begin
    RegClass(TTest18Scene);
    inherited;
    ListFields([
      'scene', @scene, CPS_MANAGED_OBJECT,
      'msacc', @msacc, typeinfo(double),
      'a1', @a1, 'a2', @a2, 'a3', @a3, typeinfo(integer),
      'mscnt', @mscnt, 'nsval', @nsval, typeinfo(integer)
    ])
  end;

  procedure TTest18Scene.RegisterFields;
  begin
    inherited;
    ListFields([
      'crapper', @crapper,
      'sky_up',  @sky_up,
      'sky_dn',   @sky_dn,
      'sky_ft',   @sky_ft,
      'sky_lf',   @sky_lf,
      'sky_rt',   @sky_rt,
      'sky_bk',    @sky_bk,
        typeinfo(TTextureFromImage),
      'mynow', @mynow, TypeInfo(double),
      'yaw', @yaw, 'pitch', @pitch, typeinfo(float)
    ]);
  end;



  procedure TTest18ViewPort.OnResize;
  begin
    Width.Initial:= Mother^.Display.WindowClientRect.Width;
    Height.Initial:= Mother^.Display.WindowClientRect.Height;
    addlog(' TViewPort.OnResize : %0x%1',[Width.Current, Height.Current]);
    inherited;
  end;

  constructor TTest18ViewPort.Create(_width, _height: float);
  begin
    inherited Create(_width, _height);
    scene:= TTest18Scene.Create();
    f_Camera:= TCamera.Create(scene);
  end;

  constructor TTest18Scene.Create;
  var sname: string;
  begin
    crapper:= TTextureFromImage.Create(
      '*M/textures/cheb/cravatar674.png', 4);
      //'*M/img/cravatar674.png', 4);
      //'*M/img/megacravatar14k.png', 6, [tp_compressed]);

    sname:= 'mc-oa-dm02';
    sky_up:= TTextureFromImage.Create('*M/env/' + sname + '/' + sname + '_up.png');
    sky_dn:= TTextureFromImage.Create('*M/env/' + sname + '/' + sname + '_dn.png');
    sky_ft:= TTextureFromImage.Create('*M/env/' + sname + '/' + sname + '_ft.png');
    sky_lf:= TTextureFromImage.Create('*M/env/' + sname + '/' + sname + '_lf.png');
    sky_rt:= TTextureFromImage.Create('*M/env/' + sname + '/' + sname + '_rt.png');
    sky_bk:= TTextureFromImage.Create('*M/env/' + sname + '/' + sname + '_bk.png');
  end;


  procedure Kubik(s, MyHdr: float);
  begin
    //glEnable(GL_DITHER);

    s:= s/2;
    glColor3f(1/MyHdr, 1/MyHdr, 0.5/MyHdr);
    glBegin(GL_QUADS);
    glTexCoord2f(0, 0);  glVertex3f(-s, -s, -s);
    glTexCoord2f(0, 1);  glVertex3f(-s, s, -s);
    glColor3f(0.7/MyHdr, 1/MyHdr, 1/MyHdr);
    glTexCoord2f(1, 1);  glVertex3f(-s, s, s);
    glTexCoord2f(1, 0);  glVertex3f(-s, -s, s);
    glEnd;

    glColor3f(0.7/MyHdr, 1/MyHdr, 1/MyHdr);
    glBegin(GL_QUADS);
    glTexCoord2f(0, 0); glVertex3f(s, -s, -s);
    glTexCoord2f(0, 1); glVertex3f(s, -s, s);
    glColor3f(1/MyHdr, 1/MyHdr, 0.5/MyHdr);
    glTexCoord2f(1, 1); glVertex3f(s, s, s);
    glTexCoord2f(1, 0); glVertex3f(s, s, -s);
    glEnd;

    glColor3f(0.5/MyHdr, 1/MyHdr, 0.5/MyHdr);
    glBegin(GL_QUADS);
    glTexCoord2f(0, 0);glVertex3f(-s, -s, -s);
    glTexCoord2f(0, 1);glVertex3f(-s, -s, s);
    glColor3f(1/MyHdr, 0.3/MyHdr, 1/MyHdr);
    glTexCoord2f(1, 1);glVertex3f(s, -s, s);
    glTexCoord2f(1, 0);glVertex3f(s, -s, -s);
    glEnd;

    glColor3f(1/MyHdr, 0.3/MyHdr, 1/MyHdr);
    glBegin(GL_QUADS);
    glTexCoord2f(0, 0);glVertex3f(-s, s, -s);
    glTexCoord2f(0, 1);glVertex3f(s, s, -s);
    glColor3f(0.5/MyHdr, 1/MyHdr, 0.5/MyHdr);
    glTexCoord2f(1, 1);glVertex3f(s, s, s);
    glTexCoord2f(1, 0);glVertex3f(-s, s, s);
    glEnd;

    glColor3f(0.7/MyHdr, 0.5/MyHdr, 1/MyHdr);
    glBegin(GL_QUADS);
    glTexCoord2f(0, 0);glVertex3f(-s, -s, -s);
    glTexCoord2f(0, 1);glVertex3f(s, -s, -s);
    glColor3f(1/MyHdr, 0.2/MyHdr, 0.2/MyHdr);
    glTexCoord2f(1, 1);glVertex3f(s, s, -s);
    glTexCoord2f(1, 0);glVertex3f(-s, s, -s);
    glEnd;

    glColor3f(1/MyHdr, 0.2/MyHdr, 0.2/MyHdr);
    glBegin(GL_QUADS);
    glTexCoord2f(0, 0);glVertex3f(-s, -s, s);
    glTexCoord2f(0, 1);glVertex3f(-s, s, s);
    glColor3f(0.7/MyHdr, 0.5/MyHdr, 1/MyHdr);
    glTexCoord2f(1, 1);glVertex3f(s, s, s);
    glTexCoord2f(1, 0);glVertex3f(s, -s, s);
    glEnd;
  end;

  procedure TTest18Scene.Skybox(MyHdr: float);
  var
    s: float = 200.0;
    f: float;
  begin
    //glEnable(GL_DITHER);


    glDisable(GL_DEPTH_TEST);
    glEnable(GL_TEXTURE_2D);

    f:= 0.5 / sky_ft.Width;

    sky_lf.Bind;
    glBegin(GL_QUADS);
    glTexCoord2f(f, f);  glVertex3f(-s, -s, -s);
    glTexCoord2f(f, 1 - f);  glVertex3f(-s, s, -s);
    glTexCoord2f(1 - f, 1 - f);   glVertex3f(-s, s, s);
    glTexCoord2f(1 - f, f);glVertex3f(-s, -s, s);
    glEnd;

    sky_rt.Bind;
    glBegin(GL_QUADS);
    glTexCoord2f(1-f, f); glVertex3f(s, -s, -s);
    glTexCoord2f(f, f);glVertex3f(s, -s, s);
    glTexCoord2f(f, 1-f);  glVertex3f(s, s, s);
    glTexCoord2f(1-f, 1-f); glVertex3f(s, s, -s);
    glEnd;

    sky_up.Bind;
    glBegin(GL_QUADS);
    glTexCoord2f(1-f, f);glVertex3f(-s, -s, -s);
    glTexCoord2f(f, f);glVertex3f(-s, -s, s);
    glTexCoord2f(f, 1-f);glVertex3f(s, -s, s);
    glTexCoord2f(1-f, 1-f);glVertex3f(s, -s, -s);
    glEnd;

    sky_dn.Bind;
    glBegin(GL_QUADS);
    glTexCoord2f(1-f, 1-f);glVertex3f(-s, s, -s);
    glTexCoord2f(1-f, f);glVertex3f(s, s, -s);
    glTexCoord2f(f, f);glVertex3f(s, s, s);
    glTexCoord2f(f, 1-f);glVertex3f(-s, s, s);
    glEnd;

    sky_ft.Bind;
    glBegin(GL_QUADS);
    glTexCoord2f(1-f, f);glVertex3f(-s, -s, -s);
    glTexCoord2f(f, f);glVertex3f(s, -s, -s);
    glTexCoord2f(f, 1-f);glVertex3f(s, s, -s);
    glTexCoord2f(1-f, 1-f);glVertex3f(-s, s, -s);
    glEnd;

    sky_bk.Bind;
    glBegin(GL_QUADS);
    glTexCoord2f(f, f);glVertex3f(-s, -s, s);
    glTexCoord2f(f, 1-f);glVertex3f(-s, s, s);
    glTexCoord2f(1-f, 1-f);glVertex3f(s, s, s);
    glTexCoord2f(1-f, f);glVertex3f(s, -s, s);
    glEnd;
  end;

//A cheap hack. I will implement proper mesh classes later.
  var
//    ix, iy, iz: array[0..11] of float;
    //point 6 is rotated 36 degrees clockwise relative to point 1 while looking along the axis at point 0
    ivertind: array[0..19, 0..2] of integer = (
      (0, 2, 1), (1, 2, 6), (0, 3, 2), (2, 3, 7), (0, 4, 3), (3, 4, 8), (0, 5, 4), (4, 5, 9), (0, 1, 5), (5, 1, 10),
      (1, 6, 10), (10, 6, 11), (2, 7, 6), (6, 7, 11), (3, 8, 7), (7, 8, 11), (4, 9, 8), (8, 9, 11), (5, 10, 9), (9, 10, 11));
//    itc: array[0..19, 0..2, 0..1] of float;
    iinitizlized: boolean = false;

  type
    Tivert = record
      x, y, z: float;
    end;

    Titvert = record
      vind: integer;
      s, t, r, g, b: float;
    end;

    TiTriangle = array[0..2] of Titvert;

    Tilrec = record
      Vertexes: array of Tivert;
      Triangles: array of TiTriangle;
    end;

  var
    ilod: array[0..8] of Tilrec;


  procedure InterpolateV(var n, f, l: Tivert);
  var q: float;
  begin
    n.x:= f.x + l.x;
    n.y:= f.y + l.y;
    n.z:= f.z + l.z;
    q:= 1 / sqrt(sqr(n.x) + sqr(n.y) + sqr(n.z));
    n.x*= q;
    n.y*= q;
    n.z*= q;
  end;

  procedure InterpolateT(var n, f, l: Titvert; ni: integer);
  begin
    n.vind:= ni;
    n.s:= (f.s + l.s) / 2;
    n.t:= (f.t + l.t) / 2;
    n.r:= (f.r + l.r) / 2;
    n.g:= (f.g + l.g) / 2;
    n.b:= (f.b + l.b) / 2;
  end;

  procedure CopyT(var n, o:  Titvert);
  begin
    MOVE(o, n, sizeof(n));
  end;


  procedure Subdivide(n: integer);
  var
    i, j, k, b, e, U, newV, newT, firstOV, lastOV : integer;
    nV: array[0..2] of integer;
  type
    Toee = record
      EndInd, NewInd: array[0..5] of integer;
    end;
  var
    OE: array of Toee;
  begin
    with ilod[n] do begin
      Vertexes:= COPY(ilod[n - 1].Vertexes);
      newV:= Length(Vertexes);
      SetLength(OE, Length(Vertexes));
      FillChar(OE[0], SizeOf(OE[0]) * Length(OE), 0);
      Triangles:= COPY(ilod[n - 1].Triangles);
      newT:= Length(Triangles);
      SetLength(Triangles, Length(Triangles) * 4);
//AddLog('step = %0, triangles = %1', [n, Length(Triangles)]);
      for i:= newT - 1 downto 0 do begin
        for j:=0 to 2 do begin
          firstOV:= Triangles[i, j].vind;
          if j < 2
            then lastOV:= Triangles[i, j + 1].vind
            else lastOV:= Triangles[i, 0].vind;
          b:= Math.Min(firstOV, lastOV);
          e:= Math.Max(firstOV, lastOV);
          with OE[b] do
            for k:=0 to 5 do begin
              if EndInd[k] = 0 then begin
                EndInd[k]:= e;
                SetLength(Vertexes, Length(Vertexes) + 1);
                NewInd[k]:= High(Vertexes);
//addlog('b=%0 e=%1 k=%2 length(vertexes)=%3', [b,e,k,length(vertexes)]);
                InterpolateV(Vertexes[High(Vertexes)], Vertexes[b], Vertexes[e]);
              end;
              if EndInd[k] = e then begin
                U:= NewInd[k];
                break;
              end;
            end;
          nv[j]:= U;
        end;

        InterpolateT(Triangles[i * 4 + 3][0], Triangles[i][2], Triangles[i][0], nV[2]);
        InterpolateT(Triangles[i * 4 + 3][1], Triangles[i][1], Triangles[i][0], nV[0]);
        InterpolateT(Triangles[i * 4 + 3][2], Triangles[i][2], Triangles[i][1], nV[1]);

        InterpolateT(Triangles[i * 4 + 2][0], Triangles[i][2], Triangles[i][0], nV[2]);
        InterpolateT(Triangles[i * 4 + 2][1], Triangles[i][2], Triangles[i][1], nV[1]);
               CopyT(Triangles[i * 4 + 2][2], Triangles[i][2]);

        InterpolateT(Triangles[i * 4 + 1][0], Triangles[i][1], Triangles[i][0], nV[0]);
               CopyT(Triangles[i * 4 + 1][1], Triangles[i][1]);
        InterpolateT(Triangles[i * 4 + 1][2], Triangles[i][2], Triangles[i][1], nV[1]);

        InterpolateT(Triangles[i * 4    ][0], ilod[n - 1].Triangles[i][1], ilod[n - 1].Triangles[i][0], nV[0]);
        InterpolateT(Triangles[i * 4    ][1], ilod[n - 1].Triangles[i][2], ilod[n - 1].Triangles[i][0], nV[2]);
               CopyT(Triangles[i * 4    ][2], ilod[n - 1].Triangles[i][0]);

      end;
    end;
  end;

  procedure InitIcosahedron;
  var
    i, j: integer;
    r, yangle, ra, ga, ba, rb, gb, bb, k: float;
  begin
    if iinitizlized then Exit;

    k:= 0.6;
    //if the edge length is 1.0
    r:= sqrt((sqrt(5) + 5) * 2) / 4; //is somewhere around 0.96. *almost* the same
    //https://ru.wikipedia.org/wiki/%D0%98%D0%BA%D0%BE%D1%81%D0%B0%D1%8D%D0%B4%D1%80
    yangle:= Pi / 2 - 2 * arctan(0.5 / sqrt(sqr(r) - sqr(0.5)));

    with ilod[0] do begin
      SetLength(Vertexes, 12);
      SetLength(Triangles, 20);
      with Vertexes[0] do begin x:= 0; y:= 1; z:= 0 end;
      with Vertexes[11] do begin x:= 0; y:= -1; z:= 0 end;
//      ix[0]:= 0; iy[0]:= 1; iz[0]:= 0;
//      ix[11]:= 0; iy[11]:= -1; iz[11]:= 0;


      for i:= 0 to 4 do begin
        with Vertexes[i + 1] do begin
          y:= sin(yangle);
          x:= cos(yangle) * sin(i *  2 * Pi /5);
          z:= cos(yangle) * cos(i *  2 * Pi /5);
        end;
        with Vertexes[i + 6] do begin
          y:= - sin(yangle);
          x:= cos(yangle) * sin(i *  2 * Pi /5 + Pi/5);
          z:= cos(yangle) * cos(i *  2 * Pi /5 + Pi/5);
        end;
      end;

      for i:=0 to 9 do begin
        ra:= (1 - k) + k * ((i and 1) shr 0);
        ga:= (1 - k) + k * ((i and 2) shr 1);
        ba:= (1 - k) + k * ((i and 4) shr 2);

        rb:= (1 - k) + k * (((i + 3) and 8) shr 3);
        gb:= (1 - k) + k * (((i + 3) and 4) shr 2);
        bb:= (1 - k) + k * (((i + 3) and 1) shr 0);

        with Triangles[i * 2][0] do begin
          s:= 0;
          t:= 0;
          r:= ra; g:= ga; b:= ba;
        end;
        with Triangles[i * 2][1] do begin
          s:= 0;
          t:= 1;
          r:= (ra + rb) / 2; g:= (ga + gb) / 2; b:= (ba + bb) / 2;
        end;
        with Triangles[i * 2][2] do begin
          s:= 1;
          t:= 0;
          r:= (ra + rb) / 2; g:= (ga + gb) / 2; b:= (ba + bb) / 2;
        end;
{
        itc[i * 2][0][0]:= 0;
        itc[i * 2][0][1]:= 1;
        itc[i * 2][1][0]:= 0;
        itc[i * 2][1][1]:= 0;
        itc[i * 2][2][0]:= 1;
        itc[i * 2][2][1]:= 1;
}
        with Triangles[i * 2 + 1][0] do begin
          s:= 1;
          t:= 0;
          r:= (ra + rb) / 2; g:= (ga + gb) / 2; b:= (ba + bb) / 2;
        end;
        with Triangles[i * 2 + 1][1] do begin
          s:= 0;
          t:= 1;
          r:= (ra + rb) / 2; g:= (ga + gb) / 2; b:= (ba + bb) / 2;
        end;
        with Triangles[i * 2 + 1][2] do begin
          s:= 1;
          t:= 1;//0;
          r:= rb; g:= gb; b:= bb;
        end;
{

        itc[i * 2 + 1][0][0]:= 1;
        itc[i * 2 + 1][0][1]:= 1;
        itc[i * 2 + 1][1][0]:= 0;
        itc[i * 2 + 1][1][1]:= 0;
        itc[i * 2 + 1][2][0]:= 1;
        itc[i * 2 + 1][2][1]:= 0;
 }
      end;
      for i:= 0 to 19 do
        for j:=0 to 2 do
          Triangles[i][j].vind:= ivertind[i][j];
    end;

    for i:= 1 to 5 do Subdivide(i);

    iinitizlized:= true;
  end;

  var ill: array[4..5] of float = (30, 280);

  procedure Icosahedron(scale, MyHdr: float; wireframe: boolean = false);
  var
    triangle, vertex, ci, lod, i: integer;
  begin
    InitIcosahedron;
    lod:= 3;
    for i:= Low(ill) to High(ill) do
      if Mother^.Timer.QF > ill[i] then lod:= i;
//    Math.Max(3, Math.Min(5, round(sqrt(Mother^.Timer.QF) / 2.78)));
    lod:= 3;//Math.Min(5, lod);
    MyHdr:= 1 / MyHdr;
    if wireframe
      then glBegin(GL_LINES)
      else glBegin(GL_TRIANGLES);
    with ilod[lod] do begin
      for triangle:= 0 to High(Triangles) do begin
        for vertex:= 0 to 2 do begin
          with Triangles[triangle][vertex] do begin
            glTexCoord2f(s, t);
            glColor3f(r * MyHdr, g * MyHdr, b * MyHdr);
            with Vertexes[vind] do glVertex3f(scale * x, scale * y, scale * z);
          end;
          {if wireframe then with Triangles[triangle][0] do begin
            glTexCoord2f(s, t);
            glColor3f(r * MyHdr, g * MyHdr, b * MyHdr);
            with Vertexes[vind] do glVertex3f(scale * x, scale * y, scale * z);
          end;
          }
        end;
      end;
    end;
    glEnd;
  end;

   Const
     FOV = 90;
     NEARPLANE = 1.0;
     FARPLANE = 500.0;
     ASPECT = 4/3;


  procedure TTest18Scene.Prepare(Camera: TAbstractCamera);
  begin

  end;

  procedure TTest18Scene.Render(Camera: TAbstractCamera);
  var
    fov, s, top, bottom, left,right, aspect: float;
    qq: qword;
    now: double;
  begin
    now:= mynow;

    glUseProgram(0);


    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    fov:= Camera.Fov;
//AddLog('fov=%0',[fov]);
    aspect:= Camera.Width/Camera.Height;
    top := Math.tan (FOV)*NEARPLANE;
    bottom := -top;
    left := ASPECT*bottom;
    right := ASPECT*top;
    glFrustum (left, right, bottom, top, NEARPLANE, FARPLANE);
 //   glrotatef(frac(Now * -0.01 * 86400.0) * 360.0, 1, 0, 0);
 //   glrotatef(frac(Now * 0.0033 * 86400.0) * 360.0, 0, 0, 1);

    glrotatef(pitch * 360.0, 1, 0, 0);
    glrotatef(yaw * 360.0, 0, 1, 0);


    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glColor4f(1, 1, 1,0.8);
    glrotatef(frac(Now * 0.0033 * 86400.0) * 360.0, 0, 1, 0);
    Skybox(1.0);

    glMatrixMode(GL_PROJECTION);
//    glLoadIdentity();

    glcolor4f(frac(Now * 86400/3), 0, frac(Now * 86400/5), 0.5);
    gltranslatef(0,0,-100);

    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LESS);
    glDepthMask(GL_TRUE);
    glDisable(GL_ALPHA_TEST);
    glDisable(GL_BLEND);
    glDisable(GL_CULL_FACE);
    glCullFace(GL_FRONT);
    glEnable (GL_TEXTURE_2D);


    glLineWidth(0.5);


    //glBindTexture(GL_TEXTURE_2D, Mother^.GL.StubTexture);
    //crapper.Bind;
    sky_up.Bind;


    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    gltranslatef(-30,20,30);
    glrotatef(frac(Now * -0.1 * 86400.0) * 360.0, 0, 1, 0);
    glrotatef(frac(Now * -0.01 * 86400.0) * 360.0, 1, 0, 0);
    Icosahedron(20, 1.0, true);
    //Kubik(20, Hdr);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glrotatef(frac(Now * 0.02 * 86400.0) * 360.0, 0, 1, 0);
    glrotatef(frac(Now * 0.0033 * 86400.0) * 360.0, 1, 0, 0);
    Icosahedron(50, 1.0);
    //Kubik(50, Hdr);

    glUseProgram(0);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0, Camera.width, 0, camera.height, 0 ,1);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

  end;

  function TTest18ViewPort.OnKey(Key: TKey): boolean;
  begin
    Result:= inherited OnKey(Key);
    if Module.Logic.KeyDown[Key] then case Key of
      KEY_1: begin a1:= 0; AddLog(RuEn('Менюшный режим: логика ждёт окончания кадра','GUI mode: logic waits the end of a frame')); end;
      KEY_2: begin a1:= 1; AddLog(RuEn('Игровой режим: логика на стабильных 100Гц','Game mode: Logic at stable 100Hz')); end;
      KEY_3: begin a1:= 2; AddLog(RuEn('Режим ускоренной промотки','Fast forward mode')); end;
      KEY_4: begin a2:= 0; AddLog(RuEn('Время просчёта логики %0мс','Logic pulse duration %0ms'),[a2]); end;
      KEY_5: begin a2:= 2; AddLog(RuEn('Время просчёта логики %0мс','Logic pulse duration %0ms'),[a2]); end;
      KEY_6: begin a2:= 4; AddLog(RuEn('Время просчёта логики %0мс','Logic pulse duration %0ms'),[a2]); end;
      KEY_7: begin a2:= 6; AddLog(RuEn('Время просчёта логики %0мс','Logic pulse duration %0ms'),[a2]); end;
      KEY_8: begin a2:= 8; AddLog(RuEn('Время просчёта логики %0мс','Logic pulse duration %0ms'),[a2]); end;
      KEY_9: begin a2:= 9; AddLog(RuEn('Время просчёта логики %0мс','Logic pulse duration %0ms'),[a2]); end;
      KEY_0: begin a2:= 10; AddLog(RuEn('Время просчёта логики %0мс','Logic pulse duration %0ms'),[a2]); end;
      {
      KEY_Q: begin a3:= 0; AddLog(RuEn('Недружественная к кешу физика.','Cache-unfriendly physics'),[]); end;
      KEY_W: begin a3:= 1; AddLog(RuEn('Дружественная к кешу физика.','Cache-friendly physics'),[]); end;
      KEY_E: begin a3:= 2; AddLog(RuEn('Дружественная к кешу ЧИТЕРСКАЯ физика.','Cache-friendly CHEATING physics'),[]); end;
      KEY_R: begin a3:= 3; AddLog(RuEn('Сдвухстороннавстречу физика.','Testing one half towards each other physics'),[]); end;
      }
    end;


  end;



  procedure TTest18ViewPort.Cycle;
  var
    i: integer;
    q: integer;
    qc: qword;
    ms: double;
    pg: boolean;
  begin
    if Assigned(Camera.Scene) then (Camera.Scene as TTest18Scene).mynow+= 0.03 / SECONDS_PER_DAY;

    pg:= (a1 = 1) and not Assigned(Module.Logic.MainMenu);
    Module.Logic.GrabPointer:= pg;
    if Assigned(Camera.Scene) then with Camera.Scene as TTest18Scene do
      if Module.Logic.GrabPointer then begin
        yaw:= frac(yaw + 0.0003 * Module.Logic.mousefpsdx);
        pitch:= min(0.9 / 4, max (-0.9 / 4, pitch - 0.0003 * Module.Logic.mousefpsdy));
      end else begin
        if yaw > 0.5 then yaw-= 1.0;
        yaw*= 0.99;
        pitch*= 0.99;
      end;

    case a1 of
      1: Module.Logic.NextPulseWhen:= lnf_Steady100Hz;
      2: Module.Logic.NextPulseWhen:= lnf_ASAPRenderAt30;
    end;
    if a2 > 0 then Sleep(a2);

    inherited;

    if Module.Logic.IsLoadingAssets then Exit;


  end;

  destructor TTest18ViewPort.Destroy;//procedure TTest18ViewPort.Scrape;
  begin
    inherited;
  end;



end.
