echo off

set BUILTIN=bryed3dev

rem set to 1 to recompile accompanying tools (incbuild, brutalstrip and the like)
set BUILD_TOOLS=0


set BUILD_WIN32=1
set BUILD_WIN64=0
set BUILD_DEBUG=1
set BUILD_LEGACYWINXP=0

set PACK_RELEASE=0
set RELEASE_DIR=..\..\..\tmp\chentrah\
set RTDIR=..\..\..\

rem set FPC_VER=3.0.1
rem set FPC_VER=3.1.1
set FPC_VER=2.6.4

set COLDPATH=%PATH%

set PATH=c:\FPC\%FPC_VER%\bin\i386-win32\;..\..\..\bin\;%COLDPATH%

set CODE_OPTIONS=-O3 -OpPentiumM -CfSSE2
rem -OpPentiumM -O2
rem set CGE_OPTIONS= -Sa -gw2 -gl -Xi -XX -dcge -dnotlaz -dcge_rc_directly -Mobjfpc -Sh -Sc -Rintel %CODE_OPTIONS%
set CGE_OPTIONS=  -vq -Sa -gl -gw2 -Xi -XX -dcge -dnotlaz -dcge_rc_directly -Mobjfpc -Sh -Sc -Rintel %CODE_OPTIONS%

rem -dglesonly
rem to build an executable that only supports OpenGL ES 2

rem  -Sa -gl -Xi -XX
set CGE64_OPTIONS=-dcge -dnotlaz -dcge_rc_directly -Mobjfpc -Sh -Sc -Rintel

rem
set CODE64_OPTIONS=-Co -Cr -Ct -Sa -CfSSE64 -Opathlon64 -O3 -Sc

set CODE_LEGACY_OPTIONS=-O2 -OpPentiumM
rem -OpPentiumM -O2
rem set CGE_OPTIONS= -Sa -gw2 -gl -Xi -XX -dcge -dnotlaz -dcge_rc_directly -Mobjfpc -Sh -Sc -Rintel %CODE_OPTIONS%
set CGE_LEGACY_OPTIONS= -Sa -gl -gw2 -Xi -XX -ve -dcge -dnotlaz -dcge_rc_directly -Mobjfpc -Sh -Sc -Rintel %CODE_LEGACY_OPTIONS%


rem set CGE_PATHS=-FE..\..\..\ -Fi..\..\%BUILTIN%\src\ -Fu..\..\%BUILTIN%\src\

set VY_PATHS=-Fu..\..\..\3rdparty\Imaging\Source\  -Fu..\..\..\3rdparty\Imaging\Source\ZLib\  -Fi..\..\..\3rdparty\Imaging\Source\ -Fu..\..\..\3rdparty\Imaging\Source\JpegLib\
set SDL2_PATHS=-Fu..\..\..\3rdparty\sdl2-fpc-master\SDL2\
set THRID_PARTY_PATHS=%VY_PATHS% %SDL2_PATHS%



mkdir ..\..\..\tmp\
mkdir ..\..\..\tmp\main
mkdir ..\..\..\tmp\main-debug
mkdir ..\..\..\tmp\tools

del /Q .\*.ppu
del /Q .\*.o

bin2obj -o cl_builtin_font.inc -c builtin_font font.png
bin2obj -o cl_console_font.inc -c iim_console consolefont.png
bin2obj -o cl_bgimg_error.inc -c error_bg_img cl_background_error.png
bin2obj -o cl_cursor_cyan.inc -c cursor_cyan_img cl_cursor_normal.png
bin2obj -o cl_cursor_yellow.inc -c cursor_yellow_img cl_cursor_error.png
bin2obj -o cl_cursor_hourglass.inc -c cursor_hourglass_img cl_cursor_hourglass.png
bin2obj -o cl_minifont.inc -c minifont_img cl_minifont.png
bin2obj -o cl_errbutton.inc -c errbutton_img cl_errbutton.png
bin2obj -o cl_erricon.inc -c erricon_img cl_erricon.png

if "%BUILD_TOOLS%" == "1" goto tooyes
goto tooend
:tooyes
fpc incbuild.pp -FE..\..\..\bin\ -FU..\..\..\tmp\tools
fpc brutalstrip.pp -FE..\..\..\bin\ -FU..\..\..\tmp\tools
fpc extractdwrflnfo.pp -FE..\..\..\bin\ -FU..\..\..\tmp\tools
fpc finalizedwrflnfo.pp -FE..\..\..\bin\ -FU..\..\..\tmp\tools
:tooend



if "%BUILD_WIN64%" == "1" goto w64yes
goto w64end
:w64yes

del /Q chentrah.res
rem Why the hell fpc is using it instead of  the *.rc it was told to use? >:(


if "%BUILD_DEBUG%" == "1" goto dbug64yes
goto dbug64end
:dbug64yes
mkdir ..\..\..\tmp\main-x86_64-debug\
del /Q ..\..\..\debug-chentrah-x86_64.exe

rem without this, compiler stops with unexplained "Fatal: Compilation aborted"
del /Q ..\..\..\tmp\main-x86_64-debug\*.ppu
del /Q ..\..\..\tmp\main-x86_64-debug\*.o

ppcrossx64 -gl	-ddebug_build -Co -Cr chentrah.lpr -Twin64 %CGE64_OPTIONS% %CODE64_OPTIONS% %THRID_PARTY_PATHS% -FE..\..\..\tmp\main-x86_64-debug\ -FU..\..\..\tmp\main-x86_64-debug\ -Fu..\..\..\tmp\main-x86_64-debug\
if errorlevel 1 goto err
move ..\..\..\tmp\main-x86_64-debug\chentrah.exe  ..\..\..\debug-chentrah-x86_64.exe
rem x86_64-win64-strip ..\..\..\debug-chentrah-x86_64.exe
rem upx -9 --force ..\..\..\debug-chentrah-x86_64.exe

:dbug64end


del /Q ..\..\..\chentrah-x86_64.exe
mkdir ..\..\..\tmp\main-x86_64\

rem without this, compiler stops with unexplained "Fatal: Compilation aborted"
del /Q ..\..\..\tmp\main-x86_64\*.ppu
del /Q ..\..\..\tmp\main-x86_64\*.o

rem fpc chentrah.lpr %CGE_OPTIONS% -CX -Twin32 -FU..\..\..\tmp\main\ %CGE_PATHS% %THRID_PARTY_PATHS%

rem -dLCL
ppcrossx64  -gl chentrah.lpr -Twin64 %CGE64_OPTIONS% %CODE64_OPTIONS% %THRID_PARTY_PATHS% -FE..\..\..\tmp\main-x86_64\ -FU..\..\..\tmp\main-x86_64\ -Fu..\..\..\tmp\main-x86_64\
if errorlevel 1 goto err
incbuild build.h
move ..\..\..\tmp\main-x86_64\chentrah.exe ..\..\..\chentrah-x86_64.exe
rem x86_64-win64-strip ..\..\..\chentrah-x86_64.exe
rem upx -9 --force ..\..\..\chentrah-x86_64.exe

:w64end




if "%BUILD_WIN32%" == "1" goto w32yes
goto w32end
:w32yes

set PATH=c:\FPC\%FPC_VER%\bin\i386-win32\;..\..\..\bin\;%COLDPATH%

del /Q chentrah.res
rem Why the hell fpc is using it instead of  the *.rc it was told to use? >:(

if "%BUILD_DEBUG%" == "1" goto dbugyes
goto dbugend
:dbugyes

del /Q ..\..\..\tmp\main-debug\*.ppu
del /Q ..\..\..\tmp\main-debug\*.o
del /Q ..\..\..\debug-chentrah.exe

if "%BUILD_LEGACYWINXP%" == "1" goto dbugcompatyes
goto dbugcompatend
:dbugcompatyes
ppc386 chentrah.lpr -dnowin10 -ddebug_build -Co -Cr %CGE_OPTIONS% -CX -Twin32 -FU..\..\..\tmp\main-debug\ -FE..\..\..\ %THRID_PARTY_PATHS%
if errorlevel 1 goto err
move ..\..\..\chentrah.exe  ..\..\..\debug-chentrah-winXP.exe
extractdwrflnfo ..\..\..\debug-chentrah-winXP.exe
strip ..\..\..\debug-chentrah-winXP.exe
rem upx -9 --force ..\..\..\debug-chentrah.exe
finalizedwrflnfo ..\..\..\debug-chentrah-winXP.exe
rem shares the units with the regular executable as the ONLY difference is the embedded manifest
:dbugcompatend

ppc386 chentrah.lpr -ddebug_build -Co -Cr %CGE_OPTIONS% -CX -Twin32 -FU..\..\..\tmp\main-debug\ -FE..\..\..\ %THRID_PARTY_PATHS%
if errorlevel 1 goto err
move ..\..\..\chentrah.exe  ..\..\..\debug-chentrah.exe
extractdwrflnfo ..\..\..\debug-chentrah.exe
strip ..\..\..\debug-chentrah.exe
rem upx -9 --force ..\..\..\debug-chentrah.exe
finalizedwrflnfo ..\..\..\debug-chentrah.exe
:dbugend


del /Q ..\..\..\tmp\main\*.ppu
del /Q ..\..\..\tmp\main\*.o

if "%BUILD_LEGACYWINXP%" == "1" goto w32compatyes
goto w32compatend
:w32compatyes
del /Q ..\..\..\chentrah.exe
fpc chentrah.lpr %CGE_OPTIONS% -dnowin10 -CX -Twin32 -FU..\..\..\tmp\main\ -FE..\..\..\ %THRID_PARTY_PATHS%
if errorlevel 1 goto err
move ..\..\..\chentrah.exe  ..\..\..\chentrah-winXP.exe
extractdwrflnfo ..\..\..\chentrah-winXP.exe
strip ..\..\..\chentrah-winXP.exe  --verbose
finalizedwrflnfo ..\..\..\chentrah-winXP.exe
rem shares the units with the regular executable as the ONLY difference is the embedded manifest
:w32compatend

del /Q ..\..\..\chentrah.exe
fpc chentrah.lpr %CGE_OPTIONS% -CX -Twin32 -FU..\..\..\tmp\main\ -FE..\..\..\ %THRID_PARTY_PATHS%
if errorlevel 1 goto err
incbuild build.h
extractdwrflnfo ..\..\..\chentrah.exe
rem brutalstrip ..\..\..\chentrah.exe
strip ..\..\..\chentrah.exe  --verbose
rem  --only-keep-debug --strip-unneeded
rem UPX is mandatory, it fixes the executable broken by brutalstrip.
rem  (how does all of this work I have no slightest clue.
rem    I guess I missed some vital detail when I was writing brutalstrip)
rem upx -9 --force ..\..\..\chentrah.exe
finalizedwrflnfo ..\..\..\chentrah.exe
rem move ..\..\..\chentrah.zd2 ..\bin\

:w32end





:err
