{
    This file is part of Chentrah,
    Copyright (C) 2004-2015 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 ********************************************************************** }

  {$ifndef fpc}
    {$fatal NOT COMPATIBLE WITH DELPHI. Use FreePascal 2.6.4 or higher.}
    <<<<<<<<<<<<
  {$endif}
  {$if FPC_FULLVERSION<20600}
    {$fatal Use FreePascal 2.6.4 or higher.}
  {$endif}
  {$ifdef che_legacy}
    {$if FPC_FULLVERSION>20604}
      {$fatal The legacy version can ONLY be compiled using FreePascal 2.6.4.}
    {$endif}
  {$endif}

  {$ifdef windows}
    { memory 150000000, 10000} // 50 Mbytes stack, 10 Kbytes heap.
    {$ifndef chentrah_legacy}
      {$ifdef cpu32}
        {$setpeflags $20} //winnt.h:#define IMAGE_FILE_LARGE_ADDRESS_AWARE 0x0020
                          // App can handle >2gb addresses
      {$endif}
    {$endif}
  {$endif}
 {  Note: the heap size doesn't really affect anything,
      it'll grow automatically anyway.
    The stack size, on the other hand, is an absolute limit.
      reach it - and you crash with "unknown run-time error 202"
      (aka stack overflow). We need a lot of stack space
      since the game modules use Chepersy
      that relies on heavy recursive algorithms.
    In Linux the stack limit is chosen by the Kernel
      according some obscure settings I know nothing about.
  }
  
  program chentrah;
  {$mode objfpc}
  {$longstrings on}
  {$codepage utf-8}
  {$if FPC_FULLVERSION>=20700}
    {$modeswitch unicodestrings}
  {$endif}
  {$ifdef windows}
    {$ifdef debug_build}
      {$apptype console}
    {$else}
      {$apptype gui}
    {$endif}
    {$ifdef cge_rc_directly}
       {$ifdef nowin10}
         {$r chentrah-nowin10.rc} //Some glitchy drivers (intel HD 3000 )
         //disable hardware acceleration of OpenGL for applications that support Windows 10
       {$else nowin10}
         {$r chentrah.rc} //includes chentrah.manifest allowing the application
                       //  to detect Windows 10
       {$endif}
      //2013: abandoned Linux, developing on Windows now. The problem not actual.
    {$else}
      {$fatal Obsoleted!}
      {$r chentrah.res} {  the application icon.
        NOTE: although fpc 2.2.0 and up allows to invoke a *.rc
          file directly, it just calls on windres,
          but windres CRASHES in Wine.
        So, the only way is to compile the icon into a *.res
          is using some third-party resource compiler that
          *does* work in Wine (such as one from
          http://www.jorgon.freeserve.co.uk/ )
         Sept. 2012: switched to using wrc (Wine Resource Compiler) adding a call to it into build.sh
      }
    {$endif}
  {$endif}
  {$ifdef darwin}
    {$fatal MacOS X NOT SUPPORTED}
  {$endif}


  uses
    sysutils, cge
    {$ifdef windows}
      , framework_winapi
      //, framework_sdl2
    {$endif}
    {$ifdef unix}
       , framework_x11
      //, framework_sdl2
    {$endif}
    , framework_server
    ;
  begin
    cge.Run();
  end.



