
{
    This file is part of Chentrah,
    Copyright (C) 2004-2008 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 ********************************************************************** 

    This file contains configuration manager class header.

 **********************************************************************}

 type

   TConfigManager = class
   protected
     Ini: array[0..2] of TCustomIniFile; { 0 - the main config file (read-only,
       resides in the install folder)
       1 - the general config in the home folder, conf.ini, stores everything
       except [video]
       2 - the per-videocard config (file based on videocard and driver details).
       Stores the [video] section. Is only initialized after OenGL is initialized.
     }
     wherefound: integer;
     CS: TProfiledCriticalSection;
     function _Find(s, i: UnicodeString): UnicodeString;
     function _ReadStr(s, i: UnicodeString): UnicodeString;
     function _ReadPath(s, i: UnicodeString): TFileNameString;
     function _ReadBool(s, i: UnicodeString): boolean;
     function _ReadInt(s, i: UnicodeString;  min, max: integer): integer; OVERLOAD;
     function _ReadInt(s, i: UnicodeString): integer; OVERLOAD;
     function _ReadFloat(s, i: UnicodeString): float;
     function _ReadIntChk(s, i: UnicodeString; min,max: integer): integer;
     function _ReadFloatChk(s, i: UnicodeString; min,max: float): float;
     procedure _WriteStr(s,i,d: UnicodeString);
     procedure _WriteInt(s,i: UnicodeString; v:integer);
     procedure _WriteFloat(s,i: UnicodeString; v:float);
     procedure _WriteIntChk(s,i: UnicodeString; min, max, v:integer);
     procedure _WriteFloatChk(s,i: UnicodeString; min, max, v:float);
     procedure _WriteBool(s,i: UnicodeString; b: boolean);
     procedure _WritePath(s,i: UnicodeString; d: TFileNameString);
     procedure ScreamLimitsRead(fnum: integer; s,i: UnicodeString; val, min, max: integer); overload;
     procedure ScreamLimitsRead(fnum: integer; s,i: UnicodeString; val, min, max: float); overload;
     //procedure ScreamLimitsWrite;
   public
     SilentCorrectionsOnWrite,
     StrictLimitsCheck: boolean;
     Constructor Create;
     Destructor Destroy; OVERRIDE;
     procedure LoadMainFile;
     procedure LoadUserFile;
     function Wherefoundname: UnicodeString;
     Property Int[sect, id: UnicodeString]: integer read _ReadInt write _WriteInt; DEFAULT;
     Property Float[sect, id: UnicodeString]: float read _ReadFloat write _WriteFloat;
     Property IntChk[sect, id: UnicodeString; min, max: integer]: integer read _ReadIntChk write _WriteIntChk;
     Property FloatChk[sect, id: UnicodeString; min, max: float]: float read _ReadFloatChk write _WriteFloatChk;
     Property Bool[sect, id: UnicodeString]: boolean read _ReadBool write _WriteBool;
     Property Str[sect, id: UnicodeString]: UnicodeString read _ReadStr write _WriteStr;
     Property Path[sect, id: UnicodeString]: TFileNameString read _ReadPath write _WritePath;
     function GetFloat(sect, id: UnicodeString; defval: float = 0.0) : float;
     procedure GetSet(penum: pointer; ti: ptypeinfo; sect, id: UnicodeString);
     procedure SetSet(penum: pointer; ti: ptypeinfo; sect, id: UnicodeString);
   end;

 var
   Config: TConfigManager;

