
//The procedures outputting the call stack chain specifically ignore procedures from this include, as well as mo_hub.die.inc

function GetExceptionState(): PMotherSehState;
{
   Note: while it *can* allocate the block for a thread
   it knows nothing about, that is *not* a desired behavior.

   Thus, any thread better call this function beforehand,
   in the beginning of it's Execute method.

   There is Mother^.Core.AllocateThreadExceptionState for the module
}
var
  T: TThreadId;
begin
  EnterCriticalsection(Mother^.SehCriticalSection);
  T:= GetCurrentThreadId();
//bgSay('  GetExceptionState for thread ID=' + IntToHex(T, 8));
  Result:= @Mother^.ExceptionState;
  while true do begin
    if Result^.ThreadId = T then begin
//bgSay('    pes is ' + IntToHex(dword(Result), 8) + ' , name=' + Result^.ThreadTitle);
      LeaveCriticalsection(Mother^.SehCriticalSection);
//bgSay('    ^');
      Exit;
    end;
    if not Assigned(Result^.Next) then begin
//bgSay('    Allocating...');
      VerboseLog('  Allocating exception state for thread ID=' + IntToHex(T, 8) + 'h...');
      Result^.Next:= new(PMotherSehState);
      Result:= Result^.Next;
//bgSay('    pes is ' + IntToHex(dword(Result), 8));
      FillChar(Result^, SizeOf(Result^), 0);
      Result^.ThreadId:= T;
     {$ifdef CPUX86_64}
      asm
       // push ax
       // push rsi
        mov rsi, qword[Result]
        mov ax, ss
        mov word[rsi + TMotherSEHState.StackSegment], ax
       // pop rsi
       // pop ax
      end['ax', 'rsi'];
    {$endif}
    {$ifdef CPU386}
      asm
        //push ax
        //push esi
        mov esi, dword[Result]
        mov ax, ss
        mov word[esi + TMotherSEHState.StackSegment], ax
        //pop esi
        //pop ax
      end['ax', 'esi'];
    {$endif}
      LeaveCriticalsection(Mother^.SehCriticalSection);
      Exit;
    end;
    Result:= Result^.Next;
//bgSay('    next is ' + IntToHex(dword(Result), 8));
  end;
end;

  Procedure _HostDyellW(txt: PUnicodeChar); cdecl;
  //To be used by module's Die() as Mother^.Module.StartDying()
  begin
  //    try
    StartDying(PUnicodeCharToUnicodeString(txt));
  //    if not Mother^.State.NowDying then begin
  //      AddLog(MI_SHIT_HAPPENS_SEE_BELOW, ['----']);
  //      Mother^.State.NowDying:=Yes;
  //    end;
  //addlog('_HostDyellW: %0', [u]);
  //    WarningQueue.Add(u);
  //    LeaveGuardedSection;
  end;


//var _crash_details: UnicodeString;

  function CallStack(IgnoreLastN: integer; Padding: UnicodeString): UnicodeString;
  var
    a, ca: pointer; i: integer;
    w: UnicodeString;
  begin
    Result:='';
    i:=0;
    a:= get_frame;
    while Assigned(a) do begin
      ca:= get_caller_addr(a);
      if Assigned(ca) then begin
        w:= ShortExpAddr(ca);
        if ((IgnoreLastN > 0) and (i >= IgnoreLastN + 1))
        or ((IgnoreLastN = 0) and (
               pos('mo_hub_die.inc', w) = 0)
          and (pos('cl_die.inc', w) = 0)
          and (pos('mo_die1.inc', w) = 0)
          and (pos('cl_seh_hack_win32.pp', w) = 0)
          and (pos('cl_seh_hack_win64.pp', w) = 0)
        )
        then begin
          if Result <> '' then Result+= #10#13;
          Result+= Padding + w;
        end;
        inc(i);
        if i > 100 then break; //sanity check
      end
      else Break;
      a:= get_caller_frame(a);
    end;
  end;


 Procedure Die(AnsiYell: AnsiString);
  begin
    Die(AnsiToWide(AnsiYell));
  end;


  Procedure Die(AnsiYell :AnsiString; Param: array of const); OVERLOAD;
  begin
    Die(PervertedFormat(AnsitoWide(AnsiYell), Param));
  end;

  Procedure Die(WideYell :UnicodeString; Param: array of const); OVERLOAD;
  begin
    Die(PervertedFormat(WideYell, Param));
  end;


  Procedure Die(Ru, En :UnicodeString; Param: array of const); OVERLOAD;
  begin
    Die(RuEn(Ru,En), Param);
  end;

  Procedure Die(YellID :TMessageID);
  begin
    Die(YellId, []);
  end;



  Procedure Die(YellID :TMessageID; Param: array of const);
  var
    U, _crash_details: UnicodeString;
    pes: PMotherSehState;

  begin
    U:=PervertedFormat(MessageContainer[YellID], Param);
    pes:= GetExceptionState();
    if not pes^.NowDying then begin
      CheckForGenericDyingYells(U, _crash_details);
      AddLog(MI_SHIT_HAPPENS_SEE_BELOW, ['----']);
      if not Mother^.State.DeveloperMode
        and not Mother^.Debug.Enabled
          then AddLog('%0'#10#13'<---------------------->',[_crash_Details]);
      pes^.NowDying:=Yes;
    end;
    StartDying(U);
    raise Exception.Create('');
  end;

  Procedure Die(WideYell: UnicodeString);
  var
    pes: PMotherSehState;
    _crash_details: UnicodeString;
  begin
    pes:= GetExceptionState();
    if not pes^.NowDying then begin
      CheckForGenericDyingYells(WideYell, _crash_details);
      AddLog(MI_SHIT_HAPPENS_SEE_BELOW, ['----']);
      with Mother^ do
        if not State.DeveloperMode and not Debug.Enabled
          then AddLog('%0'#10#13'<---------------------->',[_crash_Details]);
      pes^.NowDying:=Yes;
    end;
    StartDying(WideYell);
    raise Exception.Create('');
  end;

  //must be used in Except block of every mother callback function
  procedure ProcessGuardedException; cdecl;
  var
    CallerAddr: pointer;
    Yell, _crash_details: UnicodeString;
    pes: PMotherSehState;
  begin

   {$ifdef cpu386}
    asm
      mov eax, [ebp + 4] //read the caller's EIP
      mov [CallerAddr], eax
    end;
   {$else}
     CallerAddr:= get_caller_addr(get_caller_frame(get_frame));
   {$endif}


   pes:= GetExceptionState();

   {$ifndef buildmein}
    if not pes^.IsModuleThread { thread originates from the module
      and calls the mother API functions. }
    and (
      { only the main thread can call module which then call the
          mother API functions. Any other threads are mother-only }
      (pes^.ThreadId <> Mother^.State.MainThreadId)
      or (Mother^.Module.CurrentlyExecutingInd = NOT_A_MODULE)
    )
      //the guarded function was called by the mother for its own needs
      // (like decoding a jpeg or shit)
    then begin
      if pes^.NowDying
      then raise Exception.Create('') //re-raise silently
      else
   {$endif}
      //re-raise the exception chain
      Die(RuEn(
        'Исключение охраняемой функции'#10#13'  отловлено шлюзом %0',
        'The guarded function exception'#10#13'  re-raised at %0'),
        [ExpExpAddress(CallerAddr)]);
   {$ifndef buildmein}
    end
    else begin
    //tge guarded function was called by the module
      Yell:=PervertedFormat(RuEn(
        'Исключение коллбэк-функции модуля-матки'#10#13'  передано шлюзом %0',
        'The mother module callback function exception'#10#13'  send at %0'),
        [ExpExpAddress(CallerAddr)]);
      if not pes^.NowDying
        then CheckForGenericDyingYells(Yell, _crash_details, 0);
      StartDying(Yell);
      //return safely. The module will raise exception using AfterEfCheck();
    end;
   {$endif}
  end;


  procedure DieReraisingExceptionScreenedByModule(msg: UnicodeString);
  var
    pes: PMotherSehState;
    prevmsg: UnicodeString;
  begin
    if Assigned(Module) then Module.ResetExecutionZoneFlags;
    pes:= GetExceptionState();
    pes^.NowDying:= true; //prevents unnecessary adding of backtrace if the module reset this flag
    prevmsg:= StopDying();
    pes^.NowDying:= true; //as the function above resets it
    Die(msg + #10#13#10#13 + prevmsg);
  end;

  procedure CheckForGenericDyingYells(var U: UnicodeString;
   var _crash_details: UnicodeString; omit_frames: integer = 0);
  var
    a, ca: pointer;
    i: integer;
    csstarted: boolean = false;
    w: UnicodeString;
    pes: PMotherSehState;
  begin
    pes:= GetExceptionState();
    if pes^.NowDying then Exit;
    //Try
  //      SetEChar;
      if ExceptObjectisException then begin
        if not (ExceptObject is EFake) then begin
          U+= #10#13#10#13 + TellException(ExceptObject as Exception);
          pes^.DyingAfterTrueException:= true;
        {$ifdef win32}
          //..пробуем расшифровать показания
          //  функции WinAPI GetLastEror (в функции Win32LastEror)
          U+= Win32LastError;
        {$endif}
        end;
      end;
      {$ifdef win32}
        SetLastError(0);
      {$endif}
      _crash_details:= '';
      if not pes^.CallStackLogged then begin
        i:=0;
        a:= get_frame;
        while Assigned(a) do begin
          ca:= get_caller_addr(a);
          if Assigned(ca) then begin
            w:= ShortExpAddr(ca);
            if    (pos('mo_hub_die.inc', w) = 0)
              and (pos('cl_die.inc', w) = 0)
              and (pos('mo_die1.inc', w) = 0)
              and (pos('cl_seh_hack_win32.pp', w) = 0)
              and (pos('cl_seh_hack_win64.pp', w) = 0)
              and (pos('STOPDYING', w) = 0)
            then begin
              if not csstarted then begin
                csstarted:= true;
                _crash_details+= #10#13 + RuEn(
                  'Стек вызовов:',
                  'Call stack:');
              end;
              _crash_details+= #10#13'  ' + w;
            end;
            inc(i);
          end
          else Break;
          if ((i>MAX_STACK_FRAMES_DUMP) and not Mother^.Debug.Enabled and Mother^.State.ProgramInitialized)
            or (i > 100) //there could be up to 50000 recursive calls
          then break;
          a:= get_caller_frame(a);
        end;
        with Mother^ do
          if State.DeveloperMode or Debug.Enabled or not State.ProgramInitialized
            then U+= #10#13#10#13 + _crash_Details;
        pes^.CallStackLogged:= true;
      end;
    //Except
    //  U:=U + #10#13'!Crashed accessing Exception object!';
    //End;
  end;


  function StopDying(pes: PMotherSehState = nil): UnicodeString;
  var
    _stub: UnicodeString;
  begin
{    if not Dying and (ExceptObject <> nil) and (ExceptObject is Exception)
      then Result:= ToldException(ExceptObject as Exception)
      else Result:=ExtractDyingYell(); }

    if not Assigned(pes)
      then pes:= GetExceptionState(); //basen on GetCutrrentTHreadId() - see Mother^.


    Result:= ExtractDyingYell(pes);



    if not pes^.NowDying or (Trim(Result) = ''){and (Mother^.Module.CurrentlyExecutingInd = NOT_A_MODULE)}
      then CheckForGenericDyingYells(Result, _stub);

{    and (ExceptObject <> nil) and (ExceptObject is Exception)
      then Result:= Result + #10#13 + ToldException(ExceptObject as Exception);
}
    pes^.NowDying:= false;
    pes^.DyingAfterTrueException:= false;
    pes^.CallStackLogged:= false;
    pes^.ModuleIsAlreadyProcessingUnhandledException:= false;
  end;



procedure DieUnsupportedGLMode;
begin
  Die(MI_ERROR_PROGRAMMER_NO_BAKA, [
    PervertedFormat(RuEn(
       'попался кусок кода, не поддерживающий "%0"',
       'there is a chunk of code that doesn''t support "%0"'
      ),[GetEnumName(typeinfo(TGAPIModeEnum), Ord(Mother^.GAPI.Mode))])]);
end;

