{
    This file is part of Chentrah,
    Copyright (C) 2004-2008 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************

    This file contains the built-in fixed font handling routines.

 **********************************************************************}

  {$include cl_builtin_font.inc} // the imbedded low-res font texture (1-bit  .png)

  const
    MIN_FACE_TO_USE = 2;
//    ffMipThreshold = 0.3; //manual "mipmap" selection based on the pixel to texel ratio
    HI_BIF = 1; //two built-in fonts
  var
    fftAlreadyLoaded: boolean = false;

    BIF: array[0..HI_BIF] of TMotherBuiltinFont;

    //ffColor: TVector4f;

  const
    ffcs: array[0..17] of UnicodeString = (
      'АаБбВвГгДдЕеЁёЖж',
      'ЗзИиЙйКкЛлМмНнОо',
      'ПпРрСсТтУуФфХхЦц',
      'ЧчШшЩщЬьЫыЪъЭэЮю',
      'Яя!"#$%&''()*+,-.',
      '/0123456789:;<=>',
      '?@ABCDEFGHIJKLMN',
      'OPQRSTUVWXYZ[\]^',
      '_`abcdefghijklmn',
      'opqrstuvwxyz{|}~',
      '‘’‚“”„…‰«»§®°–—‘',
      'ƒˆŠŒŽ•˜™šœžŸ¡¢£¤',
      '¥¦§©ª¬°±²³´µ¶·¹ÿ',
      '¼½¾¿ÀÁÂ∞ÃÄÅÆÇÈÉÊ',
      'ËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚ',
      'ÛÜÝÞßàáâãäåæçèéê',
      'ëìíîïðñòóôõö÷øùú',
      'û√üýþ™№∂∆∏∑♯≈≠≤≥');
(*
    sfcs: array[0..13] of UnicodeString = (
      ' !"#$%&''()*+,-./',
      '0123456789:;<=>?',
      '@ABCDEFGHIJKLMNO',
      'PQRSTUVWXYZ[\]^_',
      '`abcdefghijklmno',
      'pqrstuvwxyz{|}~', //Do NOT edit! Lazarus may not render the aposthroph at the end of this line -- but it is there!
      'ЂЃ‚ѓ„…†‡ ‰Љ‹ЊЌЋЏ', //no Euro symbol. I drew that raster font ages ago, before there was Euro.
      'ђ‘’“”•–— ™љ›њќћџ',
      ' ЎўЈ¤Ґ¦§Ё©Є«¬­®Ї', //Do NOT edit! Lazarus displays this line with quirks because it has a strange symbol between ¬ and @!
      '°±Ііґµ¶·ё№є»јЅѕї',
      'АБВГДЕЖЗИЙКЛМНОП',
      'РСТУФХЦЧШЩЪЫЬЭЮЯ',
      'абвгдежзийклмноп',
      'рстуфхцчшщъыьэюя');
*)
    ffMaxChar = 287;
   // ffMaxFace = 16;

  type
    ffEnum = (ffSize, ffLeft, ffTop, ffGridWidth, ffGridHeight,
                     ffGlyphWidth, ffGlyphHeight, ffHspacing,
                     ffSsize, ffTsize);
    TffSet = array [ffEnum] of integer;
    Pffset = ^Tffset;

  const
    ffm_builtin: Tffset =
      (13, 14, 9,  14,  24,
          10,  22,  10,
          256,  512);
    ffm_normal: Tffset =
      (31, 22, 7,  36,  55,
          24,  54,  18,
          1024, 1024);
    ffzoomx: array[0..1] of float = (1.0, 0.85);
  var
    ffm: array[0..1] of PffSet = (@ffm_normal, @ffm_builtin);

  type
    TCArray = array of TVector4f;
  var
    ffglyph: array[0..HI_BIF] of TCArray;
    ffmap: array [UnicodeChar] of Longint;
    ffmap_high: integer = 0;

    //FixedFontTexture: array[0..1] of GLint;
    
    //  FixedFontTexture: array[0..1, 0..1] of GLint; //horz and vert MIP maps

  // the font image itself (1024x1024) is split into two 4-bit png files,
  //   this gives the best compression without any visual quality loss
  //   (more than 2x compared to the joint gray+alpha png)

  procedure LoadFixedFontTexture;
  var
    luma, alpha, combi: TImageData;
    x, y, mx, my, cx, cy: integer;
    mtz: GLsizei;
    lumaname, alphaname, filename: string;
//t: integer;
  begin
    if fftAlreadyLoaded then exit;
    try
//t:=GetTickCount;
      glGetIntegerv(GL_MAX_TEXTURE_SIZE, @mtz);

      FillChar(luma, sizeof(TImageData), 0);
      FillChar(alpha, sizeof(TImageData), 0);

      if (Mother^.State.InstallPath='') or (Mother^.State.HomePath='')
        or (mtz < 2048) //usually indicates that there's no support for the luminance+alpha format
        or not FileExists(Mother^.State.InstallPath + ImagesDir + 'fixed_luma.png')
        or not FileExists(Mother^.State.InstallPath + ImagesDir + 'fixed_alpha.png')
      then begin
        //the installation path not found,
        // OR it's the GDI render which doesn't support the GL_LUMINANCE format
        Mother^.Text.FixedFontEmergencyDownsample:= true;
        Mother^.Text.FixedFontQuality:= 1;
        if Mother^.Debug.Verbose then AddLog('Using the built-in low-res font texture: install path'#10#13'  not found or OpenGL doesn''t support the GL_LUMINANCE_ALPHA format.');
      end;

      //the shitty built-in 256x512 w/o shadow
      glGenTextures(1, @BIF[1].Texture);
      glBindTexture(GL_TEXTURE_2D, BIF[1].Texture);
      glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
      glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
      LoadImageFromMemory(@builtin_font, sizeof(builtin_font), luma);
      if Mother^.Text.FixedFontEmergencyDownsample and Mother^.Debug.Verbose
        then AddLog('Using the built-in %0x%1 font texture: install path'#10#13+
                    '  not found or OpenGL doesn''t support GL_LUMINANCE_ALPHA.', [luma.width, luma.height]);
      ConvertImage(luma, ifGray8);
      glTexImage2D (GL_TEXTURE_2D, 0, GL_RGB, luma.width, luma.height, 0, GL_LUMINANCE, GL_UNSIGNED_BYTE, luma.Bits);
      FreeImage(luma);

      Mother^.Text.NumBuiltinFonts:= 1;

      //the quality texture (Liberation Mono Bold) w/shadow
      if not Mother^.Text.FixedFontEmergencyDownsample then begin
        lumaname:= Mother^.State.InstallPath + ImagesDir + 'fixed_luma.png';
        alphaname:= Mother^.State.InstallPath + ImagesDir + 'fixed_alpha.png';
        glGenTextures(1, @BIF[0].Texture);
        glBindTexture(GL_TEXTURE_2D, BIF[0].Texture);
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
        glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, 4);
        filename:= Mother^.State.CacheDir + 'fixedfont.png';
        if FileExists(filename)
        then
          LoadImageFromFile(filename, combi)
        else begin
          LoadImageFromFile(lumaname, luma);
          if (luma.width <> 1024) or (luma.height <> 1024)
            then Die('%0 is not a 1024x1024.', [lumaname]);
          ConvertImage(luma, ifGray8);

          LoadImageFromFile(alphaname, alpha);
          if (alpha.width <> 1024) or (alpha.height <> 1024)
            then Die('%0 is not a 1024x1024.', [alphaname]);
          ConvertImage(alpha, ifGray8);

          NewImage(1024, 1024, ifA8Gray8, combi);

          // combine the separately packed luma and alpha into one A8G8 image:
          for y:=0 to 1023 do
            for x:=0 to 1023 do begin
              pbyte(combi.bits + y*2048 + x*2)^:= pbyte(luma.bits + x + y*1024)^;
              pbyte(combi.bits + y*2048 + x*2 + 1)^:= pbyte(alpha.bits + x + y*1024)^;
            end;
          if Mother^.State.CacheDir <> ''
            then SaveImageToFile(filename, combi);
        end;
        glTexImage2D (GL_TEXTURE_2D, 0, GL_LUMINANCE_ALPHA, 1024, 1024, 0, GL_LUMINANCE_ALPHA, GL_UNSIGNED_BYTE, combi.bits);
        FreeImage(combi);
        FreeImage(alpha);
        FreeImage(luma);
        Mother^.Text.NumBuiltinFonts:= 2;
      end;

      BIF[0].MaxChars:= ffMaxChar;
      BIF[0].TexCoords:= pointer(ffglyph[0]);
      BIF[0].CharMap:= @ffmap;
      BIF[0].CharMapHigh:= ffmap_high;
      BIF[1].MaxChars:= ffMaxChar;
      BIF[1].TexCoords:= pointer(ffglyph[1]);
      BIF[1].CharMap:= @ffmap;
      BIF[1].CharMapHigh:= ffmap_high;
      Mother^.Text.BuiltinFont:= @BIF;
//AddLog('---------- %0', [GetTickCount - t]);
    except
      Die(MI_ERROR_PROGRAMMER_NO_BAKA, ['failed to load the built-in fixed font']);
    end;
    fftAlreadyLoaded:= true;
  end;



  procedure InitFixedFont();
  var
    w: UnicodeChar;
    ghi, x, y, z, f, rf, stubInd: integer;
    c: UnicodeChar;
    s, t, ds, dt: GLfloat;
  begin
    for w:= low(UnicodeChar) to high(UnicodeChar) do ffmap[w]:= -1;

    for z:=0 to 1 do begin
      SetLength(ffglyph[z], 18 * 16);
      ghi:= -1;
      ds:= ffm[z]^[ffGlyphWidth] / ffm[z]^[ffSsize];
      dt:= ffm[z]^[ffGlyphHeight] / ffm[z]^[ffTsize];

      for y:=0 to 17 do
        for x:=0 to 15 do begin
          inc (ghi);
          if z = 0 //glyph set is identic in both fonts
          then begin
            c:= ffcs[y][x + 1]; //extract from string array constant (see above)
            ffmap[c]:= ghi;
            ffmap_high:= math.Max(ffmap_high, ord(c));
            if (x = 5) and (y = 11) then stubInd:= ghi; //the index of  "•", sixt of the twelfth row.
          end;

          s:= (ffm[z]^[ffLeft] + ffm[z]^[ffGridWidth] * x) / ffm[z]^[ffSsize];
          t:= (ffm[z]^[ffTop] + ffm[z]^[ffGridHeight] * y) / ffm[z]^[ffTsize];

          ffglyph[z][ghi][0]:= s;
          ffglyph[z][ghi][1]:= t;
          ffglyph[z][ghi][2]:= s + ds;
          ffglyph[z][ghi][3]:= t + dt;
        end;
    end;

    // fill the entire map with the index of  "•"
    for w:= low(UnicodeChar) to high(UnicodeChar) do
      if ffmap[w] < 0 then ffmap[w]:= stubInd;

    LoadFixedFontTexture;

  end;

 {$include un_fixed_font.inc}

