Type

  { TModule }
  TModuleParams = record
    Name: UnicodeString;
    Dll,
    PureN: ansistring;
    RequiresOpenGL2: boolean;
    ControlLogicThreadStackSize,
    BackgroundThreadStackSize: PtrUint;
  end;

  TModule = class (TObject)
    constructor Create;
    destructor Destroy; OVERRIDE;
  protected
     _Fname, _FromDir, _ToDir, {_Basedir,} _dllname: TFileNameString;
     DLL: {$ifdef unix} pointer {$else} THandle {$endif} ;
     M_Initialize: function(ms: PMother): boolean; cdecl;
     M_Pulse,
     //M_Shutdown,
     M_Cleanup: function (): boolean; cdecl;
     f_dll_age,
     f_bad_age: longint;
     f_reload_failed_msg: UnicodeString;
     f_Index, f_IndexToLoad,
     PrevModuleDateCheckTick,
     ModuleCheckPeriod: longint;
     ListAlreadyBuilt: boolean;
     PureName: AnsiString;
     AssetStorage: array of pointer;  //Index begins from 1! See Mother^.Module.CurrentlyExecutingInd

     procedure _RebuildModulesList;
     procedure _LoadAddresses;
     function _GetProcAddress(ProcName: AnsiString): Pointer;
     function _GetFname: TFileNameString;
     procedure _LoadMeDll(n: TFileNameString);
     procedure _UnloadMeDll;
     procedure _Initialize;
     procedure _SwitchToStopScreen(itisfatal: boolean);
     procedure _BSOD;
     procedure _Processfatality;

     procedure ResetExecutionZoneFlags;

  public
{    ModuleName: array of UnicodeString;
    ModuleDll,
    ModulePureN: array of ansistring;}

    MList: array of TModuleParams; //Index begins at 0, while modules number begin from 1! Add or substract 1 when indexing when needed!
    HasFocus, SwitchedConsoleOff: boolean;

    ReloadAt: longint; //in tickcounts
    AttemptNum: integer;
    //PassThreadDying: procedure(details: PUnicodeChar); cdecl;
   {$ifndef buildmein}
    PassUnhandledException: procedure; cdecl;
    property DllHandle: {$ifdef unix} pointer {$else} THandle {$endif} read DLL;
   {$endif}


//    function InputMessage (msg: TCbMessage; par0, par1, par2: integer): boolean;
//    function ProcessMessage (msg: TCbMessage; par0, par1, par2: integer): boolean;
    procedure Load;
    procedure Unload;
    property ErrorMessage: UnicodeString read f_reload_failed_msg;
    property Fname: TFileNameString read _fname;
    property Index: integer read f_index;
    property IndexToLoad: integer read f_indexToLoad;
//    property Active: boolean read f_active;
//    property Loaded: boolean read f_loaded;

    procedure Reload(i: integer);
    
    function Pulse(): boolean;
    
    procedure EraseSession(modnum: integer); virtual; abstract;
    function GetDefaultNum: integer;

    procedure Checkdate;

    procedure ReactToSpace;
    procedure ReactToEsc;

    procedure GoToModuleSelectionMenu;
    procedure RollBackSession;

    function GetAssetStorage: pointer;
    procedure SetAssetStorage(p: pointer);
    function IsDllLoaded: boolean;
    procedure LoadBIM;
    function StopIfScreenedExceptionPresent: boolean;
 end;


var
  Module: TModule = nil;

