// *----------------------  CORE INTERFACING --------------------------- -------

procedure _ValidateVersion (m, n, b: integer); cdecl;
procedure _ValidateTypesets (i, n: integer); cdecl;
procedure _ValidateTypesetsEq (n: PAnsiChar; v1, v2: integer); cdecl;
procedure _ValidateTypesetsLe (n: PAnsiChar; v1, v2: integer); cdecl;
procedure _AllocateThreadExceptionState(thread_title: PUnicodeChar); cdecl; //to be called by module threads when they begin their Execute()
function _ModuleStopDying(pes: PMotherSehState = nil): PUnicodeChar; cdecl;

procedure _RequestExit (); cdecl;
function GoingDownHard (): boolean; cdecl;
//procedure _cgeHeartBeat (); cdecl;
//function _exp_StopDying (): PUnicodeChar; cdecl;  //M: StopDying
procedure DbgSayW (Yell: PUnicodeChar); cdecl;
//procedure SetDying (d: boolean); cdecl;
procedure _HostDyellW (txt: PUnicodeChar); cdecl;
procedure _HostLogW (txt: PUnicodeChar); cdecl;
function _HostMsg  (M: TMessageId): PUnicodeChar; cdecl;
procedure AddLogOK  (); cdecl;

//This is a per-module setting!
function CgeGetAssetStorageMemoryStream (): pointer; cdecl;
procedure CgeSetAssetStorageMemoryStream (s: pointer); cdecl;
procedure FatalityMessageBox(w: PUnicodeChar); cdecl;

// *----------------- DISPLAY --------------------------------------------------

procedure _cgeSetBackground (FileName: PFileNameChar); cdecl;
procedure _cgeSetBackgroundPtr (p: pointer; size: integer); cdecl;
procedure _cgeDrawBackground (); cdecl;
//function GetWindowExists (): boolean; cdecl;
procedure BeginBlackout(delta: double = 0.0); cdecl;


// *------------------ INPUT ---------------------------------------------------

//function _GetCGM (): integer; cdecl; //reads the message queue;

// *-------------------- CONFIG ------------------------------------------------

procedure _SetConfigInt (section, id: PAnsiChar; Value: integer); cdecl;
function _GetConfigInt (section, id: PAnsiChar): integer; cdecl;
function _GetConfigIntCh (section, id: PAnsiChar; min, max: integer): integer; cdecl;
procedure _SetConfigStr (section, id, Value: PAnsiChar); cdecl;
function _GetConfigStr (section, id: PAnsiChar): PAnsiChar; cdecl;



// *--------------------------------- OPENGL HELPERS AND WRAPPERS --------------

procedure _CgeSwapBuffers (); cdecl;
procedure _CgeBuildAlphaMipmaps (Width, Height: integer; Data: pointer); cdecl;
function exGetGlProcAddress (ProcName: PAnsiChar; Suffix: PAnsiChar = nil): Pointer; cdecl; //M: GetGLProcAddress
function exGetGlProcAddress2 (ProcName, Suffix1, Suffix2: PAnsiChar): Pointer; cdecl; // M: GetGLProcAddress2

//function GetHigherPowerOf2 (i: integer): integer; cdecl;
//function GetLowerPowerOf2 (i: integer): integer; cdecl;


// * --------------------------------- SOUND ------------------------------------
function exGetALProcAddress (ProcName: PAnsiChar): Pointer; cdecl; //M: GetALProcAddress

//the data format is always 16 bits stereo.
procedure CgeNewSoundData (begins: TDateTime; samples, rate: integer; data: pointer); cdecl;
procedure CgeSetSoundVolume (volume: float); cdecl;

procedure _PlaySound (Wavfilename: PAnsiChar); cdecl;



//  *-------------------------------- FILE MANAGEMENT ----------------------

//procedure _MakeSurePathExists (path: PAnsiChar); cdecl;
//function _UnmangleFileName (m: PFileNameChar): PFileNameChar; cdecl;
//function _MangleFileName (m: PFileNameChar): PFileNameChar; cdecl;
//procedure _GetFileHash (name: PAnsiChar; phash: PAssetHash); cdecl;
//function _GetFileDateTime (name: PAnsiChar): TDateTime; cdecl;
//function _GetIsHashvalid (phash: pMd5Digest): boolean; cdecl;

// *--------------------- KEEPING MODULE RESOURCES -------------------------

procedure GenHash (phash: PAssetHash); cdecl;
//procedure StoreResource (phandle: pDWORD; phash: PAssetHash; ChepersyClassIndex: integer); cdecl;
//function ClaimResource (phash: PAssetHash): PAssetRecord; cdecl;
//function GetFirstResource (): PAssetRecord; cdecl;
//function GetNextResource (): PAssetRecord; cdecl;
//procedure ClearResourceList (); cdecl;
function HashesMatch (a, b: PAssetHash): boolean; cdecl;


// ---------- ACCESS TO MEMORY ALLOCATED BY MOTHER ------------------------

//These are used for storing the classes information:
function CgeCreateMemoryStream_ (): pointer; cdecl;
///procedure CgeDeleteMemoryStream (s: pointer); cdecl;
//procedure CgeSeekMemoryStream (s: pointer; pos: integer); cdecl;
//procedure CgeWriteToMemoryStream (s: pointer; buf: pointer; len: integer); cdecl;
//function CgeReadFromMemoryStream (s: pointer; buf: pointer; len: integer): integer; cdecl;
//procedure CgeWriteIntToMemoryStream (s: pointer; i: integer); cdecl;
//function CgeReadIntFromMemoryStream (s: pointer): integer; cdecl;
function CgeGetMemoryStreamMem (s: pointer): pointer; cdecl;
//function CgeGetMemoryStreamSize (s: pointer): integer; cdecl;
//procedure CgeMemoryStreamLoadFromFile (s: pointer; name: PAnsiChar); cdecl;
//procedure CgeMemoryStreamSaveToFile (s: pointer; name: PAnsiChar); cdecl;



function CgeGetHostMem (size: integer): pointer; cdecl;
procedure CgeFreeHostMem (p: pointer); cdecl;
function CgeReallocHostMem (p: pointer; newsize: integer): pointer; cdecl;

// -------------- ACCESS TO STREAMS OWNED BY MOTHER --------------------------

function CgeCreateFileStream(name: PFileNameChar; Mode: Word): pointer; cdecl;
function CgeGetStreamSize(s:pointer): Int64; cdecl;
procedure CgeSetStreamSize(s:pointer; const NewSize: Int64); cdecl;
function CgeReadFromStream(s:pointer; Buf: pointer; Count: Longint): Longint; cdecl;
function CgeWriteToStream(s:pointer; Buf: pointer; Count: Longint): Longint; cdecl;
function CgeGetStreamPosition(s:pointer): Int64; cdecl;
procedure CgeSetStreamPosition (s:pointer; const Pos: Int64); cdecl;
procedure CgeFreeStream (var s: pointer) cdecl;

// *-------------------------------- MOUSE POINTER -----------------------------

//procedure CgeLoadCursorFromFile (FileName: PFileNameChar; xhotspot, yhotspot: integer); cdecl;
//procedure CgeLoadCursorFromMemory (pfile: pointer; size, xhotspot, yhotspot: integer); cdecl;

//Remember, kids! 32x32 only!
procedure CgeLoadCursorFromRawPixmap (pixels: pointer; xhotspot, yhotspot: integer); cdecl;
procedure CgeEmptyCursor (); cdecl;
procedure CgeStandardCursor (); cdecl;
procedure CgeHourglassCursor (); cdecl;

// *-------------------------------------- TIMER -------------------------------

function Second (): double; cdecl;
function UsecDelta (ptsc: pqword): double; cdecl;


// *----------------------------------- VAMPYRE IMAGING -------------------------

procedure DeletePic (name: pointer); cdecl;
function LoadPic (FileName: PFileNameChar): pointer; cdecl;
function LoadPicAs (FileName: PFileNameChar; format: GLenum): pointer; cdecl;
function LoadPicFromMem (p: pointer; size: integer): pointer; cdecl;
function LoadPicFromMemAs (p: pointer; size: integer; format: GLenum): pointer; cdecl;

function CreatePic (width, height: integer; format: GLuint): pointer; cdecl;

procedure SavePic (FileName: PFileNameChar; name: pointer); cdecl;

procedure ResizePic (name: pointer; newwidth, newheight: integer); cdecl;
procedure ResamplePic (name: pointer; newwidth, newheight: integer; wrap: boolean); cdecl;
function ClonePic (name1: pointer): pointer; cdecl;
function CloneResamplePic (name1: pointer; newwidth, newheight: integer; wrap: boolean; newformat: GLuint = 0): pointer; cdecl;

function GetPicFmt (name: pointer): GLuint; cdecl;
procedure SetPicFmt(name: pointer; format: GLuint); cdecl;

function GetPicPixels (name: pointer): pointer; cdecl;
function GetPicWidth (name: pointer): integer; cdecl;
function GetPicHeight (name: pointer): integer; cdecl;
function GetPicBytes (name: pointer): integer; cdecl;

// * -------------------------------- FONT MANAGEMENT ---------------------------

//procedure cgeffSizeToFace (size: integer; face: Pinteger; zoom: PGLfloat); cdecl;
//procedure cgeffFitStringIntoRectangle (Size, numChars, numLines, Width, Height: integer; fit: PStringFitRec);  cdecl;
//function cgeffGetStringWidth (Size, numChars: integer): GLfloat; cdecl;
//function cgeffGetStringHeight (Size, numLines: integer): GLfloat; cdecl;

//the caller is responsible for switching to FFP and setting the ortho projection!
//procedure cgeffSetRenderState (noshadow: boolean); cdecl;
//procedure cgeffRenderString (fit: PStringFitRec; Left, Top: glFloat; w: PUnicodeChar); cdecl;

