{
    This file is part of Chentrah,
    Copyright (C) 2004-2008 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************}

  function _HashesMatch(a, b: PAssetHash): longbool;
  begin
    if not Assigned(a) and not Assigned(b) then Exit(Yes); //nil+nil=true
    if not Assigned(a) or not Assigned(b) then Exit(No);
    Result:=
        (a^.Q1 = b^.Q1) and (a^.Q2 = b^.Q2) and (a^.Q3 = b^.Q3) and (a^.Q4 = b^.Q4);
  end;

  function _HashesMatch2(var a: TAssetHash; b: PAssetHash): longbool;
  begin
    if not Assigned(b) then Exit(No);
    Result:=
      (a.Q1 = b^.Q1) and (a.Q2 = b^.Q2) and (a.Q3 = b^.Q3) and (a.Q4 = b^.Q4);
  end;

  function HashesMatch(a, b: PAssetHash): longbool; cdecl;
  begin
   try
    Result:=_HashesMatch(a, b);
   except
    ProcessGuardedException();
   end;
  end;

  procedure _GenHash (phash: PAssetHash);
  begin
    phash^.Q1:= 0; //clear md5 checksum
    phash^.Q2:= 0;
    phash^.Date:= Now();
    phash^.TSC:= GetTimeStamp();
  end;
  
  
  procedure GenHash (phash: PAssetHash); cdecl;
  begin
   try
    _GenHash(phash);
   except
    ProcessGuardedException();
   end;
  end;
  
function CgeGetAssetStorageMemoryStream (): pointer; cdecl;
begin
//addlog('CgeGetAssetStorageMemoryStream: Mother^.Module.CurrentlyExecutingInd = %0',[Mother^.Module.CurrentlyExecutingInd]);
  try
  //if Mother^.Module.CurrentlyExecutingInd > High(AssetStorage) then Raise Exception.Create('Invalid Mother^.Module.CurrentlyExecutingInd ' + IntToStr(Mother^.Module.CurrentlyExecutingInd) + ' vs ' + IntToStr(High(AssetStorage)));
    EnterCriticalSectionWv(Mother^.Core.AssetStorageCriticalSection);
    try
      Result:= Module.GetAssetStorage();
    finally
      LeaveCriticalSection(Mother^.Core.AssetStorageCriticalSection)
    end;
  except
   ProcessGuardedException();
  end;
end;

procedure CgeSetAssetStorageMemoryStream (s: pointer); cdecl;
begin
//addlog('CgeSetAssetStorageMemoryStream: Mother^.Module.CurrentlyExecutingInd = %0',[Mother^.Module.CurrentlyExecutingInd]);
 try
  //now this check fails due to multi-threadingness if (Mother^.Module.CurrentlyExecutingInd < 0) or (Mother^.Module.CurrentlyExecutingInd > High(AssetStorage)) then Raise Exception.Create('Invalid Mother^.Module.CurrentlyExecutingInd ' + IntToStr(Mother^.Module.CurrentlyExecutingInd));
  EnterCriticalSectionWv(Mother^.Core.AssetStorageCriticalSection);
  try
    Module.SetAssetStorage(s);
  finally
    LeaveCriticalSection(Mother^.Core.AssetStorageCriticalSection)
  end;
 except
  ProcessGuardedException();
 end;
end;


{***********************************************************************}

{
procedure krah(i: integer);
begin
  try
    case i of
      1: raise Exception.create('TEST');
      2: Die('BOOM!');
      3: byte(nil^):=0;
    end;
  except
    raise Exception.create('Krah: ' + (ExceptObject as Exception).Message);
  end;

end;
}

function CgeCreateMemoryStream_ (): pointer; cdecl;
begin
 try
  Result:=Pointer(TMemoryStream.Create);
  // krah(3);
   except
    ProcessGuardedException();
   end;
end;

function CgeGetMemoryStreamMem (s: pointer): pointer; cdecl;
begin
 try
  Result:=TMemoryStream(s).Memory;
   except
    ProcessGuardedException();
   end;
end;


function CgeGetHostMem (size: integer): pointer; cdecl;
begin
 try
  Result:=GetMem(size);
   except
    ProcessGuardedException();
   end;
end;

procedure CgeFreeHostMem (p: pointer); cdecl;
begin
 try
  FreeMem(p);
   except
    ProcessGuardedException();
   end;
end;

function CgeReallocHostMem (p: pointer; newsize: integer): pointer; cdecl;
begin
 try
  Result:=ReallocMem(p, newsize);
   except
    ProcessGuardedException();
   end;
end;



function CgeCreateFileStream(name: PFileNameChar; Mode: Word): pointer; cdecl;
begin
 try
  Result:= pointer(
    TFileStream.Create(
      UnmangleFileName(
        PFileNameCharToFileNameString(
          name
        )
      )
      , mode
    )
  );
  TFileStream(Result).Position:= 0;
 except
  ProcessGuardedException();
 end;
end;

function CgeGetStreamSize(s:pointer): Int64; cdecl;
begin
 try
  Result:= TStream(s).Size;
 except
  ProcessGuardedException();
 end;
end;

procedure CgeSetStreamSize(s:pointer; const NewSize: Int64); cdecl;
begin
 try
  TStream(s).Size:= NewSize;
   except
    ProcessGuardedException();
   end;
end;

function CgeReadFromStream(s:pointer; Buf: pointer; Count: Longint): Longint; cdecl;
begin
 try
  Result:= TStream(s).Read(Buf^, Count);
   except
    ProcessGuardedException();
   end;
end;

function CgeWriteToStream(s:pointer; Buf: pointer; Count: Longint): Longint; cdecl;
begin
 try
  Result:= TStream(s).Write(Buf^, Count);
   except
    ProcessGuardedException();
   end;
end;

function CgeGetStreamPosition(s:pointer): Int64; cdecl;
begin
 try
  Result:= TStream(s).Position;
   except
    ProcessGuardedException();
   end;
end;

procedure CgeSetStreamPosition (s:pointer; const Pos: Int64); cdecl;
begin
 try
  TStream(s).Position:= Pos;
   except
    ProcessGuardedException();
   end;
end;

procedure CgeFreeStream (var s: pointer) cdecl;
begin
 if not Assigned(s) then exit;
 try
  TStream(s).Free;
  s:= nil;
   except
    ProcessGuardedException();
   end;
end;







