{
    This file is part of Chentrah,
    Copyright (C) 2004-2010 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************

    Windows intel 32-bit only.

    This unit is to copensate for the bug
      http://bugs.freepascal.org/view.php?id=4605
      also known as
      http://bugs.freepascal.org/view.php?id=12974

    There is a hack for the Windows Structured Exception Handling
      mechanism allowing to catch AVs and other system exceptions
      in a DLL (typically these just ignore the try...except blocks
      not belonging to the main executable).

    Without this module, any errors in one of the threads created by the
      game module DLL would cause a silent crash-to-desktop.

    This unit has some definitions borrowed from the System unit of the
      FreePascal RTL since these were defined in the implementation section.

 **********************************************************************}
{$codepage utf-8}

{$if not defined(windows)}// or not defined(cpu32)}
  {$fatal This unit is only wor Win32}
{$endif}

{$rangechecks off}
{$overflowchecks off}

unit cl_seh_hack_win32;

interface

uses SysUtils, Classes, Windows;

  procedure InitSehHack;
  procedure TerminateSehHack;

implementation
  uses cge;
  {$ifdef cpu64}
//Copy-pasted from the System unit (FPC 2.6.4)--------------------------------\

type
  M128A = record
    Low : QWord;
    High : Int64;
  end;

  PContext = ^TContext;
  TContext = record
    P1Home : QWord;
    P2Home : QWord;
    P3Home : QWord;
    P4Home : QWord;
    P5Home : QWord;
    P6Home : QWord;
    ContextFlags : DWord;
    MxCsr : DWord;
    SegCs : word;
    SegDs : word;
    SegEs : word;
    SegFs : word;
    SegGs : word;
    SegSs : word;
    EFlags : DWord;
    Dr0 : QWord;
    Dr1 : QWord;
    Dr2 : QWord;
    Dr3 : QWord;
    Dr6 : QWord;
    Dr7 : QWord;
    Rax : QWord;
    Rcx : QWord;
    Rdx : QWord;
    Rbx : QWord;
    Rsp : QWord;
    Rbp : QWord;
    Rsi : QWord;
    Rdi : QWord;
    R8 : QWord;
    R9 : QWord;
    R10 : QWord;
    R11 : QWord;
    R12 : QWord;
    R13 : QWord;
    R14 : QWord;
    R15 : QWord;
    Rip : QWord;
    Header : array[0..1] of M128A;
    Legacy : array[0..7] of M128A;
    Xmm0 : M128A;
    Xmm1 : M128A;
    Xmm2 : M128A;
    Xmm3 : M128A;
    Xmm4 : M128A;
    Xmm5 : M128A;
    Xmm6 : M128A;
    Xmm7 : M128A;
    Xmm8 : M128A;
    Xmm9 : M128A;
    Xmm10 : M128A;
    Xmm11 : M128A;
    Xmm12 : M128A;
    Xmm13 : M128A;
    Xmm14 : M128A;
    Xmm15 : M128A;
    VectorRegister : array[0..25] of M128A;
    VectorControl : QWord;
    DebugControl : QWord;
    LastBranchToRip : QWord;
    LastBranchFromRip : QWord;
    LastExceptionToRip : QWord;
    LastExceptionFromRip : QWord;
 end;

type
  PExceptionRecord = ^TExceptionRecord;
  TExceptionRecord = record
    ExceptionCode   : DWord;
    ExceptionFlags  : DWord;
    ExceptionRecord : PExceptionRecord;
    ExceptionAddress : Pointer;
    NumberParameters : DWord;
    ExceptionInformation : array[0..EXCEPTION_MAXIMUM_PARAMETERS-1] of Pointer;
  end;

  PExceptionPointers = ^TExceptionPointers;
  TExceptionPointers = packed record
    ExceptionRecord   : PExceptionRecord;
    ContextRecord     : PContext;
  end;
  {$else cpu64}
  //Copy-pasted from the System unit (FPC 2.2.4)--------------------------------\
  const
    EXCEPTION_EXECUTE_HANDLER    =  1;
    EXCEPTION_CONTINUE_EXECUTION = -1;
    EXCEPTION_CONTINUE_SEARCH    =  0;
    EXCEPTION_MAXIMUM_PARAMETERS = 15;
    MAXIMUM_SUPPORTED_EXTENSION  = 512;

  type
    PFloatingSaveArea = ^TFloatingSaveArea;
    TFloatingSaveArea = packed record
            ControlWord : Cardinal;
            StatusWord : Cardinal;
            TagWord : Cardinal;
            ErrorOffset : Cardinal;
            ErrorSelector : Cardinal;
            DataOffset : Cardinal;
            DataSelector : Cardinal;
            RegisterArea : array[0..79] of Byte;
            Cr0NpxState : Cardinal;
    end;

    PContext = ^TContext;
    TContext = packed record
        //
        // The flags values within this flag control the contents of
        // a CONTEXT record.
        //
            ContextFlags : Cardinal;

        //
        // This section is specified/returned if CONTEXT_DEBUG_REGISTERS is
        // set in ContextFlags.  Note that CONTEXT_DEBUG_REGISTERS is NOT
        // included in CONTEXT_FULL.
        //
            Dr0, Dr1, Dr2,
            Dr3, Dr6, Dr7 : Cardinal;

        //
        // This section is specified/returned if the
        // ContextFlags word contains the flag CONTEXT_FLOATING_POINT.
        //
            FloatSave : TFloatingSaveArea;

        //
        // This section is specified/returned if the
        // ContextFlags word contains the flag CONTEXT_SEGMENTS.
        //
            SegGs, SegFs,
            SegEs, SegDs : Cardinal;

        //
        // This section is specified/returned if the
        // ContextFlags word contains the flag CONTEXT_INTEGER.
        //
            Edi, Esi, Ebx,
            Edx, Ecx, Eax : Cardinal;

        //
        // This section is specified/returned if the
        // ContextFlags word contains the flag CONTEXT_CONTROL.
        //
            Ebp : Cardinal;
            Eip : Cardinal;
            SegCs : Cardinal;
            EFlags, Esp, SegSs : Cardinal;

        //
        // This section is specified/returned if the ContextFlags word
        // contains the flag CONTEXT_EXTENDED_REGISTERS.
        // The format and contexts are processor specific
        //
            ExtendedRegisters : array[0..MAXIMUM_SUPPORTED_EXTENSION-1] of Byte;
    end;

  type
    PExceptionRecord = ^TExceptionRecord;
    TExceptionRecord = packed record
            ExceptionCode   : cardinal;
            ExceptionFlags  : Longint;
            ExceptionRecord : PExceptionRecord;
            ExceptionAddress : Pointer;
            NumberParameters : Longint;
            ExceptionInformation : array[0..EXCEPTION_MAXIMUM_PARAMETERS-1] of Pointer;
    end;

    PExceptionPointers = ^TExceptionPointers;
    TExceptionPointers = packed record
            ExceptionRecord   : PExceptionRecord;
            ContextRecord     : PContext;
    end;
 {$endif cpu64}
  { type of functions that should be used for exception handling }
    TTopLevelExceptionFilter
         = function (excep : PExceptionPointers) : Longint; stdcall;

  function SetUnhandledExceptionFilter( lpTopLevelExceptionFilter:
                            TTopLevelExceptionFilter) : TTopLevelExceptionFilter;
        stdcall; external 'kernel32' name 'SetUnhandledExceptionFilter';

  //end copy-paste --------------------------------------------------------------/

 var
   OldFilter: TTopLevelExceptionFilter = nil;

  procedure JumpToDllRaiseFunction; {$if FPC_FULLVERSION>=20800} noreturn; {$endif}
  begin
    SysResetFPU;

    Module.PassUnhandledException;

    repeat sleep(1000) until false; //lock up if unthinkable happens
  end;

{ support for violation addresses.

http://msdn.microsoft.com/en-us/library/windows/desktop/aa363082%28v=vs.85%29.aspx

ExceptionInformation
    An array of additional arguments that describe the exception. The RaiseException function can specify this array of arguments. For most exception codes, the array elements are undefined. The following table describes the exception codes whose array elements are defined.
    Exception code	Meaning

    EXCEPTION_ACCESS_VIOLATION
    The first element of the array contains a read-write flag that indicates the type of operation that caused the access violation. If this value is zero, the thread attempted to read the inaccessible data. If this value is 1, the thread attempted to write to an inaccessible address. If this value is 8, the thread causes a user-mode data execution prevention (DEP) violation.
    The second array element specifies the virtual address of the inaccessible data.

    EXCEPTION_IN_PAGE_ERROR
    The first element of the array contains a read-write flag that indicates the type of operation that caused the access violation. If this value is zero, the thread attempted to read the inaccessible data. If this value is 1, the thread attempted to write to an inaccessible address. If this value is 8, the thread causes a user-mode data execution prevention (DEP) violation.
    The second array element specifies the virtual address of the inaccessible data.
    The third array element specifies the underlying NTSTATUS code that resulted in the exception.
}

  function GetModuleByAddr(addr: pointer): THandle;
  var
    Tmm: TMemoryBasicInformation;
  begin
    if (ptruint(addr) < $ffff)
      or (ptruint(addr) > {$ifdef cpu64}$ffffffffffff0000{$else}$ffff0000{$endif})
    then Result:= 0
    else begin
      if VirtualQuery(addr, @Tmm, SizeOf(Tmm)) <> sizeof(Tmm)
        then Result:= 0
        else Result:= THandle(Tmm.AllocationBase);
    end;
  end;

  function MyExceptionFilter(excep : PExceptionPointers) : Longint;  stdcall;
  var
    pes: PMotherSehState;
  begin
//bgsay('* MyExceptionFilter');
//bgsay('   Exception code = '+ IntToHex(excep^.ExceptionRecord^.ExceptionCode,8)) ;
//bgsay('   IP = '+ IntToHex(excep^.ContextRecord^.{$ifdef cpu64}Rip{$else}Eip{$endif} ,8)) ;
//bgsay('   Addr = '+ IntToHex(dword(excep^.ExceptionRecord^.ExceptionAddress) ,8)) ;
//bgsay('   Thread ID=' + IntToHex(GetCurrentTHreadID(), 8));
//bgsay('   Main thread ID=' + IntToHex(Mother^.State.MainThreadId, 8)) ;


    pes:= GetExceptionState();

//writeln('========= pes=', IntToHex(ptruint(pes), 8));
//if assigned(pes) then //bgsay('  pes^.StackSegment=' + IntToHex(pes^.StackSegment, 8)+ ', SS=' + IntToHex(excep^.ContextRecord^.SegSs, 8));
    if not Assigned(pes) //or (pes^.StackSegment <> excep^.ContextRecord^.SegSs)
      then Exit(OldFilter(excep));

//bgsay('   pes='+ IntToHex(dword(pes), 8));
//writeln('   pes^.IsModuleThread='+ IntToStr(ord(pes^.IsModuleThread)));
//bgsay('   pes^.ThreadTitle='+ pes^.ThreadTitle);
//bgsay('   pes^.ModuleIsAlreadyProcessingUnhandledException='+ IntToStr(ord(pes^.ModuleIsAlreadyProcessingUnhandledException)));
//writeln('   Addr belongs to the EXE='+ IntToStr(Ord(Mother^.State.ExeHandle = GetModuleByAddr(pointer(excep^.ContextRecord^.{$ifdef cpu64}Rip{$else}Eip{$endif})))));
//writeln('   Addr belongs to the DLL='+ IntToStr(Ord(Module.DllHandle = GetModuleByAddr(pointer(excep^.ContextRecord^.{$ifdef cpu64}Rip{$else}Eip{$endif})))));

//save the bloody details
    pes^.ExceptionCode:= excep^.ExceptionRecord^.ExceptionCode;
    pes^.ExceptionAddress:= excep^.ContextRecord^.{$ifdef cpu64}Rip{$else}Eip{$endif};


    if excep^.ExceptionRecord^.ExceptionCode = $C0000005 then begin
      pes^.AVMemoryOperation:= ptruint(excep^.ExceptionRecord^.ExceptionInformation[0]);
      pes^.AVMemoryAddress:= ptruint(excep^.ExceptionRecord^.ExceptionInformation[1]);
//bgsay('   AV memory address = '+ IntToHex(pes^.AVMemoryAddress, 8));
//bgsay('   AV memory operation = '+ IntToStr(pes^.AVMemoryOperation));

    end;

    if
      not Mother^.State.Terminated
      and Assigned(Module) and Assigned(Module.PassUnhandledException) //DLL is loaded
      and not pes^.ModuleIsAlreadyProcessingUnhandledException
      and (
        (
          (Module.DllHandle
            = GetModuleByAddr(pointer(excep^.ContextRecord^.{$ifdef cpu64}Rip{$else}Eip{$endif})))
          { Case 1. Exception is in the DLL code. Whatever the thread is,
            pass it to the module. }
        )
       or
        (
          (
            (pes^.IsModuleThread)//ThreadId <> Mother^.State.MainThreadId)
           or
            (
              { This case filters calls to uninitialized procedure variables
                in the main thread by the module }
              (pes^.ThreadId = Mother^.State.MainThreadId)
              and
              (Mother^.Module.CurrentlyExecutingInd <> NOT_A_MODULE)
            )

          )
          and (Mother^.State.ExeHandle
            <> GetModuleByAddr(pointer(excep^.ContextRecord^.{$ifdef cpu64}Rip{$else}Eip{$endif})))
          { Case 2. The thread belongs to the module. If the address is
            outside the EXE, pass it to the module even if the address
            is outside the DLL as well. Assume it is in some system dll
            the module DLL has called. }
         )

{
this condition only worked while the architecture remained single-threaded
       (
         (pes^.ThreadId = Mother^.State.MainThreadId)
         and (Mother^.Module.CurrentlyExecutingInd
            <> NOT_A_MODULE) //we are really in the process of calling one of the the DLL functions
       )
}
      )
    then begin
//bgsay('   Passing to module.');

      pes^.ModuleIsAlreadyProcessingUnhandledException:= true;


      //cheat by changing the return address to the function
      //  that calls the module to raise its own language exception
      excep^.ContextRecord^.{$ifdef cpu64}Rip{$else}Eip{$endif} := ptruint (@JumpToDllRaiseFunction);

      //tell Windows: we have corrected the problem, go on.
      excep^.ExceptionRecord^.ExceptionCode := 0;
      Result := EXCEPTION_CONTINUE_EXECUTION;
    end
    else begin
//bgsay('  Calling the old handler.');

      Result:= OldFilter(excep);
    end;
  end;

  procedure InitSehHack;
  begin
    Mother^.State.ExeHandle:= GetModuleByAddr (@InitSehHack);
    Mother^.State.MainThreadId:= GetCurrentThreadId;
    OldFilter:= SetUnhandledExceptionFilter(@MyExceptionFilter);
    if not Assigned(OldFilter) then Die(RuEn(
      'Не удалось установить фильтр обработки исключений',
      'Failed to install the unhandled exception filter'));
  end;

  procedure TerminateSehHack;
  begin
    if Assigned(OldFilter) then SetUnhandledExceptionFilter(OldFilter);
  end;

end.
