procedure InitStubTexture;
var
  image: array[0..1] of TImageData;
  imagename: TFileNameString;
  i, j, x, y : integer;
begin
  imagename:= Mother^.State.InstallPath + ImagesDir + 'missingno.png';
  if (Mother^.State.InstallPath <> '') and FileExists(imagename) then begin
      LoadImageFromFile(imagename, image[0]);
      ConvertImage(image[0], ifR8G8B8);
//SaveImageToFile(Mother^.State.InstallPath + ImagesDir + 'missingno0.png', image[0]);
      NewImage(image[0].width, image[0].height, ifR8G8B8, image[1]);
      for i:=0 to image[0].width * image[0].height * 3 - 1 do
        pbyte(image[1].bits + i)^:= $ff - pbyte(image[0].bits + i)^;
//SaveImageToFile(Mother^.State.InstallPath + ImagesDir + 'missingno1.png', image[1]);
  end else begin
    if Mother^.Debug.Verbose then AddLog('Stub texture image %0 not found, using black and white stub stubs.', [Mother^.State.InstallPath + ImagesDir + 'missingno.png']);
    NewImage(16, 16, ifR8G8B8, image[0]);
    NewImage(16, 16, ifR8G8B8, image[1]);
    for j:= 0 to 1 do
      for i:=0 to 256 * 3 - 1 do
        pbyte(image[j].bits + i)^:= byte($ff * j);
  end;
  for i:= 0 to 1 do begin
    glGenTextures(1, @StubTexture[i]);
    glBindTexture(GL_TEXTURE_2D, StubTexture[i]);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexImage2D (GL_TEXTURE_2D, 0, GL_RGB, image[i].width, image[i].height, 0, GL_RGB, GL_UNSIGNED_BYTE, image[i].bits);
    FreeImage(image[i]);
  end;
  SwapStubTexture;
end;

procedure SwapStubTexture;
begin
  Inc(CurrentStubTextureInd);
//  if CurrentStubTextureInd > High(StubTexture) then CurrentStubTextureInd:= 0;
  if Frac(Now() * 86400 / 2) < 0.5
    then CurrentStubTextureInd:= 0
    else CurrentStubTextureInd:= 1;
  Mother^.GAPI.StubTexture:= StubTexture[CurrentStubTextureInd];
end;
