{
    This file is part of Chentrah,
    Copyright (C) 2004-2008 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************}






{
  var doubleBufferAttributes: array [0..12] of cint = (
        GLX_DRAWABLE_TYPE, GLX_WINDOW_BIT,
        GLX_RENDER_TYPE,  GLX_RGBA_BIT,
        GLX_DOUBLEBUFFER,  1,     // Request a double-buffered color buffer with
        GLX_RED_SIZE,      8,     // the maximum number of bits per component
        GLX_GREEN_SIZE,    8,
        GLX_BLUE_SIZE,     8,
//        GLX_DEPTH_SIZE,   24,
        None
  );
}


var pfd: array //[0..5] of cint =
  //(GLX_RENDER_TYPE, GLX_RGBA, GLX_DOUBLEBUFFER, GLX_DEPTH_SIZE, 0, 0);//GLX_DEPTH_SIZE, 16, 0);
  {We don't need a depth buffer because the scene will be
    rendered into a FBO with its own depth buffer}
 //This work in Ubuntu 11.10 but Ubuntu 16.10 say:
 //libGL error: No matching fbConfigs or visuals found
 //libGL error: failed to load driver: swrast

 //Copying from ZenGL:
 [0..14] of cint = (
  GLX_RGBA, GL_TRUE,
  GLX_RED_SIZE, 8,
  GLX_GREEN_SIZE, 8,
  GLX_BLUE_SIZE, 8,
  GLX_ALPHA_SIZE,
      // NVIDIA sucks!
      0, //index 9 //8 * Byte( not appInitedToHandle );
  GLX_DOUBLEBUFFER, GL_TRUE,
  GLX_DEPTH_SIZE, 0, //index 13
  0
  );

  procedure TX11Framework.InitGLFirstStage;
  var
    depth, a, alpha: cint;
  begin
    if GLInitialized then Exit;

    InitOpenGL;
    case Mother^.GAPI.Mode of
      gapi_DeprecatedImmediateGL,
      gapi_GL21: begin
        //just like ZenGL does, but while ZenGL tries to find
        // largest depth buffer, we prefer none at all. FBO rulez.
        VisualInfo:= nil;
        for a:= 0 to 1 do begin
          alpha:= a * 8;
          pfd[9]:= alpha;
          depth:= 0;
          while not Assigned(VisualInfo) and (depth <= 32) do begin
            pfd[13]:= depth;
            VisualInfo:= GlXChooseVisual(Display, screen, @(pfd[0]));
            if Mother^.Debug.Verbose then
              if Assigned(VisualInfo)
                then AddLog('  Visual found for alpha=%0, depth=%1',[alpha, depth])
                else AddLog('  No visual found for alpha=%0, depth=%1',[alpha, depth]);
            depth+= 8;
          end;
          if Assigned(VisualInfo) then break;
        end;
        if not Assigned(VisualInfo) then
          Die(MI_ERROR_CANTINITOPENGL,['glXChooseVisual() returned NULL']);
      end;
      gapi_GLES2: begin
        New(VisualInfo);
        XMatchVisualInfo(Display, screen, DefaultDepth(Display, screen), TrueColor, VisualInfo);

        eDisplay:= eglGetDisplay(display);
        if eDisplay = EGL_NO_DISPLAY then Die(MI_ERROR_CANTINITOPENGL,['eglGetDisplay() returned 0']);

      end;
      else
        DieUnsupportedGLMode;
    end;
  end;

  procedure TX11Framework.InitGL;
  var
    rr, rg, rb, ra, rd, rs,  vhi, vmed: integer;
  begin

    if GLInitialized then Exit;

    if Mother^.Debug.Verbose then AddLog('  Second stage of OpenGL initialization...');

    {Had we need to support FSAA, the pixel format selection would
     be much more elaborate. But as we use manual oversampling via
     rendering into an oversized texture instead, no FSAA is required.}

    if Mother^.Debug.Verbose then AddLog('    Creating rendering context...');

    RenderingContext:= glXCreateContext(Display, VisualInfo, nil, true);
    if not Assigned(RenderingContext) then begin
      RenderingContext:= glXCreateContext(Display, VisualInfo, nil, false);
      if Assigned(RenderingContext) then AddLog(RuEn(
        '  Не удалось создать контекст с прямым подключением. Возможно, аппаратное ускорение недоступно!',
        '  Failed to create direct rendering context. Hardware acceleration may not be available.'));
    end;
    if not Assigned(RenderingContext)
      then Die(MI_ERROR_CANTINITOPENGL,['glXCreateContext() returned NULL']);

    if Mother^.Debug.Verbose then AddLog('    Making the rendering context current...');

    if not glXMakeCurrent(Display, Windowhandle, RenderingContext)
      then Die(MI_ERROR_CANTINITOPENGL,['glXMakeCurrent() returned FALSE']);
      
    CheckGLVersion;

    glXGetConfig(Display, VisualInfo, GLX_RED_SIZE, rr);
    glXGetConfig(Display, VisualInfo, GLX_GREEN_SIZE, rg);
    glXGetConfig(Display, VisualInfo, GLX_BLUE_SIZE, rb);
    glXGetConfig(Display, VisualInfo, GLX_ALPHA_SIZE, ra);
    glXGetConfig(Display, VisualInfo, GLX_DEPTH_SIZE, rd);
    glXGetConfig(Display, VisualInfo, GLX_STENCIL_SIZE, rs);
    AddLog(MI_LOG_Screen_format, [
      Mother^.Display.WindowClientRect.Width, Mother^.Display.WindowClientRect.Height,
      rr, rg, rb, ra, rd, rs]);

    LoadOpenGLFunctions;

    GLInitialized:=Yes;

    if Assigned(@glXSwapIntervalSGI) then begin
      if glXSwapIntervalSGI(1) > 0
        then GivePeriodicWarning(1.0, 'unable-to-turn-vsync-off', MI_WARN_WARNING,
              MI_SWAP_CRAP, [RuEn(
             'OpenGL отказалась отключить Vsync.'
            ,'OpenGL refused to switch Vsync off.')])
        else
          if Mother^.Debug.Verbose then AddLog('Vsync disabled.');
    end
    else GivePeriodicWarning(7.0, 'unable-to-turn-vsync-off', MI_WARN_WARNING,
              MI_SWAP_CRAP, [RuEn(
               'Не поддерживается GLX_SGI_swap_control',
               'GLX_SGI_swap_control not supported')]);
  end;




  Procedure TX11Framework.CloseGL;
  begin
    if not GLInitialized then Exit;

    if Mother^.Debug.Verbose then AddLog('ClosingOpenGL...');


    if not GoingDownHard and Mother^.Display.WindowExists
      then GLXDestroyContext(Display, RenderingContext);


    //выгружаем DLL
    CloseOpenGL;

    if Mother^.Debug.Verbose then AddLogOk;
  end;



