{
    This file is part of Chentrah,
    Copyright (C) 2004-2016 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************

  Only devices compatible with Xbox360 are supported,
   thanks to Microsoft providing us developers with a *really* simple API

 **********************************************************************}


  {$ifndef windows}
    //Stubs for Linux
    constructor TGamepadManager.Create;
    begin
      inherited;
      with Mother^ do begin
        Gamepad.Present:= false;
        Gamepad.Name:= RuEn(
          'отсутствует',
          'not present');
        Gamepad.AbsenceReason:= RuEn(
          'Поддерживается только для платформы Windows',
          'Only supported on the Windows platform');
        //GamepadManager:= Self;
      end;
    end;
    destructor TGamepadManager.Destroy;
    begin
      //pointer(Mother^.GamepadManager):= nil;
      inherited;
    end;
    procedure TGamepadManager.Pulse; begin end;
  {$else}

    function TGamepadmanagerThread.Poll: boolean;
    var i: integer;
      k: TKey;
      BitMask: word;
    begin
      if Mother^.Gamepad.Present then begin
        FillChar(State, Sizeof(State), 0);
        if HasFocus or Mother^.Display.WindowHasFocus then begin
          if 0 <> XInputGetState (0, State) then begin
            AddLog(RuEn('Геймпад "%0" был отсоединён!','Controller "%0" detached!'),[Mother^.Gamepad.Name]);
            Mother^.Gamepad.Present:= false;
            Mother^.Gamepad.Rumble[0]:= 0;
            Mother^.Gamepad.Rumble[1]:= 0;
            Mother^.Gamepad.Rumble[2]:= 0;
            Mother^.Gamepad.Rumble[3]:= 0;
            Exit(false);
          end;
  //AddLog('--%0',[State.dwPacketNumber]);
        end else begin
          if HasFocus and not Mother^.Display.WindowHasFocus then begin
            if assigned(XInputEnable) then XInputEnable(false); //not supported in vanilla Vista and 7
            Exit(false);
          end;
          if not HasFocus and Mother^.Display.WindowHasFocus then begin
            if assigned(XInputEnable) then XInputEnable(true);
            Exit(false);
          end;
        end;

        //the actual analysis
        with State.Gamepad do begin
          ProcessKey(KEY_GAMEPAD_LEFT_TRIGGER, (bLeftTrigger / 255.0) > parent.LeftTriggerThreshold);
          ProcessKey(KEY_GAMEPAD_RIGHT_TRIGGER, (bRightTrigger / 255.0) > parent.RightTriggerThreshold);
          for k:= KEY_GAMEPAD_DPAD_UP to KEY_GAMEPAD_Y do begin
            BitMask:= XinputButtons[k];
            ProcessKey(k, (BitMask and wButtons) = BitMask);
          end;
          ProcessJoystick(JoytypePrimary, sThumbLX, sThumbLY, 32767);
          ProcessJoystick(JoytypeRightThumb, sThumbRX, sThumbRY, 32767);
          ProcessJoystick(JoytypeLeftTrigger, 0, bLeftTrigger, 255);
          ProcessJoystick(JoytypeRightTrigger, 0, bRightTrigger, 255);
        end;
        Result:= true;
      end else begin
         for i:=0 to GAMEPAD_PRESENCE_CHECK_PERIOD div 100 do begin
           NoteThreadOccupation(tlk_Sleeping);
           Sleep(100);
           NoteThreadOccupation(tlk_Working);
           if Terminated then Exit(false);
         end;
         parent.Init;
         Result:= false;
      end;
    end;

  {   TjoyState = record
      ix, iy, ixmax,ixmin,iymax,iymin: integer;
      x, y: float;
      rdtstamp: qword;
    end;
   }

    procedure TGamepadmanagerThread.ProcessJoystick(t: TJoystickType; rawix, rawiy, range: integer);
      var
        delta: double;
        newx, newy: float;
  {    function RawToFloat(var vmax, vmin: integer; v, range: integer): float;
      begin
        if v > 0 then begin
          vmax:= Math.max(vmax, Math.min(range, v)); //dynamic range correction
          Exit(v / vmax);
        end;
        if v < 0 then begin
          vmin:= Math.min(vmin, Math.max(-range,v));
          Exit(- v / vmin);
        end;
        Result:= 0.0;
      end; }
    begin
      with JoyState[t] do begin
  {      ixmax:= max(ixmax, round(0.9 * range));
        ixmin:= min(ixmin, round(-0.9 * range));
        iymax:= max(iymax, round(0.9 * range));
        iymin:= min(iymin, round(-0.9 * range));
  }
        if (rawix <> ix) or (rawiy <> iy) then begin
           newx:= rawix/range;//RawToFloat(ixmax, ixmin, rawix, range);
           newy:= rawiy/range;//RawToFloat(iymax, iymin, rawiy, range);
           delta:= Math.max(0.001, 0.001*UsecDelta(@rdtstamp));
           parent.AddEvent(t, newx, newy, (newx - x) / delta, (newy - y) /delta);
  //         AddLog('%0   |   %1   |   %2',[delta, (newx - x) / delta, (newy - y) /delta]);
           x:= newx;
           y:= newy;
           ix:= rawix;
           iy:= rawiy;
        end;
      end;
    end;

    procedure TGamepadmanagerThread.ProcessKey(k: TKey; pressed: boolean);
    begin
  //if pressed then addlog('++ %0',[ord(k)]);
      if (ord(k) < 0) or (ord(k) > 255) then Die('Invalid pressed key, scan code = %0', [ord(k)]);
      if pressed and (not KeyState[k]) then begin
        parent.AddEvent(CGM_PRESS, k);
        Self.KeyState[k]:= true;
  //addlog('++ %0',[IntToHex(ord(k),2)]);
        Exit;
      end;
      if (not pressed) and KeyState[k] then begin
        parent.AddEvent(CGM_RELEASE, k);
        Self.KeyState[k]:= false;
  //addlog('-- %0',[IntToHex(ord(k),2)]);
      end;
    end;

    procedure TGamepadmanagerThread.ProcessRumble(seconds_passed: float);
    var
      i
        //, j
        : integer;
      changed: boolean = No;
      Vibro: T_XINPUT_VIBRATION;
    begin
      for i:=0 to 1 do begin
        Vibro.Amp[i]:= trunc(65535 * Math.max(0.0, Math.min(1.0, Mother^.Gamepad.Rumble[i * 2])));
        RumbleTime[i]+= seconds_passed;
        if Mother^.Gamepad.Rumble[i * 2] <> RumbleAmp[i] then begin
          RumbleAmp[i]:= Mother^.Gamepad.Rumble[i * 2];
          RumbleTime[i]:= 0;
          changed:= Yes;
        end;
        if RumbleTime[i] >= Math.min(GAMEPAD_RUMBLE_DURATION_LIMIT, Mother^.Gamepad.Rumble[i * 2 + 1]) then begin
          changed:= Yes;
          Vibro.Amp[i]:= 0;
        end;
      end;
      if changed then XInputSetState(0, Vibro);
    end;

    constructor TGamepadmanagerThread.Create(_parent:  TGamepadManager);
    begin
      if Mother^.Debug.Verbose then AddLog('  Creating the background polling thread...');
      inherited Create(Yes, 16 * 1024 * 1024);
      parent:= _parent;
      FreeOnTerminate:= No;
      Priority:= tpHigher;
      Resume;
      if Mother^.Debug.Verbose then AddLogOk();
    end;

    procedure TGamepadmanagerThread.Execute;
    var delta: double;
    begin
      with GetExceptionState()^ do begin
        ThreadTitle:= RuEn(
          'Поток опроса геймпада',
          'Game controller polling thread');
        AbbrTitleForIndicator:= 'gpp';
      end;

      try
        try
          repeat
            NoteThreadOccupation(tlk_Working);
            ProcessRumble(1.0 / GAMEPAD_POLLING_FREQUENCE);
            NoteThreadOccupation(tlk_PollingInput);
            if Poll then begin
              delta:= UsecDelta(@PreviousRateCullTsc) - 1000000.0 / GAMEPAD_POLLING_FREQUENCE;
              delta:= 1.0 * Sign(delta) * Math.min(abs(delta), 1000000.0 / 30);
              if delta < 0 then begin
                Mother^.Timer.HiResSleep(-Round(delta / 1000.0));
                delta:= 0;
              end;
              UsecDelta(@PreviousRateCullTsc);
              PreviousRateCullTsc+= round(delta);
            end else begin
              NoteThreadOccupation(tlk_Sleeping);
              Sleep(100);
            end;
          until Terminated;
        except
          Die(RuEn( //This only goes into the thread-local exception state (not visible)
            'Крах в фоновом потоке опроса геймпада.',
            'Game controller background polling thread crashed.'));
        end;
      except
        Mother^.Gamepad.Name:= RuEn(
          'Недоступен (крах в фоновом потоке опроса)',
          'Unavailable (the background polling thread had crashed)'
        );
        parent.ThreadCrashed:= StopDying();
        AddLog(parent.ThreadCrashed); //making the entire chain visible to the user
  //AddLog('----%0',[parent.ThreadCrashed]);
      end;
    end;

    constructor TGamepadManager.Create;
      var
        i: integer;
      function _GetProcAddress(ProcName: ansistring; ignore_error: boolean = false): Pointer;
      var
        exename: UnicodeString;
      begin
        Result:=GetProcAddress(Dll, PAnsiChar(ProcName));
        if Assigned(Result) and Mother^.Debug.Verbose then begin
          exename:= GetExeFileName(Result);
          if (DllName <> exename) and (DllName <> '')
            then AddLog('  %0() at %1 in %2 (wrapper %3)', [ProcName, Result, exename, DllName])
            else AddLog('  %0() at %1 in %2', [ProcName, Result, exename]);
        end;
        if not Assigned(Result) then begin
          if ignore_error then begin
            if Mother^.Debug.Enabled then AddLog(MI_ERROR_FUNCTION_NOT_FOUND_IN_DLL, [ProcName, DllName]);
          end
          else Mother^.Gamepad.AbsenceReason:= PervertedFormat(
            MessageContainer[MI_ERROR_FUNCTION_NOT_FOUND_IN_DLL], [ProcName, DllName]);
        end;
      end;

      function LoadDll: boolean;
      begin
        if Mother^.Debug.Verbose then AddLog('  Loading %0...', [DllName]);
        {$ifdef che_unicode}
         Dll:= LoadLibraryW(PUnicodeChar(DllName));
        {$else}
         Dll:= LoadLibraryA(PAnsiChar(DllName));
        {$endif}
        Result:= Dll <> 0;
        if Mother^.Debug.Verbose then
          if not result then AddLogComment('FAILED.')
                        else AddLogComment('Ok');
      end;

    begin
      AddLog(RuEn('Геймпад:','Сontroller:'));
      inherited;
      Inc(Mother^.State.NumMotherThreads);

      InitCriticalSection(CriticalSection);

      LeftTriggerThreshold:= 0.3;
      RightTriggerThreshold:= 0.3;
      LeftThumbDeadZone:=0;
      RightThumbDeadZone:=0;

      Mother^.Gamepad.Present:= false;
      Mother^.Gamepad.Name:= RuEn('отсутствует','not present');

      Mother^.Gamepad.MouseSpeedMultiplier:= Config.IntChk['game_controller', 'mouse_emul_speed_multiplier', 100, 3000];
      Mother^.Gamepad.MouseAccelThreshold:= Config.IntChk['game_controller', 'mouse_emul_acceleration_threshold', 0, 90];
      Mother^.Gamepad.MouseAccelMultiplier:= Config.IntChk['game_controller', 'mouse_emul_acceleration_multiplier', 0, 3000];


      i:=0;
       repeat
         DllName:= Config.Str['microsoft_xinput', 'dll_' + IntToStr(i)];
         if DllName='' then break;
         if LoadDll() then break;
         inc(i);
       until false;

      if DllName = '' then DllName:= Config.Str['microsoft_xinput','dll_0'];
      if Dll = 0 then begin
        Mother^.Gamepad.AbsenceReason:= RuEn(
          'не удалось загрузить '+DllName+', убедитесь что DirectX установлен правильно',
          'failed to load '+DllName+', make sure latest DirectX is installed');
      end else begin;
        DllName:= GetDLLFileName(Dll);
        pointer(XInputGetCapabilities):= _GetProcAddress('XInputGetCapabilities');
      end;
      if Assigned(XInputGetCapabilities) then begin
        Init(true);
        pointer(XInputGetState):= _GetProcAddress('XInputGetState');
        pointer(XInputSetState):= _GetProcAddress('XInputSetState');
        pointer(XInputEnable):= _GetProcAddress('XInputEnable', true);
      end;
      if Mother^.Gamepad.AbsenceReason <> '' then begin
        AddLogComment('%0 (%1)',[Mother^.Gamepad.Name, Mother^.Gamepad.AbsenceReason]);
        Exit;
      end;
      Thread:= TGamepadmanagerThread.Create(Self);
      if not Mother^.Gamepad.Present then begin
        Mother^.Gamepad.AbsenceReason:= RuEn(
          'драйвер загрузился нормально, но устройство отсутствует, не является Xbox360-совместимым или переключено на канал отличный от №1.',
          'driver loaded Ok but no controller is present or it isn''t Xbox360-compatible or is set to a channel other than #1');
        AddLogComment('%0 (%1)',[Mother^.Gamepad.Name, Mother^.Gamepad.AbsenceReason]);
      end
      else AddLogComment(Mother^.Gamepad.Name);
    end;

    function TGamepadManager.Init(just_starting: boolean = false): boolean;
      var
        caps: T_XINPUT_CAPABILITIES;
    begin
      FillChar(caps, sizeof(caps), 0);
      Mother^.Gamepad.Present:= 0 = XInputGetCapabilities(0, XINPUT_FLAG_GAMEPAD, caps);
      if Mother^.Gamepad.Present then begin
        Mother^.Gamepad.Name:= RuEn(
          'Совместимый с Xbox 360',
          'Xbox 360 compatible');
        if not just_starting then AddLog(RuEn(
          'Обнаружен геймпад: "%0"',
          'Controller detected: "%0"'),[Mother^.Gamepad.Name]);
        Mother^.Gamepad.Rumble[0]:= 0.15; //a test shake
        Mother^.Gamepad.Rumble[1]:= 0.8;
        Mother^.Gamepad.Rumble[2]:= 0.7;
        Mother^.Gamepad.Rumble[3]:= 0.1;
      end;
    end;

    destructor TGamepadManager.Destroy;
    var Vibro: T_XINPUT_VIBRATION;
    begin
      if Assigned(pointer_to_instance) and Assigned(Framework) then pointer_to_instance^:= nil; //clears the global variable
      if Assigned(Thread) then Thread.Free;
      if Assigned(XInputSetState) then begin
        if assigned(XInputEnable) then XInputEnable(true);
        Vibro.wLeftMotorSpeed:=0;
        Vibro.wRightMotorSpeed:=0;
        XInputSetState(0, Vibro);
        if assigned(XInputEnable) then XInputEnable(false);
      end;
      if Dll <> 0 then begin
        FreeLibrary(Dll);
      end;
      DoneCriticalsection(CriticalSection);
      inherited;
      Dec(Mother^.State.NumMotherThreads);
    end;

    procedure TGamepadManager.Pulse;
    var i, k, n, ne: integer;
    begin
      if ThreadCrashed <> '' then Exit;//Die(ThreadCrashed); //Relay the error message
      //Dumping the local event queue into the global one.
  //exit;
      if MaxEvent > 0 then begin
        EnterCriticalSectionWv(CriticalSection);
        try
  {
  Yeah, I screwed myself good here.
  Forgot that module has Mother^.Input.Events defined as a chain of pointers, _not_ as an array.
  So, unless it's plugged with an extra empty one (generated in NewInputEvent()),
  module's ProcessMessages goes past the array end merrily exploring random memory :((((((
          k:= length(Mother^.Input.Events);
          SetLength(Mother^.Input.Events, k + MaxEvent);
          for i:= 1 to MaxEvent do Mother^.Input.Events[k + i - 1]:= Events[i];
  }

          for i:= 1 to MaxEvent do begin
            ne:= NewInputEvent();
            Mother^.Input.Events[ne]:= Events[i];
          end;
          MaxEvent:= 0;
        finally
          LeaveCriticalSection(CriticalSection);
        end;
      end;
    end;

    procedure TGamepadManager.AddEvent(_evtype: integer; _key: TKey);
    begin
  //    if MaxEvent = (GAMEPAD_EVENT_QUEUE_LIMIT - 1) then AddLog(RuEn('Переполнение очереди событий геймпада!','Controller event queue full!'));
      if MaxEvent = GAMEPAD_EVENT_QUEUE_LIMIT then begin
  //      AddLog(RuEn('Переполнение очереди событий геймпада!','Controller event queue full!'));
        Exit;
      end;
      if (ord(_key) < 0) or (ord(_key) > 255) then Die('Invalid pressed key, scan code = %0', [ord(_key)]);
      EnterCriticalSection(CriticalSection);
        if MaxEvent < GAMEPAD_EVENT_QUEUE_LIMIT then begin
          inc(MaxEvent);
          with Events[MaxEvent] do begin
            EventType:= _evtype;
            key:= _key;
            mx:= Framework.MouseX;
            my:= Framework.MouseY;
          end;
        end;
      LeaveCriticalSection(CriticalSection);
    end;

    procedure TGamepadManager.AddEvent(joy_type: TJoystickType; _x, _y, _dx, _dy: float); overload;
    begin
  //    if MaxEvent = (GAMEPAD_EVENT_QUEUE_LIMIT - 1) then AddLog(RuEn('Переполнение очереди событий геймпада!','Controller event queue full!'));
      if MaxEvent = GAMEPAD_EVENT_QUEUE_LIMIT then begin
  //      AddLog(RuEn('Переполнение очереди событий геймпада!','Controller event queue full!'));
        Exit;
      end;
  //addlog('  тип %0, x:y = %1:%2, dx:dy = %3:%4',[joy_type, round(_x*100),round(_y*100),round(_dx*100),round(_dy*100)]);
      EnterCriticalSection(CriticalSection);
      if MaxEvent < GAMEPAD_EVENT_QUEUE_LIMIT then begin
        inc(MaxEvent);
        with Events[MaxEvent] do begin
          EventType:= CGM_JOYSTICK;
          JoyType:= joy_type;
          joyx:= _x;
          joyy:= _y;
          joydx:= _dx;
          joydy:= _dy;
        end;
        if joy_type = JoytypeRightThumb then (Framework as TNativeFramework).AddRightThumbToMouseMovement(_x, _y);
      end;
      LeaveCriticalSection(CriticalSection);
    end;


  {$endif}

end.

