{
    This file is part of Chentrah,
    Copyright (C) 2004-2008 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************}

const
     Attr:array[0..6] of EGLint=(EGL_BUFFER_SIZE,16,
                                  EGL_DEPTH_SIZE,8,
                                  EGL_RENDERABLE_TYPE,EGL_OPENGL_ES2_BIT,
                                  EGL_NONE);
     CtxAttr:array[0..2] of EGLint=(EGL_CONTEXT_CLIENT_VERSION,2,EGL_NONE);

  procedure TWinApiFramework.InitGLFirstStage;
  begin

  end;

  procedure TWinApiFramework.InitGL;
  var
    PixelFormat : GLuint;
    DDevice: TDisplayDeviceW;
    majo, mino: EGLint;
    num_config: EGLint;
    i: integer;
    s: UnicodeString;
    pfd2 : TPIXELFORMATDESCRIPTOR;
  begin
    if GLInitialized then Exit;

    InitOpenGL;

    display := GetDC(WindowHandle);//GetDesktopWindow());//0);//
    if (display = 0) then Die(MI_ERROR_CANTINITOPENGL, ['GetDC() returned 0']);

    case Mother^.GAPI.Mode of
      gapi_DeprecatedImmediateGL,
      gapi_GL21: begin

//        function EnumDisplayDevicesW(lpDeviceName: Pointer; iDevNum: DWORD;
//           lpDisplayDevice: PDisplayDeviceW; dwFlags: DWORD): WINBOOL;
//           external 'user32' name 'EnumDisplayDevicesW';
        if Mother^.Debug.Verbose then begin
          AddLog('  Listing display devices...');
          i:=0;
          DDevice.cb:= SizeOf(DDevice);
          while EnumDisplayDevicesW(nil, i, @DDevice, DISPLAY_DEVICE_ATTACHED_TO_DESKTOP) do begin
            s:= PervertedFormat('    %0: %1 %2', [i, UnicodeString(DDevice.DeviceName), UnicodeString(DDevice.DeviceString)]);
            inc(i);
            if 0 = (DISPLAY_DEVICE_ACTIVE and DDevice.StateFlags) then continue; //This can only happen in XP
            AddLog(s);

            //display := CreateDCW(pointer(UnicodeString(DDevice.DeviceName)), pointer(UnicodeString(DDevice.DeviceString)), nil, nil);
            //if (display = 0) then Die(MI_ERROR_CANTINITOPENGL, [PervertedFormat('CreateDCW(''%0'', ''$1'') returned 0', [UnicodeString(DDevice.DeviceName), UnicodeString(DDevice.DeviceString)])]);
          end;

          AddLog('  Listing pixel formats...');
          for i:= 0 to min(255, //sanity check
            DescribePixelFormat(display, 1, sizeof(pfd2), @pfd2))
          do begin
            if DescribePixelFormat(display, i, sizeof(pfd2), @pfd2) <= 0 then continue;
            s:= PervertedFormat('    #%0: R%1G%2B%3',[i, pfd2.cRedBits, pfd2.cGreenBits,pfd2.cBlueBits]);
            if pfd2.cAlphaBits > 0 then s+= PervertedFormat('A%0',[pfd2.cAlphaBits]);
            if pfd2.cDepthBits > 0 then s+= PervertedFormat(' Z%0', [pfd2.cDepthBits]);
            if pfd2.cStencilBits > 0 then s+= PervertedFormat('S%0', [pfd2.cStencilBits]);
            if (pfd2.dwFlags and PFD_SUPPORT_OPENGL) = 0 then s+= ' NoOpenGL';
            if ((pfd2.dwFlags and PFD_GENERIC_ACCELERATED) = 0) and ((pfd2.dwFlags and PFD_GENERIC_FORMAT) > 0) then s+= ' NoHardwareAcceleration';
            if (pfd2.dwFlags and PFD_DOUBLEBUFFER) = 0 then s+= ' NoDoubleBuffer';
            if (pfd2.dwFlags and PFD_DRAW_TO_WINDOW) = 0 then s+= ' NoWindowed';
            if (pfd2.dwFlags and PFD_STEREO) > 0 then s+= ' Stereo';
            if pfd2.iPixelType = PFD_TYPE_COLORINDEX then s+= ' Paletted';
          end;
          //addlog('  Current pixel format of DC %0 is %1', [display, wglGetPixelFormat(display)]);
        end;

        FillChar(pfd, SizeOf(pfd), 0);

        // Заполняем бланк-формуляр для процедуры подбора формата пикселя

        { NOTE: We do not need a depth buffer since we render everything using FBO!
          Sadly, the Windows implementations of OpenGL tend to ignore that
           and create a depth buffer anyway. See the log file or console,
           the pixel format description should ideally state depth and stencil = 0
        }
        with pfd do
        begin
          nSize           := SizeOf(TPIXELFORMATDESCRIPTOR); // Size Of This Pixel Format Descriptor
          nVersion        := 1;                    // The version of this data structure
          dwFlags         := PFD_DRAW_TO_WINDOW    // Buffer supports drawing to window. Should be off for Voodoo2 ?..
                             or PFD_SUPPORT_OPENGL // Buffer supports OpenGL drawing
                             or PFD_DOUBLEBUFFER;  // Supports double buffering

          iPixelType      := PFD_TYPE_RGBA;        // RGBA color format
          //cColorBits      := 32;                   // OpenGL color depth
          //cDepthBits      := 16;
          iLayerType      := PFD_MAIN_PLANE;       // Ignored
        end;

        // Пытаемся подобрать формат пикселя, поддерживаемый контекстом устройства,
        //  наиболее близкий к желаемому... Почему-то очень часто роняло Win98
        //  если запрашивался буфер глубины больше 16 бит... :(
        // P.S. Сколько лет этому куску кода?
        if Mother^.Debug.Verbose then AddLog('Calling wglChoosePixelFormat()...');
        // in Win98 calling ChoosePixelFormat() often caused a system-wide crash... :(

        PixelFormat := wglChoosePixelFormat(display, @pfd);
        if (PixelFormat = 0)
          then Die(MI_ERROR_CANTINITOPENGL,['wglChoosePixelFormat() returned 0']);

        if Mother^.Debug.Verbose then AddLog('chosen pixel format = %0.',[PixelFormat]);

        wglDescribePixelFormat(display, PixelFormat, sizeof(pfd2), @pfd2);
        AddLog(MI_LOG_SCREEN_FORMAT, [Mother^.Display.WindowClientRect.Width, Mother^.Display.WindowClientRect.Height,
                  pfd2.cRedBits, pfd2.cGreenBits,pfd2.cBlueBits, pfd2.cAlphaBits,
                  pfd2.cDepthBits, pfd2.cStencilBits]);

        // Устанавливаем для нашего контекста устройства подобранный формат пикселя
        if not wglSetPixelFormat(display, PixelFormat, @pfd)
          then  Die(MI_ERROR_CANTINITOPENGL,['wglSetPixelFormat() returned FALSE.']);

        // Создаём рисовальный контекст OpenGL..
        RenderingContext := wglCreateContext(display);
        if (RenderingContext = 0)
          then Die(MI_ERROR_CANTINITOPENGL, ['wglCreateContext() returned 0']);

        if Mother^.Debug.Verbose then AddLog('rendering context = %0',[RenderingContext]);

        // ..и делаем его текущим.
        if (not wglMakeCurrent(display, RenderingContext))
          then Die(MI_ERROR_CANTINITOPENGL, ['wglMakeCurrent() call failed']);

        CheckGLVersion;


        LoadOpenGLFunctions; //2.0 and up only become visible after creating the context

        pointer(wglSwapInterval):= _GetGLProcAddress ('wglSwapInterval');
        if not Assigned(wglSwapInterval) then pointer(wglSwapInterval):= _GetGLProcAddress ('wglSwapIntervalEXT');
        pointer(wglGetSwapInterval):= _GetGLProcAddress ('wglGetSwapInterval');
        if not Assigned(wglGetSwapInterval) then pointer(wglGetSwapInterval):= _GetGLProcAddress ('wglGetSwapIntervalEXT');

        if Assigned(wglSwapInterval) then begin
          wglSwapInterval(0);
          if Assigned(wglGetSwapInterval) and (wglGetSwapInterval() > 0)
            then GivePeriodicWarning(1.0, 'unable-to-turn-vsync-off', MI_WARN_WARNING, //annoy the user once a day
                  MI_SWAP_CRAP, [RuEn(
                 'OpenGL отказалась отключить Vsync.'
                ,'OpenGL refused to switch Vsync off.')])
            else
              if Mother^.Debug.Enabled then AddLog('Vsync disabled.');
        end
        else
          if not (Mother^.State.OS in WindowsEmulators) then //cut the emulator some slack, won't we?
             GivePeriodicWarning(7.0, 'unable-to-turn-vsync-off', MI_WARN_WARNING, //annoy the user weekly
                  MI_SWAP_CRAP, [RuEn(
                   'Не поддерживается WGL_EXT_swap_control',
                   'WGL_EXT_swap_control not supported')])
          else AddLog(RuEn(
               'WARNING: Не поддерживается WGL_EXT_swap_control,'#10#13'  невозможно отключить Vsync.'
              ,'WARNING: WGL_EXT_swap_control not supported,'#10#13'  cannot switch Vsync off.'));
      end;
      gapi_GLES2: begin

        eDisplay:= eglGetDisplay(display);
        if eDisplay = EGL_NO_DISPLAY then Die(MI_ERROR_CANTINITOPENGL,['eglGetDisplay() returned 0']);

        majo:= 2;
        mino:= 0;
        if 0 = eglInitialize(eDisplay, nil, nil)//@majo, @mino)
          then Die(MI_ERROR_CANTINITOPENGL,['eglInitialize() returned 0']);

        num_config:= 0;
        if 0 = eglChooseConfig(eDisplay, @Attr, @eConfig, 1, @num_config)
          then Die(MI_ERROR_CANTINITOPENGL,['eglChooseConfig() returned 0']);

        if num_config <> 1
          then Die(MI_ERROR_CANTINITOPENGL,['eglChooseConfig() returned not 1 but ' + IntToStr(num_config)]);

        eSurface:= eglCreateWindowSurface(eDisplay, eConfig, Windowhandle, nil);
          if eSurface = EGL_NO_SURFACE then Die(MI_ERROR_CANTINITOPENGL,['eglCreateWindowSurface() returned 0']);

        eContext:= eglCreateContext(eDisplay, eConfig, EGL_NO_CONTEXT, @CtxAttr);
          if eContext = EGL_NO_CONTEXT  then Die(MI_ERROR_CANTINITOPENGL,['eglCreateContext() returned 0']);

        if EGL_FALSE = eglMakeCurrent(eDisplay, eSurface, eSurface, eContext)
          then Die(MI_ERROR_CANTINITOPENGL,['eglMakeCurrent() returned EGL_FALSE']);

        CheckGLESVersion(majo, mino);

        AddLog(MI_LOG_SCREEN_FORMAT, [Mother^.Display.WindowClientRect.Width, Mother^.Display.WindowClientRect.Height,
                  '?', '?', '?',
                  '?', '?', '?']);

        CreateESFFPEmulationProgram;

      end;
      else
        DieUnsupportedGLMode;
    end;
    GLInitialized:=Yes;
  end;



  Procedure TWinApiFramework.CloseGL;
  begin
    if not GLInitialized then Exit;

    if Mother^.Debug.Verbose then AddLog('ClosingOpenGL...');

    if Mother^.Display.CanRender then try

    // Делаем текущий рисовальный контекст не текущим...
      if (not wglMakeCurrent(display, 0))
        then AddLog('wglMakeCurrent() failed');

    // ...и пытаемся удалить его
      if (not wglDeleteContext(RenderingContext)) then
      begin
        AddLog('wglDeleteContext() failed');
        RenderingContext := 0;
      end;

    // Пытаемся освободить контекст устройства
      if (ReleaseDC(WindowHandle, display) = 0)
      and IsWindow(WindowHandle)
      then begin
        AddLog('ReleaseDC() failed');
        display := 0;
      end;
    except
      AddLog(StopDying());
    end;


    //выгружаем DLL
    CloseOpenGL;

    if Mother^.Debug.Verbose then AddLogOk;
  end;




