{
    This file is part of chepersy
    Copyright (c) 2004-2008 by Anton Rzheshevski (chebmaster@mail.ru),

    See the file COPYING.CPS, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}

//       "NO USER SERVICEABLE PARTS BELOW THIS POINT"

(*
function aligntoptr(p : pointer) : pointer;inline;
   begin
{$ifdef FPC_REQUIRES_PROPER_ALIGNMENT}
     result:=align(p,sizeof(p));
{$else FPC_REQUIRES_PROPER_ALIGNMENT}
     result:=p;
{$endif FPC_REQUIRES_PROPER_ALIGNMENT}
   end;
Procedure int_Addref (Data, TypeInfo : Pointer); [external name 'FPC_ADDREF'];
type
   { don't add new fields, the size is used }
   { to calculate memory requirements       }
   pdynarray = ^tdynarray;
   tdynarray = packed record
      refcount : ptrint;
      high : tdynarrayindex;
   end;
const
   tkManagedTypes   = [tkAstring,tkWstring,tkUstring,tkArray,
                     tkObject,tkRecord,tkDynArray,tkInterface,tkVariant];

function _dynarray_copy(psrc : pointer;ti : pointer;
    lowidx,count:tdynarrayindex) : pointer;
  var
    realpdest,
    realpsrc : pdynarray;
    cnt,
    i,size : longint;
    highidx : tdynarrayindex;
    elesize : sizeint;
    eletype : pdynarraytypeinfo;
    pdest : pointer;
  begin
     highidx:=lowidx+count-1;
     pdest:=nil;
     result:=pdest;
     if psrc=nil then
       exit;
     realpsrc:=pdynarray(psrc-sizeof(tdynarray));
     { skip kind and name }
     inc(pointer(ti),ord(pdynarraytypeinfo(ti)^.namelen)+2);

     ti:=aligntoptr(ti);

     elesize:=psizeint(ti)^;
     eletype:=pdynarraytypeinfo(pointer(pdynarraytypeinfo(pointer(ti)+sizeof(sizeint)))^);

     { -1, -1 (highidx=lowidx-1-1=-3) is used to copy the whole array like a:=copy(b);, so
       update the lowidx and highidx with the values from psrc }
     if (lowidx=-1) and (highidx=-3) then
      begin
        lowidx:=0;
        highidx:=realpsrc^.high;
      end;
     { get number of elements and check for invalid values }
     if (lowidx<0) or (highidx<0) or (lowidx > realpsrc^.high) then
       ;//HandleErrorFrame(201,get_frame);
     cnt:=highidx-lowidx+1;
     if (cnt > realpsrc^.high - lowidx + 1) then
       cnt := realpsrc^.high - lowidx + 1;
     { create new array }
     size:=elesize*cnt;
     getmem(realpdest,size+sizeof(tdynarray));
     pdest:=pointer(realpdest)+sizeof(tdynarray);
     { copy data }
     move(pointer(psrc+elesize*lowidx)^,pdest^,size);
     { fill new refcount }
     realpdest^.refcount:=1;
     realpdest^.high:=cnt-1;

     { increment ref. count of members? }
     if TTypeKind(PByte(eletype)^) in tkManagedTypes then
       for i:= 0 to cnt-1 do
         int_addref(pointer(pdest+elesize*i),eletype);

     result:=pdest;
  end;
*)


var
  DH: TChepersyDatabaseHeader;



const
//  StringLikeTypes: set of TFieldKind = [fk_string, fk_8bit_string]; //types that have pointer^.ReferenceCount layout
//  StringAndEnumTypes: set of TFieldKind = [fk_string, fk_8bit_string, fk_Enum];

  ManagedFieldKindsSet: set of TFieldKind = [fk_string,fk_8bit_string,fk_Array,fk_dynamic_array];

  StdTindPointer = 0;
  StdTindTChepersyObject = 2;// 1;
  StdTindDword = 1;//2;
  StdTindArrayOfDword = 3;
  StdTind2dArrayOfDword = 4;
  StdTindUnknownSet = 5;
  StdTindQword = 6;
  StdTindArrayOfQword = 7;
  StdTindArrayOfTChepersyObject = 8;
  StdTindArrayOfUnknownSet = 9;
  StdTind2dArrayOfUnknownSet = 10;
  StdTind2dArrayOfTChepersyObject = 11;
  StdTind2dArrayOfQWord = 12;
  StdTindUnknownRecord = 13;
  StdTindArrayOfUnknownRecord = 14;
  StdTind2dArrayOfUnknownRecord = 15;
  StdTindMetaclass = 16;
  //Beginning with 2.4.0, the wide string type has changed for non-Windows platforms:
  //WstringType = {$ifdef windows}tkWstring {$else}tkUstring{$endif};






  // *********** FIELD SAVING / LOADING ROUTINES **********************
// ! AS OF 0.9.x most of these are scraped, replaced with
//   the direct calls to the stream via the B_Stream global variable.


{   These can be used in the custom processing procedures}
//  Function SizeToBufferIndex(s: integer): integer; {$ifdef fpc}inline;{$endif} forward;
//  procedure WriteInt(i: integer); {$ifdef fpc}inline;{$endif} forward;
//  function ReadInt: integer; {$ifdef fpc}inline;{$endif} forward;

//These are the same as ***Bin, but use bytes instead.
// When writing to the stream they round up to dwords.
//  procedure ReadUnaligned(p: pointer; NumBytes: integer); {$ifdef fpc}inline;{$endif} forward;
//  procedure SkipUnaligned(NumBytes: integer); {$ifdef fpc}inline;{$endif} forward;
//  procedure WriteAnsiString(v: AnsiString); {$ifdef fpc}inline;{$endif} forward;
//  procedure WriteWideString(v: WideString); {$ifdef fpc}inline;{$endif} forward;
//  procedure SkipAnsiString; {$ifdef fpc}inline;{$endif} forward;
//  procedure SkipWideString; {$ifdef fpc}inline;{$endif} forward;
//  function ReadWideString(): WideString; {$ifdef fpc}inline;{$endif} forward;
//  function ReadAnsiString(): AnsiString; {$ifdef fpc}inline;{$endif} forward;

//  procedure WriteNil; {$ifdef fpc}inline;{$endif} forward;

  procedure ReadPersistent(var o: pointer//TChepersyObject
    ; fprops: TFieldPropertiesSet); register; forward;
  procedure WritePersistent(o: pointer //TChepersyObject
    ; fprops: TFieldPropertiesSet); forward;

  procedure LogWarnings(); forward;
//  private
  procedure DieInvalidContainer(nng: unicodestring); forward;
  procedure DieIncompatible(M: TMessageId; Param: array of Const); forward;

  procedure LoadEnum(tyi: integer; p: pointer); forward;
   //making it "inline"
   // causes a complete пиздец. Sorry for my French.
   // Note to self: report as a FreePascal bug.

  function NumObjects: integer;  forward;//_readonum(): integer;//property NumObjects: integer read _readOnum;
//  end;


type
  TCpsStub1 = (cps_st1_1, cps_st1_2);
  Chepersy_UnknownSet = set of TCpsStub1;
  Chepersy_arrayofUnknownSet = array of Chepersy_UnknownSet;
  Chepersy_2darrayofUnknownSet = array of array of Chepersy_UnknownSet;


{$ifdef oldhacky}
  var
    vmtMyClassIndex,
    vmtMyScenarioIndex,
    vmtMyFieldsList,
    vmtMyLocalFieldsList,
    vmtMyLocalClassIndex: integer;
   procedure InitializeVmtxxxConsts; forward;
{$else}
  var
    aClassInd,
    aScenarioInd: array of integer;
    aFieldsList: array of TFieldsList;
    aOffset: ptruint = 0;
   procedure InitializeIndexArrays; forward;
{$endif}
var
  BottleNeckCounter1, BottleNeckCounter2: int64;
  procedure CpsValidate(n: string); overload; forward;
  procedure CpsValidate(i: PTypeInfo); overload; forward;

//  procedure OpenCGEFileForWrite (Target: TStream); overload; forward;

  procedure PrepareToSave(Target: TStream); forward;
  procedure PrepareToLoad(Source: TStream); forward;
  procedure PrepareToClone; forward;

  procedure DoneSaving(FreeTheStream: boolean); forward;
  procedure DoneLoading(FreeTheStream: boolean; POutputList: PArrayOfPointer);forward; //PArrayOfChepersyObjects); forward;
  procedure DoneCloning(); forward;


  function GetConverterProc(Tind1, Tind2: integer): TCustomConverterProc; forward;


  function GetClassIndex(C: TClass): integer; forward;
  procedure SetClassIndex(C: TClass; index: integer); forward;


  procedure CpsFindLoadingScenario(Cind, B_LocalClassInd: integer); forward;
  procedure CpsBuildsavingScenario(Cind: integer); forward;
  procedure CpsBuildCloningScenario(Cind: integer); forward;

  procedure LoadRecord(base: pointer; op: TFieldOperation; B_ClassIndex: integer; fprops: TFieldPropertiesSet); forward;
  procedure SaveRecord(base: pointer; Cind: integer; fprops: TFieldPropertiesSet); forward;
  procedure WalkRecord(base: pointer; Cind: integer; fprops: TFieldPropertiesSet); forward;
  procedure CloneRecord(base, newbase: pointer; Cind: integer; fprops: TFieldPropertiesSet); forward;

  procedure IncRawByteStringRefCount(ps: pointer); forward;
  procedure IncWideStringRefCount(ps: pointer); forward;
  procedure IncUnicodeStringRefCount(ps: pointer); forward;

{$ifndef cge}
  function RuEn(ru, en: WideString): WideString; forward;

  Procedure Die(YellID :TMessageID; Param: array of const); overload; forward;
  Procedure Die(YellID :TMessageID); overload;  forward;
  Procedure Die(u: WideString; Param: array of const);  overload;  forward;
  Procedure Die(u: WideString);  overload;  forward;

  Procedure AddLog(U: WideString); overload;  forward;
  Procedure AddLog(mID: TMessageID); overload;  forward;
  Procedure AddLog(mID: TMessageID; Param: array of const); overload;  forward;
  Procedure AddLog(U: WideString; Param: array of const); overload; forward;

  {$include mo_cps_stubs_public.inc}
   //simplified replacements for parts of the Cheb's Game Engine
   
{$endif}


var
  //new in 0.8.90: the old buffer allocation system finally scraped for good.
//  CpsStream: TStream; //0.8.95 replaced with CpsStream
  
  //new in 0.9
  CpsWalkMarkVal: integer = -1;

  //new in 0.9
  mXorMask, mAndMask: dword;
  CurrentWalkProc: TcustomWalkProc;


var
  CpsBuffer: array[0..CpsBufferSize] of byte;
  BufferPos, BufferHigh: integer;

procedure InitBuffer;
begin
  BufferPos:= 0;
  BufferHigh:= -1;
end;

procedure FlushBuffer; inline;
begin
  if BufferPos > 0 then begin
    {$ifdef bench_streaming}{$include un_bottleneck_begin}{$endif}
    CpsStream.Write(CpsBuffer[0], BufferPos);
    {$ifdef bench_streaming}{$include un_bottleneck_end}{$endif}
    BufferPos:= 0;
  end;
end;

procedure WriteToBuffer(var v; size: longint); inline;
begin
  if size + BufferPos >= CpsBufferSize then FlushBuffer;
  if size >= CpsBufferSize
  then begin
    {$ifdef bench_streaming}{$include un_bottleneck_begin}{$endif}
    CpsStream.Write(v, size);
    {$ifdef bench_streaming}{$include un_bottleneck_end}{$endif}
  end
  else begin
    MOVE(v, CpsBuffer[BufferPos], size);
    BufferPos+= size;
  end;
end;

procedure FillBuffer; inline;
begin
//bgsay('* FillBuffer');
  BufferPos:= 0;
  {$ifdef bench_streaming}{$include un_bottleneck_begin}{$endif}
  BufferHigh:= CpsStream.Read(CpsBuffer[0], CpsBufferSize) - 1;
//bgsay('  FillBuffer : high=' + IntToStr(BufferHigh));
  {$ifdef bench_streaming}{$include un_bottleneck_end}{$endif}
end;

procedure ReadFromBuffer(var v; size: longint); inline;
var a: longint;
begin
  if BufferHigh < 0 then begin
    if size >= CpsBufferSize then begin
      {$ifdef bench_streaming}{$include un_bottleneck_begin}{$endif}
      CpsStream.Read(v, size);
      {$ifdef bench_streaming}{$include un_bottleneck_end}{$endif}
      Exit;
    end;
    FillBuffer;
  end;
  if BufferPos + size > BufferHigh + 1 then begin
    MOVE(CpsBuffer[BufferPos], pointer(@v)^, BufferHigh + 1 - BufferPos);
    if (size - (BufferHigh + 1 - BufferPos)) > CpsBufferSize then begin
      {$ifdef bench_streaming}{$include un_bottleneck_begin}{$endif}
      CpsStream.Read((pointer(@v) + BufferHigh + 1 - BufferPos)^, size - (BufferHigh + 1 - BufferPos));
      {$ifdef bench_streaming}{$include un_bottleneck_end}{$endif}
      BufferPos:= 0;
      BufferHigh:= -1;
      Exit;
    end;
    a:= BufferHigh + 1 - BufferPos;
    FillBuffer;
    MOVE(CpsBuffer[0], (pointer(@v) + a)^, size - a);
    BufferPos:= size - a;
  end
  else begin
    MOVE(CpsBuffer[BufferPos], v, size);
    BufferPos+= size;
  end;
end;

procedure WriteInt(i: longint);// inline;
begin
  WriteToBuffer(i, 4);
end;

function ReadInt: longint;// inline;
begin
  ReadFromBuffer(Result, 4);
end;


procedure BasketWarningsAdd(w: WideString); forward;
  {$include mo_cps_cfile_func.inc}

procedure DieTypeFailed(T: TTypeRecord; reason: string); forward;

//new in 0.9. Resolves derivative types like TDateTime (cannot be registered!) to basic single and double.
procedure ResolveTypeInfoToTind(Info: PTypeInfo; var tind: integer; var StringId: WideString); forward;
function ResolveTypeInfoToAlias(Info: PTypeInfo): PTypeInfo; forward;


function _RegEnum(var T: TTypeRecord): TMd5Digest; forward;

//  procedure _RegisterField(name: string; Pf: pointer; PI: PTypeInfo; SkipIt: boolean);
  procedure RegBegin(C: TObject);  forward;
  procedure RegEnd;  forward;
  function ClassIndex(C: TClass): integer; forward;

procedure _RegTypeBin(Info: PTypeInfo; Size: Integer); forward;
procedure _RegTypeComplexWZK(Info: PTypeInfo; Proc: TCustomTypeProcessingProc;
                             S: integer; K: TFieldKind); forward;
Procedure NewDynArray(parray: pointer; Len, ElementTypeInd: integer); forward;
function GetDynArrayLength(parray: pointer): integer; forward;
procedure IncDynArrayRefCount(parray: pointer); forward;

function _ListRecordFields(packd, addrrequired: boolean; base: pointer; startoffset: longint; var eGran: ptruint; v: array of const): TFieldDesc; forward;

procedure RegTypeClass(C: CChepersyObject); forward;
procedure RegTypeComplex(Info: PTypeInfo; Proc: TCustomTypeProcessingProc); forward;
procedure RegTypeDynArrayNd(Dimensions: integer; ArrayInfo, BaseType: PTypeInfo); forward;
procedure RegTypeEnum(Info: PTypeInfo); forward;
procedure RegTypeDynArray1d(ArrayInfo, BaseType: PTypeInfo); forward;

 {$ifdef delphiworkaround}
  procedure DumbDelphiSetMyFieldsList(C: TClass; F: TObject); forward;
 {$endif}
 
  //registers procedure that converts between the known types
  //  (e.g. shortint / longint), so you can change field types
  //  and the class could still be loaded.
  //Converters for all known numeric types are already registered.
  procedure RegTypeConverter(types1, types2: array of const; p: TCustomConverterProc); forward;


const
  tind_pointer = 0;
  tind_dword = 1;
  tind_arrayofdword = 3;
  tind_2darrayofdword = 4;
  tind_unknown_set = 5;
  tind_unknown_record = 13;

var
 // Scenario,
 // CloningScenario: array of dword; //does not have to contain pointers

{$ifdef oldhacky}
  InvalidClassIndex: integer;
{$endif}
//  LocalTI: integer;

  //Global variables, formerly fields of classes TRegistrator and TBasket:
  Fields, SaveableFields: TFieldInfos;
  Records: TAOI; //type indices. Formerly for classes, since v0.9 also for records
  ClassAncestors: T2DAOI;
  NameSpace,
  TypeNameSpace,
  ClassNameSpace: TNameSpace;
  Types: TTypeRegistry;
  TypeToRecInd: array of integer;
  Enums: T2DAOI;
  //tScenarioIndex, clScenarioIndex: array of integer;
  
  CurrentObject: TAOMO;//TChepersyObject;
  CurrentObjectInd: TAOI;
  prevOffset, prevSize, prevname, prevtype: integer;




//  B_ScenarioIndex: array of Integer;
  ContName: string;
  CurrentInd: integer;
  Obj: TAOP;//TAOMO;

  procedure RP_Dyna (PField: pointer; OP: TFieldOperation; Tind: integer;
    FieldProperties: TFieldPropertiesSet); RP_CallingConvention; forward;

type
  TDwordArray = array[0..$0FFFFFFF] of Dword;
  PDwordArray = ^TDwordArray;


var
  NowSaving, NowLoading: boolean; //additional check for out-of-scope calls

  operator = (a, b: TMd5Digest) z: system.boolean;
  var i: integer;
  begin
    for i:=0 to High(a) do if a[i] <> b[i] then begin z:= False; Exit end;
    z:= True;
  end;

  procedure ValidateChepersyState(s: string);
  begin
    if Mother^.Debug.Verbose then AddLog('Chepersy: validating state for %0', [s]);
    if not CpsFinalized then ClassesRegistrationEnd;
    if not CpsValid then raise Exception.Create(
      Utf8Encode('Call to ' + s + ' when Chepersy is not initialized yet!'));
  end;

  procedure BasketwarningsAdd(w: WideString);
  begin
    CpsParserWarnings.Add({$ifdef fpc} Utf8Encode(w) {$else} w {$endif} );
  end;

  function min(a, b: integer): integer; inline;
  begin
    if a < b then Result:=a else Result:=b;
  end;

  Function SizeToBufferIndex(s: integer): integer; inline;
  begin
    if s > 0 then Result:= 1 + ((s - 1) div SizeOf(dword)) //compiler should optimize it into shr 2
             else Result:= 0;
  end;
  
{$ifndef oldhacky}
  const hShift = {$ifdef fpc}5{$else}7{$endif};

  function CHash(C: TClass): ptruint; register; inline;
  begin
    //Result:=(cardinal(C) shr hShift) - aOffset;
    Result:= ptruint(int64(ptruint(C) shr hShift) - int64(aOffset));
  end;
  
  function cFitsIndexArrays(C: TClass): boolean; register; inline;
  begin
    Result:=(CHash(C) <= high(aClassInd));
  end;

  procedure MakeSureClassFitsIndexArrays(C: TClass);
  var
    n: int64;
    i, j: integer;
  begin
    if cFitsIndexArrays(C) then Exit;
    n:= int64(ptruint(C) shr hShift) - int64(aOffset);
//addlog(' -----------------  %0  %1  %2  %3', [cardinal(C) shr hShift, aoffset, high(aClassInd), n] );
    if n < 0 then begin
      if Mother^.Debug.Verbose then AddLog(RuEn(
        '  Индексные массивы расширяются на %1 чтобы вместить %0',
        '  Expanding index arrays by %1 to fit %0.'), [string(C.ClassName), n]);
      i:=length(aClassInd);
      SetLength(aClassInd, i - n);
      SetLength(aScenarioInd, i - n);
      SetLength(aFieldsList, i - n);
      For j:=high(aClassInd) downto - n do begin
        aClassInd[j]:=aClassInd[j + n];
        aScenarioInd[j]:=aScenarioInd[j + n];
        pointer(aFieldsList[j]):=pointer(aFieldsList[j + n]);
      end;
      For j:=0 to -n - 1 do begin
        aClassInd[j]:=0;
        aScenarioInd[j]:=0;
        pointer(aFieldsList[j]):=nil;
      end;
      aOffset:=0;
      aOffset:=CHash(C);
    end
    else begin
      i:= Length(aClassInd);
      if Mother^.Debug.Verbose then AddLog(RuEn(
        '  Индексные массивы расширяются на %1 чтобы вместить %0',
        '  Expanding index arrays by %1 to fit %0.'), [string(C.ClassName), n - i + 1]);
      SetLength(aClassInd, n + 1);
      SetLength(aScenarioInd, n + 1);
      SetLength(aFieldsList, n + 1);
      For j:=i to high(aClassInd) do begin
        aClassInd[j]:= 0;
        aScenarioInd[j]:= 0;
        pointer(aFieldsList[j]):= nil;
      end;
    end;
    
  end;

  procedure InitializeIndexArrays;
  var
    C: TClass;
  begin
    C:= TChepersyObject.ClassType;
    aOffset:= CHash(C);
  end;
  
{$endif}

  function LocalClassNameStr(i: integer): AnsiString;
  begin
    Result:=DH.B_NameSpace[DH.CNames[i]];
  end;




{
  procedure WriteDword(i: dword);
  begin
    CpsStream.WriteBuffer(i, 4);
  end;

  function ReadDword: dword;
  begin
    CpsStream.ReadBuffer(Result, 4);
  end;
  {$endif}
}
  procedure ReadUnaligned(p: pointer; NumBytes: integer);
  {$ifdef support08x}
  var w, i: dword;
  {$endif}
  begin
    ReadFromBuffer(p^, NumBytes);
    {$ifdef support08x}
     if DH.StreamVersion = 0 then begin
       i:= (4 - (NumBytes and 3)) and 3;
       if i > 0 then ReadFromBuffer(w, i);
     end;
    {$endif}
  end;
  
(*  procedure WriteUnaligned(p: pointer; NumBytes: integer);
  begin
    CpsStream.Write(p^, NumBytes);
    CpsStream.Position:= CpsStream.Position + (4 - (NumBytes and 3)) and 3;
  end;
*)

  procedure SkipUnaligned(NumBytes: integer);
  var a: array of byte;
  begin
   {$ifdef support08x}
    if DH.StreamVersion = 0 then
      SetLength(a, AlignGranularity * SizeToBufferIndex(NumBytes))
    else
   {$endif}
      SetLength(a, NumBytes);
    ReadFromBuffer(a[0], Length(a));
  end;

    function AlignedSize(s: integer): integer; inline;
    begin
      Result:=SizeToBufferIndex(s) * SizeOf(integer);
    end;

    function AlignedWideStringSize(s: integer): integer; inline;
    const
      IdW = (SizeOf(integer) div SizeOf(WideChar));
    begin
      Result:=IdW * (1 + ((s - 1) div IdW));
    end;

  procedure SkipWideString; inline;
  begin
    SkipUnaligned(4 * AlignedSize(ReadInt * SizeOf(WideChar)));
  end;

  procedure SkipUnicodeString; inline;
  begin
    SkipUnaligned(4 * AlignedSize(ReadInt * SizeOf(UnicodeChar)));
  end;

  procedure SkipRawByteString; inline;
  begin
    SkipUnaligned(ReadInt());
  end;

  procedure WriteRawByteString(v: RawByteString); inline;
  begin
    WriteInt(Length(v));
    if Length(v) > 0
      then WriteToBuffer(v[1], Length(v))
  end;

  procedure WriteWideString(v: WideString); inline;
  begin
    WriteInt(Length(v));
//***TODO Check if this shit overwrites 1..3 bytes beyond the allocated memory block
//Probably nothing, thanks to allocation granularity, but still...
    if Length(v) > 0 then
      WriteToBuffer(v[1], 4 * SizeToBufferIndex(Length(v) * SizeOf(WideChar)));
  end;

  function ReadWideString(): WideString; inline;
  begin
    SetLength(Result, ReadInt());
    if Length(Result) > 0 then
      ReadFromBuffer(Result[1], 4 * SizeToBufferIndex(Length(Result) * SizeOf(WideChar)));
  end;


  procedure WriteUnicodeString(v: UnicodeString); inline;
  begin
    WriteInt(Length(v));
    if Length(v) > 0 then
      WriteToBuffer(v[1], 4 * SizeToBufferIndex(Length(v) * SizeOf(UnicodeChar)));
  end;

  function ReadUnicodeString(): UnicodeString; inline;
  begin
    SetLength(Result, ReadInt());
    if Length(Result) > 0 then
      ReadFromBuffer(Result[1], 4 * SizeToBufferIndex(Length(Result) * SizeOf(UnicodeChar)));
  end;

  function ReadRawByteString(): RawByteString; inline;
  begin
    SetLength(Result, ReadInt());
    if length(Result) > 0 then ReadUnaligned(@Result[1], length(Result));
  end;

  procedure WriteNil; inline;
  begin
    WriteInt(-1);
  end;

const
  FKName : array[TFieldKind] of WideString = (
   'неподдерживаемый','бинарный','целый','вещественный','строковой (utf-16)','множество',
   'перечислимый','класс','особый','строковой (ANSI)','неперзистентный класс','устаревш. статический массив',
   'перечислимый массив','запись', 'динамический массив', 'запись (упакованная)', 'статический массив',
   'ERRORпользовательский класс', 'метакласс');

  FKNameEnglish : array[TFieldKind] of string = (
   'unsupported','binary','integer','floating-point','string(utf-16)','set',
   'enumerated','class','custom','string(ANSI)','non-persistent class','obsolete static array',
   'enumerated array','record','dynamic array', 'packed record', 'static array',
   'ERRORcustom class', 'metaclass');

function FieldKindToStr(k: TFieldKind): WideString;
  begin
    Result:=RuEn(FKName[k], FKNameEnglish[k]);
  end;
const _ctt: array[0..23] of WideString = (
'нН','бБ','цЦ','вВ','сС','мМ','пП','кК','оО','уУ','зЗ','дД',
'uU','bB','iI','fF','sS','eE','cC','nN','oO','rR','dD','pP');
function FieldKindToCapStr(k: TFieldKind): WideString;
  var j: integer;
  begin
    Result:=RuEn(FKName[k], FKNameEnglish[k]);
    for j:=0 to High(_ctt) do
      if Result[1] = _ctt[j][1]
        then Result[1]:= _ctt[j][2];
  end;


var
  reg_depth: integer = 0; //these two serve to format the log so that the nested class registration calls make sense.
  reg_tabul: WideString = '';
function StringOfSpaces(i: integer): AnsiString;
begin
  SetLength(Result, i);
  if i > 0 then FillChar(Result[1], i, Ord(' '));
end;

  procedure WalkPersistent(o: pointer//TChepersyObject
                            ; fprops: TFieldPropertiesSet); forward;

{$ifdef cge}
  {$include mo_fixedpoint.inc}
{$endif}

{$include mo_cps_dyna.inc}

{$include mo_cps_basket.inc}

{$include mo_cps_typeprocs.inc}

{$include mo_cps_convert.inc}

{$include mo_cps_scenario.inc}

{$include mo_cps_registrator.inc}

{$include mo_cps_trulypersistent.inc}

{$include mo_cps_walker.inc}

{$include mo_cps_garbagecollector.inc}

{$include mo_cps_spaia.inc}

{$include mo_cps_spala.inc}

{ TNameSpace }

function TNameSpace.Ind(i_s: string; AssumedInd: integer): integer;
var
  i: integer;
begin
  i_s:=UpperCase(i_s);
  Result:=-1;
  if (AssumedInd >=0) and (AssumedInd <= High) and (Self[AssumedInd] = i_s)
  then begin
    if Alias[AssumedInd] >= 0 then Result:=Alias[AssumedInd]
                              else Result:=AssumedInd;
  end
  else
    For i:=0 to High do
      if Self[i] = i_s then begin
        if Alias[i] >= 0 then Result:=Alias[i]
                         else Result:=i;
        Break;
      end;
end;

function TNameSpace.Translate(RegNS: TNameSpace): TAOI;
var
  o: TAOI;
  i: integer;
begin
  o:=TAOI.Create;
  o.Length:=Length;
  For i:=0 to High do begin
    o[i]:=RegNS.Ind(Self[i], i); //to speed up translation of identic name spaces
//if Mother^.Debug.Verbose then AddLog('---NS tran: %0 %1 %2',[i, Self[i], o[i]]);
  end;
  Result:=o;
end;

function TNameSpace.Add(a_s: Utf8string): integer;
var
  i: integer;
begin
  a_s:=UpperCase(a_s);
  i:=Ind(a_s, -1);
  if i >=0 then Result:= i//Ind(a_s, -1)
  else begin
    Result:=inherited Add(a_s);
    SetLength(Alias, Self.Length);
    Alias[Result]:= -1;
  end;
end;

function TNameSpace.Add(s1, s2: Utf8string): integer;
var
  i: integer;
begin
  s2:=UpperCase(s2);
  i:=Ind(s1, -1);
  if i >=0 then Result:=Ind(s1, -1)
  else begin
    Add(s2);
    Result:=inherited Add(s1);
    SetLength(Alias, Self.Length);
    Alias[Result]:= Ind(s2, -1);
  end;
end;

//added in 0.8.2
//deprecated in 0.9.0
  function ExportChepersyClassList(): TStringList; //class names per index
    var i: integer;
  begin
    Result:=TStringList.Create;
    For i:=0 to Records.High do
      if Types[Records[i]].Kind in [fk_Class]
        then Result.AddObject(TypeNameSpace[Records[i]], TObject(Types[Records[i]]._class));
  end;

  //added in 0.9.0
  function ExportClassesList(OnlyDescendantsOf: CChepersyObject = nil): TArrayOfExportClassDesc;
  var i: integer;
  begin
    SetLength(Result, 0);
    For i:=0 to Records.High do begin
//writeln(i,': ',TypeNameSpace[Records[i]]);
//writeln( ord(Types[Records[i]].Kind), ' ', ord(fk_Class));
      if (Types[Records[i]].Kind = fk_Class)
        and (not Assigned(OnlyDescendantsOf) or IsDescendantOf(OnlyDescendantsOf, i))
      then begin
//writeln('  passes');
        SetLength(Result, Length(Result) + 1);
        with Result[High(Result)] do begin
          Name:= TypeNameSpace[Records[i]];
          Metaclass:= CChepersyObject(Types[Records[i]]._class);
          Index:= i;
        end;
      end;
     end;
   end;

  function IsDescendantOf(Ancestor, Descendant: CChepersyObject): boolean;
  begin
    Result:= IsDescendantOf(Ancestor, Descendant.ClassIndex());
  end;

  function IsDescendantOf(Ancestor: CChepersyObject; DescendantClassIndex: integer): boolean;
  var aci, ans, i: integer;
  begin
    aci:= Ancestor.ClassIndex();
    ans:= Types[Records[aci]].Name; //the ancestors array is made up of name indices in the global name space.
    for i:= 0 to ClassAncestors[DescendantClassIndex].High do begin
      if ClassAncestors[DescendantClassIndex][i] = ans then Exit(true);
    end;
    Result:= false;
  end;

  function IsRegistered(pinfo: PTypeInfo): boolean;
  var
    i: integer;
  begin
    for i:=0 to Types.High do
      if Types[i].Info = pinfo then Exit(true);
    Result:= false;
  end;

  var gsb_p: pointer;
  function GetStackLimit(): pointer; inline;
  {$ifdef windows}
  var
    Tmm: TMemoryBasicInformation;
  {$else}

  {$endif}
  begin
    {$ifdef windows}
     (* {$ifdef cpu64}
        //WhyTF mov qword[gsb_p], rsp causes a HARD crash-to-desktop ?
        Asm
          mov rax, rsp
          mov qword[gsb_p], rax
        End['rax'];
      {$else}
        Asm
          mov [gsb_p], esp
        End;
      {$endif}
*)
      gsb_p:= sptr();
      if VirtualQuery(gsb_p, @Tmm, SizeOf(Tmm)) <> sizeof(Tmm)
        then Die(RuEn(
          'Не удалось получить информацию о блоке памяти стека',
          'Failed to get info for the stack memory block'));
      Result:= Tmm.AllocationBase;
      if Mother^.Debug.Verbose
        then AddLog('  Stack limit is %0 (%3 = %1, reserve %2 Mb)'
          , [Result, gsb_p, (ptruint(gsb_p) - ptruint(Result)) div (1024 * 1024)
            , {$ifdef cpu64}'RSP'{$else}'ESP'{$endif}]);
      {$else}
Result:= nil;
//***TODO: find the way. There should be a way. As it is now,
// custom stack checking only works in Windows
    {$endif}
  end;

  function GetTypeIndex(info: PTypeInfo): integer;
  var i: integer;
  begin
    For i:= 0 to Types.High do if Types[i].info = info then Exit(i);
    Result:= -1;
  end;

  function GetTypeInfoMd5(p: PTypeInfo): TMd5Digest;
  var i: integer;
  begin
    i:= GetTypeIndex(p);
    if i < 0
      then FillChar(Result, SizeOf(Result), 0)
      else Result:= Types[i].TypeInfoMd5;
  end;

  type TMd5DigestQword = packed record
    case integer of
    0: (
      D: TMd5Digest;
    );
    1: (
      Q: Qword;
    );
  end;

  function Md5String(s: RawByteString): TMd5Digest;
  begin
    Result:= md5.Md5String(s);
  end;

  function Md5String(s: UnicodeString): TMd5Digest;
  begin
    Result:= Md5String(Utf8Encode(s));
  end;

  function GetTypeInfoByName(n: RawByteString): PTypeInfo;
  var
    i: integer;
  begin
    i:= NameSpace.Ind(n, -1);
    if i < 0
      then Result:= nil
      else Result:= Types[i].Info;
  end;

  function GetNameByTypeInfo(p: PTypeInfo): RawByteString;
  var
    i: integer;
  begin
    Result:= '';
    for i:=0 to Types.High do
      if Types[i].Info = p then begin
        Result:= NameSpace[Types[i].name];
        break;
      end;
  end;
