{
    This file is part of chepersy
    Copyright (c) 2004-2015 by Anton Rzheshevski (chebmaster@mail.ru),

    See the file COPYING.CPS, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}


{
    This file contains headers for the sparce longint index.
}


  TSparceLongintArrayAbstractChunk = class(TChepersyObject)
  protected
    f_count: Longint;
  public
    procedure CopyTo(otherchunk: TSparceLongintArrayAbstractChunk); virtual; abstract;

    function Get(off: dword): Longint; virtual; abstract;

    function Add(off: dword; L: Longint): TSparceLongintArrayAbstractChunk;
      virtual; abstract; { May upgrade itself to a larger chunk }

    function Remove(off: dword): TSparceLongintArrayAbstractChunk;
      virtual; abstract; { May demote itself to a smaller chunk or just call
                                                    Self.Free and return nil! }
    property Count: Longint read f_count;

    procedure RegisterFields; override;
  end;


  TSparceLongintArrayChunk3 = class(TSparceLongintArrayAbstractChunk)
  protected
    type
      T64DwordArray = array[0..63] of dword; //array[0..1023] of <2 bits>;
      TSLAC3MAOArray = array[1..3] of Longint;
      TSLAC3BIArray = array[1..3] of word;
    var
      data: TSLAC3MAOArray;
      bind: TSLAC3BIArray;
      reloc: T64DwordArray;
  public
    procedure CopyTo(otherchunk: TSparceLongintArrayAbstractChunk); override;
    function Get(off: dword): Longint; override;
    function Add(off: dword; L: Longint): TSparceLongintArrayAbstractChunk; override;
    function Remove(off: dword): TSparceLongintArrayAbstractChunk; override;
    procedure RegisterFields; override;
  end;


  TSparceLongintArrayChunk15 = class(TSparceLongintArrayAbstractChunk)
  protected
    type
      T128DwordArray = array[0..127] of dword; //array[0..1023] of <4 bits>;
      TSLAC15MAOArray = array[1..15] of Longint;
      TSLAC15BIArray = array[1..15] of word;
    var
      data: TSLAC15MAOArray;
      bind: TSLAC15BIArray;
      reloc: T128DwordArray;
  public
    procedure CopyTo(otherchunk: TSparceLongintArrayAbstractChunk); override;
    function Get(off: dword): Longint; override;
    function Add(off: dword; L: Longint): TSparceLongintArrayAbstractChunk; override;
    function Remove(off: dword): TSparceLongintArrayAbstractChunk; override;
    procedure RegisterFields; override;
  end;



  TSparceLongintArrayChunk255 = class(TSparceLongintArrayAbstractChunk)
  protected
    type
      TThousandByteArray = array[0..1023] of Byte;
      TSLAC256BIArray = array[1..255] of word;
    var
      data: TArrayOfLongint; { The array only shrinks during
        defragmentation, which only happens before saving }
      bind: TSLAC256BIArray;
      reloc: TThousandByteArray;
    procedure Defragment;
  public
    procedure CopyTo(otherchunk: TSparceLongintArrayAbstractChunk); override;
    function Get(off: dword): Longint; override;
    function Add(off: dword; L: Longint): TSparceLongintArrayAbstractChunk; override;
    function Remove(off: dword): TSparceLongintArrayAbstractChunk; override;
    procedure RegisterFields; override;
    procedure BeforeSaving; override;
    destructor Destroy; override;
  end;



  TNotSoSparceLongintArrayChunk = class(TSparceLongintArrayAbstractChunk)
  protected
  type
    TThousandLongintArray = array[0..1023] of Longint;
  var
    data: TThousandLongintArray; { if more than one fourth of the chunk is filled,
      switch to full-sized storage to avoid fragmentation }
  public
    procedure CopyTo(otherchunk: TSparceLongintArrayAbstractChunk); override;
    function Get(off: dword): Longint; override;
    function Add(off: dword; L: Longint): TSparceLongintArrayAbstractChunk; override;
    function Remove(off: dword): TSparceLongintArrayAbstractChunk; override;
    procedure RegisterFields; override;
  end;



  TSparceLongintArray = class(TChepersyObject)
  protected
    type
      TSparceLongintArrayChunksArray = array of TSparceLongintArrayAbstractChunk;
    var
      chunks: TSparceLongintArrayChunksArray;
      chunks_offset: dword;
      f_count: longint;
    procedure ShrinkArray();
  public
    procedure Clear;
    procedure Add(index: Longint; L: Longint);
    function Get(index: Longint): Longint;
    procedure RegisterFields; override;
    procedure BeforeSaving; override;
    property Count: Longint read f_count;
    property Data[index: Longint]: Longint read Get write Add; default;
  end;

{
  generic TSparceMOArray<T> = class(TSparceObjectArray)
  public
    procedure Add(index: Longint; o: T);
    function Get(index: Longint): T;
  end;
}



