// http://gafferongames.com/networking-for-game-programmers/floating-point-determinism/

type

  fixed32 = packed record
    i: longint;
  end;


  fixed64 = packed record
    i: int64;
  end;


  fixedFake = packed record
    f: single;
  end;

  fixed = fixed32;

  operator := (f: fixed32) s: single;
//  operator := (f: fixed64) s: single;
  operator := (f: fixed32) d: double;
//  operator := (f: fixed64) d: double;


  operator := (f: fixed32) i: int64;
  operator := (f: fixed32) i: qword;
  operator := (f: fixed32) i: longint;
  operator := (f: fixed32) i: dword;
  operator := (f: fixed32) i: smallint;
  operator := (f: fixed32) i: word;
  operator := (f: fixed32) i: shortint;
  operator := (f: fixed32) i: byte;

  operator := (i: int64) f: fixed32;
  operator := (i: qword) f: fixed32;
  operator := (i: longint) f: fixed32;
  operator := (i: dword) f: fixed32;
  operator := (i: smallint) f: fixed32;
  operator := (i: word) f: fixed32;
  operator := (i: shortint) f: fixed32;
  operator := (i: byte) f: fixed32;


  operator := (s: single) f: fixed32;
  operator := (d: double) f: fixed32;
//  operator := (s: single) f: fixed64;
//  operator := (d: double) f: fixed64;

  operator * (a, b: fixed32) z: fixed32;
  operator / (a, b: fixed32) z: fixed32;
  operator + (a, b: fixed32) z: fixed32;
  operator - (a, b: fixed32) z: fixed32;


  //Since we have boolean re-defined as longbool, it says Error: Comparative operator must return a boolean value
  operator = (a, u: fixed32) b: System.boolean;
  operator < (a, u: fixed32) b: System.boolean;
  operator > (a, u: fixed32) b: System.boolean;
  operator >= (a, u: fixed32) b: System.boolean;
  operator <= (a, u: fixed32) b: System.boolean;

  function FixedToStr(Value: fixed32): string; overload;
  function FixedToStr(Value: fixed32; const FormatSettings: TFormatSettings): string; overload;


