


procedure TGameLayer.RegisterFields;
begin
  RegClass(TGameTickSchedule);
  RegType(typeinfo(TickScheduleArray), typeinfo(TGameTickSchedule));

  inherited;

  ListFields([
    'LayerKind', @LayerKind, typeinfo(longint),
    'NoSplittingOnWrite', @NoSplittingOnWrite, typeinfo(boolean),
    'container', @container, typeinfo(TSparceObjectArray),
    'parent', @Parent, CPS_Managed_object,
    'children', @Children, typeinfo(TArrayOfChepersyObjects), //TGameObjectLayerArray but Chepersy can't deal with such circulars
    'TickSchedules', @TickSchedules, typeinfo(TickScheduleArray),
    'FullGameplayTime', @FullGameplayTime, typeinfo(int64),
    'LoopingGameplayTime', @LoopingGameplayTime, typeinfo(SmallInt)
  ]);
end;


procedure TGameLayer.AddNew(o: TGameObject); //2b used by the game object constructor
var
  oo: TGameObject;
  i, a, r: Longint;
begin
  if Self.LayerType = 0 then begin
    a:= Game.RefCounts[0].FindFreeIndex();
    o.Index:= a;
  end
  else begin
    if Assigned(Render)
      then o.Index:= Render.Objects.FindFreeIndex()
      else o.Index:= - Game.RefCounts[1].FindFreeIndex();
  end;


  Inc(o.RefCount);
  if Container.Has(index) then begin
    i:= index shr 31;
    a:= abs(index);
  Game.RefCounts[i][a];
    if r > 1 then begin


    end
    else
      if r = 1 then begin
        TGameObject(Container.Get(index)).Free;
      end
    Dec(oo.RefCount);
    if oo.RefCount < 1 then oo.Free;  //no Scrape for these things
  end;
  Container.Add(index, o);
end;

procedure TGameLayer.Remove(index: Longint);
var
  o: TGameObject;
begin
  if not Container.Has(index) then Exit;
  o:= TGameObject(Container.Get(index));
  if o.RefCount > 1
    then Dec(o.RefCount)
    else o.Free; //no Scrape for these things
  Container.Remove(index);
end;

function TGameLayer.GetForModification(index: Longint): TGameObject;
var
  o: TGameObject = nil;
  i: integer;
  prnt: TGameLayer;
  procedure Split; inline;
  begin
    o:= Result;
    Result:= TGameObject(o.Clone);
    Result.RefCount:= 0;
    Self.Add(index, Result); //does both Result.RefCount++ and o.RefCount--
  end;
begin
  Result:= TGameObject(Container.Get(index));
  if Assigned(Result) then begin
    if Result.RefCount > 1 then Split;
    if Assigned(Children) then begin
       for i:= 0 to High(Children) do
        with Children[i] do
          if not NoSplittingOnWrite and not Has(index)
          then begin
            if not Assigned(o) then Split;
            Add(index, o);
          end;
    end;
  end
  else begin
    if Assigned(Parent) then Result:= Parent.Get(index);
    if Assigned(Result) then Split;
  end;
end;

function TGameLayer.Get(index: Longint): TGameObject;
begin
  Result:= TGameObject(Container.Get(index));
  if not Assigned(Result) and Assigned(Parent) then Result:= Parent.Get(index);
end;

function TGameLayer.Has(index: Longint): boolean;
begin
  Result:= Container.Has(index);
end;

constructor TGameLayer.Create;
begin


end;

destructor TGameLayer.Destroy;
begin


end;

procedure TGameLayer.Scrape;
var i: Integer;
begin
  if Assigned(Children) then for i:=0 to High(Children) do Children[i].Scrape;
  if Assigned(Container) then begin
    Container.FreeContained;
    Container.Free;
  end;

end;

procedure TGameLayer.Tick;
begin

end;

function TGameLayer.SpawnMultiplayerFloatingLayer(): TGameLayer;
begin

end;




