{
    This file is part of Chentrah,
    Copyright (C) 2004-2008 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************

    This file contains the log/error processing routines.

 **********************************************************************}
 
//Temporary. To be incorporated later into the module body.



  function StrOrUndefined(U: UnicodeString): UnicodeString;
  begin
    if U='' then Result:=PUnicodeCharToUnicodeString(Mother^.Core.MsgToString(MI_UNDEFINED))
            else Result:=U;
    AfterEfCheck;
  end;

 {$ifdef win32}
  function Win32LastError: UnicodeString;
  var
    M: Cardinal;
    u: UnicodeString;
  begin
    Result:='';
{    M:=GetLastError;
    if M = ERROR_SUCCESS then Result:=''
    else begin
      u:=AnsiToWide(SysErrorMessage(M));
      Result:=#10#13 + Result + #10#13 + PervertedFormat(
        PUnicodeCharToUnicodeString(MsgRaw(MI_WIN32_EXPLAINS)),
        [IntToHex(M, 8), u]);
    end;}
  end;
 {$endif}

    //var _dyell: UnicodeString;

    function ExceptObjectisException: boolean;
    begin
      Try
        Result:=ExceptObject is Exception;
      Except
        Result:=No;
      End;
    end;





{$ifdef windows}
  function SehNameByCode(pes: PMotherSehState): UnicodeString;
  begin
//bgSay('* SehNameByCode, ' + inttohex(ptruint(pes), 8));
    case pes^.ExceptionCode of
      $C0000005: begin
        Result:= 'Access Violation,';
        if pes^.ExceptionAddress <> 0 then begin //otherwise it reports both reading and executing at NIL

          Result+= #10#13'    ' + RuEn('Попытка ', 'Attempt to ');
          case pes^.AVMemoryOperation of
            0: Result+= RuEn(
              'чтения',
              'read from');
            1: Result+= RuEn(
              'записи',
              'write to');
            8: Result+= RuEn(
              'нарушить политику DEP (Предотвращения Выполнения Данных)'#10#13'    ',
              'violate the DEP policy (Data Execution Prevention) at'#10#13'    ');
          else
            Result+= '<unknown kind of memory access>';
          end;
          if pes^.AVMemoryAddress = 0
            then Result+= RuEn(
              ' по нулевому адресу',
              ' the NULL address')
            else Result+= RuEn(
              ' по адресу ',
              ' ')
              + IntToHex(pes^.AVMemoryAddress, 2 * sizeof(pointer)) + 'h'
              + #10#13 + ToldMemRgn(pointer(pes^.AVMemoryAddress));
        end;
      end;
      $C0000006: Result:= 'IN_PAGE_ERROR';
      $C0000008: Result:= 'INVALID_HANDLE';
      $C0000017: Result:= 'NO_MEMORY';
      $C000001D: Result:= 'ILLEGAL_INSTRUCTION';
      $C0000025: Result:= 'NONCONTINUABLE_EXCEPTION';
      $C0000026: Result:= 'INVALID_DISPOSITION';
      $C000008C: Result:= 'ARRAY_BOUNDS_EXCEEDED';
      $C000008D: Result:= 'FLOAT_DENORMAL_OPERAND';
      $C000008E: Result:= 'FLOAT_DIVIDE_BY_ZERO';
      $C000008F: Result:= 'FLOAT_INEXACT_RESULT';
      $C0000090: Result:= 'FLOAT_INVALID_OPERATION';
      $C0000091: Result:= 'FLOAT_OVERFLOW';
      $C0000092: Result:= 'FLOAT_STACK_CHECK';
      $C0000093: Result:= 'FLOAT_UNDERFLOW';
      $C0000094: Result:= 'INTEGER_DIVIDE_BY_ZERO';
      $C0000095: Result:= 'INTEGER_OVERFLOW';
      $C0000096: Result:= 'PRIVILEGED_INSTRUCTION';
      $C00000FD: Result:= 'STACK_OVERFLOW';
      $C000013A: Result:= 'CONTROL_C_EXIT';
      $C00002B4: Result:= 'FLOAT_MULTIPLE_FAULTS';
      $C00002B5: Result:= 'FLOAT_MULTIPLE_TRAPS';
      $C00002C9: Result:= 'REG_NAT_CONSUMPTION';
    else
      Result:= RuEn('Неизвестное ','Unknown ') + IntToHex(pes^.ExceptionCode, 2 * sizeof(pointer)) + 'h'
    end;
//bgSay('  Result = ' + Result);
  end;
{$else}
  function SehNameByCode(pes: PMotherSehState): UnicodeString;
  begin
    case pes^.ExceptioncCode of
       1: Result:= 'SIGFPE, Floating point exception -- no further details available';
       2: Result:= 'SIGFPE, Division by zero';
       3: Result:= 'SIGFPE, Invalid FPU state';
       4: Result:= 'SIGFPE, Floating point overflow';
       5: Result:= 'SIGFPE, Floating point underflow';
       6: Result:= 'SIGFPE, Floating point denormal';
       7: Result:= 'SIGFPE, Floating point exception';
       8: Result:= 'SIGBUS';
       9: Result:= 'SIGILL, Access Violation';
      10: Result:= 'SIGSEGV, Access Violation';
    else
      Result:= RuEn('Неизвестное ','Unknown ') + IntToHex(c, 8) + 'h'
    end;
  end;
{$endif}

  type MyException = class(Exception);

  //sep 2014: what the FUCK is this procedure? I don't remember using it anywhere
{
procedure MySafeCallErrorProc(error : HResult;addr : pointer);
  var a, ca: pointer; i: integer;
    p: procedure; register;
  begin
    Raise Exception(NIL) at addr;//MyException.Create('blah') at addr;
    addlog('safecall %0',[IntToHex(error,8)]);
    if error <> 0 then begin
      SafeCallExceptionCaught:= true;
      Die(RuEn('Исключение при safecall вызове.','Safecall exception.'));
    end
    else begin
      asm
        MOV EAX, DWORD[addr];
        JMP EAX;
      end;
    end;
}
(*    //try Die(RuEn('Исключение при safecall вызове.','Safecall exception.')) except end;
    _dyell:= RuEn('Safecall-исключение: ','Safecall exception: ')
      + SehNameByCode(error)
      + #10#13'  ' + SehHackTellExceptionAddress(cardinal(addr));
    if not Mother^.State.NowDying
     then begin
      Mother^.State.DyingAfterTrueException:= True;
      if not Mother^.State.CallStackLogged then begin
        _crash_details:= '';
        i:=0;
        a:= get_frame;
        while Assigned(a) do begin
          ca:= get_caller_addr(a);
          {ignore the first two callers. These always are: 0). call to this
            procedure from Die() or TryWrap() and 1). Call to Die itself from the
            except... block}
          if Assigned(ca) then begin
            if i = 1 then _crash_details+= #10#13'Call stack:';
            if i >= 1 then _crash_details+= #10#13'  ' + ShortExpAddr(ca);
            inc(i);
          end
          else Break;
          if i> MAX_STACK_FRAMES_DUMP then break;
          a:= get_caller_frame(a);
        end;
        with Mother^ do begin
          if _crash_Details <> '' //State.DeveloperMode or State.DebugMode
            then _dyell+= #10#13#10#13 + _crash_Details;
          State.CallStackLogged:= Yes;
        end;
      end;
    end;
    Mother^.Core.DyingYellW(PUnicodeChar(_dyell));
    with Mother^ do
      if not State.DeveloperMode and not State.DebugMode and not GenericDyingYellsLogged
        then AddLog('%0'#10#13'<---------------------->',[_crash_details]);
    if Assigned(OldSafeCallErrorProc) then OldSafeCallErrorProc(error, addr);
  *)
//  end;




  Procedure AddLog(S: Ansistring; Param: array of const);
  var w: UnicodeString;
  begin
    gv_LogCS.Enter;
    w:= AnsiToWide(S);
    gv_LogCS.Leave;
    AddLog(w, Param);
  end;

   // var _2log: UnicodeString;
  Procedure AddLog(U: UnicodeString; Param: array of const);
   var
     _2log, tn: UnicodeString;
     tnum: integer;
  begin
    gv_LogCS.Enter;
    // BULLCRAP. The mother AddLog is inherently thread safe since
    //   the mother started using threads for polling the XBox360 game controller

    //{$ifdef windows}
    //  if Mother^.State.MainThreadId <> GetCurrentThreadId() then begin
    //    ThreadManager.PassLog(PervertedFormat(u, Param));
    //    exit;
    //  end;
    //{$else}
    //  {$fatal not implemented yet}
    //{$endif}
    _2log:=PervertedFormat(u, Param);
    if (Mother^.State.MainThreadId <> GetCurrentThreadId()) then begin
      tnum:= -1;
      if Assigned(Module.ThreadManager)
        then tnum:= Module.ThreadManager.GetThreadNumById(GetCurrentThreadId());
      if (tnum < 0)
        then tn:= RuEn('неучтённый поток','unaccounted thread')
        else tn:= RuEn('поток №','thread #') + IntToStr(tnum);
      _2log:= PervertedFormat('(%0) ' + _2log, [tn]);
    end;

    Mother^.Core.LogW(PUnicodeChar(_2log));
    gv_LogCS.Leave;
   // AfterEfCheck; //whoops... This caused an infinite exception loop.
  end;

  Procedure AddLog(mID: TMessageID; Param: array of const);
  var w: UnicodeString;
  begin
    gv_LogCS.Enter;
    w:= MsgFormat(mID, Param);
    gv_LogCS.Leave;
    AddLog(w, []);
  end;

  Procedure AddLog(mID: TMessageID);
  begin
    AddLog(mID, []);
  end;

  Procedure AddLog(S: AnsiString);
  var w: UnicodeString;
  begin
    gv_LogCS.Enter;
    w:= AnsiToWide(S);
    gv_LogCS.Leave;
    AddLog(w, []);
  end;

  Procedure AddLog(U: UnicodeString);
  begin
    AddLog(U, []);
  end;

  procedure DbgSay(w: UnicodeString);
  begin
    Mother^.Core.DbgSay(PUnicodeChar(w));
  end;

{$ifndef unix}
function mo_ReportDebugBacktrack(addr: pointer): UnicodeString;
begin
  Result:=ExpExpAddress(addr);
end;

(*
Procedure mo_CatchUnhandledException (Obj : TObject; Addr: Pointer; FrameCount: Longint; Frames: PPointer);
Var
  Message : UnicodeString;
  i : longint;
begin
  Message:= 'An unhandled exception occurred at ' + HexStr(Ptrint(Addr),sizeof(PtrInt)*2) + ' :'#10#13;
  if Obj is exception
    then Message+= '  ' + Exception(Obj).ClassName+' : '+Exception(Obj).Message
    else Message+= '  Exception object '{ + Obj.ClassName} + ' is not of class Exception.';
  Message+= #10#13 + BackTraceStrFunc(Addr);
{  if (FrameCount>0) then
    begin
      for i:=0 to FrameCount-1 do
        Message+= #10#13 + BackTraceStrFunc(Frames[i]);
    end;}
  Mother^.Core.DyingYellW(PUnicodeChar(Message));
  Halt(217);
end;
*)

{  Procedure CgeCatchUnhandledException (Obj : TObject; Addr: Pointer; FrameCount: Longint; Frames: PPointer);
  begin
    Die('An unhandled exception occurred at %0'#10#13'  %1:  %2', [Addr, Exception(Obj).ClassName, Exception(Obj).Message]);
    Writeln(stdout,'An unhandled exception occurred at $',HexStr(Ptrint(Addr),sizeof(PtrInt)*2),' :');
    if Obj is exception
      then Die('An unhandled exception occurred at %0'#10#13'  %1:  %2', [Addr, Exception(Obj).ClassName, Exception(Obj).Message])
      else Die('An unhandled exception occurred at %0', [Addr]);
  end;
     }
{$endif}

procedure PlaySound(wawfilename: ansistring);
begin
  Mother^.Sound.PlayFromFile(PAnsiChar(wawfilename));
  AfterEfCheck;
end;

function IsHashZero(h: TAssetHash): boolean;
begin
  Result:= (h.Q1 = 0) and (h.Q2 = 0) and (h.Q3 = 0) and (h.Q4 = 0);
end;

procedure ZeroHash(var h: TAssetHash);
begin
  FillChar(h, SizeOf(h), 0);
end;

function HashToHex(h: TAssetHash): UnicodeString;
begin
  Result:= IntToHex(h.Q1, 16) + IntToHex(h.Q3, 16) + IntToHex(h.Q2, 16) + IntToHex(h.Q1, 16);
end;

function SetToStr(pset: pointer; BasicEnumTypeInfo: ptypeinfo): UnicodeString;
 var
   e: array of UnicodeString = nil;
   i: integer;
   D: PTypeData;
 begin
   if not (BasicEnumTypeInfo^.Kind in [tkEnumeration, tkInteger])
     then Exit (RuEn(
       '<приведённая TypeInfo не принадлежит перечислимому типу>',
       '<the TypeInfo provided os not of an enumerated type>'));
   D:= GetTypeData(BasicEnumTypeInfo);
   if D^.MinValue <> 0
      then Exit(RuEn(
        '<не рассчитано на поддиапазонные типы>',
        '<not designed for subrange types>'));
   if D^.MaxValue > 31
     then Exit(RuEn(
        '<рассчитано только на типы, множества от которых приводимы к dword (не более 32 элементов)>',
        '<only designed for enums with derivative sets type-castable to dword (no more than 32 entries)>'));
   for i:= 0 to D^.MaxValue do begin
     if (dword(pset^) and (dword(1) shl i)) = 0 then continue;
     SetLength(e, Length(e) + 1);
     if BasicEnumTypeInfo^.Kind = tkEnumeration
       then e[High(e)]:= GetEnumName(BasicEnumTypeInfo, i)
       else e[High(e)]:= IntToStr(i);
   end;
   Result:= '[' + Implode(', ', e) + ']';
 end;



