

procedure TLogic.RegisterJoystickMovement(t: TJoystickType; _x, _y, _dx, _dy: float);
  var i, it: integer;
  begin
    it:= ord(t);
    if (it < 0) or (it > ord(high(TJoystickType))) then Exit; //when range checking is off, shit could happen.
    if length(JoysticksStates[t]) < JoystickHistoryLimit
      then SetLength(JoysticksStates[t],
        length(JoysticksStates[t]) + 1);
    if length(JoysticksStates[t]) > JoystickHistoryLimit then SetLength(JoysticksStates[t], JoystickHistoryLimit);
    for i:= high(JoysticksStates[t]) downto 1 do JoysticksStates[t][i]:= JoysticksStates[t][i - 1];
    with JoysticksStates[t][0] do begin
      x:= _x;
      y:= _y;
      dx:= _dx;
      dy:= _dy;
    end;
  end;


	procedure TLogic.ProcessMessages();
	var e: PInputEvent;
	begin
    if f_FrameNum = 1 then OnPress(KEY_NULL); //send a fake mouse pointer movement message
    while true do begin
			e:= Self.UnshiftInputEvent();
			if not Assigned(e) then break;
			case e^.EventType of
				CGM_PRESS, CGM_RELEASE, CGM_TYPE: begin
				  mousex:= Trunc(e^.mx);
				  mousey:= Trunc(e^.my);
				  case e^.EventType of
					CGM_PRESS: OnPress(e^.key);
					CGM_RELEASE: OnRelease(e^.key);
					CGM_TYPE: TextInput+= e^.character;
				  end;
				end;
				CGM_MOUSEMOVE: begin
				  //mx:=Mother^.Input.GetEventElement();
				  //AfterEfCheck;
				  //my:=Mother^.Input.GetEventElement();
				  //AfterEfCheck;
				  if (Trunc(e^.mx) <> mousex) or (Trunc(e^.my) <> mousey) then begin
					mousex:= Trunc(e^.mx);
					mousey:= Trunc(e^.my);
					OnPress(KEY_NULL);
				  end;
				end;
				CGM_MOUSEDELTA: begin
					mousefpsdx:= e^.mx;
					mousefpsdy:= e^.my;
				end;
				CGM_PEN: begin
		//          PenState.x:= e^.PenX;
		//          PenState.y:= e^.PenY;
				  mousex:= e^.PenX;
				  mousey:= e^.PenY;
				  PenState.pressure:= e^.PenPressure;
				  PenState.xTilt:= e^.PenReserved1;
				  PenState.yTilt:= e^.PenReserved2;
				  PenState.Rotation:= e^.PenReserved3;
				  OnPress(KEY_TABLET_PEN_ACTION);
				  Mother^.Timer.CullFrameRate:= 999; //pedal to metal! (disable framerate culling for the next frame: pen tablet messages may flow in at a very high rate)
				end;
				CGM_JOYSTICK: begin
				  Self.RegisterJoystickMovement(e^.JoyType, e^.JoyX, e^.JoyY, e^.JoydX, e^.JoydY);
				end;
			else
				; //silently ignore unknown events Die(MI_ERROR_PROGRAMMER_NO_BAKA, ['TModule.ProcessMessages() :Invalid input ' + IntToStr(t)]);
			end;
      Dispose(e);
		end;
	end;


	procedure TLogic.PushInputEvent(e: PInputEvent);
	begin
		EnterWv(InputCs);
    try
      SetLength(InputEvents, Length(InputEvents) + 1);

      //the original event points to a temporary location
      //  allocated by the mother mm. Untouchable, must copy.
		  InputEvents[High(InputEvents)]:= new (PInputEvent);
		  MOVE(e^, InputEvents[High(InputEvents)]^, sizeof(TInputEvent));
    finally
      InputCS.Leave;
    end;
	end;

	function TLogic.UnshiftInputEvent(): PInputEvent;
	var i: integer;
	begin
		EnterWv(InputCs);
    try
      if Length(InputEvents) = 0 then Result:= nil
		  else begin
			  Result:= InputEvents[0];
        if Length(InputEvents) > 1
          then InputEvents:= COPY(InputEvents, 1, Length(InputEvents) - 1)
          else SetLength(InputEvents, 0);
		  end;
    finally
      InputCS.Leave;
    end;
	end;

  function TLogic._get_pressed_keys: TKeySet;
  var k: TKey;
  begin
    Result:= [];
    for k in TKey do if Self.KeyDown[k] then Include(Result, k);
  end;

  function TLogic.CheckHotkey(k: Tkey; def: TKeySetArray): boolean;
  var
    pk: TKeySet;
    i: integer;
  begin
//pk:=[k]; addlog('* %0',[GetOneHotKeyName(pk)]);
    //if Self.KeyDown[k] then Exit(false);
    result:= false;
    pk:= Self.PressedKeys + [k]; //cache it
    for i:= 0 to High(def) do begin
      if ([k] * def[i]) <> [k] then continue;
      if (def[i] * pk) = def[i] then begin Result:= true; break end;
    end;
  end;


 { These two are called by ProcessMessages(),
      they dispatch events to MainMenu and Control. }
  procedure TLogic.OnPress(key: TKey);
  begin
    if (ord(key) < 0) or (ord(key) > 255) then Die('Invalid pressed key, scan code = %0', [ord(key)]); //shit happens
    if (key <> KEY_NULL)
      and (Mother^.Module.State <> ms_WaitingForModuleToFinish)
    then begin
      if
        CheckHotKey(key, Module.MainMenuHotKey)
        and (not Assigned(MainMenu))// or MainMenu.Scraped)
      then begin
        InvokeMenu(TModuleMainMenu);
        Exit;
      end;

      if CheckHotKey(key, Module.QuickSaveHotKey) then begin
        SaveSession;
        Exit;
      end;

      if CheckHotKey(key, Module.QuickLoadHotKey) then begin
        RollbackSession;
        Exit;
      end;

      if CheckHotKey(key, Module.ScreenShotHotKey)
        and (Mother^.Display.Screenshot.request = 0)
      then begin
        if Mother^.Debug.Verbose then AddLog('Hot key detected, requesting the mother to prepare data for a screenshot');
        Mother^.Display.Screenshot.request:= 1;
      end;
    end;
    if not (Key in NonKeys) and
      (KeyDown[key] and not (Mother^.Input.TextInput and (key in KeysAcceptingAutoRepeatInTextInputMode)))
    then Exit;
    KeyDown[key]:=Yes;
    if Assigned(Control)
      and (Mother^.Module.State <> ms_WaitingForModuleToFinish)
      then Control.OnKey(key);

    if Assigned(MainMenu)
      then MainMenu.OnKey(key);
  end;

  procedure TLogic.OnRelease(key: TKey);
  begin
    if not KeyDown[key] then Exit;
    KeyDown[key]:=No;
    if Assigned(Control)
      then Control.OnKey(key);
    if Assigned(MainMenu)
      then MainMenu.OnKey(key);
  end;
