{
    This file is part of Chentrah,
    Copyright (C) 2004-2014 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************}

//This is for _asynchronous_ file operations
//C

{$include mo_globaldefs.h}
{$typeinfo on}

unit mo_skin_atlas;
interface
uses SysUtils, Classes {$ifdef windows}, Windows {$else} , baseunix, dl {$endif},
  mo_hub, chepersy, mo_classes, syncobjs, mo_threads, mo_assets, mo_image;



type

  TSkinAtlas = class; //forward declaration

  TImageListEntry = packed record
    DecodeTask: TImageDecodeTask;
    width, height, memsize: longint;
    name: TFileNameString;
  end;
  TImageList = array of TImageListEntry;

  TSkinAtlasInitTask = class(TAbstractThreadedTask)
  protected
    f_sa: TSkinAtlas;
    f_list: TImageList;
    function Perform: boolean; override;
  public
    property List: TImageList read f_list;
    function GetType: TThreadedTaskType; override;
    constructor Create(sa: TSkinAtlas);
  end;


  TSkinAtlas = class(TGenericAsset)
  protected
    f_list: TImageList;
    f_init_task: TSkinAtlasInitTask;
    function _GetActualized: boolean; override;
//b: boolean;
  public
    property PakFiles: TArrayOfPackFiles read f_paks;
    property List: TImageList read f_list;

    procedure RegisterFields; override;
    procedure OnModuleDestroy; override;
//    procedure GenResource; override;
//    procedure FreeResource; override;

    procedure ClearCache;
    procedure Refresh; virtual;

    function Actualize: boolean; override;

    function FileExists(n: TFileNameString): boolean;
    function GetFileSize(n: TFileNameString): ptrint;

    //To be used by threaded tasks ONLY:
    //Checks the current thread ID (on the Wiindows platform)
    function ReadFile(fname: TFileNameString; var fhash: TAssetHash): TArrayOfByte;

    function GetHash(fname: TFileNameString): TAssetHash;
    function MakeCombinedHashOfManyFiles(
      _list: TFileListArray): TAssetHash; { in this case, hash consists of:
       Age -- equals to number of files
       NameCRC -- crc32 of all names joined sequentially
       FileSize -- combined size of all files
    }

    function Devour(c: TGenericAsset): boolean; override;
    procedure EraseContainer; override;
    procedure CopyLists(out l: TFileListArray; out p: TArrayOfPackFiles); //on devoured
    procedure EraseLists; virtual; //on devoured
    procedure DumpIncompleteLists; virtual; {Usually called after devour
      if not actualized (one of the pak files changed on disk).
      Can be invoked by the pak files if it finds the file on disk changed
    }
    procedure RebuildListFromPaks;
  end;

implementation

uses crc, mo_module;

