  function GetHigherPowerOf2 (i: integer): integer;
  begin
    if (cardinal(i) > (1 shl 31)) then Exit(0);
    Result:=1;
    repeat
      Result:=Result shl 1
    until Result >= i;
  end;

  function GetLowerPowerOf2 (i: integer): integer;
  var p: integer = 0;
  begin
    repeat inc(p) until (i shr p) = 0;
    Result:=1 shl (p - 1);
  end;

  function UnmangleFileName (a: TFileNameString): TFileNameString;
  begin
    if (Length(a) < 2) or (a[1] <> '*') then Result:= a
    else begin
      case a[2] of
        'M': begin
              {$ifndef cgemodule}
               if not Assigned(Module)
                 then Die(MI_ERROR_PROGRAMMER_NO_BAKA,
                   ['Module = NIL when called UnmangleFileName(''' + a + ''')']);
              {$endif}
               Result:= Mother^.State.ModuleBaseDir
             end;
        'C': Result:= Mother^.State.CacheDir;
        'S': Result:= Mother^.State.SessionDir;
        'H': Result:= Mother^.State.HomePath;
        'I': Result:= Mother^.State.InstallPath;
      else
        Die(MI_ERROR_PROGRAMMER_NO_BAKA, ['Unknown symbol "' + a[2] +'" in the mangled file name "'+a+'".']);
      end;
      if Length(a) > 3 then Result+= COPY(a, 4, length(a) - 3);
    end;
  end;

  function MangleFileName (a: TFileNameString): TFileNameString;
  var i: integer;
  begin
    if {$ifndef cgemodule} Assigned(Module) and {$endif}
      (COPY(a, 1, Length(Mother^.State.ModuleBaseDir)) = Mother^.State.ModuleBaseDir)
    then
      Result:= '*M/' + COPY(a, Length(Mother^.State.ModuleBaseDir) + 1, Length(a) - Length(Mother^.State.ModuleBaseDir))
    else
      if COPY(a, 1, Length(Mother^.State.CacheDir)) = Mother^.State.CacheDir
      then
        Result:= '*C/' + COPY(a, Length(Mother^.State.CacheDir) + 1, Length(a) - Length(Mother^.State.CacheDir))
    else
      if COPY(a, 1, Length(Mother^.State.SessionDir)) = Mother^.State.SessionDir
      then
        Result:= '*S/' + COPY(a, Length(Mother^.State.SessionDir) + 1, Length(a) - Length(Mother^.State.SessionDir))
    else
      if COPY(a, 1, Length(Mother^.State.HomePath)) = Mother^.State.HomePath
      then
        Result:= '*H/' + COPY(a, Length(Mother^.State.HomePath) + 1, Length(a) - Length(Mother^.State.HomePath))
    else
      if COPY(a, 1, Length(Mother^.State.InstallPath)) = Mother^.State.InstallPath
      then
        Result:= '*I/' + COPY(a, Length(Mother^.State.InstallPath) + 1, Length(a) - Length(Mother^.State.InstallPath))
    else
      Result:= a;
    for i:= 1 to Length(Result) do if Result[i] = '\' then Result[i]:= '/';
  end;


  procedure MakeSurePathExists (path: TFileNameString);
  var
//    sl: TStringList;
    j: integer;
    p: TFileNameString = '';
    a: array of TFileNameString;
  begin
    path:= UnmangleFileName(path);
    if DirectoryExists(path) then Exit;
    a:= Explode(TFileNameString('/'), StrReplace(path, TFileNameString('\'), TFileNameString('/')));
//    sl:=TStringList.Create;
//    sl.Text:=(StrReplace(StrReplace(ExtractFilepath(CgePath(path)), '\', #13), '/', #13));
    if Length(a) > 1 then begin //the file system root is  not yet reached
      p:= a[0];
      for j:= 1 to High(a) do begin
       if not DirectoryExists(p + DS + a[j]) then begin
         AddLog(RuEn(
           'Создаю папку "%0" ...',
           'Creating folder "%0" ...'
           ), [p + DS + a[j]]);
         MkDir(p + DS + a[j] + DS);
//         AddLogOk;
       end;
       p:= p + DS + a[j];
      end;
    end;
//    sl.Free;
  end;


  function ValidateWritePath (path: TFileNameString): boolean;
  var
    a: array of TFileNameString;
    j: integer;
    p: TFileNameString;
    f: file;
    IsNetworkFolder: boolean = false;
  begin
    if path = '' then Exit(false);
    path:= UnmangleFileName(path);
    {$ifdef cgekernel}VerboseLog{$else}AddLog{$endif}
      ('  Validating that path is writeable: %0', [path]);
//    sl:=TStringList.Create;
    try
     {$ifdef windows}
      { Drekk. >_< A network folder on windows can start with "\\".
        Moreover, some folders in its path might not be accessible.}
      if copy(path, 1, 2) = '\\' then begin
        p:= ExtractFilePath(path) + DS;
        if not DirectoryExists(p) then begin
          {$ifdef cgekernel}VerboseLog{$else}AddLog{$endif}
            ('    ABORTING: network path doesn''t exist.');
          {$ifdef cgekernel}VerboseLog{$else}AddLog{$endif}
            ('    Result = false');
          Exit(false);
        end;
      end
      else begin
     {$endif}
        a:= Explode(TFileNameString('/'), StrReplace(path, TFileNameString('\'), TFileNameString('/')));
        //sl.Text:=(StrReplace(StrReplace(ExtractFilepath(CgePath(path)), '\', #13), '/', #13));
        { On Windows, sl[0] will be drive "c:", "d:", etc.
           On Unix it's always an empty string, as any path begins with "/"}
        {$ifdef cgekernel}VerboseLog{$else}AddLog{$endif}
          ('    Path split to %0 directories.', [Length(a)]);//sl.Count]);
        p:= a[0] + DS;
        For j:= 1 to High(a) do begin //sl.Count - 1 do begin
          p:=p + a[j] + DS; //DirectorySeparator;
//if not DirectoryExists(p) then writeln('  ', p, ' does not exist, creating.');
          if not DirectoryExists(p) then begin
            {$ifdef cgekernel}VerboseLog{$else}AddLog{$endif}
              ('    Creating directory %0', [p]);
            MkDir(p);
          end;
        end;
     {$ifdef windows}
      end;
     {$endif}
      p+= DS + 'delete-me-im-a-temporary-file-';// + AppNick;
     {$ifdef cgekernel}VerboseLog{$else}AddLog{$endif}
       ('    Creating temporary file %0', [p]);
      AssignFile(f, p);
      Rewrite(f, 10);
      BlockWrite(f, p[1], 1);
      Close(f);
      Erase(f);
      Result:=True;
    except
//writeln('Exception: ', (ExceptObject as Exception).Message);
      {$ifdef cgekernel}VerboseLog{$else}AddLog{$endif}
        ('    ..whoops. %0: %1',
       [string((ExceptObject as Exception).ClassName), (ExceptObject as Exception).Message]);
      Result:=False;
    end;
    //sl.Free;
    SetLength(a, 0);
    {$ifdef cgekernel}VerboseLog{$else}AddLog{$endif}
      ('    Result = %0', [Result]);
  end;

  function FileGetContents(name: TFileNameString): RawByteString;
  var
    s: TFileStream;
  begin
    if Mother^.Debug.Verbose then AddLog('  FileGetContents: %0', [name]);
    name:= UnmangleFileName(name);
    if Mother^.Debug.Verbose then AddLog('    ..name resolved to %0', [name]);
    if not FileExists(name)
      then Die(MI_ERROR_FILE_NOT_FOUND, [name]);
    s:= TFileStream.Create(name, fmOpenRead);
    SetLength(Result, s.Size);
    s.ReadBuffer(Result[1], s.Size);
    s.Free;
    if Mother^.Debug.Verbose then AddLog('    ..read %0 bytes', [Length(Result)]);
  end;

  function FileGetContents(name: TFileNameString): TByteArray;
  var
    s: TFileStream;
  begin
    if Mother^.Debug.Verbose then AddLog('  FileGetContents: %0', [name]);
    name:= UnmangleFileName(name);
    if Mother^.Debug.Verbose then AddLog('    ..name resolved to %0', [name]);
    if not FileExists(name)
      then Die(MI_ERROR_FILE_NOT_FOUND, [name]);
    s:= TFileStream.Create(name, fmOpenRead);
    SetLength(Result, s.Size);
    s.ReadBuffer(Result[0], s.Size);
    s.Free;
    if Mother^.Debug.Verbose then AddLog('    ..read %0 bytes', [Length(Result)]);
  end;

