{
    This file is part of Chentrah,
    Copyright (C) 2004-2016 Anton Rzheshevski (chebmaster@mail.ru).

    This file was made by modifying a unit from FPC opengl package

    Why: need to have completerly different initialization behavior,
      unable to use the standard unit without modifying it
     (for starters, Initialization section does not work in DLLs in Linux)
    Secondly, the game DLL must receive function adresses from the mother
      executable, it should not load or initialize the OpenGL dll by itself


 **********************************************************************}

{$ifdef windows}
{$ifdef cgekernel}



//If I try to use the plain ChoosePixelFormat() from the Windows module,
//  it yells "function variables of overloaded functions not allowed".
//W.T.F.
{
function gdiChoosePixelFormat
                                (p1:HDC; var p2:PIXELFORMATDESCRIPTOR):longint; stdcall;
                                     external 'gdi32' name 'ChoosePixelFormat';
function gdiDescribePixelFormat (
         DC: HDC; p2: Integer; p3: UINT; var p4: TPixelFormatDescriptor): BOOL; stdcall;
                                   external 'gdi32' name 'DescribePixelFormat';
function gdiGetPixelFormat
                      (p1:HDC):longint;  stdcall; external 'gdi32' name 'GetPixelFormat';
function gdiSetPixelFormat
                        (p1:HDC; p2:longint;p3:PPIXELFORMATDESCRIPTOR):WINBOOL;
                                         stdcall; external 'gdi32' name 'SetPixelFormat';
function gdiSwapBuffers  (p1:HDC):WINBOOL;  stdcall; external 'gdi32' name 'SwapBuffers';
}

procedure  LoadFiveQuestionableWglFunctions;
{   This is VITAL for running in Windows 98!

    http://www.opengl.org/resources/faq/technical/mswindows.htm  says:

    5.190 What do I need to know about mixing WGL and GDI calls?

    On the Win32 platform a number of platform specific
    function calls are duplicated in the OpenGL ICD mechanism and the GDI.
    This may cause confusion as they appear to be functionally identical,
    the only difference being whether wgl precedes the rest of the function
    name. To ensure correct operation of OpenGL use ChoosePixelformat,
    DescribePixelformat, GetPixelformat, SetPixelformat, and SwapBuffers,
    instead of the wgl equivalents,  wglChoosePixelformat,
    wglDescribePixelformat, wglGetPixelformat, wglSetPixelformat,
    and wglSwapBuffers. In all other cases use the wgl function where available.
    Using the five wgl functions is only of interest to developers run-time
    linking to an OpenGL driver. Not using the functions as described may
    result in a black OpenGL window, or a correctly functioning application
    in Windows 9x that produces a black OpenGL window on Windows NT/2000.
}
  var
    gdi32: THandle;
    dontLoadEm: boolean;
  function LoadProcAddress(ProcName: ansistring) : pointer;
  var
    exename: TFileNameString;
  begin
    Result:= GetProcAddress(gdi32, PAnsiChar(ProcName));
    if Assigned(Result) then begin
      if Mother^.Debug.Verbose then begin
        exename:= GetExeFileName(Result);
        //if (exename <> 'gdi32.dll')
        //  then AddLog('   %0() at %1 in %2 (wrapper %3)', [ProcName, Result, exename, 'gdi32.dll'])
        //  else
          AddLog('    %0() at %1 in %2', [ProcName, Result, exename]);
      end;
    end
    else
      VerboseLog('    %0() not found!', [ProcName]);
  end;

  function TLwF(fn: Ansistring): pointer;
  var a: pointer;
  begin
    //a:= GetGLProcAddressIgnoreMissing({'wgl' +} fn);
    //if not Assigned(a) then

    if dontLoadEm
      then begin
        a:= LoadProcAddress(fn);
      end
      else begin
        a:= GetGLProcAddressIgnoreMissing('wgl' + fn);
        if not Assigned(a) then begin
          if Mother^.Debug.Verbose then AddLog('    wgl' + fn + ' function not found in the OpenGL library, using the one from GDI.');
          a:= LoadProcAddress(fn);
        end;
      end;
    Result:=a;
  end;

begin
  dontLoadEm:= not (Config.Bool['opengl', 'LoadFiveQuestionablewglFunctions']
            or Config.bool['opengl','Use_Mesa_GL']) ;
  VerboseLog('  loading gdi32.dll...');
    gdi32:= LoadLibrary('gdi32.dll');
  pointer(wglChoosePixelFormat):= TLwF('ChoosePixelFormat');//, @gdiChoosePixelFormat);
  pointer(wglDescribePixelformat):= TLwF('DescribePixelFormat');//, @gdiDescribePixelformat);
  pointer(wglGetPixelformat):= TLwF('GetPixelFormat');//,@gdiGetPixelformat);
  pointer(wglSetPixelformat):= TLwF('SetPixelFormat');//, @gdiSetPixelformat);
  pointer(wglSwapBuffers):= TLwF('SwapBuffers');//,@gdiSwapBuffers);
end;

var wglGetCurrentDC: function(): HDC; stdcall;

//doing some hacking I found this shit links STATICALLY to opengl32.dll
//  (declared in /source/rtl/win/wininc/func.inc
//  so making using wrappers or custom opengl32.dll not possible
function WrapperWglGetCurrentDC: HDC;
begin
  Result:= 0;
  if Assigned(Framework) then Result:= (Framework as TWinApiFramework).display;
  if not Assigned(wglGetCurrentDC) then begin
    pointer(wglGetCurrentDC):= GetGLProcAddressIgnoreMissing('wglGetCurrentDC');
  end;
  if Assigned(wglGetCurrentDC) then Result:= wglGetCurrentDC();
end;


{$else cgekernel}

function WrapperWglGetCurrentDC: HDC;
begin
  Die(MI_ERROR_PROGRAMMER_NO_BAKA, ['This should have never been called!'])
end;


{$endif}
{$endif}



function GlErrorCodeToString(c: GLenum): UnicodeString;
begin
  case c of
    GL_INVALID_ENUM: Result:= 'GL_INVALID_ENUM';
    GL_INVALID_VALUE: Result:= 'GL_INVALID_VALUE';
    GL_INVALID_OPERATION: Result:= 'GL_INVALID_OPERATION';
    GL_STACK_OVERFLOW: Result:= 'GL_STACK_OVERFLOW';
    GL_STACK_UNDERFLOW: Result:= 'GL_STACK_UNDERFLOW';
    GL_OUT_OF_MEMORY: Result:= 'GL_OUT_OF_MEMORY';
    GL_INVALID_FRAMEBUFFER_OPERATION_EXT: Result:= 'GL_INVALID_FRAMEBUFFER_OPERATION_EXT';
    GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT: Result:= 'GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT';
    GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT: Result:= 'GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT';
    GL_FRAMEBUFFER_INCOMPLETE_DUPLICATE_ATTACHMENT_EXT: Result:= 'GL_FRAMEBUFFER_INCOMPLETE_DUPLICATE_ATTACHMENT_EXT';
    GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT: Result:= 'GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT';
    GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT: Result:= 'GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT';
    GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT: Result:= 'GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT';
    GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT: Result:= 'GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT';
    GL_FRAMEBUFFER_UNSUPPORTED_EXT: Result:= 'GL_FRAMEBUFFER_UNSUPPORTED_EXT';
    GL_FRAMEBUFFER_STATUS_ERROR_EXT: Result:= 'GL_FRAMEBUFFER_STATUS_ERROR_EXT';
  else
    Result:= RuEn('код', 'code') + ' ' + IntToHex(c, 8) + 'h';
  end;
end;

function GlTextureFormatToString(c: GLenum): UnicodeString;
begin
  case c of
    //texture internal formats

    GL_ALPHA4                         : Result:= 'GL_ALPHA4';
    GL_ALPHA8                         : Result:= 'GL_ALPHA8';
    GL_ALPHA12                        : Result:= 'GL_ALPHA12';
    GL_ALPHA16                        : Result:= 'GL_ALPHA16';
    GL_LUMINANCE4                     : Result:= 'GL_LUMINANCE4';
    GL_LUMINANCE8                     : Result:= 'GL_LUMINANCE8';
    GL_LUMINANCE12                    : Result:= 'GL_LUMINANCE12';
    GL_LUMINANCE16                    : Result:= 'GL_LUMINANCE16';
    GL_LUMINANCE4_ALPHA4              : Result:= 'GL_LUMINANCE4_ALPHA4';
    GL_LUMINANCE6_ALPHA2              : Result:= 'GL_LUMINANCE6_ALPHA2';
    GL_LUMINANCE8_ALPHA8              : Result:= 'GL_LUMINANCE8_ALPHA8';
    GL_LUMINANCE12_ALPHA4             : Result:= 'GL_LUMINANCE12_ALPHA4';
    GL_LUMINANCE12_ALPHA12            : Result:= 'GL_LUMINANCE12_ALPHA12';
    GL_LUMINANCE16_ALPHA16            : Result:= 'GL_LUMINANCE16_ALPHA16';
    GL_INTENSITY                      : Result:= 'GL_INTENSITY';
    GL_INTENSITY4                     : Result:= 'GL_INTENSITY4';
    GL_INTENSITY8                     : Result:= 'GL_INTENSITY8';
    GL_INTENSITY12                    : Result:= 'GL_INTENSITY12';
    GL_INTENSITY16                    : Result:= 'GL_INTENSITY16';
    GL_R3_G3_B2                       : Result:= 'GL_R3_G3_B2';
    GL_RGB4                           : Result:= 'GL_RGB4';
    GL_RGB5                           : Result:= 'GL_RGB5';
    GL_RGB8                           : Result:= 'GL_RGB8';
    GL_RGB10                          : Result:= 'GL_RGB10';
    GL_RGB12                          : Result:= 'GL_RGB12';
    GL_RGB16                          : Result:= 'GL_RGB16';
    GL_RGBA2                          : Result:= 'GL_RGBA2';
    GL_RGBA4                          : Result:= 'GL_RGBA4';
    GL_RGB5_A1                        : Result:= 'GL_RGB5_A1';
    GL_RGBA8                          : Result:= 'GL_RGBA8';
    GL_RGB10_A2                       : Result:= 'GL_RGB10_A2';
    GL_RGBA12                         : Result:= 'GL_RGBA12';
    GL_RGBA16                         : Result:= 'GL_RGBA16';
    GL_COMPRESSED_RGB_S3TC_DXT1_EXT   : Result:= 'GL_COMPRESSED_RGB_S3TC_DXT1_EXT';
    GL_COMPRESSED_RGBA_S3TC_DXT1_EXT  : Result:= 'GL_COMPRESSED_RGBA_S3TC_DXT1_EXT';
    GL_COMPRESSED_RGBA_S3TC_DXT3_EXT  : Result:= 'GL_COMPRESSED_RGBA_S3TC_DXT3_EXT';
    GL_COMPRESSED_RGBA_S3TC_DXT5_EXT  : Result:= 'GL_COMPRESSED_RGBA_S3TC_DXT5_EXT';

    //fbo depth buffer:
    GL_DEPTH_COMPONENT16_ARB          : Result:= 'GL_DEPTH_COMPONENT16_ARB';
    GL_DEPTH_COMPONENT24_ARB          : Result:= 'GL_DEPTH_COMPONENT24_ARB';
    GL_DEPTH_COMPONENT32_ARB          : Result:= 'GL_DEPTH_COMPONENT32_ARB';

    //image formats for uploading/downloading a texture:
    GL_UNSIGNED_BYTE_3_3_2            : Result:= 'GL_UNSIGNED_BYTE_3_3_2';
    GL_UNSIGNED_SHORT_4_4_4_4         : Result:= 'GL_UNSIGNED_SHORT_4_4_4_4';
    GL_UNSIGNED_SHORT_5_5_5_1         : Result:= 'GL_UNSIGNED_SHORT_5_5_5_1';
    GL_UNSIGNED_INT_8_8_8_8           : Result:= 'GL_UNSIGNED_INT_8_8_8_8';
    GL_UNSIGNED_INT_10_10_10_2        : Result:= 'GL_UNSIGNED_INT_10_10_10_2';
    GL_RESCALE_NORMAL                 : Result:= 'GL_RESCALE_NORMAL';
    GL_UNSIGNED_BYTE_2_3_3_REV        : Result:= 'GL_UNSIGNED_BYTE_2_3_3_REV';
    GL_UNSIGNED_SHORT_5_6_5           : Result:= 'GL_UNSIGNED_SHORT_5_6_5';
    GL_UNSIGNED_SHORT_5_6_5_REV       : Result:= 'GL_UNSIGNED_SHORT_5_6_5_REV';
    GL_UNSIGNED_SHORT_4_4_4_4_REV     : Result:= 'GL_UNSIGNED_SHORT_4_4_4_4_REV';
    GL_UNSIGNED_SHORT_1_5_5_5_REV     : Result:= 'GL_UNSIGNED_SHORT_1_5_5_5_REV';
    GL_UNSIGNED_INT_8_8_8_8_REV       : Result:= 'GL_UNSIGNED_INT_8_8_8_8_REV';
    GL_UNSIGNED_INT_2_10_10_10_REV    : Result:= 'GL_UNSIGNED_INT_2_10_10_10_REV';
    GL_BGR                            : Result:= 'GL_BGR';
    GL_BGRA                           : Result:= 'GL_BGRA';

  else
    Result:= RuEn('формат', 'format') + ' ' + IntToHex(c, 4) + 'h';
  end;
end;

procedure CheckGlError(DieAnyway: boolean);
var ec: GLenum;
begin
  ec:= glGetError();

  if ec <> 0 then
    if DieAnyway or Mother^.Debug.StopOnOpenGlErrors
      then Die(RuEn(
          'Ошибка OpenGL, %0',
          'OpenGL error, %0'
        ),
        [GlErrorCodeToString(ec)])
      else
        if Mother^.Debug.Verbose then AddLog(RuEn(
            'Ошибка OpenGL, %0',
            'OpenGL error, %0'
          ),
          [GlErrorCodeToString(ec)]);
end;

procedure InitGlProcAddresses(Load2: system.boolean = false);
begin
  Load_Basic_GL_1_2;
end;

procedure LoadOpenGLFunctions;
var
  List: array of AnsiString;
  i: integer;
begin
  List:= Explode(',', '' + WideToAnsi(Mother^.Config.GetString('OpenGL', 'load')), true);
  For i:= 0 to High(List) do
    if not LoadExtension(List[i])
      then Die(RuEn('Не удалось загрузить "%0"','Failed to load "%0"'),[List[i]]);
end;

{$ifndef cgekernel}
function GetGLProcAddress(Name: AnsiString): pointer;
begin
  Result:= Mother^.GAPI.GetProcAddress(pointer(Name), nil);
end;
{$endif}

(*
{$IFNDEF Windows}
function wglGetProcAddress(proc: PAnsiChar): Pointer;
begin
  Result := GetProcAddress(LibGL, proc);
end;
{$ENDIF}
*)

function glext_ExtensionSupported(const extension: String; const searchIn: String): Boolean;
var
  extensions: PAnsiChar;
  start: PAnsiChar;
  where, terminator: PAnsiChar;
begin

  if (Pos(' ', extension) <> 0) or (extension = '') then
  begin
    Result := FALSE;
    Exit;
  end;

  if searchIn = '' then extensions := PAnsiChar(glGetString(GL_EXTENSIONS))
  else extensions := PAnsiChar(searchIn);
  start := extensions;
  while TRUE do
  begin
    where := StrPos(start, PAnsiChar(extension));
    if where = nil then Break;
    terminator := Pointer(PtrUInt(where) + Length(extension));
    if (where = start) or (PAnsiChar(PtrUInt(where) - 1)^ = ' ') then
    begin
      if (terminator^ = ' ') or (terminator^ = #0) then
      begin
        Result := TRUE;
        Exit;
      end;
    end;
    start := terminator;
  end;
  Result := FALSE;

end;

function Load_GL_version_1_2: Boolean;
begin

  Result := FALSE;

    pointer(glBlendColor) := GetGLProcAddress('glBlendColor');
    pointer(glBlendEquation) := GetGLProcAddress('glBlendEquation');
    pointer(glDrawRangeElements) := GetGLProcAddress('glDrawRangeElements');
    pointer(glTexImage3D) := GetGLProcAddress('glTexImage3D');
    pointer(glTexSubImage3D) := GetGLProcAddress('glTexSubImage3D');
    pointer(glCopyTexSubImage3D) := GetGLProcAddress('glCopyTexSubImage3D');
    Result := TRUE;

end;

function Load_GL_ARB_imaging: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_imaging', extstring) then
  begin
    pointer(glColorTable) := GetGLProcAddress('glColorTable');
    pointer(glColorTableParameterfv) := GetGLProcAddress('glColorTableParameterfv');
    pointer(glColorTableParameteriv) := GetGLProcAddress('glColorTableParameteriv');
    pointer(glCopyColorTable) := GetGLProcAddress('glCopyColorTable');
    pointer(glGetColorTable) := GetGLProcAddress('glGetColorTable');
    pointer(glGetColorTableParameterfv) := GetGLProcAddress('glGetColorTableParameterfv');
    pointer(glGetColorTableParameteriv) := GetGLProcAddress('glGetColorTableParameteriv');
    pointer(glColorSubTable) := GetGLProcAddress('glColorSubTable');
    pointer(glCopyColorSubTable) := GetGLProcAddress('glCopyColorSubTable');
    pointer(glConvolutionFilter1D) := GetGLProcAddress('glConvolutionFilter1D');
    pointer(glConvolutionFilter2D) := GetGLProcAddress('glConvolutionFilter2D');
    pointer(glConvolutionParameterf) := GetGLProcAddress('glConvolutionParameterf');
    pointer(glConvolutionParameterfv) := GetGLProcAddress('glConvolutionParameterfv');
    pointer(glConvolutionParameteri) := GetGLProcAddress('glConvolutionParameteri');
    pointer(glConvolutionParameteriv) := GetGLProcAddress('glConvolutionParameteriv');
    pointer(glCopyConvolutionFilter1D) := GetGLProcAddress('glCopyConvolutionFilter1D');
    pointer(glCopyConvolutionFilter2D) := GetGLProcAddress('glCopyConvolutionFilter2D');
    pointer(glGetConvolutionFilter) := GetGLProcAddress('glGetConvolutionFilter');
    pointer(glGetConvolutionParameterfv) := GetGLProcAddress('glGetConvolutionParameterfv');
    pointer(glGetConvolutionParameteriv) := GetGLProcAddress('glGetConvolutionParameteriv');
    pointer(glGetSeparableFilter) := GetGLProcAddress('glGetSeparableFilter');
    pointer(glSeparableFilter2D) := GetGLProcAddress('glSeparableFilter2D');
    pointer(glGetHistogram) := GetGLProcAddress('glGetHistogram');
    pointer(glGetHistogramParameterfv) := GetGLProcAddress('glGetHistogramParameterfv');
    pointer(glGetHistogramParameteriv) := GetGLProcAddress('glGetHistogramParameteriv');
    pointer(glGetMinmax) := GetGLProcAddress('glGetMinmax');
    pointer(glGetMinmaxParameterfv) := GetGLProcAddress('glGetMinmaxParameterfv');
    pointer(glGetMinmaxParameteriv) := GetGLProcAddress('glGetMinmaxParameteriv');
    pointer(glHistogram) := GetGLProcAddress('glHistogram');
    pointer(glMinmax) := GetGLProcAddress('glMinmax');
    pointer(glResetHistogram) := GetGLProcAddress('glResetHistogram');
    pointer(glResetMinmax) := GetGLProcAddress('glResetMinmax');
    Result := TRUE;
  end;

end;

function Load_GL_version_1_3: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

    pointer(glActiveTexture) := GetGLProcAddress('glActiveTexture');
    pointer(glClientActiveTexture) := GetGLProcAddress('glClientActiveTexture');
    pointer(glMultiTexCoord1d) := GetGLProcAddress('glMultiTexCoord1d');
    pointer(glMultiTexCoord1dv) := GetGLProcAddress('glMultiTexCoord1dv');
    pointer(glMultiTexCoord1f) := GetGLProcAddress('glMultiTexCoord1f');
    pointer(glMultiTexCoord1fv) := GetGLProcAddress('glMultiTexCoord1fv');
    pointer(glMultiTexCoord1i) := GetGLProcAddress('glMultiTexCoord1i');
    pointer(glMultiTexCoord1iv) := GetGLProcAddress('glMultiTexCoord1iv');
    pointer(glMultiTexCoord1s) := GetGLProcAddress('glMultiTexCoord1s');
    pointer(glMultiTexCoord1sv) := GetGLProcAddress('glMultiTexCoord1sv');
    pointer(glMultiTexCoord2d) := GetGLProcAddress('glMultiTexCoord2d');
    pointer(glMultiTexCoord2dv) := GetGLProcAddress('glMultiTexCoord2dv');
    pointer(glMultiTexCoord2f) := GetGLProcAddress('glMultiTexCoord2f');
    pointer(glMultiTexCoord2fv) := GetGLProcAddress('glMultiTexCoord2fv');
    pointer(glMultiTexCoord2i) := GetGLProcAddress('glMultiTexCoord2i');
    pointer(glMultiTexCoord2iv) := GetGLProcAddress('glMultiTexCoord2iv');
    pointer(glMultiTexCoord2s) := GetGLProcAddress('glMultiTexCoord2s');
    pointer(glMultiTexCoord2sv) := GetGLProcAddress('glMultiTexCoord2sv');
    pointer(glMultiTexCoord3d) := GetGLProcAddress('glMultiTexCoord3d');
    pointer(glMultiTexCoord3dv) := GetGLProcAddress('glMultiTexCoord3dv');
    pointer(glMultiTexCoord3f) := GetGLProcAddress('glMultiTexCoord3f');
    pointer(glMultiTexCoord3fv) := GetGLProcAddress('glMultiTexCoord3fv');
    pointer(glMultiTexCoord3i) := GetGLProcAddress('glMultiTexCoord3i');
    pointer(glMultiTexCoord3iv) := GetGLProcAddress('glMultiTexCoord3iv');
    pointer(glMultiTexCoord3s) := GetGLProcAddress('glMultiTexCoord3s');
    pointer(glMultiTexCoord3sv) := GetGLProcAddress('glMultiTexCoord3sv');
    pointer(glMultiTexCoord4d) := GetGLProcAddress('glMultiTexCoord4d');
    pointer(glMultiTexCoord4dv) := GetGLProcAddress('glMultiTexCoord4dv');
    pointer(glMultiTexCoord4f) := GetGLProcAddress('glMultiTexCoord4f');
    pointer(glMultiTexCoord4fv) := GetGLProcAddress('glMultiTexCoord4fv');
    pointer(glMultiTexCoord4i) := GetGLProcAddress('glMultiTexCoord4i');
    pointer(glMultiTexCoord4iv) := GetGLProcAddress('glMultiTexCoord4iv');
    pointer(glMultiTexCoord4s) := GetGLProcAddress('glMultiTexCoord4s');
    pointer(glMultiTexCoord4sv) := GetGLProcAddress('glMultiTexCoord4sv');
    pointer(glLoadTransposeMatrixf) := GetGLProcAddress('glLoadTransposeMatrixf');
    pointer(glLoadTransposeMatrixd) := GetGLProcAddress('glLoadTransposeMatrixd');
    pointer(glMultTransposeMatrixf) := GetGLProcAddress('glMultTransposeMatrixf');
    pointer(glMultTransposeMatrixd) := GetGLProcAddress('glMultTransposeMatrixd');
    pointer(glSampleCoverage) := GetGLProcAddress('glSampleCoverage');
    pointer(glCompressedTexImage3D) := GetGLProcAddress('glCompressedTexImage3D');
    pointer(glCompressedTexImage2D) := GetGLProcAddress('glCompressedTexImage2D');
    pointer(glCompressedTexImage1D) := GetGLProcAddress('glCompressedTexImage1D');
    pointer(glCompressedTexSubImage3D) := GetGLProcAddress('glCompressedTexSubImage3D');
    pointer(glCompressedTexSubImage2D) := GetGLProcAddress('glCompressedTexSubImage2D');
    pointer(glCompressedTexSubImage1D) := GetGLProcAddress('glCompressedTexSubImage1D');
    pointer(glGetCompressedTexImage) := GetGLProcAddress('glGetCompressedTexImage');
    Result := Load_GL_version_1_2;

end;

function Load_GL_ARB_multitexture: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_multitexture', extstring) then
  begin
    pointer(glActiveTextureARB) := GetGLProcAddress('glActiveTextureARB');
    pointer(glClientActiveTextureARB) := GetGLProcAddress('glClientActiveTextureARB');
    pointer(glMultiTexCoord1dARB) := GetGLProcAddress('glMultiTexCoord1dARB');
    pointer(glMultiTexCoord1dvARB) := GetGLProcAddress('glMultiTexCoord1dvARB');
    pointer(glMultiTexCoord1fARB) := GetGLProcAddress('glMultiTexCoord1fARB');
    pointer(glMultiTexCoord1fvARB) := GetGLProcAddress('glMultiTexCoord1fvARB');
    pointer(glMultiTexCoord1iARB) := GetGLProcAddress('glMultiTexCoord1iARB');
    pointer(glMultiTexCoord1ivARB) := GetGLProcAddress('glMultiTexCoord1ivARB');
    pointer(glMultiTexCoord1sARB) := GetGLProcAddress('glMultiTexCoord1sARB');
    pointer(glMultiTexCoord1svARB) := GetGLProcAddress('glMultiTexCoord1svARB');
    pointer(glMultiTexCoord2dARB) := GetGLProcAddress('glMultiTexCoord2dARB');
    pointer(glMultiTexCoord2dvARB) := GetGLProcAddress('glMultiTexCoord2dvARB');
    pointer(glMultiTexCoord2fARB) := GetGLProcAddress('glMultiTexCoord2fARB');
    pointer(glMultiTexCoord2fvARB) := GetGLProcAddress('glMultiTexCoord2fvARB');
    pointer(glMultiTexCoord2iARB) := GetGLProcAddress('glMultiTexCoord2iARB');
    pointer(glMultiTexCoord2ivARB) := GetGLProcAddress('glMultiTexCoord2ivARB');
    pointer(glMultiTexCoord2sARB) := GetGLProcAddress('glMultiTexCoord2sARB');
    pointer(glMultiTexCoord2svARB) := GetGLProcAddress('glMultiTexCoord2svARB');
    pointer(glMultiTexCoord3dARB) := GetGLProcAddress('glMultiTexCoord3dARB');
    pointer(glMultiTexCoord3dvARB) := GetGLProcAddress('glMultiTexCoord3dvARB');
    pointer(glMultiTexCoord3fARB) := GetGLProcAddress('glMultiTexCoord3fARB');
    pointer(glMultiTexCoord3fvARB) := GetGLProcAddress('glMultiTexCoord3fvARB');
    pointer(glMultiTexCoord3iARB) := GetGLProcAddress('glMultiTexCoord3iARB');
    pointer(glMultiTexCoord3ivARB) := GetGLProcAddress('glMultiTexCoord3ivARB');
    pointer(glMultiTexCoord3sARB) := GetGLProcAddress('glMultiTexCoord3sARB');
    pointer(glMultiTexCoord3svARB) := GetGLProcAddress('glMultiTexCoord3svARB');
    pointer(glMultiTexCoord4dARB) := GetGLProcAddress('glMultiTexCoord4dARB');
    pointer(glMultiTexCoord4dvARB) := GetGLProcAddress('glMultiTexCoord4dvARB');
    pointer(glMultiTexCoord4fARB) := GetGLProcAddress('glMultiTexCoord4fARB');
    pointer(glMultiTexCoord4fvARB) := GetGLProcAddress('glMultiTexCoord4fvARB');
    pointer(glMultiTexCoord4iARB) := GetGLProcAddress('glMultiTexCoord4iARB');
    pointer(glMultiTexCoord4ivARB) := GetGLProcAddress('glMultiTexCoord4ivARB');
    pointer(glMultiTexCoord4sARB) := GetGLProcAddress('glMultiTexCoord4sARB');
    pointer(glMultiTexCoord4svARB) := GetGLProcAddress('glMultiTexCoord4svARB');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_transpose_matrix: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_transpose_matrix', extstring) then
  begin
    pointer(glLoadTransposeMatrixfARB) := GetGLProcAddress('glLoadTransposeMatrixfARB');
    pointer(glLoadTransposeMatrixdARB) := GetGLProcAddress('glLoadTransposeMatrixdARB');
    pointer(glMultTransposeMatrixfARB) := GetGLProcAddress('glMultTransposeMatrixfARB');
    pointer(glMultTransposeMatrixdARB) := GetGLProcAddress('glMultTransposeMatrixdARB');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_multisample: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_multisample', extstring) then
  begin
    pointer(glSampleCoverageARB) := GetGLProcAddress('glSampleCoverageARB');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_texture_env_add: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_texture_env_add', extstring) then
  begin
    Result := TRUE;
  end;

end;

{$IFDEF Windows}
function Load_WGL_ARB_extensions_string: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_ARB_extensions_string', extstring) then
  begin
    pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
    Result := TRUE;
  end;

end;

function Load_WGL_ARB_buffer_region: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_ARB_buffer_region', extstring) then
  begin
    pointer(wglCreateBufferRegionARB) := GetGLProcAddress('wglCreateBufferRegionARB');
    pointer(wglDeleteBufferRegionARB) := GetGLProcAddress('wglDeleteBufferRegionARB');
    pointer(wglSaveBufferRegionARB) := GetGLProcAddress('wglSaveBufferRegionARB');
    pointer(wglRestoreBufferRegionARB) := GetGLProcAddress('wglRestoreBufferRegionARB');
    Result := TRUE;
  end;

end;
{$ENDIF}

function Load_GL_ARB_texture_cube_map: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_texture_cube_map', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_depth_texture: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_depth_texture', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_point_parameters: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_point_parameters', extstring) then
  begin
    pointer(glPointParameterfARB) := GetGLProcAddress('glPointParameterfARB');
    pointer(glPointParameterfvARB) := GetGLProcAddress('glPointParameterfvARB');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_shadow: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_shadow', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_shadow_ambient: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_shadow_ambient', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_texture_border_clamp: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_texture_border_clamp', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_texture_compression: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_texture_compression', extstring) then
  begin
    pointer(glCompressedTexImage3DARB) := GetGLProcAddress('glCompressedTexImage3DARB');
    pointer(glCompressedTexImage2DARB) := GetGLProcAddress('glCompressedTexImage2DARB');
    pointer(glCompressedTexImage1DARB) := GetGLProcAddress('glCompressedTexImage1DARB');
    pointer(glCompressedTexSubImage3DARB) := GetGLProcAddress('glCompressedTexSubImage3DARB');
    pointer(glCompressedTexSubImage2DARB) := GetGLProcAddress('glCompressedTexSubImage2DARB');
    pointer(glCompressedTexSubImage1DARB) := GetGLProcAddress('glCompressedTexSubImage1DARB');
    pointer(glGetCompressedTexImageARB) := GetGLProcAddress('glGetCompressedTexImageARB');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_texture_env_combine: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_texture_env_combine', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_texture_env_crossbar: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_texture_env_crossbar', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_texture_env_dot3: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_texture_env_dot3', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_texture_mirrored_repeat: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_texture_mirrored_repeat', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_vertex_blend: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_vertex_blend', extstring) then
  begin
    pointer(glWeightbvARB) := GetGLProcAddress('glWeightbvARB');
    pointer(glWeightsvARB) := GetGLProcAddress('glWeightsvARB');
    pointer(glWeightivARB) := GetGLProcAddress('glWeightivARB');
    pointer(glWeightfvARB) := GetGLProcAddress('glWeightfvARB');
    pointer(glWeightdvARB) := GetGLProcAddress('glWeightdvARB');
    pointer(glWeightvARB) := GetGLProcAddress('glWeightvARB');
    pointer(glWeightubvARB) := GetGLProcAddress('glWeightubvARB');
    pointer(glWeightusvARB) := GetGLProcAddress('glWeightusvARB');
    pointer(glWeightuivARB) := GetGLProcAddress('glWeightuivARB');
    pointer(glWeightPointerARB) := GetGLProcAddress('glWeightPointerARB');
    pointer(glVertexBlendARB) := GetGLProcAddress('glVertexBlendARB');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_vertex_program: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_vertex_program', extstring) then
  begin
    pointer(glVertexAttrib1sARB) := GetGLProcAddress('glVertexAttrib1sARB');
    pointer(glVertexAttrib1fARB) := GetGLProcAddress('glVertexAttrib1fARB');
    pointer(glVertexAttrib1dARB) := GetGLProcAddress('glVertexAttrib1dARB');
    pointer(glVertexAttrib2sARB) := GetGLProcAddress('glVertexAttrib2sARB');
    pointer(glVertexAttrib2fARB) := GetGLProcAddress('glVertexAttrib2fARB');
    pointer(glVertexAttrib2dARB) := GetGLProcAddress('glVertexAttrib2dARB');
    pointer(glVertexAttrib3sARB) := GetGLProcAddress('glVertexAttrib3sARB');
    pointer(glVertexAttrib3fARB) := GetGLProcAddress('glVertexAttrib3fARB');
    pointer(glVertexAttrib3dARB) := GetGLProcAddress('glVertexAttrib3dARB');
    pointer(glVertexAttrib4sARB) := GetGLProcAddress('glVertexAttrib4sARB');
    pointer(glVertexAttrib4fARB) := GetGLProcAddress('glVertexAttrib4fARB');
    pointer(glVertexAttrib4dARB) := GetGLProcAddress('glVertexAttrib4dARB');
    pointer(glVertexAttrib4NubARB) := GetGLProcAddress('glVertexAttrib4NubARB');
    pointer(glVertexAttrib1svARB) := GetGLProcAddress('glVertexAttrib1svARB');
    pointer(glVertexAttrib1fvARB) := GetGLProcAddress('glVertexAttrib1fvARB');
    pointer(glVertexAttrib1dvARB) := GetGLProcAddress('glVertexAttrib1dvARB');
    pointer(glVertexAttrib2svARB) := GetGLProcAddress('glVertexAttrib2svARB');
    pointer(glVertexAttrib2fvARB) := GetGLProcAddress('glVertexAttrib2fvARB');
    pointer(glVertexAttrib2dvARB) := GetGLProcAddress('glVertexAttrib2dvARB');
    pointer(glVertexAttrib3svARB) := GetGLProcAddress('glVertexAttrib3svARB');
    pointer(glVertexAttrib3fvARB) := GetGLProcAddress('glVertexAttrib3fvARB');
    pointer(glVertexAttrib3dvARB) := GetGLProcAddress('glVertexAttrib3dvARB');
    pointer(glVertexAttrib4bvARB) := GetGLProcAddress('glVertexAttrib4bvARB');
    pointer(glVertexAttrib4svARB) := GetGLProcAddress('glVertexAttrib4svARB');
    pointer(glVertexAttrib4ivARB) := GetGLProcAddress('glVertexAttrib4ivARB');
    pointer(glVertexAttrib4ubvARB) := GetGLProcAddress('glVertexAttrib4ubvARB');
    pointer(glVertexAttrib4usvARB) := GetGLProcAddress('glVertexAttrib4usvARB');
    pointer(glVertexAttrib4uivARB) := GetGLProcAddress('glVertexAttrib4uivARB');
    pointer(glVertexAttrib4fvARB) := GetGLProcAddress('glVertexAttrib4fvARB');
    pointer(glVertexAttrib4dvARB) := GetGLProcAddress('glVertexAttrib4dvARB');
    pointer(glVertexAttrib4NbvARB) := GetGLProcAddress('glVertexAttrib4NbvARB');
    pointer(glVertexAttrib4NsvARB) := GetGLProcAddress('glVertexAttrib4NsvARB');
    pointer(glVertexAttrib4NivARB) := GetGLProcAddress('glVertexAttrib4NivARB');
    pointer(glVertexAttrib4NubvARB) := GetGLProcAddress('glVertexAttrib4NubvARB');
    pointer(glVertexAttrib4NusvARB) := GetGLProcAddress('glVertexAttrib4NusvARB');
    pointer(glVertexAttrib4NuivARB) := GetGLProcAddress('glVertexAttrib4NuivARB');
    pointer(glVertexAttribPointerARB) := GetGLProcAddress('glVertexAttribPointerARB');
    pointer(glEnableVertexAttribArrayARB) := GetGLProcAddress('glEnableVertexAttribArrayARB');
    pointer(glDisableVertexAttribArrayARB) := GetGLProcAddress('glDisableVertexAttribArrayARB');
    pointer(glProgramStringARB) := GetGLProcAddress('glProgramStringARB');
    pointer(glBindProgramARB) := GetGLProcAddress('glBindProgramARB');
    pointer(glDeleteProgramsARB) := GetGLProcAddress('glDeleteProgramsARB');
    pointer(glGenProgramsARB) := GetGLProcAddress('glGenProgramsARB');
    pointer(glProgramEnvParameter4dARB) := GetGLProcAddress('glProgramEnvParameter4dARB');
    pointer(glProgramEnvParameter4dvARB) := GetGLProcAddress('glProgramEnvParameter4dvARB');
    pointer(glProgramEnvParameter4fARB) := GetGLProcAddress('glProgramEnvParameter4fARB');
    pointer(glProgramEnvParameter4fvARB) := GetGLProcAddress('glProgramEnvParameter4fvARB');
    pointer(glProgramLocalParameter4dARB) := GetGLProcAddress('glProgramLocalParameter4dARB');
    pointer(glProgramLocalParameter4dvARB) := GetGLProcAddress('glProgramLocalParameter4dvARB');
    pointer(glProgramLocalParameter4fARB) := GetGLProcAddress('glProgramLocalParameter4fARB');
    pointer(glProgramLocalParameter4fvARB) := GetGLProcAddress('glProgramLocalParameter4fvARB');
    pointer(glGetProgramEnvParameterdvARB) := GetGLProcAddress('glGetProgramEnvParameterdvARB');
    pointer(glGetProgramEnvParameterfvARB) := GetGLProcAddress('glGetProgramEnvParameterfvARB');
    pointer(glGetProgramLocalParameterdvARB) := GetGLProcAddress('glGetProgramLocalParameterdvARB');
    pointer(glGetProgramLocalParameterfvARB) := GetGLProcAddress('glGetProgramLocalParameterfvARB');
    pointer(glGetProgramivARB) := GetGLProcAddress('glGetProgramivARB');
    pointer(glGetProgramStringARB) := GetGLProcAddress('glGetProgramStringARB');
    pointer(glGetVertexAttribdvARB) := GetGLProcAddress('glGetVertexAttribdvARB');
    pointer(glGetVertexAttribfvARB) := GetGLProcAddress('glGetVertexAttribfvARB');
    pointer(glGetVertexAttribivARB) := GetGLProcAddress('glGetVertexAttribivARB');
    pointer(glGetVertexAttribPointervARB) := GetGLProcAddress('glGetVertexAttribPointervARB');
    pointer(glIsProgramARB) := GetGLProcAddress('glIsProgramARB');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_window_pos: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_window_pos', extstring) then
  begin
    pointer(glWindowPos2dARB) := GetGLProcAddress('glWindowPos2dARB');
    pointer(glWindowPos2fARB) := GetGLProcAddress('glWindowPos2fARB');
    pointer(glWindowPos2iARB) := GetGLProcAddress('glWindowPos2iARB');
    pointer(glWindowPos2sARB) := GetGLProcAddress('glWindowPos2sARB');
    pointer(glWindowPos2dvARB) := GetGLProcAddress('glWindowPos2dvARB');
    pointer(glWindowPos2fvARB) := GetGLProcAddress('glWindowPos2fvARB');
    pointer(glWindowPos2ivARB) := GetGLProcAddress('glWindowPos2ivARB');
    pointer(glWindowPos2svARB) := GetGLProcAddress('glWindowPos2svARB');
    pointer(glWindowPos3dARB) := GetGLProcAddress('glWindowPos3dARB');
    pointer(glWindowPos3fARB) := GetGLProcAddress('glWindowPos3fARB');
    pointer(glWindowPos3iARB) := GetGLProcAddress('glWindowPos3iARB');
    pointer(glWindowPos3sARB) := GetGLProcAddress('glWindowPos3sARB');
    pointer(glWindowPos3dvARB) := GetGLProcAddress('glWindowPos3dvARB');
    pointer(glWindowPos3fvARB) := GetGLProcAddress('glWindowPos3fvARB');
    pointer(glWindowPos3ivARB) := GetGLProcAddress('glWindowPos3ivARB');
    pointer(glWindowPos3svARB) := GetGLProcAddress('glWindowPos3svARB');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_422_pixels: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_422_pixels', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_abgr: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_abgr', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_bgra: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_bgra', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_blend_color: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_blend_color', extstring) then
  begin
    pointer(glBlendColorEXT) := GetGLProcAddress('glBlendColorEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_blend_func_separate: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_blend_func_separate', extstring) then
  begin
    pointer(glBlendFuncSeparateEXT) := GetGLProcAddress('glBlendFuncSeparateEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_blend_logic_op: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_blend_logic_op', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_blend_minmax: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_blend_minmax', extstring) then
  begin
    pointer(glBlendEquationEXT) := GetGLProcAddress('glBlendEquationEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_blend_subtract: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_blend_subtract', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_clip_volume_hint: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_clip_volume_hint', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_color_subtable: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_color_subtable', extstring) then
  begin
    pointer(glColorSubTableEXT) := GetGLProcAddress('glColorSubTableEXT');
    pointer(glCopyColorSubTableEXT) := GetGLProcAddress('glCopyColorSubTableEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_compiled_vertex_array: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_compiled_vertex_array', extstring) then
  begin
    pointer(glLockArraysEXT) := GetGLProcAddress('glLockArraysEXT');
    pointer(glUnlockArraysEXT) := GetGLProcAddress('glUnlockArraysEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_convolution: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_convolution', extstring) then
  begin
    pointer(glConvolutionFilter1DEXT) := GetGLProcAddress('glConvolutionFilter1DEXT');
    pointer(glConvolutionFilter2DEXT) := GetGLProcAddress('glConvolutionFilter2DEXT');
    pointer(glCopyConvolutionFilter1DEXT) := GetGLProcAddress('glCopyConvolutionFilter1DEXT');
    pointer(glCopyConvolutionFilter2DEXT) := GetGLProcAddress('glCopyConvolutionFilter2DEXT');
   pointer( glGetConvolutionFilterEXT) := GetGLProcAddress('glGetConvolutionFilterEXT');
    pointer(glSeparableFilter2DEXT) := GetGLProcAddress('glSeparableFilter2DEXT');
    pointer(glGetSeparableFilterEXT) := GetGLProcAddress('glGetSeparableFilterEXT');
    pointer(glConvolutionParameteriEXT) := GetGLProcAddress('glConvolutionParameteriEXT');
    pointer(glConvolutionParameterivEXT) := GetGLProcAddress('glConvolutionParameterivEXT');
    pointer(glConvolutionParameterfEXT) := GetGLProcAddress('glConvolutionParameterfEXT');
    pointer(glConvolutionParameterfvEXT) := GetGLProcAddress('glConvolutionParameterfvEXT');
    pointer(glGetConvolutionParameterivEXT) := GetGLProcAddress('glGetConvolutionParameterivEXT');
    pointer(glGetConvolutionParameterfvEXT) := GetGLProcAddress('glGetConvolutionParameterfvEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_fog_coord: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_fog_coord', extstring) then
  begin
    pointer(glFogCoordfEXT) := GetGLProcAddress('glFogCoordfEXT');
    pointer(glFogCoorddEXT) := GetGLProcAddress('glFogCoorddEXT');
    pointer(glFogCoordfvEXT) := GetGLProcAddress('glFogCoordfvEXT');
    pointer(glFogCoorddvEXT) := GetGLProcAddress('glFogCoorddvEXT');
    pointer(glFogCoordPointerEXT) := GetGLProcAddress('glFogCoordPointerEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_histogram: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_histogram', extstring) then
  begin
    pointer(glHistogramEXT) := GetGLProcAddress('glHistogramEXT');
    pointer(glResetHistogramEXT) := GetGLProcAddress('glResetHistogramEXT');
    pointer(glGetHistogramEXT) := GetGLProcAddress('glGetHistogramEXT');
    pointer(glGetHistogramParameterivEXT) := GetGLProcAddress('glGetHistogramParameterivEXT');
    pointer(glGetHistogramParameterfvEXT) := GetGLProcAddress('glGetHistogramParameterfvEXT');
    pointer(glMinmaxEXT) := GetGLProcAddress('glMinmaxEXT');
    pointer(glResetMinmaxEXT) := GetGLProcAddress('glResetMinmaxEXT');
    pointer(glGetMinmaxEXT) := GetGLProcAddress('glGetMinmaxEXT');
    pointer(glGetMinmaxParameterivEXT) := GetGLProcAddress('glGetMinmaxParameterivEXT');
    pointer(glGetMinmaxParameterfvEXT) := GetGLProcAddress('glGetMinmaxParameterfvEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_multi_draw_arrays: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_multi_draw_arrays', extstring) then
  begin
    pointer(glMultiDrawArraysEXT) := GetGLProcAddress('glMultiDrawArraysEXT');
    pointer(glMultiDrawElementsEXT) := GetGLProcAddress('glMultiDrawElementsEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_packed_depth_stencil: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_packed_depth_stencil', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_packed_pixels: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_packed_pixels', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_paletted_texture: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_paletted_texture', extstring) then
  begin
    pointer(glColorTableEXT) := GetGLProcAddress('glColorTableEXT');
    pointer(glColorSubTableEXT) := GetGLProcAddress('glColorSubTableEXT');
    pointer(glGetColorTableEXT) := GetGLProcAddress('glGetColorTableEXT');
    pointer(glGetColorTableParameterivEXT) := GetGLProcAddress('glGetColorTableParameterivEXT');
    pointer(glGetColorTableParameterfvEXT) := GetGLProcAddress('glGetColorTableParameterfvEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_point_parameters: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_point_parameters', extstring) then
  begin
    pointer(glPointParameterfEXT) := GetGLProcAddress('glPointParameterfEXT');
    pointer(glPointParameterfvEXT) := GetGLProcAddress('glPointParameterfvEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_polygon_offset: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_polygon_offset', extstring) then
  begin
    pointer(glPolygonOffsetEXT) := GetGLProcAddress('glPolygonOffsetEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_secondary_color: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_secondary_color', extstring) then
  begin
    pointer(glSecondaryColor3bEXT) := GetGLProcAddress('glSecondaryColor3bEXT');
    pointer(glSecondaryColor3sEXT) := GetGLProcAddress('glSecondaryColor3sEXT');
    pointer(glSecondaryColor3iEXT) := GetGLProcAddress('glSecondaryColor3iEXT');
    pointer(glSecondaryColor3fEXT) := GetGLProcAddress('glSecondaryColor3fEXT');
    pointer(glSecondaryColor3dEXT) := GetGLProcAddress('glSecondaryColor3dEXT');
    pointer(glSecondaryColor3ubEXT) := GetGLProcAddress('glSecondaryColor3ubEXT');
    pointer(glSecondaryColor3usEXT) := GetGLProcAddress('glSecondaryColor3usEXT');
    pointer(glSecondaryColor3uiEXT) := GetGLProcAddress('glSecondaryColor3uiEXT');
    pointer(glSecondaryColor3bvEXT) := GetGLProcAddress('glSecondaryColor3bvEXT');
    pointer(glSecondaryColor3svEXT) := GetGLProcAddress('glSecondaryColor3svEXT');
    pointer(glSecondaryColor3ivEXT) := GetGLProcAddress('glSecondaryColor3ivEXT');
    pointer(glSecondaryColor3fvEXT) := GetGLProcAddress('glSecondaryColor3fvEXT');
    pointer(glSecondaryColor3dvEXT) := GetGLProcAddress('glSecondaryColor3dvEXT');
    pointer(glSecondaryColor3ubvEXT) := GetGLProcAddress('glSecondaryColor3ubvEXT');
    pointer(glSecondaryColor3usvEXT) := GetGLProcAddress('glSecondaryColor3usvEXT');
    pointer(glSecondaryColor3uivEXT) := GetGLProcAddress('glSecondaryColor3uivEXT');
    pointer(glSecondaryColorPointerEXT) := GetGLProcAddress('glSecondaryColorPointerEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_separate_specular_color: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_separate_specular_color', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_shadow_funcs: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_shadow_funcs', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_shared_texture_palette: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_shared_texture_palette', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_stencil_two_side: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_stencil_two_side', extstring) then
  begin
    pointer(glActiveStencilFaceEXT) := GetGLProcAddress('glActiveStencilFaceEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_stencil_wrap: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_stencil_wrap', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_subtexture: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_subtexture', extstring) then
  begin
    pointer(glTexSubImage1DEXT) := GetGLProcAddress('glTexSubImage1DEXT');
    pointer(glTexSubImage2DEXT) := GetGLProcAddress('glTexSubImage2DEXT');
    pointer(glTexSubImage3DEXT) := GetGLProcAddress('glTexSubImage3DEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_texture3D: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_texture3D', extstring) then
  begin
    pointer(glTexImage3DEXT) := GetGLProcAddress('glTexImage3DEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_texture_compression_s3tc: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_texture_compression_s3tc', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_texture_env_add: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_texture_env_add', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_texture_env_combine: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_texture_env_combine', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_texture_env_dot3: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_texture_env_dot3', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_texture_filter_anisotropic: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_texture_filter_anisotropic', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_texture_lod_bias: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_texture_lod_bias', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_texture_object: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_texture_object', extstring) then
  begin
    pointer(glGenTexturesEXT) := GetGLProcAddress('glGenTexturesEXT');
    pointer(glDeleteTexturesEXT) := GetGLProcAddress('glDeleteTexturesEXT');
    pointer(glBindTextureEXT) := GetGLProcAddress('glBindTextureEXT');
    pointer(glPrioritizeTexturesEXT) := GetGLProcAddress('glPrioritizeTexturesEXT');
    pointer(glAreTexturesResidentEXT) := GetGLProcAddress('glAreTexturesResidentEXT');
    pointer(glIsTextureEXT) := GetGLProcAddress('glIsTextureEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_vertex_array: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_vertex_array', extstring) then
  begin
    pointer(glArrayElementEXT) := GetGLProcAddress('glArrayElementEXT');
    pointer(glDrawArraysEXT) := GetGLProcAddress('glDrawArraysEXT');
    pointer(glVertexPointerEXT) := GetGLProcAddress('glVertexPointerEXT');
    pointer(glNormalPointerEXT) := GetGLProcAddress('glNormalPointerEXT');
    pointer(glColorPointerEXT) := GetGLProcAddress('glColorPointerEXT');
    pointer(glIndexPointerEXT) := GetGLProcAddress('glIndexPointerEXT');
    pointer(glTexCoordPointerEXT) := GetGLProcAddress('glTexCoordPointerEXT');
    pointer(glEdgeFlagPointerEXT) := GetGLProcAddress('glEdgeFlagPointerEXT');
    pointer(glGetPointervEXT) := GetGLProcAddress('glGetPointervEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_vertex_shader: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_vertex_shader', extstring) then
  begin
    pointer(glBeginVertexShaderEXT) := GetGLProcAddress('glBeginVertexShaderEXT');
    pointer(glEndVertexShaderEXT) := GetGLProcAddress('glEndVertexShaderEXT');
    pointer(glBindVertexShaderEXT) := GetGLProcAddress('glBindVertexShaderEXT');
    pointer(glGenVertexShadersEXT) := GetGLProcAddress('glGenVertexShadersEXT');
    pointer(glDeleteVertexShaderEXT) := GetGLProcAddress('glDeleteVertexShaderEXT');
    pointer(glShaderOp1EXT) := GetGLProcAddress('glShaderOp1EXT');
    pointer(glShaderOp2EXT) := GetGLProcAddress('glShaderOp2EXT');
    pointer(glShaderOp3EXT) := GetGLProcAddress('glShaderOp3EXT');
    pointer(glSwizzleEXT) := GetGLProcAddress('glSwizzleEXT');
    pointer(glWriteMaskEXT) := GetGLProcAddress('glWriteMaskEXT');
    pointer(glInsertComponentEXT) := GetGLProcAddress('glInsertComponentEXT');
    pointer(glExtractComponentEXT) := GetGLProcAddress('glExtractComponentEXT');
    pointer(glGenSymbolsEXT) := GetGLProcAddress('glGenSymbolsEXT');
    pointer(glSetInvariantEXT) := GetGLProcAddress('glSetInvariantEXT');
    pointer(glSetLocalConstantEXT) := GetGLProcAddress('glSetLocalConstantEXT');
    pointer(glVariantbvEXT) := GetGLProcAddress('glVariantbvEXT');
    pointer(glVariantsvEXT) := GetGLProcAddress('glVariantsvEXT');
    pointer(glVariantivEXT) := GetGLProcAddress('glVariantivEXT');
    pointer(glVariantfvEXT) := GetGLProcAddress('glVariantfvEXT');
    pointer(glVariantdvEXT) := GetGLProcAddress('glVariantdvEXT');
    pointer(glVariantubvEXT) := GetGLProcAddress('glVariantubvEXT');
    pointer(glVariantusvEXT) := GetGLProcAddress('glVariantusvEXT');
    pointer(glVariantuivEXT) := GetGLProcAddress('glVariantuivEXT');
    pointer(glVariantPointerEXT) := GetGLProcAddress('glVariantPointerEXT');
    pointer(glEnableVariantClientStateEXT) := GetGLProcAddress('glEnableVariantClientStateEXT');
    pointer(glDisableVariantClientStateEXT) := GetGLProcAddress('glDisableVariantClientStateEXT');
    pointer(glBindLightParameterEXT) := GetGLProcAddress('glBindLightParameterEXT');
    pointer(glBindMaterialParameterEXT) := GetGLProcAddress('glBindMaterialParameterEXT');
    pointer(glBindTexGenParameterEXT) := GetGLProcAddress('glBindTexGenParameterEXT');
    pointer(glBindTextureUnitParameterEXT) := GetGLProcAddress('glBindTextureUnitParameterEXT');
    pointer(glBindParameterEXT) := GetGLProcAddress('glBindParameterEXT');
    pointer(glIsVariantEnabledEXT) := GetGLProcAddress('glIsVariantEnabledEXT');
    pointer(glGetVariantBooleanvEXT) := GetGLProcAddress('glGetVariantBooleanvEXT');
    pointer(glGetVariantIntegervEXT) := GetGLProcAddress('glGetVariantIntegervEXT');
    pointer(glGetVariantFloatvEXT) := GetGLProcAddress('glGetVariantFloatvEXT');
    pointer(glGetVariantPointervEXT) := GetGLProcAddress('glGetVariantPointervEXT');
    pointer(glGetInvariantBooleanvEXT) := GetGLProcAddress('glGetInvariantBooleanvEXT');
    pointer(glGetInvariantIntegervEXT) := GetGLProcAddress('glGetInvariantIntegervEXT');
    pointer(glGetInvariantFloatvEXT) := GetGLProcAddress('glGetInvariantFloatvEXT');
    pointer(glGetLocalConstantBooleanvEXT) := GetGLProcAddress('glGetLocalConstantBooleanvEXT');
    pointer(glGetLocalConstantIntegervEXT) := GetGLProcAddress('glGetLocalConstantIntegervEXT');
    pointer(glGetLocalConstantFloatvEXT) := GetGLProcAddress('glGetLocalConstantFloatvEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_vertex_weighting: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_vertex_weighting', extstring) then
  begin
    pointer(glVertexWeightfEXT) := GetGLProcAddress('glVertexWeightfEXT');
    pointer(glVertexWeightfvEXT) := GetGLProcAddress('glVertexWeightfvEXT');
    pointer(glVertexWeightPointerEXT) := GetGLProcAddress('glVertexWeightPointerEXT');
    Result := TRUE;
  end;

end;

function Load_GL_HP_occlusion_test: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_HP_occlusion_test', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_blend_square: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_blend_square', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_copy_depth_to_color: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_copy_depth_to_color', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_depth_clamp: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_depth_clamp', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_evaluators: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_evaluators', extstring) then
  begin
    pointer(glMapControlPointsNV) := GetGLProcAddress('glMapControlPointsNV');
    pointer(glMapParameterivNV) := GetGLProcAddress('glMapParameterivNV');
    pointer(glMapParameterfvNV) := GetGLProcAddress('glMapParameterfvNV');
    pointer(glGetMapControlPointsNV) := GetGLProcAddress('glGetMapControlPointsNV');
    pointer(glGetMapParameterivNV) := GetGLProcAddress('glGetMapParameterivNV');
    pointer(glGetMapParameterfvNV) := GetGLProcAddress('glGetMapParameterfvNV');
    pointer(glGetMapAttribParameterivNV) := GetGLProcAddress('glGetMapAttribParameterivNV');
    pointer(glGetMapAttribParameterfvNV) := GetGLProcAddress('glGetMapAttribParameterfvNV');
    pointer(glEvalMapsNV) := GetGLProcAddress('glEvalMapsNV');
    Result := TRUE;
  end;

end;

function Load_GL_NV_fence: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_fence', extstring) then
  begin
    pointer(glGenFencesNV) := GetGLProcAddress('glGenFencesNV');
    pointer(glDeleteFencesNV) := GetGLProcAddress('glDeleteFencesNV');
    pointer(glSetFenceNV) := GetGLProcAddress('glSetFenceNV');
    pointer(glTestFenceNV) := GetGLProcAddress('glTestFenceNV');
    pointer(glFinishFenceNV) := GetGLProcAddress('glFinishFenceNV');
    pointer(glIsFenceNV) := GetGLProcAddress('glIsFenceNV');
    pointer(glGetFenceivNV) := GetGLProcAddress('glGetFenceivNV');
    Result := TRUE;
  end;

end;

function Load_GL_NV_fog_distance: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_fog_distance', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_light_max_exponent: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_light_max_exponent', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_multisample_filter_hint: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_multisample_filter_hint', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_occlusion_query: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_occlusion_query', extstring) then
  begin
    pointer(glGenOcclusionQueriesNV) := GetGLProcAddress('glGenOcclusionQueriesNV');
    pointer(glDeleteOcclusionQueriesNV) := GetGLProcAddress('glDeleteOcclusionQueriesNV');
    pointer(glIsOcclusionQueryNV) := GetGLProcAddress('glIsOcclusionQueryNV');
    pointer(glBeginOcclusionQueryNV) := GetGLProcAddress('glBeginOcclusionQueryNV');
    pointer(glEndOcclusionQueryNV) := GetGLProcAddress('glEndOcclusionQueryNV');
    pointer(glGetOcclusionQueryivNV) := GetGLProcAddress('glGetOcclusionQueryivNV');
    pointer(glGetOcclusionQueryuivNV) := GetGLProcAddress('glGetOcclusionQueryuivNV');
  end;

end;

function Load_GL_NV_packed_depth_stencil: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_packed_depth_stencil', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_point_sprite: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_point_sprite', extstring) then
  begin
    pointer(glPointParameteriNV) := GetGLProcAddress('glPointParameteriNV');
    pointer(glPointParameterivNV) := GetGLProcAddress('glPointParameterivNV');
    Result := TRUE;
  end;

end;

function Load_GL_NV_register_combiners: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_register_combiners', extstring) then
  begin
    pointer(glCombinerParameterfvNV) := GetGLProcAddress('glCombinerParameterfvNV');
    pointer(glCombinerParameterivNV) := GetGLProcAddress('glCombinerParameterivNV');
    pointer(glCombinerParameterfNV) := GetGLProcAddress('glCombinerParameterfNV');
    pointer(glCombinerParameteriNV) := GetGLProcAddress('glCombinerParameteriNV');
    pointer(glCombinerInputNV) := GetGLProcAddress('glCombinerInputNV');
    pointer(glCombinerOutputNV) := GetGLProcAddress('glCombinerOutputNV');
    pointer(glFinalCombinerInputNV) := GetGLProcAddress('glFinalCombinerInputNV');
    pointer(glGetCombinerInputParameterfvNV) := GetGLProcAddress('glGetCombinerInputParameterfvNV');
    pointer(glGetCombinerInputParameterivNV) := GetGLProcAddress('glGetCombinerInputParameterivNV');
    pointer(glGetCombinerOutputParameterfvNV) := GetGLProcAddress('glGetCombinerOutputParameterfvNV');
    pointer(glGetCombinerOutputParameterivNV) := GetGLProcAddress('glGetCombinerOutputParameterivNV');
    pointer(glGetFinalCombinerInputParameterfvNV) := GetGLProcAddress('glGetFinalCombinerInputParameterfvNV');
    pointer(glGetFinalCombinerInputParameterivNV) := GetGLProcAddress('glGetFinalCombinerInputParameterivNV');
    Result := TRUE;
  end;

end;

function Load_GL_NV_register_combiners2: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_register_combiners2', extstring) then
  begin
    pointer(glCombinerStageParameterfvNV) := GetGLProcAddress('glCombinerStageParameterfvNV');
    pointer(glGetCombinerStageParameterfvNV) := GetGLProcAddress('glGetCombinerStageParameterfvNV');
    Result := TRUE;
  end;

end;

function Load_GL_NV_texgen_emboss: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_texgen_emboss', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_texgen_reflection: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_texgen_reflection', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_texture_compression_vtc: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_texture_compression_vtc', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_texture_env_combine4: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_texture_env_combine4', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_texture_rectangle: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_texture_rectangle', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_texture_shader: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_texture_shader', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_texture_shader2: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_texture_shader2', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_texture_shader3: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_texture_shader3', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_vertex_array_range: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_vertex_array_range', extstring) then
  begin
    pointer(glVertexArrayRangeNV) := GetGLProcAddress('glVertexArrayRangeNV');
    pointer(glFlushVertexArrayRangeNV) := GetGLProcAddress('glFlushVertexArrayRangeNV');
{$IFDEF Windows}
    pointer(wglAllocateMemoryNV) := GetGLProcAddress('wglAllocateMemoryNV');
    pointer(wglFreeMemoryNV) := GetGLProcAddress('wglFreeMemoryNV');
{$ENDIF}
    Result := TRUE;
  end;

end;

function Load_GL_NV_vertex_array_range2: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_vertex_array_range2', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_vertex_program: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_vertex_program', extstring) then
  begin
    pointer(glBindProgramNV) := GetGLProcAddress('glBindProgramNV');
    pointer(glDeleteProgramsNV) := GetGLProcAddress('glDeleteProgramsNV');
    pointer(glExecuteProgramNV) := GetGLProcAddress('glExecuteProgramNV');
    pointer(glGenProgramsNV) := GetGLProcAddress('glGenProgramsNV');
    pointer(glAreProgramsResidentNV) := GetGLProcAddress('glAreProgramsResidentNV');
    pointer(glRequestResidentProgramsNV) := GetGLProcAddress('glRequestResidentProgramsNV');
    pointer(glGetProgramParameterfvNV) := GetGLProcAddress('glGetProgramParameterfvNV');
    pointer(glGetProgramParameterdvNV) := GetGLProcAddress('glGetProgramParameterdvNV');
    pointer(glGetProgramivNV) := GetGLProcAddress('glGetProgramivNV');
    pointer(glGetProgramStringNV) := GetGLProcAddress('glGetProgramStringNV');
    pointer(glGetTrackMatrixivNV) := GetGLProcAddress('glGetTrackMatrixivNV');
    pointer(glGetVertexAttribdvNV) := GetGLProcAddress('glGetVertexAttribdvNV');
    pointer(glGetVertexAttribfvNV) := GetGLProcAddress('glGetVertexAttribfvNV');
    pointer(glGetVertexAttribivNV) := GetGLProcAddress('glGetVertexAttribivNV');
    pointer(glGetVertexAttribPointervNV) := GetGLProcAddress('glGetVertexAttribPointervNV');
    pointer(glIsProgramNV) := GetGLProcAddress('glIsProgramNV');
    pointer(glLoadProgramNV) := GetGLProcAddress('glLoadProgramNV');
    pointer(glProgramParameter4fNV) := GetGLProcAddress('glProgramParameter4fNV');
    pointer(glProgramParameter4fvNV) := GetGLProcAddress('glProgramParameter4fvNV');
    pointer(glProgramParameters4dvNV) := GetGLProcAddress('glProgramParameters4dvNV');
    pointer(glProgramParameters4fvNV) := GetGLProcAddress('glProgramParameters4fvNV');
    pointer(glTrackMatrixNV) := GetGLProcAddress('glTrackMatrixNV');
    pointer(glVertexAttribPointerNV) := GetGLProcAddress('glVertexAttribPointerNV');
    pointer(glVertexAttrib1sNV) := GetGLProcAddress('glVertexAttrib1sNV');
    pointer(glVertexAttrib1fNV) := GetGLProcAddress('glVertexAttrib1fNV');
    pointer(glVertexAttrib1dNV) := GetGLProcAddress('glVertexAttrib1dNV');
    pointer(glVertexAttrib2sNV) := GetGLProcAddress('glVertexAttrib2sNV');
    pointer(glVertexAttrib2fNV) := GetGLProcAddress('glVertexAttrib2fNV');
    pointer(glVertexAttrib3sNV) := GetGLProcAddress('glVertexAttrib3sNV');
    pointer(glVertexAttrib3fNV) := GetGLProcAddress('glVertexAttrib3fNV');
    pointer(glVertexAttrib3dNV) := GetGLProcAddress('glVertexAttrib3dNV');
    pointer(glVertexAttrib4sNV) := GetGLProcAddress('glVertexAttrib4sNV');
    pointer(glVertexAttrib4fNV) := GetGLProcAddress('glVertexAttrib4fNV');
    pointer(glVertexAttrib4dNV) := GetGLProcAddress('glVertexAttrib4dNV');
    pointer(glVertexAttrib4ubNV) := GetGLProcAddress('glVertexAttrib4ubNV');
    pointer(glVertexAttrib1svNV) := GetGLProcAddress('glVertexAttrib1svNV');
    pointer(glVertexAttrib1fvNV) := GetGLProcAddress('glVertexAttrib1fvNV');
    pointer(glVertexAttrib1dvNV) := GetGLProcAddress('glVertexAttrib1dvNV');
    pointer(glVertexAttrib2svNV) := GetGLProcAddress('glVertexAttrib2svNV');
    pointer(glVertexAttrib2fvNV) := GetGLProcAddress('glVertexAttrib2fvNV');
    pointer(glVertexAttrib2dvNV) := GetGLProcAddress('glVertexAttrib2dvNV');
    pointer(glVertexAttrib3svNV) := GetGLProcAddress('glVertexAttrib3svNV');
    pointer(glVertexAttrib3fvNV) := GetGLProcAddress('glVertexAttrib3fvNV');
    pointer(glVertexAttrib3dvNV) := GetGLProcAddress('glVertexAttrib3dvNV');
    pointer(glVertexAttrib4svNV) := GetGLProcAddress('glVertexAttrib4svNV');
   pointer( glVertexAttrib4fvNV) := GetGLProcAddress('glVertexAttrib4fvNV');
    pointer(glVertexAttrib4dvNV) := GetGLProcAddress('glVertexAttrib4dvNV');
    pointer(glVertexAttrib4ubvNV) := GetGLProcAddress('glVertexAttrib4ubvNV');
    pointer(glVertexAttribs1svNV) := GetGLProcAddress('glVertexAttribs1svNV');
    pointer(glVertexAttribs1fvNV) := GetGLProcAddress('glVertexAttribs1fvNV');
    pointer(glVertexAttribs1dvNV) := GetGLProcAddress('glVertexAttribs1dvNV');
    pointer(glVertexAttribs2svNV) := GetGLProcAddress('glVertexAttribs2svNV');
    pointer(glVertexAttribs2fvNV) := GetGLProcAddress('glVertexAttribs2fvNV');
    pointer(glVertexAttribs2dvNV) := GetGLProcAddress('glVertexAttribs2dvNV');
    pointer(glVertexAttribs3svNV) := GetGLProcAddress('glVertexAttribs3svNV');
    pointer(glVertexAttribs3fvNV) := GetGLProcAddress('glVertexAttribs3fvNV');
    pointer(glVertexAttribs3dvNV) := GetGLProcAddress('glVertexAttribs3dvNV');
    pointer(glVertexAttribs4svNV) := GetGLProcAddress('glVertexAttribs4svNV');
    pointer(glVertexAttribs4fvNV) := GetGLProcAddress('glVertexAttribs4fvNV');
    pointer(glVertexAttribs4dvNV) := GetGLProcAddress('glVertexAttribs4dvNV');
    pointer(glVertexAttribs4ubvNV) := GetGLProcAddress('glVertexAttribs4ubvNV');
    Result := TRUE;
  end;

end;

function Load_GL_NV_vertex_program1_1: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_vertex_program1_1', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ATI_element_array: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_element_array', extstring) then
  begin
    pointer(glElementPointerATI) := GetGLProcAddress('glElementPointerATI');
    pointer(glDrawElementArrayATI) := GetGLProcAddress('glDrawElementArrayATI');
    pointer(glDrawRangeElementArrayATI) := GetGLProcAddress('glDrawRangeElementArrayATI');
    Result := TRUE;
  end;

end;

function Load_GL_ATI_envmap_bumpmap: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_envmap_bumpmap', extstring) then
  begin
    pointer(glTexBumpParameterivATI) := GetGLProcAddress('glTexBumpParameterivATI');
    pointer(glTexBumpParameterfvATI) := GetGLProcAddress('glTexBumpParameterfvATI');
    pointer(glGetTexBumpParameterfvATI) := GetGLProcAddress('glGetTexBumpParameterfvATI');
    Result := TRUE;
  end;

end;

function Load_GL_ATI_fragment_shader: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_fragment_shader', extstring) then
  begin
    pointer(glGenFragmentShadersATI) := GetGLProcAddress('glGenFragmentShadersATI');
    pointer(glBindFragmentShaderATI) := GetGLProcAddress('glBindFragmentShaderATI');
    pointer(glDeleteFragmentShaderATI) := GetGLProcAddress('glDeleteFragmentShaderATI');
    pointer(glBeginFragmentShaderATI) := GetGLProcAddress('glBeginFragmentShaderATI');
    pointer(glEndFragmentShaderATI) := GetGLProcAddress('glEndFragmentShaderATI');
    pointer(glPassTexCoordATI) := GetGLProcAddress('glPassTexCoordATI');
    pointer(glSampleMapATI) := GetGLProcAddress('glSampleMapATI');
    pointer(glColorFragmentOp1ATI) := GetGLProcAddress('glColorFragmentOp1ATI');
    pointer(glColorFragmentOp2ATI) := GetGLProcAddress('glColorFragmentOp2ATI');
    pointer(glColorFragmentOp3ATI) := GetGLProcAddress('glColorFragmentOp3ATI');
    pointer(glAlphaFragmentOp1ATI) := GetGLProcAddress('glAlphaFragmentOp1ATI');
    pointer(glAlphaFragmentOp2ATI) := GetGLProcAddress('glAlphaFragmentOp2ATI');
    pointer(glAlphaFragmentOp3ATI) := GetGLProcAddress('glAlphaFragmentOp3ATI');
    pointer(glSetFragmentShaderConstantATI) := GetGLProcAddress('glSetFragmentShaderConstantATI');
    Result := TRUE;
  end;

end;

function Load_GL_ATI_pn_triangles: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_pn_triangles', extstring) then
  begin
    pointer(glPNTrianglesiATI) := GetGLProcAddress('glPNTrianglesiATI');
    pointer(glPNTrianglesfATI) := GetGLProcAddress('glPNTrianglesfATI');
    Result := TRUE;
  end;

end;

function Load_GL_ATI_texture_mirror_once: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_texture_mirror_once', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ATI_vertex_array_object: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_vertex_array_object', extstring) then
  begin
    pointer(glNewObjectBufferATI) := GetGLProcAddress('glNewObjectBufferATI');
    pointer(glIsObjectBufferATI) := GetGLProcAddress('glIsObjectBufferATI');
    pointer(glUpdateObjectBufferATI) := GetGLProcAddress('glUpdateObjectBufferATI');
    pointer(glGetObjectBufferfvATI) := GetGLProcAddress('glGetObjectBufferfvATI');
    pointer(glGetObjectBufferivATI) := GetGLProcAddress('glGetObjectBufferivATI');
    pointer(glDeleteObjectBufferATI) := GetGLProcAddress('glDeleteObjectBufferATI');
    pointer(glArrayObjectATI) := GetGLProcAddress('glArrayObjectATI');
    pointer(glGetArrayObjectfvATI) := GetGLProcAddress('glGetArrayObjectfvATI');
    pointer(glGetArrayObjectivATI) := GetGLProcAddress('glGetArrayObjectivATI');
    pointer(glVariantArrayObjectATI) := GetGLProcAddress('glVariantArrayObjectATI');
    pointer(glGetVariantArrayObjectfvATI) := GetGLProcAddress('glGetVariantArrayObjectfvATI');
    pointer(glGetVariantArrayObjectivATI) := GetGLProcAddress('glGetVariantArrayObjectivATI');
    Result := TRUE;
  end;

end;

function Load_GL_ATI_vertex_streams: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_vertex_streams', extstring) then
  begin
    pointer(glVertexStream1s) := GetGLProcAddress('glVertexStream1s');
    pointer(glVertexStream1i) := GetGLProcAddress('glVertexStream1i');
    pointer(glVertexStream1f) := GetGLProcAddress('glVertexStream1f');
    pointer(glVertexStream1d) := GetGLProcAddress('glVertexStream1d');
    pointer(glVertexStream1sv) := GetGLProcAddress('glVertexStream1sv');
    pointer(glVertexStream1iv) := GetGLProcAddress('glVertexStream1iv');
    pointer(glVertexStream1fv) := GetGLProcAddress('glVertexStream1fv');
    pointer(glVertexStream1dv) := GetGLProcAddress('glVertexStream1dv');
    pointer(glVertexStream2s) := GetGLProcAddress('glVertexStream2s');
    pointer(glVertexStream2i) := GetGLProcAddress('glVertexStream2i');
    pointer(glVertexStream2f) := GetGLProcAddress('glVertexStream2f');
    pointer( glVertexStream2d) := GetGLProcAddress('glVertexStream2d');
    pointer(glVertexStream2sv) := GetGLProcAddress('glVertexStream2sv');
    pointer(glVertexStream2iv) := GetGLProcAddress('glVertexStream2iv');
    pointer(glVertexStream2fv) := GetGLProcAddress('glVertexStream2fv');
    pointer(glVertexStream2dv) := GetGLProcAddress('glVertexStream2dv');
    pointer(glVertexStream3s) := GetGLProcAddress('glVertexStream3s');
    pointer(glVertexStream3i) := GetGLProcAddress('glVertexStream3i');
    pointer(glVertexStream3f) := GetGLProcAddress('glVertexStream3f');
    pointer(glVertexStream3d) := GetGLProcAddress('glVertexStream3d');
    pointer(glVertexStream3sv) := GetGLProcAddress('glVertexStream3sv');
    pointer(glVertexStream3iv) := GetGLProcAddress('glVertexStream3iv');
    pointer(glVertexStream3fv) := GetGLProcAddress('glVertexStream3fv');
    pointer(glVertexStream3dv) := GetGLProcAddress('glVertexStream3dv');
    pointer( glVertexStream4s) := GetGLProcAddress('glVertexStream4s');
    pointer(glVertexStream4i) := GetGLProcAddress('glVertexStream4i');
    pointer(glVertexStream4f) := GetGLProcAddress('glVertexStream4f');
    pointer(glVertexStream4d) := GetGLProcAddress('glVertexStream4d');
    pointer(glVertexStream4sv) := GetGLProcAddress('glVertexStream4sv');
    pointer(glVertexStream4iv) := GetGLProcAddress('glVertexStream4iv');
    pointer(glVertexStream4fv) := GetGLProcAddress('glVertexStream4fv');
    pointer(glNormalStream3b) := GetGLProcAddress('glNormalStream3b');
    pointer(glNormalStream3s) := GetGLProcAddress('glNormalStream3s');
    pointer(glNormalStream3i) := GetGLProcAddress('glNormalStream3i');
    pointer(glNormalStream3f) := GetGLProcAddress('glNormalStream3f');
    pointer(glNormalStream3d) := GetGLProcAddress('glNormalStream3d');
    pointer(glNormalStream3bv) := GetGLProcAddress('glNormalStream3bv');
    pointer(glNormalStream3sv) := GetGLProcAddress('glNormalStream3sv');
    pointer(glNormalStream3iv) := GetGLProcAddress('glNormalStream3iv');
    pointer(glNormalStream3fv) := GetGLProcAddress('glNormalStream3fv');
    pointer(glNormalStream3dv) := GetGLProcAddress('glNormalStream3dv');
    pointer(glClientActiveVertexStream) := GetGLProcAddress('glClientActiveVertexStream');
    pointer(glVertexBlendEnvi) := GetGLProcAddress('glVertexBlendEnvi');
    pointer(glVertexBlendEnvf) := GetGLProcAddress('glVertexBlendEnvf');
    Result := TRUE;
  end;

end;

{$IFDEF Windows}
function Load_WGL_I3D_image_buffer: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_I3D_image_buffer', extstring) then
  begin
    pointer(wglCreateImageBufferI3D) := GetGLProcAddress('wglCreateImageBufferI3D');
    pointer(wglDestroyImageBufferI3D) := GetGLProcAddress('wglDestroyImageBufferI3D');
    pointer(wglAssociateImageBufferEventsI3D) := GetGLProcAddress('wglAssociateImageBufferEventsI3D');
    pointer(wglReleaseImageBufferEventsI3D) := GetGLProcAddress('wglReleaseImageBufferEventsI3D');
    Result := TRUE;
  end;

end;

function Load_WGL_I3D_swap_frame_lock: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_I3D_swap_frame_lock', extstring) then
  begin
    pointer(wglEnableFrameLockI3D) := GetGLProcAddress('wglEnableFrameLockI3D');
    pointer(wglDisableFrameLockI3D) := GetGLProcAddress('wglDisableFrameLockI3D');
    pointer(wglIsEnabledFrameLockI3D) := GetGLProcAddress('wglIsEnabledFrameLockI3D');
    pointer(wglQueryFrameLockMasterI3D) := GetGLProcAddress('wglQueryFrameLockMasterI3D');
    Result := TRUE;
  end;

end;

function Load_WGL_I3D_swap_frame_usage: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_I3D_swap_frame_usage', extstring) then
  begin
    pointer(wglGetFrameUsageI3D) := GetGLProcAddress('wglGetFrameUsageI3D');
    pointer(wglBeginFrameTrackingI3D) := GetGLProcAddress('wglBeginFrameTrackingI3D');
    pointer(wglEndFrameTrackingI3D) := GetGLProcAddress('wglEndFrameTrackingI3D');
    pointer(wglQueryFrameTrackingI3D) := GetGLProcAddress('wglQueryFrameTrackingI3D');
    Result := TRUE;
  end;

end;
{$ENDIF}

function Load_GL_3DFX_texture_compression_FXT1: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_3DFX_texture_compression_FXT1', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_IBM_cull_vertex: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_IBM_cull_vertex', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_IBM_multimode_draw_arrays: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_IBM_multimode_draw_arrays', extstring) then
  begin
    pointer(glMultiModeDrawArraysIBM) := GetGLProcAddress('glMultiModeDrawArraysIBM');
    pointer(glMultiModeDrawElementsIBM) := GetGLProcAddress('glMultiModeDrawElementsIBM');
    Result := TRUE;
  end;

end;

function Load_GL_IBM_raster_pos_clip: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_IBM_raster_pos_clip', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_IBM_texture_mirrored_repeat: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_IBM_texture_mirrored_repeat', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_IBM_vertex_array_lists: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_IBM_vertex_array_lists', extstring) then
  begin
    pointer(glColorPointerListIBM) := GetGLProcAddress('glColorPointerListIBM');
    pointer(glSecondaryColorPointerListIBM) := GetGLProcAddress('glSecondaryColorPointerListIBM');
    pointer(glEdgeFlagPointerListIBM) := GetGLProcAddress('glEdgeFlagPointerListIBM');
    pointer(glFogCoordPointerListIBM) := GetGLProcAddress('glFogCoordPointerListIBM');
    pointer(glNormalPointerListIBM) := GetGLProcAddress('glNormalPointerListIBM');
    pointer(glTexCoordPointerListIBM) := GetGLProcAddress('glTexCoordPointerListIBM');
    pointer(glVertexPointerListIBM) := GetGLProcAddress('glVertexPointerListIBM');
    Result := TRUE;
  end;

end;

function Load_GL_MESA_resize_buffers: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_MESA_resize_buffers', extstring) then
  begin
    pointer(glResizeBuffersMESA) := GetGLProcAddress('glResizeBuffersMESA');
    Result := TRUE;
  end;

end;

function Load_GL_MESA_window_pos: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_MESA_window_pos', extstring) then
  begin
    pointer(glWindowPos2dMESA) := GetGLProcAddress('glWindowPos2dMESA');
    pointer(glWindowPos2fMESA) := GetGLProcAddress('glWindowPos2fMESA');
    pointer(glWindowPos2iMESA) := GetGLProcAddress('glWindowPos2iMESA');
    pointer(glWindowPos2sMESA) := GetGLProcAddress('glWindowPos2sMESA');
    pointer(glWindowPos2svMESA) := GetGLProcAddress('glWindowPos2svMESA');
    pointer(glWindowPos2fvMESA) := GetGLProcAddress('glWindowPos2fvMESA');
    pointer(glWindowPos2dvMESA) := GetGLProcAddress('glWindowPos2dvMESA');
    pointer(glWindowPos3iMESA) := GetGLProcAddress('glWindowPos3iMESA');
    pointer(glWindowPos3sMESA) := GetGLProcAddress('glWindowPos3sMESA');
    pointer(glWindowPos3fMESA) := GetGLProcAddress('glWindowPos3fMESA');
    pointer(glWindowPos3dMESA) := GetGLProcAddress('glWindowPos3dMESA');
    pointer(glWindowPos3ivMESA) := GetGLProcAddress('glWindowPos3ivMESA');
    pointer(glWindowPos3svMESA) := GetGLProcAddress('glWindowPos3svMESA');
    pointer(glWindowPos3fvMESA) := GetGLProcAddress('glWindowPos3fvMESA');
    pointer(glWindowPos3dvMESA) := GetGLProcAddress('glWindowPos3dvMESA');
    pointer(glWindowPos4iMESA) := GetGLProcAddress('glWindowPos4iMESA');
    pointer(glWindowPos4sMESA) := GetGLProcAddress('glWindowPos4sMESA');
    pointer(glWindowPos4fMESA) := GetGLProcAddress('glWindowPos4fMESA');
    pointer(glWindowPos4dMESA) := GetGLProcAddress('glWindowPos4dMESA');
    pointer(glWindowPos4ivMESA) := GetGLProcAddress('glWindowPos4ivMESA');
    pointer(glWindowPos4svMESA) := GetGLProcAddress('glWindowPos4svMESA');
    pointer(glWindowPos4fvMESA) := GetGLProcAddress('glWindowPos4fvMESA');
    pointer(glWindowPos4dvMESA) := GetGLProcAddress('glWindowPos4dvMESA');
    Result := TRUE;
  end;

end;

function Load_GL_OML_interlace: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_OML_interlace', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_OML_resample: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_OML_resample', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_OML_subsample: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_OML_subsample', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_SGIS_generate_mipmap: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGIS_generate_mipmap', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_SGIS_multisample: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGIS_multisample', extstring) then
  begin
    pointer(glSampleMaskSGIS) := GetGLProcAddress('glSampleMaskSGIS');
    pointer(glSamplePatternSGIS) := GetGLProcAddress('glSamplePatternSGIS');
    Result := TRUE;
  end;

end;

function Load_GL_SGIS_pixel_texture: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGIS_pixel_texture', extstring) then
  begin
    pointer(glPixelTexGenParameteriSGIS) := GetGLProcAddress('glPixelTexGenParameteriSGIS');
    pointer(glPixelTexGenParameterfSGIS) := GetGLProcAddress('glPixelTexGenParameterfSGIS');
    pointer(glGetPixelTexGenParameterivSGIS) := GetGLProcAddress('glGetPixelTexGenParameterivSGIS');
    pointer(glGetPixelTexGenParameterfvSGIS) := GetGLProcAddress('glGetPixelTexGenParameterfvSGIS');
    Result := TRUE;
  end;

end;

function Load_GL_SGIS_texture_border_clamp: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGIS_texture_border_clamp', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_SGIS_texture_color_mask: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGIS_texture_color_mask', extstring) then
  begin
    pointer(glTextureColorMaskSGIS) := GetGLProcAddress('glTextureColorMaskSGIS');
    Result := TRUE;
  end;

end;

function Load_GL_SGIS_texture_edge_clamp: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGIS_texture_edge_clamp', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_SGIS_texture_lod: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGIS_texture_lod', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_SGIS_depth_texture: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGIS_depth_texture', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_SGIX_fog_offset: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGIX_fog_offset', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_SGIX_interlace: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGIX_interlace', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_SGIX_shadow_ambient: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGIX_shadow_ambient', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_SGI_color_matrix: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGI_color_matrix', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_SGI_color_table: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGI_color_table', extstring) then
  begin
    pointer(glColorTableSGI) := GetGLProcAddress('glColorTableSGI');
    pointer(glCopyColorTableSGI) := GetGLProcAddress('glCopyColorTableSGI');
    pointer(glColorTableParameterivSGI) := GetGLProcAddress('glColorTableParameterivSGI');
    pointer(glColorTableParameterfvSGI) := GetGLProcAddress('glColorTableParameterfvSGI');
    pointer(glGetColorTableSGI) := GetGLProcAddress('glGetColorTableSGI');
    if not Assigned(glGetColorTableSGI) then Exit;
    pointer(glGetColorTableParameterivSGI) := GetGLProcAddress('glGetColorTableParameterivSGI');
    Result := TRUE;
  end;

end;

function Load_GL_SGI_texture_color_table: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SGI_texture_color_table', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_SUN_vertex: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_SUN_vertex', extstring) then
  begin
    pointer(glColor4ubVertex2fSUN) := GetGLProcAddress('glColor4ubVertex2fSUN');
    pointer(glColor4ubVertex2fvSUN) := GetGLProcAddress('glColor4ubVertex2fvSUN');
    pointer(glColor4ubVertex3fSUN) := GetGLProcAddress('glColor4ubVertex3fSUN');
    pointer(glColor4ubVertex3fvSUN) := GetGLProcAddress('glColor4ubVertex3fvSUN');
    pointer(glColor3fVertex3fSUN) := GetGLProcAddress('glColor3fVertex3fSUN');
    pointer(glColor3fVertex3fvSUN) := GetGLProcAddress('glColor3fVertex3fvSUN');
    pointer(glNormal3fVertex3fSUN) := GetGLProcAddress('glNormal3fVertex3fSUN');
    pointer(glNormal3fVertex3fvSUN) := GetGLProcAddress('glNormal3fVertex3fvSUN');
    pointer(glColor4fNormal3fVertex3fSUN) := GetGLProcAddress('glColor4fNormal3fVertex3fSUN');
    pointer(glColor4fNormal3fVertex3fvSUN) := GetGLProcAddress('glColor4fNormal3fVertex3fvSUN');
    pointer(glTexCoord2fVertex3fSUN) := GetGLProcAddress('glTexCoord2fVertex3fSUN');
    pointer(glTexCoord2fVertex3fvSUN) := GetGLProcAddress('glTexCoord2fVertex3fvSUN');
    pointer(glTexCoord4fVertex4fSUN) := GetGLProcAddress('glTexCoord4fVertex4fSUN');
    pointer(glTexCoord4fVertex4fvSUN) := GetGLProcAddress('glTexCoord4fVertex4fvSUN');
    pointer(glTexCoord2fColor4ubVertex3fSUN) := GetGLProcAddress('glTexCoord2fColor4ubVertex3fSUN');
    pointer(glTexCoord2fColor4ubVertex3fvSUN) := GetGLProcAddress('glTexCoord2fColor4ubVertex3fvSUN');
    pointer(glTexCoord2fColor3fVertex3fSUN) := GetGLProcAddress('glTexCoord2fColor3fVertex3fSUN');
    pointer(glTexCoord2fColor3fVertex3fvSUN) := GetGLProcAddress('glTexCoord2fColor3fVertex3fvSUN');
    pointer(glTexCoord2fNormal3fVertex3fSUN) := GetGLProcAddress('glTexCoord2fNormal3fVertex3fSUN');
    pointer(glTexCoord2fNormal3fVertex3fvSUN) := GetGLProcAddress('glTexCoord2fNormal3fVertex3fvSUN');
    pointer(glTexCoord2fColor4fNormal3fVertex3fSUN) := GetGLProcAddress('glTexCoord2fColor4fNormal3fVertex3fSUN');
    pointer(glTexCoord2fColor4fNormal3fVertex3fvSUN) := GetGLProcAddress('glTexCoord2fColor4fNormal3fVertex3fvSUN');
    pointer(glTexCoord4fColor4fNormal3fVertex4fSUN) := GetGLProcAddress('glTexCoord4fColor4fNormal3fVertex4fSUN');
    pointer(glTexCoord4fColor4fNormal3fVertex4fvSUN) := GetGLProcAddress('glTexCoord4fColor4fNormal3fVertex4fvSUN');
    pointer(glReplacementCodeuiVertex3fSUN) := GetGLProcAddress('glReplacementCodeuiVertex3fSUN');
    pointer(glReplacementCodeuiVertex3fvSUN) := GetGLProcAddress('glReplacementCodeuiVertex3fvSUN');
    pointer(glReplacementCodeuiColor4ubVertex3fSUN) := GetGLProcAddress('glReplacementCodeuiColor4ubVertex3fSUN');
    pointer(glReplacementCodeuiColor4ubVertex3fvSUN) := GetGLProcAddress('glReplacementCodeuiColor4ubVertex3fvSUN');
    pointer(glReplacementCodeuiColor3fVertex3fSUN) := GetGLProcAddress('glReplacementCodeuiColor3fVertex3fSUN');
    pointer(glReplacementCodeuiColor3fVertex3fvSUN) := GetGLProcAddress('glReplacementCodeuiColor3fVertex3fvSUN');
    pointer(glReplacementCodeuiNormal3fVertex3fSUN) := GetGLProcAddress('glReplacementCodeuiNormal3fVertex3fSUN');
    pointer(glReplacementCodeuiNormal3fVertex3fvSUN) := GetGLProcAddress('glReplacementCodeuiNormal3fVertex3fvSUN');
    pointer(glReplacementCodeuiColor4fNormal3fVertex3fSUN) := GetGLProcAddress('glReplacementCodeuiColor4fNormal3fVertex3fSUN');
    pointer(glReplacementCodeuiColor4fNormal3fVertex3fvSUN) := GetGLProcAddress('glReplacementCodeuiColor4fNormal3fVertex3fvSUN');
    pointer(glReplacementCodeuiTexCoord2fVertex3fSUN) := GetGLProcAddress('glReplacementCodeuiTexCoord2fVertex3fSUN');
    pointer(glReplacementCodeuiTexCoord2fVertex3fvSUN) := GetGLProcAddress('glReplacementCodeuiTexCoord2fVertex3fvSUN');
    pointer(glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN) := GetGLProcAddress('glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN');
    pointer(glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN) := GetGLProcAddress('glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN');
    pointer(glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN) := GetGLProcAddress('glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN');
    pointer(glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN) := GetGLProcAddress('glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_fragment_program: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_fragment_program', extstring) then
  begin
    pointer(glProgramStringARB) := GetGLProcAddress('glProgramStringARB');
    pointer(glBindProgramARB) := GetGLProcAddress('glBindProgramARB');
    pointer(glDeleteProgramsARB) := GetGLProcAddress('glDeleteProgramsARB');
    pointer(glGenProgramsARB) := GetGLProcAddress('glGenProgramsARB');
    pointer(glProgramEnvParameter4dARB) := GetGLProcAddress('glProgramEnvParameter4dARB');
    pointer(glProgramEnvParameter4dvARB) := GetGLProcAddress('glProgramEnvParameter4dvARB');
    pointer(glProgramEnvParameter4fARB) := GetGLProcAddress('glProgramEnvParameter4fARB');
    pointer(glProgramEnvParameter4fvARB) := GetGLProcAddress('glProgramEnvParameter4fvARB');
    pointer(glProgramLocalParameter4dARB) := GetGLProcAddress('glProgramLocalParameter4dARB');
    pointer(glProgramLocalParameter4dvARB) := GetGLProcAddress('glProgramLocalParameter4dvARB');
    pointer(glProgramLocalParameter4fARB) := GetGLProcAddress('glProgramLocalParameter4fARB');
    pointer(glProgramLocalParameter4fvARB) := GetGLProcAddress('glProgramLocalParameter4fvARB');
    pointer(glGetProgramEnvParameterdvARB) := GetGLProcAddress('glGetProgramEnvParameterdvARB');
    pointer(glGetProgramEnvParameterfvARB) := GetGLProcAddress('glGetProgramEnvParameterfvARB');
    pointer(glGetProgramLocalParameterdvARB) := GetGLProcAddress('glGetProgramLocalParameterdvARB');
    pointer(glGetProgramLocalParameterfvARB) := GetGLProcAddress('glGetProgramLocalParameterfvARB');
    pointer(glGetProgramivARB) := GetGLProcAddress('glGetProgramivARB');
    pointer(glGetProgramStringARB) := GetGLProcAddress('glGetProgramStringARB');
    pointer(glIsProgramARB) := GetGLProcAddress('glIsProgramARB');
    Result := TRUE;
  end;

end;

function Load_GL_ATI_text_fragment_shader: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_text_fragment_shader', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_APPLE_client_storage: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_APPLE_client_storage', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_APPLE_element_array: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_APPLE_element_array', extstring) then
  begin
    pointer(glElementPointerAPPLE) := GetGLProcAddress('glElementPointerAPPLE');
    pointer(glDrawElementArrayAPPLE) := GetGLProcAddress('glDrawElementArrayAPPLE');
    pointer(glDrawRangeElementArrayAPPLE) := GetGLProcAddress('glDrawRangeElementArrayAPPLE');
    pointer(glMultiDrawElementArrayAPPLE) := GetGLProcAddress('glMultiDrawElementArrayAPPLE');
    pointer(glMultiDrawRangeElementArrayAPPLE) := GetGLProcAddress('glMultiDrawRangeElementArrayAPPLE');
    Result := TRUE;
  end;

end;

function Load_GL_APPLE_fence: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_APPLE_fence', extstring) then
  begin
    pointer(glGenFencesAPPLE) := GetGLProcAddress('glGenFencesAPPLE');
    pointer(glDeleteFencesAPPLE) := GetGLProcAddress('glDeleteFencesAPPLE');
    pointer(glSetFenceAPPLE) := GetGLProcAddress('glSetFenceAPPLE');
    pointer(glIsFenceAPPLE) := GetGLProcAddress('glIsFenceAPPLE');
    pointer(glTestFenceAPPLE) := GetGLProcAddress('glTestFenceAPPLE');
    pointer(glFinishFenceAPPLE) := GetGLProcAddress('glFinishFenceAPPLE');
    pointer(glTestObjectAPPLE) := GetGLProcAddress('glTestObjectAPPLE');
    Result := TRUE;
  end;

end;

function Load_GL_APPLE_vertex_array_object: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_APPLE_vertex_array_object', extstring) then
  begin
    pointer(glBindVertexArrayAPPLE) := GetGLProcAddress('glBindVertexArrayAPPLE');
    pointer(glDeleteVertexArraysAPPLE) := GetGLProcAddress('glDeleteVertexArraysAPPLE');
    pointer(glGenVertexArraysAPPLE) := GetGLProcAddress('glGenVertexArraysAPPLE');
    pointer(glIsVertexArrayAPPLE) := GetGLProcAddress('glIsVertexArrayAPPLE');
    Result := TRUE;
  end;

end;

function Load_GL_APPLE_vertex_array_range: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_APPLE_vertex_array_range', extstring) then
  begin
    pointer(glVertexArrayRangeAPPLE) := GetGLProcAddress('glVertexArrayRangeAPPLE');
    pointer(glFlushVertexArrayRangeAPPLE) := GetGLProcAddress('glFlushVertexArrayRangeAPPLE');
    pointer(glVertexArrayParameteriAPPLE) := GetGLProcAddress('glVertexArrayParameteriAPPLE');
    Result := TRUE;
  end;

end;


function load_GL_ARB_vertex_buffer_object : boolean;

var extstring:string;

begin
  Result:=false;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));
  if glext_ExtensionSupported('GL_ARB_vertex_buffer_object',extstring) then
    begin
      pointer(glBindBufferARB) := GetGLProcAddress('glBindBufferARB');
      pointer(glDeleteBuffersARB) := GetGLProcAddress('glDeleteBuffersARB');
      pointer(glGenBuffersARB) := GetGLProcAddress('glGenBuffersARB');
      pointer(glIsBufferARB) := GetGLProcAddress('glIsBufferARB');
      pointer(glBufferDataARB) := GetGLProcAddress('glBufferDataARB');
      pointer(glBufferSubDataARB) := GetGLProcAddress('glBufferSubDataARB');
      pointer(glGetBufferSubDataARB) := GetGLProcAddress('glGetBufferSubDataARB');
      pointer(glMapBufferARB) := GetGLProcAddress('glMapBufferARB');
      pointer(glUnmapBufferARB) := GetGLProcAddress('glUnmapBufferARB');
      pointer(glGetBufferParameterivARB) := GetGLProcAddress('glGetBufferParameterivARB');
      pointer(glGetBufferPointervARB) := GetGLProcAddress('glGetBufferPointervARB');
      Result:=true;
    end;
end;

{$IFDEF Windows}
function Load_WGL_ARB_pixel_format: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_ARB_pixel_format', extstring) then
  begin
    pointer(wglGetPixelFormatAttribivARB) := GetGLProcAddress('wglGetPixelFormatAttribivARB');
    pointer(wglGetPixelFormatAttribfvARB) := GetGLProcAddress('wglGetPixelFormatAttribfvARB');
    pointer(wglChoosePixelFormatARB) := GetGLProcAddress('wglChoosePixelFormatARB');
    Result := TRUE;
  end;

end;

function Load_WGL_ARB_make_current_read: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_ARB_make_current_read', extstring) then
  begin
    pointer(wglMakeContextCurrentARB) := GetGLProcAddress('wglMakeContextCurrentARB');
    pointer(wglGetCurrentReadDCARB) := GetGLProcAddress('wglGetCurrentReadDCARB');
    Result := TRUE;
  end;

end;

function Load_WGL_ARB_pbuffer: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_ARB_pbuffer', extstring) then
  begin
    pointer(wglCreatePbufferARB) := GetGLProcAddress('wglCreatePbufferARB');
    pointer(wglGetPbufferDCARB) := GetGLProcAddress('wglGetPbufferDCARB');
    pointer(wglReleasePbufferDCARB) := GetGLProcAddress('wglReleasePbufferDCARB');
    pointer(wglDestroyPbufferARB) := GetGLProcAddress('wglDestroyPbufferARB');
    pointer(wglQueryPbufferARB) := GetGLProcAddress('wglQueryPbufferARB');
    Result := TRUE;
  end;

end;

function Load_WGL_EXT_swap_control: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_EXT_swap_control', extstring) then
  begin
    pointer(wglSwapIntervalEXT) := GetGLProcAddress('wglSwapIntervalEXT');
    pointer(wglGetSwapIntervalEXT) := GetGLProcAddress('wglGetSwapIntervalEXT');
    Result := TRUE;
  end;

end;

function Load_WGL_ARB_render_texture: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_ARB_render_texture', extstring) then
  begin
    pointer(wglBindTexImageARB) := GetGLProcAddress('wglBindTexImageARB');
    pointer(wglReleaseTexImageARB) := GetGLProcAddress('wglReleaseTexImageARB');
    pointer(wglSetPbufferAttribARB) := GetGLProcAddress('wglSetPbufferAttribARB');
    Result := TRUE;
  end;

end;

function Load_WGL_EXT_extensions_string: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_EXT_extensions_string', extstring) then
  begin
    pointer(wglGetExtensionsStringEXT) := GetGLProcAddress('wglGetExtensionsStringEXT');
    Result := TRUE;
  end;

end;

function Load_WGL_EXT_make_current_read: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_EXT_make_current_read', extstring) then
  begin
    pointer(wglMakeContextCurrentEXT) := GetGLProcAddress('wglMakeContextCurrentEXT');
    pointer(wglGetCurrentReadDCEXT) := GetGLProcAddress('wglGetCurrentReadDCEXT');
    Result := TRUE;
  end;

end;

function Load_WGL_EXT_pbuffer: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_EXT_pbuffer', extstring) then
  begin
    pointer(wglCreatePbufferEXT) := GetGLProcAddress('wglCreatePbufferEXT');
    pointer(wglGetPbufferDCEXT) := GetGLProcAddress('wglGetPbufferDCEXT');
    pointer(wglReleasePbufferDCEXT) := GetGLProcAddress('wglReleasePbufferDCEXT');
    pointer(wglDestroyPbufferEXT) := GetGLProcAddress('wglDestroyPbufferEXT');
    pointer(wglQueryPbufferEXT) := GetGLProcAddress('wglQueryPbufferEXT');
    Result := TRUE;
  end;

end;

function Load_WGL_EXT_pixel_format: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_EXT_pixel_format', extstring) then
  begin
    pointer(wglGetPixelFormatAttribivEXT) := GetGLProcAddress('wglGetPixelFormatAttribivEXT');
    pointer(wglGetPixelFormatAttribfvEXT) := GetGLProcAddress('wglGetPixelFormatAttribfvEXT');
    pointer(wglChoosePixelFormatEXT) := GetGLProcAddress('wglChoosePixelFormatEXT');
    Result := TRUE;
  end;

end;

function Load_WGL_I3D_digital_video_control: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_I3D_digital_video_control', extstring) then
  begin
    pointer(wglGetDigitalVideoParametersI3D) := GetGLProcAddress('wglGetDigitalVideoParametersI3D');
    pointer(wglSetDigitalVideoParametersI3D) := GetGLProcAddress('wglSetDigitalVideoParametersI3D');
    Result := TRUE;
  end;

end;

function Load_WGL_I3D_gamma: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_I3D_gamma', extstring) then
  begin
    pointer(wglGetGammaTableParametersI3D) := GetGLProcAddress('wglGetGammaTableParametersI3D');
    pointer(wglSetGammaTableParametersI3D) := GetGLProcAddress('wglSetGammaTableParametersI3D');
    pointer(wglGetGammaTableI3D) := GetGLProcAddress('wglGetGammaTableI3D');
    pointer(wglSetGammaTableI3D) := GetGLProcAddress('wglSetGammaTableI3D');
    Result := TRUE;
  end;

end;

function Load_WGL_I3D_genlock: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := String(PAnsiChar(wglGetExtensionsStringARB(WrapperWglGetCurrentDC)));

  if glext_ExtensionSupported('WGL_I3D_genlock', extstring) then
  begin
    pointer(wglEnableGenlockI3D) := GetGLProcAddress('wglEnableGenlockI3D');
    pointer(wglDisableGenlockI3D) := GetGLProcAddress('wglDisableGenlockI3D');
    pointer(wglIsEnabledGenlockI3D) := GetGLProcAddress('wglIsEnabledGenlockI3D');
    pointer(wglGenlockSourceI3D) := GetGLProcAddress('wglGenlockSourceI3D');
    pointer(wglGetGenlockSourceI3D) := GetGLProcAddress('wglGetGenlockSourceI3D');
    pointer(wglGenlockSourceEdgeI3D) := GetGLProcAddress('wglGenlockSourceEdgeI3D');
    pointer(wglGetGenlockSourceEdgeI3D) := GetGLProcAddress('wglGetGenlockSourceEdgeI3D');
    pointer(wglGenlockSampleRateI3D) := GetGLProcAddress('wglGenlockSampleRateI3D');
    pointer(wglGetGenlockSampleRateI3D) := GetGLProcAddress('wglGetGenlockSampleRateI3D');
    pointer(wglGenlockSourceDelayI3D) := GetGLProcAddress('wglGenlockSourceDelayI3D');
    pointer(wglGetGenlockSourceDelayI3D) := GetGLProcAddress('wglGetGenlockSourceDelayI3D');
    pointer(wglQueryGenlockMaxSourceDelayI3D) := GetGLProcAddress('wglQueryGenlockMaxSourceDelayI3D');
    Result := TRUE;
  end;

end;
{$ENDIF}

function Load_GL_ARB_matrix_palette: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_matrix_palette', extstring) then
  begin
    pointer(glCurrentPaletteMatrixARB) := GetGLProcAddress('glCurrentPaletteMatrixARB');
    pointer(glMatrixIndexubvARB) := GetGLProcAddress('glMatrixIndexubvARB');
    pointer(glMatrixIndexusvARB) := GetGLProcAddress('glMatrixIndexusvARB');
    pointer(glMatrixIndexuivARB) := GetGLProcAddress('glMatrixIndexuivARB');
    pointer(glMatrixIndexPointerARB) := GetGLProcAddress('glMatrixIndexPointerARB');
    Result := TRUE;
  end;

end;

function Load_GL_NV_element_array: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_element_array', extstring) then
  begin
    pointer(glElementPointerNV) := GetGLProcAddress('glElementPointerNV');
    pointer(glDrawElementArrayNV) := GetGLProcAddress('glDrawElementArrayNV');
    pointer(glDrawRangeElementArrayNV) := GetGLProcAddress('glDrawRangeElementArrayNV');
    pointer(glMultiDrawElementArrayNV) := GetGLProcAddress('glMultiDrawElementArrayNV');
    pointer(glMultiDrawRangeElementArrayNV) := GetGLProcAddress('glMultiDrawRangeElementArrayNV');
    Result := TRUE;
  end;

end;

function Load_GL_NV_float_buffer: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_float_buffer', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_fragment_program: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_fragment_program', extstring) then
  begin
    pointer(glProgramNamedParameter4fNV) := GetGLProcAddress('glProgramNamedParameter4fNV');
    pointer(glProgramNamedParameter4dNV) := GetGLProcAddress('glProgramNamedParameter4dNV');
    pointer(glGetProgramNamedParameterfvNV) := GetGLProcAddress('glGetProgramNamedParameterfvNV');
    pointer(glGetProgramNamedParameterdvNV) := GetGLProcAddress('glGetProgramNamedParameterdvNV');
    pointer(glProgramLocalParameter4dARB) := GetGLProcAddress('glProgramLocalParameter4dARB');
    pointer(glProgramLocalParameter4dvARB) := GetGLProcAddress('glProgramLocalParameter4dvARB');
    pointer(glProgramLocalParameter4fARB) := GetGLProcAddress('glProgramLocalParameter4fARB');
    pointer(glProgramLocalParameter4fvARB) := GetGLProcAddress('glProgramLocalParameter4fvARB');
    pointer(glGetProgramLocalParameterdvARB) := GetGLProcAddress('glGetProgramLocalParameterdvARB');
    pointer(glGetProgramLocalParameterfvARB) := GetGLProcAddress('glGetProgramLocalParameterfvARB');
    Result := TRUE;
  end;

end;

function Load_GL_NV_primitive_restart: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_primitive_restart', extstring) then
  begin
    pointer(glPrimitiveRestartNV) := GetGLProcAddress('glPrimitiveRestartNV');
   pointer( glPrimitiveRestartIndexNV) := GetGLProcAddress('glPrimitiveRestartIndexNV');
    Result := TRUE;
  end;

end;

function Load_GL_NV_vertex_program2: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_vertex_program2', extstring) then
  begin
    Result := TRUE;
  end;

end;

{$IFDEF Windows}
function Load_WGL_NV_render_texture_rectangle: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := wglGetExtensionsStringARB(WrapperWglGetCurrentDC);

  if glext_ExtensionSupported('WGL_NV_render_texture_rectangle', extstring) then
  begin
    Result := TRUE;
  end;

end;
{$ENDIF}

function Load_GL_NV_pixel_data_range: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_pixel_data_range', extstring) then
  begin
    pointer(glPixelDataRangeNV) := GetGLProcAddress('glPixelDataRangeNV');
    pointer(glFlushPixelDataRangeNV) := GetGLProcAddress('glFlushPixelDataRangeNV');
    {$IFDEF Windows}
    pointer(wglAllocateMemoryNV) := GetGLProcAddress('wglAllocateMemoryNV');
    pointer(wglFreeMemoryNV) := GetGLProcAddress('wglFreeMemoryNV');
    {$ENDIF}
    Result := TRUE;
  end;

end;

function Load_GL_EXT_texture_rectangle: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_texture_rectangle', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_S3_s3tc: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_S3_s3tc', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ATI_draw_buffers: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_draw_buffers', extstring) then
  begin
    pointer(glDrawBuffersATI) := GetGLProcAddress('glDrawBuffersATI');
    Result := TRUE;
  end;

end;

{$IFDEF Windows}
function Load_WGL_ATI_pixel_format_float: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  pointer(wglGetExtensionsStringARB) := GetGLProcAddress('wglGetExtensionsStringARB');
  extstring := wglGetExtensionsStringARB(WrapperWglGetCurrentDC);

  if glext_ExtensionSupported('WGL_ATI_pixel_format_float', extstring) then
  begin
    Result := TRUE;
  end;

end;
{$ENDIF}

function Load_GL_ATI_texture_env_combine3: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_texture_env_combine3', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ATI_texture_float: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_texture_float', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_texture_expand_normal: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_texture_expand_normal', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_half_float: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_half_float', extstring) then
  begin
    pointer(glVertex2hNV) := GetGLProcAddress('glVertex2hNV');
    pointer(glVertex2hvNV) := GetGLProcAddress('glVertex2hvNV');
    pointer(glVertex3hNV) := GetGLProcAddress('glVertex3hNV');
    pointer(glVertex3hvNV) := GetGLProcAddress('glVertex3hvNV');
    pointer(glVertex4hNV) := GetGLProcAddress('glVertex4hNV');
    pointer(glVertex4hvNV) := GetGLProcAddress('glVertex4hvNV');
    pointer(glNormal3hNV) := GetGLProcAddress('glNormal3hNV');
    pointer(glNormal3hvNV) := GetGLProcAddress('glNormal3hvNV');
    pointer(glColor3hNV) := GetGLProcAddress('glColor3hNV');
    pointer(glColor3hvNV) := GetGLProcAddress('glColor3hvNV');
    pointer(glColor4hNV) := GetGLProcAddress('glColor4hNV');
    pointer(glColor4hvNV) := GetGLProcAddress('glColor4hvNV');
    pointer(glTexCoord1hNV) := GetGLProcAddress('glTexCoord1hNV');
    pointer(glTexCoord1hvNV) := GetGLProcAddress('glTexCoord1hvNV');
    pointer(glTexCoord2hNV) := GetGLProcAddress('glTexCoord2hNV');
    pointer(glTexCoord2hvNV) := GetGLProcAddress('glTexCoord2hvNV');
    pointer(glTexCoord3hNV) := GetGLProcAddress('glTexCoord3hNV');
    pointer(glTexCoord3hvNV) := GetGLProcAddress('glTexCoord3hvNV');
    pointer(glTexCoord4hNV) := GetGLProcAddress('glTexCoord4hNV');
    pointer(glTexCoord4hvNV) := GetGLProcAddress('glTexCoord4hvNV');
    pointer(glMultiTexCoord1hNV) := GetGLProcAddress('glMultiTexCoord1hNV');
    pointer(glMultiTexCoord1hvNV) := GetGLProcAddress('glMultiTexCoord1hvNV');
    pointer(glMultiTexCoord2hNV) := GetGLProcAddress('glMultiTexCoord2hNV');
    pointer(glMultiTexCoord2hvNV) := GetGLProcAddress('glMultiTexCoord2hvNV');
    pointer(glMultiTexCoord3hNV) := GetGLProcAddress('glMultiTexCoord3hNV');
    pointer(glMultiTexCoord3hvNV) := GetGLProcAddress('glMultiTexCoord3hvNV');
    pointer(glMultiTexCoord4hNV) := GetGLProcAddress('glMultiTexCoord4hNV');
    pointer(glMultiTexCoord4hvNV) := GetGLProcAddress('glMultiTexCoord4hvNV');
    pointer(glFogCoordhNV) := GetGLProcAddress('glFogCoordhNV');
    pointer(glFogCoordhvNV) := GetGLProcAddress('glFogCoordhvNV');
    pointer(glSecondaryColor3hNV) := GetGLProcAddress('glSecondaryColor3hNV');
    pointer(glSecondaryColor3hvNV) := GetGLProcAddress('glSecondaryColor3hvNV');
    pointer(glVertexWeighthNV) := GetGLProcAddress('glVertexWeighthNV');
    pointer(glVertexWeighthvNV) := GetGLProcAddress('glVertexWeighthvNV');
    pointer(glVertexAttrib1hNV) := GetGLProcAddress('glVertexAttrib1hNV');
    pointer(glVertexAttrib1hvNV) := GetGLProcAddress('glVertexAttrib1hvNV');
    pointer(glVertexAttrib2hNV) := GetGLProcAddress('glVertexAttrib2hNV');
    pointer(glVertexAttrib2hvNV) := GetGLProcAddress('glVertexAttrib2hvNV');
    pointer(glVertexAttrib3hNV) := GetGLProcAddress('glVertexAttrib3hNV');
    pointer(glVertexAttrib3hvNV) := GetGLProcAddress('glVertexAttrib3hvNV');
    pointer(glVertexAttrib4hNV) := GetGLProcAddress('glVertexAttrib4hNV');
    pointer(glVertexAttrib4hvNV) := GetGLProcAddress('glVertexAttrib4hvNV');
    pointer(glVertexAttribs1hvNV) := GetGLProcAddress('glVertexAttribs1hvNV');
    pointer(glVertexAttribs2hvNV) := GetGLProcAddress('glVertexAttribs2hvNV');
    pointer(glVertexAttribs3hvNV) := GetGLProcAddress('glVertexAttribs3hvNV');
    pointer(glVertexAttribs4hvNV) := GetGLProcAddress('glVertexAttribs4hvNV');
    Result := TRUE;
  end;

end;

function Load_GL_ATI_map_object_buffer: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_map_object_buffer', extstring) then
  begin
    pointer(glMapObjectBufferATI) := GetGLProcAddress('glMapObjectBufferATI');
    pointer(glUnmapObjectBufferATI) := GetGLProcAddress('glUnmapObjectBufferATI');
    Result := TRUE;
  end;

end;

function Load_GL_ATI_separate_stencil: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_separate_stencil', extstring) then
  begin
    pointer(glStencilOpSeparateATI) := GetGLProcAddress('glStencilOpSeparateATI');
    pointer(glStencilFuncSeparateATI) := GetGLProcAddress('glStencilFuncSeparateATI');
    Result := TRUE;
  end;

end;

function Load_GL_ATI_vertex_attrib_array_object: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ATI_vertex_attrib_array_object', extstring) then
  begin
    pointer(glVertexAttribArrayObjectATI) := GetGLProcAddress('glVertexAttribArrayObjectATI');
    pointer(glGetVertexAttribArrayObjectfvATI) := GetGLProcAddress('glGetVertexAttribArrayObjectfvATI');
    pointer(glGetVertexAttribArrayObjectivATI) := GetGLProcAddress('glGetVertexAttribArrayObjectivATI');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_occlusion_query: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_occlusion_query', extstring) then
  begin
    pointer(glGenQueriesARB) := GetGLProcAddress('glGenQueriesARB');
    pointer(glDeleteQueriesARB) := GetGLProcAddress('glDeleteQueriesARB');
    pointer(glIsQueryARB) := GetGLProcAddress('glIsQueryARB');
    pointer(glBeginQueryARB) := GetGLProcAddress('glBeginQueryARB');
    pointer(glEndQueryARB) := GetGLProcAddress('glEndQueryARB');
    pointer(glGetQueryivARB) := GetGLProcAddress('glGetQueryivARB');
    pointer(glGetQueryObjectivARB) := GetGLProcAddress('glGetQueryObjectivARB');
    pointer(glGetQueryObjectuivARB) := GetGLProcAddress('glGetQueryObjectuivARB');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_shader_objects: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_shader_objects', extstring) then
  begin
    pointer(glDeleteObjectARB) := GetGLProcAddress('glDeleteObjectARB');
    pointer(glGetHandleARB) := GetGLProcAddress('glGetHandleARB');
    pointer(glDetachObjectARB) := GetGLProcAddress('glDetachObjectARB');
    pointer(glCreateShaderObjectARB) := GetGLProcAddress('glCreateShaderObjectARB');
    pointer(glShaderSourceARB) := GetGLProcAddress('glShaderSourceARB');
    pointer(glCompileShaderARB) := GetGLProcAddress('glCompileShaderARB');
    pointer(glCreateProgramObjectARB) := GetGLProcAddress('glCreateProgramObjectARB');
    pointer(glAttachObjectARB) := GetGLProcAddress('glAttachObjectARB');
    pointer(glLinkProgramARB) := GetGLProcAddress('glLinkProgramARB');
    pointer(glUseProgramObjectARB) := GetGLProcAddress('glUseProgramObjectARB');
    pointer(glValidateProgramARB) := GetGLProcAddress('glValidateProgramARB');
    pointer(glUniform1fARB) := GetGLProcAddress('glUniform1fARB');
    pointer(glUniform2fARB) := GetGLProcAddress('glUniform2fARB');
    pointer(glUniform3fARB) := GetGLProcAddress('glUniform3fARB');
    pointer(glUniform4fARB) := GetGLProcAddress('glUniform4fARB');
    pointer(glUniform1iARB) := GetGLProcAddress('glUniform1iARB');
    pointer(glUniform2iARB) := GetGLProcAddress('glUniform2iARB');
    pointer(glUniform3iARB) := GetGLProcAddress('glUniform3iARB');
    pointer(glUniform4iARB) := GetGLProcAddress('glUniform4iARB');
    pointer(glUniform1fvARB) := GetGLProcAddress('glUniform1fvARB');
    pointer(glUniform2fvARB) := GetGLProcAddress('glUniform2fvARB');
    pointer(glUniform3fvARB) := GetGLProcAddress('glUniform3fvARB');
    pointer(glUniform4fvARB) := GetGLProcAddress('glUniform4fvARB');
    pointer(glUniform1ivARB) := GetGLProcAddress('glUniform1ivARB');
    pointer(glUniform2ivARB) := GetGLProcAddress('glUniform2ivARB');
    pointer(glUniform3ivARB) := GetGLProcAddress('glUniform3ivARB');
    pointer(glUniform4ivARB) := GetGLProcAddress('glUniform4ivARB');
    pointer(glUniformMatrix2fvARB) := GetGLProcAddress('glUniformMatrix2fvARB');
    pointer(glUniformMatrix3fvARB) := GetGLProcAddress('glUniformMatrix3fvARB');
    pointer(glUniformMatrix4fvARB) := GetGLProcAddress('glUniformMatrix4fvARB');
    pointer(glGetObjectParameterfvARB) := GetGLProcAddress('glGetObjectParameterfvARB');
    pointer(glGetObjectParameterivARB) := GetGLProcAddress('glGetObjectParameterivARB');
    pointer(glGetInfoLogARB) := GetGLProcAddress('glGetInfoLogARB');
    pointer(glGetAttachedObjectsARB) := GetGLProcAddress('glGetAttachedObjectsARB');
    pointer(glGetUniformLocationARB) := GetGLProcAddress('glGetUniformLocationARB');
    pointer(glGetActiveUniformARB) := GetGLProcAddress('glGetActiveUniformARB');
    pointer(glGetUniformfvARB) := GetGLProcAddress('glGetUniformfvARB');
    pointer(glGetUniformivARB) := GetGLProcAddress('glGetUniformivARB');
    pointer(glGetShaderSourceARB) := GetGLProcAddress('glGetShaderSourceARB');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_vertex_shader: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_vertex_shader', extstring) then
  begin
    pointer(glVertexAttrib1fARB) := GetGLProcAddress('glVertexAttrib1fARB');
    pointer(glVertexAttrib1sARB) := GetGLProcAddress('glVertexAttrib1sARB');
    pointer(glVertexAttrib1dARB) := GetGLProcAddress('glVertexAttrib1dARB');
    pointer(glVertexAttrib2fARB) := GetGLProcAddress('glVertexAttrib2fARB');
    pointer(glVertexAttrib2sARB) := GetGLProcAddress('glVertexAttrib2sARB');
    pointer(glVertexAttrib2dARB) := GetGLProcAddress('glVertexAttrib2dARB');
    pointer(glVertexAttrib3fARB) := GetGLProcAddress('glVertexAttrib3fARB');
    pointer(glVertexAttrib3sARB) := GetGLProcAddress('glVertexAttrib3sARB');
    pointer(glVertexAttrib3dARB) := GetGLProcAddress('glVertexAttrib3dARB');
    pointer(glVertexAttrib4fARB) := GetGLProcAddress('glVertexAttrib4fARB');
    pointer(glVertexAttrib4sARB) := GetGLProcAddress('glVertexAttrib4sARB');
    pointer(glVertexAttrib4dARB) := GetGLProcAddress('glVertexAttrib4dARB');
    pointer(glVertexAttrib4NubARB) := GetGLProcAddress('glVertexAttrib4NubARB');
    pointer(glVertexAttrib1fvARB) := GetGLProcAddress('glVertexAttrib1fvARB');
    pointer(glVertexAttrib1svARB) := GetGLProcAddress('glVertexAttrib1svARB');
    pointer(glVertexAttrib1dvARB) := GetGLProcAddress('glVertexAttrib1dvARB');
    pointer(glVertexAttrib2fvARB) := GetGLProcAddress('glVertexAttrib2fvARB');
    pointer(glVertexAttrib2svARB) := GetGLProcAddress('glVertexAttrib2svARB');
    pointer(glVertexAttrib2dvARB) := GetGLProcAddress('glVertexAttrib2dvARB');
    pointer(glVertexAttrib3fvARB) := GetGLProcAddress('glVertexAttrib3fvARB');
    pointer(glVertexAttrib3svARB) := GetGLProcAddress('glVertexAttrib3svARB');
    pointer(glVertexAttrib3dvARB) := GetGLProcAddress('glVertexAttrib3dvARB');
    pointer(glVertexAttrib4fvARB) := GetGLProcAddress('glVertexAttrib4fvARB');
    pointer(glVertexAttrib4svARB) := GetGLProcAddress('glVertexAttrib4svARB');
    pointer(glVertexAttrib4dvARB) := GetGLProcAddress('glVertexAttrib4dvARB');
    pointer(glVertexAttrib4ivARB) := GetGLProcAddress('glVertexAttrib4ivARB');
    pointer(glVertexAttrib4bvARB) := GetGLProcAddress('glVertexAttrib4bvARB');
    pointer(glVertexAttrib4ubvARB) := GetGLProcAddress('glVertexAttrib4ubvARB');
    pointer(glVertexAttrib4usvARB) := GetGLProcAddress('glVertexAttrib4usvARB');
    pointer(glVertexAttrib4uivARB) := GetGLProcAddress('glVertexAttrib4uivARB');
    pointer(glVertexAttrib4NbvARB) := GetGLProcAddress('glVertexAttrib4NbvARB');
    pointer(glVertexAttrib4NsvARB) := GetGLProcAddress('glVertexAttrib4NsvARB');
    pointer(glVertexAttrib4NivARB) := GetGLProcAddress('glVertexAttrib4NivARB');
    pointer(glVertexAttrib4NubvARB) := GetGLProcAddress('glVertexAttrib4NubvARB');
    pointer(glVertexAttrib4NusvARB) := GetGLProcAddress('glVertexAttrib4NusvARB');
    pointer(glVertexAttrib4NuivARB) := GetGLProcAddress('glVertexAttrib4NuivARB');
    pointer(glVertexAttribPointerARB) := GetGLProcAddress('glVertexAttribPointerARB');
    pointer(glEnableVertexAttribArrayARB) := GetGLProcAddress('glEnableVertexAttribArrayARB');
    pointer(glDisableVertexAttribArrayARB) := GetGLProcAddress('glDisableVertexAttribArrayARB');
    pointer(glBindAttribLocationARB) := GetGLProcAddress('glBindAttribLocationARB');
    pointer(glGetActiveAttribARB) := GetGLProcAddress('glGetActiveAttribARB');
    pointer(glGetAttribLocationARB) := GetGLProcAddress('glGetAttribLocationARB');
    pointer(glGetVertexAttribdvARB) := GetGLProcAddress('glGetVertexAttribdvARB');
    pointer(glGetVertexAttribfvARB) := GetGLProcAddress('glGetVertexAttribfvARB');
    pointer(glGetVertexAttribivARB) := GetGLProcAddress('glGetVertexAttribivARB');
    pointer(glGetVertexAttribPointervARB) := GetGLProcAddress('glGetVertexAttribPointervARB');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_fragment_shader: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_fragment_shader', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_shading_language_100: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_shading_language_100', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_texture_non_power_of_two: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_texture_non_power_of_two', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_point_sprite: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_point_sprite', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_depth_bounds_test: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_depth_bounds_test', extstring) then
  begin
    pointer(glDepthBoundsEXT) := GetGLProcAddress('glDepthBoundsEXT');
    Result := TRUE;
  end;

end;

function Load_GL_EXT_texture_mirror_clamp: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_texture_mirror_clamp', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_blend_equation_separate: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_blend_equation_separate', extstring) then
  begin
    pointer(glBlendEquationSeparateEXT) := GetGLProcAddress('glBlendEquationSeparateEXT');
    Result := TRUE;
  end;

end;

function Load_GL_MESA_pack_invert: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_MESA_pack_invert', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_MESA_ycbcr_texture: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_MESA_ycbcr_texture', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_fragment_program_shadow: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_ARB_fragment_program_shadow', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_fragment_program_option: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_fragment_program_option', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_pixel_buffer_object: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_EXT_pixel_buffer_object', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_fragment_program2: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_fragment_program2', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_vertex_program2_option: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_vertex_program2_option', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_NV_vertex_program3: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if glext_ExtensionSupported('GL_NV_vertex_program3', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_draw_buffers: Boolean;
var
  extstring: PAnsiChar;
begin

  Result := FALSE;
  extstring := glGetString(GL_EXTENSIONS);

  if glext_ExtensionSupported('GL_ARB_draw_buffers', extstring) then
  begin
    pointer(glDrawBuffersARB) := GetGLProcAddress('glDrawBuffersARB');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_texture_rectangle: Boolean;
var
  extstring: PAnsiChar;
begin

  Result := FALSE;
  extstring := glGetString(GL_EXTENSIONS);

  if glext_ExtensionSupported('GL_ARB_texture_rectangle', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_color_buffer_float: Boolean;
var
  extstring: PAnsiChar;
begin

  Result := FALSE;
  extstring := glGetString(GL_EXTENSIONS);

  if glext_ExtensionSupported('GL_ARB_color_buffer_float', extstring) then
  begin
    pointer(glClampColorARB) := GetGLProcAddress('glClampColorARB');
    Result := TRUE;
  end;

end;

function Load_GL_ARB_half_float_pixel: Boolean;
var
  extstring: PAnsiChar;
begin

  Result := FALSE;
  extstring := glGetString(GL_EXTENSIONS);

  if glext_ExtensionSupported('GL_ARB_half_float_pixel', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_texture_float: Boolean;
var
  extstring: PAnsiChar;
begin

  Result := FALSE;
  extstring := glGetString(GL_EXTENSIONS);

  if glext_ExtensionSupported('GL_ARB_texture_float', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_texture_compression_dxt1: Boolean;
var
  extstring: PAnsiChar;
begin

  Result := FALSE;
  extstring := glGetString(GL_EXTENSIONS);

  if glext_ExtensionSupported('GL_EXT_texture_compression_dxt1', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_ARB_pixel_buffer_object: Boolean;
var
  extstring: PAnsiChar;
begin

  Result := FALSE;
  extstring := glGetString(GL_EXTENSIONS);

  if glext_ExtensionSupported('GL_ARB_pixel_buffer_object', extstring) then
  begin
    Result := TRUE;
  end;

end;

function Load_GL_EXT_framebuffer_object: Boolean;
var
  extstring: PAnsiChar;
begin

  Result := FALSE;
  extstring := glGetString(GL_EXTENSIONS);

  if glext_ExtensionSupported('GL_EXT_framebuffer_object', extstring) then
  begin
    pointer(glIsRenderbufferEXT) := GetGLProcAddress('glIsRenderbufferEXT');
    pointer(glBindRenderbufferEXT) := GetGLProcAddress('glBindRenderbufferEXT');
    pointer(glDeleteRenderbuffersEXT) := GetGLProcAddress('glDeleteRenderbuffersEXT');
    pointer(glGenRenderbuffersEXT) := GetGLProcAddress('glGenRenderbuffersEXT');
    pointer(glRenderbufferStorageEXT) := GetGLProcAddress('glRenderbufferStorageEXT');
    pointer(glGetRenderbufferParameterivEXT) := GetGLProcAddress('glGetRenderbufferParameterivEXT');
    pointer(glIsFramebufferEXT) := GetGLProcAddress('glIsFramebufferEXT');
    pointer(glBindFramebufferEXT) := GetGLProcAddress('glBindFramebufferEXT');
    pointer(glDeleteFramebuffersEXT) := GetGLProcAddress('glDeleteFramebuffersEXT');
    pointer(glGenFramebuffersEXT) := GetGLProcAddress('glGenFramebuffersEXT');
    pointer(glCheckFramebufferStatusEXT) := GetGLProcAddress('glCheckFramebufferStatusEXT');
    pointer(glFramebufferTexture1DEXT) := GetGLProcAddress('glFramebufferTexture1DEXT');
    pointer(glFramebufferTexture2DEXT) := GetGLProcAddress('glFramebufferTexture2DEXT');
    pointer(glFramebufferTexture3DEXT) := GetGLProcAddress('glFramebufferTexture3DEXT');
    pointer(glFramebufferRenderbufferEXT) := GetGLProcAddress('glFramebufferRenderbufferEXT');
    pointer(glGetFramebufferAttachmentParameterivEXT) := GetGLProcAddress('glGetFramebufferAttachmentParameterivEXT');
    pointer(glGenerateMipmapEXT) := GetGLProcAddress('glGenerateMipmapEXT');
    Result := TRUE;
  end;

end;


function Commit_Horrible_FBO_Forgery: Boolean;
var
  extstring: PAnsiChar;
begin
  Result := FALSE;

  extstring := glGetString(GL_EXTENSIONS);
  if glext_ExtensionSupported('GL_EXT_framebuffer_object', extstring) then
  begin
    AddLog(RuEn(
      'GL_ARB_framebuffer_object не поддерживается!',
      'GL_ARB_framebuffer_object is not supported!'));
    AddLog(RuEn(
      'Пытаюсь осуществить подлог, подменив на функции расширения GL_EXT_framebuffer_object...',
      'Trying to make a forgery by loading the functions of GL_EXT_framebuffer_object instead...'));
    pointer(glIsRenderbuffer) := GetGLProcAddress('glIsRenderbufferEXT');
    pointer(glBindRenderbuffer) := GetGLProcAddress('glBindRenderbufferEXT');
    pointer(glDeleteRenderbuffers) := GetGLProcAddress('glDeleteRenderbuffersEXT');
    pointer(glGenRenderbuffers) := GetGLProcAddress('glGenRenderbuffersEXT');
    pointer(glRenderbufferStorage) := GetGLProcAddress('glRenderbufferStorageEXT');
    pointer(glGetRenderbufferParameteriv) := GetGLProcAddress('glGetRenderbufferParameterivEXT');
    pointer(glIsFramebuffer) := GetGLProcAddress('glIsFramebufferEXT');
    pointer(glBindFramebuffer) := GetGLProcAddress('glBindFramebufferEXT');
    pointer(glDeleteFramebuffers) := GetGLProcAddress('glDeleteFramebuffersEXT');
    pointer(glGenFramebuffers) := GetGLProcAddress('glGenFramebuffersEXT');
    pointer(glCheckFramebufferStatus) := GetGLProcAddress('glCheckFramebufferStatusEXT');
    pointer(glFramebufferTexture1D) := GetGLProcAddress('glFramebufferTexture1DEXT');
    pointer(glFramebufferTexture2D) := GetGLProcAddress('glFramebufferTexture2DEXT');
    pointer(glFramebufferTexture3D) := GetGLProcAddress('glFramebufferTexture3DEXT');
    pointer(glFramebufferRenderbuffer) := GetGLProcAddress('glFramebufferRenderbufferEXT');
    pointer(glGetFramebufferAttachmentParameteriv) := GetGLProcAddress('glGetFramebufferAttachmentParameterivEXT');
    pointer(glGenerateMipmap) := GetGLProcAddress('glGenerateMipmapEXT');
    Result := TRUE;
    AddLog(RuEn(
      '  ..успешно.',
      '  ..success.'));
  end;

end;

function Load_GL_ARB_framebuffer_object(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_framebuffer_object', extstring) then
  begin
    pointer(glIsRenderbuffer) := GetGLProcAddress('glIsRenderbuffer');
    pointer(glBindRenderbuffer) := GetGLProcAddress('glBindRenderbuffer');
    pointer(glDeleteRenderbuffers) := GetGLProcAddress('glDeleteRenderbuffers');
    pointer(glGenRenderbuffers) := GetGLProcAddress('glGenRenderbuffers');
    pointer(glRenderbufferStorage) := GetGLProcAddress('glRenderbufferStorage');
    pointer(glGetRenderbufferParameteriv) := GetGLProcAddress('glGetRenderbufferParameteriv');
    pointer(glIsFramebuffer) := GetGLProcAddress('glIsFramebuffer');
    pointer(glBindFramebuffer) := GetGLProcAddress('glBindFramebuffer');
    pointer(glDeleteFramebuffers) := GetGLProcAddress('glDeleteFramebuffers');
    pointer(glGenFramebuffers) := GetGLProcAddress('glGenFramebuffers');
    pointer(glCheckFramebufferStatus) := GetGLProcAddress('glCheckFramebufferStatus');
    pointer(glFramebufferTexture1D) := GetGLProcAddress('glFramebufferTexture1D');
    pointer(glFramebufferTexture2D) := GetGLProcAddress('glFramebufferTexture2D');
    pointer(glFramebufferTexture3D) := GetGLProcAddress('glFramebufferTexture3D');
    pointer(glFramebufferRenderbuffer) := GetGLProcAddress('glFramebufferRenderbuffer');
    pointer(glGetFramebufferAttachmentParameteriv) := GetGLProcAddress('glGetFramebufferAttachmentParameteriv');
    pointer(glGenerateMipmap) := GetGLProcAddress('glGenerateMipmap');
    pointer(glBlitFramebuffer) := GetGLProcAddress('glBlitFramebuffer');
    pointer(glRenderbufferStorageMultisample) := GetGLProcAddress('glRenderbufferStorageMultisample');
    pointer(glFramebufferTextureLayer) := GetGLProcAddress('glFramebufferTextureLayer');
    Result := True;
  end
  //***TODO: investigate. It works, but rendering falls back to software
  //else Result:= Commit_Horrible_FBO_Forgery();
end;

function Load_GL_ARB_map_buffer_range(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_map_buffer_range', extstring) then
  begin
    pointer(glMapBufferRange) := GetGLProcAddress('glMapBufferRange');
    pointer(glFlushMappedBufferRange) := GetGLProcAddress('glFlushMappedBufferRange');
    Result := True;
  end;
end;

function Load_GL_ARB_vertex_array_object(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_vertex_array_object', extstring) then
  begin
    pointer(glBindVertexArray) := GetGLProcAddress('glBindVertexArray');
    pointer(glDeleteVertexArrays) := GetGLProcAddress('glDeleteVertexArrays');
    pointer(glGenVertexArrays) := GetGLProcAddress('glGenVertexArrays');
    pointer(glIsVertexArray) := GetGLProcAddress('glIsVertexArray');
    Result := True;
  end;
end;

function Load_GL_ARB_copy_buffer(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_copy_buffer', extstring) then
  begin
    pointer(glCopyBufferSubData) := GetGLProcAddress('glCopyBufferSubData');
    Result := True;
  end;
end;

function Load_GL_ARB_uniform_buffer_object(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_uniform_buffer_object', extstring) then
  begin
    pointer(glGetUniformIndices) := GetGLProcAddress('glGetUniformIndices');
    pointer(glGetActiveUniformName) := GetGLProcAddress('glGetActiveUniformName');
    pointer(glGetUniformBlockIndex) := GetGLProcAddress('glGetUniformBlockIndex');
    pointer(glGetActiveUniformBlockiv) := GetGLProcAddress('glGetActiveUniformBlockiv');
    pointer(glGetActiveUniformBlockName) := GetGLProcAddress('glGetActiveUniformBlockName');
    pointer(glUniformBlockBinding) := GetGLProcAddress('glUniformBlockBinding');
    (* Shared entry points *)
    pointer(glBindBufferRange) := GetGLProcAddress('glBindBufferRange');
    pointer(glBindBufferBase) := GetGLProcAddress('glBindBufferBase');
    pointer(glGetIntegeri_v) := GetGLProcAddress('glGetIntegeri_v');
    Result := True;
  end;
end;

function Load_GL_ARB_draw_elements_base_vertex(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_draw_elements_base_vertex', extstring) then
  begin
    pointer(glDrawElementsBaseVertex) := GetGLProcAddress('glDrawElementsBaseVertex');
    pointer(glDrawRangeElementsBaseVertex) := GetGLProcAddress('glDrawRangeElementsBaseVertex');
    pointer(glDrawElementsInstancedBaseVertex) := GetGLProcAddress('glDrawElementsInstancedBaseVertex');
    pointer(glMultiDrawElementsBaseVertex) := GetGLProcAddress('glMultiDrawElementsBaseVertex');
    Result := True;
  end;
end;

function Load_GL_ARB_provoking_vertex(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_provoking_vertex', extstring) then
  begin
    pointer(glProvokingVertex) := GetGLProcAddress('glProvokingVertex');
    Result := True;
  end;
end;

function Load_GL_ARB_sync(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_sync', extstring) then
  begin
    pointer(glFenceSync) := GetGLProcAddress('glFenceSync');
    pointer(glIsSync) := GetGLProcAddress('glIsSync');
    pointer(glDeleteSync) := GetGLProcAddress('glDeleteSync');
    pointer(glClientWaitSync) := GetGLProcAddress('glClientWaitSync');
    pointer(glWaitSync) := GetGLProcAddress('glWaitSync');
    pointer(glGetInteger64v) := GetGLProcAddress('glGetInteger64v');
    pointer(glGetSynciv) := GetGLProcAddress('glGetSynciv');
    Result := True;
  end;
end;

function Load_GL_ARB_texture_multisample(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_texture_multisample', extstring) then
  begin
    pointer(glTexImage2DMultisample) := GetGLProcAddress('glTexImage2DMultisample');
    pointer(glTexImage3DMultisample) := GetGLProcAddress('glTexImage3DMultisample');
    pointer(glGetMultisamplefv) := GetGLProcAddress('glGetMultisamplefv');
    pointer(glSampleMaski) := GetGLProcAddress('glSampleMaski');
    Result := True;
  end;
end;

function Load_GL_ARB_sampler_objects(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_sampler_objects', extstring) then
  begin
    pointer(glGenSamplers) := GetGLProcAddress('glGenSamplers');
    pointer(glDeleteSamplers) := GetGLProcAddress('glDeleteSamplers');
    pointer(glIsSampler) := GetGLProcAddress('glIsSampler');
   pointer( glBindSampler) := GetGLProcAddress('glBindSampler');
    pointer(glSamplerParameteri) := GetGLProcAddress('glSamplerParameteri');
    pointer(glSamplerParameteriv) := GetGLProcAddress('glSamplerParameteriv');
    pointer(glSamplerParameterf) := GetGLProcAddress('glSamplerParameterf');
    pointer(glSamplerParameterfv) := GetGLProcAddress('glSamplerParameterfv');
    pointer(glSamplerParameterIiv) := GetGLProcAddress('glSamplerParameterIiv');
    pointer(glSamplerParameterIuiv) := GetGLProcAddress('glSamplerParameterIuiv');
    pointer(glGetSamplerParameteriv) := GetGLProcAddress('glGetSamplerParameteriv');
    pointer(glGetSamplerParameterIiv) := GetGLProcAddress('glGetSamplerParameterIiv');
    pointer(glGetSamplerParameterfv) := GetGLProcAddress('glGetSamplerParameterfv');
    pointer(glGetSamplerParameterIuiv) := GetGLProcAddress('glGetSamplerParameterIuiv');
    Result := True;
  end;
end;

function Load_GL_ARB_blend_func_extended(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_blend_func_extended', extstring) then
  begin
    pointer(glBindFragDataLocationIndexed) := GetGLProcAddress('glBindFragDataLocationIndexed');
    pointer(glGetFragDataIndex) := GetGLProcAddress('glGetFragDataIndex');
    Result := True;
  end;
end;

function Load_GL_ARB_timer_query(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_timer_query', extstring) then
  begin
    pointer(glQueryCounter) := GetGLProcAddress('glQueryCounter');
    pointer(glGetQueryObjecti64v) := GetGLProcAddress('glGetQueryObjecti64v');
    pointer(glGetQueryObjectui64v) := GetGLProcAddress('glGetQueryObjectui64v');
    Result := True;
  end;
end;

function Load_GL_ARB_vertex_type_2_10_10_10_rev(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_vertex_type_2_10_10_10_rev', extstring) then
  begin
    pointer(glVertexP2ui) := GetGLProcAddress('glVertexP2ui');
    pointer(glVertexP2uiv) := GetGLProcAddress('glVertexP2uiv');
    pointer(glVertexP3ui) := GetGLProcAddress('glVertexP3ui');
    pointer(glVertexP3uiv) := GetGLProcAddress('glVertexP3uiv');
    pointer(glVertexP4ui) := GetGLProcAddress('glVertexP4ui');
    pointer(glVertexP4uiv) := GetGLProcAddress('glVertexP4uiv');
    pointer(glTexCoordP1ui) := GetGLProcAddress('glTexCoordP1ui');
    pointer(glTexCoordP1uiv) := GetGLProcAddress('glTexCoordP1uiv');
    pointer(glTexCoordP2ui) := GetGLProcAddress('glTexCoordP2ui');
    pointer(glTexCoordP2uiv) := GetGLProcAddress('glTexCoordP2uiv');
    pointer(glTexCoordP3ui) := GetGLProcAddress('glTexCoordP3ui');
    pointer(glTexCoordP3uiv) := GetGLProcAddress('glTexCoordP3uiv');
    pointer(glTexCoordP4ui) := GetGLProcAddress('glTexCoordP4ui');
    pointer(glTexCoordP4uiv) := GetGLProcAddress('glTexCoordP4uiv');
    pointer(glMultiTexCoordP1ui) := GetGLProcAddress('glMultiTexCoordP1ui');
    pointer(glMultiTexCoordP1uiv) := GetGLProcAddress('glMultiTexCoordP1uiv');
    pointer(glMultiTexCoordP2ui) := GetGLProcAddress('glMultiTexCoordP2ui');
    pointer(glMultiTexCoordP2uiv) := GetGLProcAddress('glMultiTexCoordP2uiv');
    pointer(glMultiTexCoordP3ui) := GetGLProcAddress('glMultiTexCoordP3ui');
    pointer(glMultiTexCoordP3uiv) := GetGLProcAddress('glMultiTexCoordP3uiv');
    pointer(glMultiTexCoordP4ui) := GetGLProcAddress('glMultiTexCoordP4ui');
    pointer(glMultiTexCoordP4uiv) := GetGLProcAddress('glMultiTexCoordP4uiv');
    if not Assigned(glMultiTexCoordP4uiv) then Exit;
   pointer( glNormalP3ui) := GetGLProcAddress('glNormalP3ui');
    pointer(glNormalP3uiv) := GetGLProcAddress('glNormalP3uiv');
    pointer(glColorP3ui) := GetGLProcAddress('glColorP3ui');
    pointer(glColorP3uiv) := GetGLProcAddress('glColorP3uiv');
    pointer(glColorP4ui) := GetGLProcAddress('glColorP4ui');
    pointer(glColorP4uiv) := GetGLProcAddress('glColorP4uiv');
    pointer(glSecondaryColorP3ui) := GetGLProcAddress('glSecondaryColorP3ui');
    pointer(glSecondaryColorP3uiv) := GetGLProcAddress('glSecondaryColorP3uiv');
    pointer(glVertexAttribP1ui) := GetGLProcAddress('glVertexAttribP1ui');
    pointer(glVertexAttribP1uiv) := GetGLProcAddress('glVertexAttribP1uiv');
    pointer(glVertexAttribP2ui) := GetGLProcAddress('glVertexAttribP2ui');
    pointer(glVertexAttribP2uiv) := GetGLProcAddress('glVertexAttribP2uiv');
    pointer(glVertexAttribP3ui) := GetGLProcAddress('glVertexAttribP3ui');
    pointer(glVertexAttribP3uiv) := GetGLProcAddress('glVertexAttribP3uiv');
    pointer(glVertexAttribP4ui) := GetGLProcAddress('glVertexAttribP4ui');
    pointer(glVertexAttribP4uiv) := GetGLProcAddress('glVertexAttribP4uiv');
    Result := True;
  end;
end;

function Load_GL_ARB_gpu_shader_fp64(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_gpu_shader_fp64', extstring) then
  begin
    pointer(glUniform1d) := GetGLProcAddress('glUniform1d');
    pointer(glUniform2d) := GetGLProcAddress('glUniform2d');
    pointer(glUniform3d) := GetGLProcAddress('glUniform3d');
    pointer(glUniform4d) := GetGLProcAddress('glUniform4d');
    pointer(glUniform1dv) := GetGLProcAddress('glUniform1dv');
    pointer(glUniform2dv) := GetGLProcAddress('glUniform2dv');
    pointer(glUniform3dv) := GetGLProcAddress('glUniform3dv');
    pointer(glUniform4dv) := GetGLProcAddress('glUniform4dv');
    pointer(glUniformMatrix2dv) := GetGLProcAddress('glUniformMatrix2dv');
    pointer(glUniformMatrix3dv) := GetGLProcAddress('glUniformMatrix3dv');
    pointer(glUniformMatrix4dv) := GetGLProcAddress('glUniformMatrix4dv');
    pointer(glUniformMatrix2x4dv) := GetGLProcAddress('glUniformMatrix2x4dv');
    pointer(glUniformMatrix3x2dv) := GetGLProcAddress('glUniformMatrix3x2dv');
    pointer(glUniformMatrix3x4dv) := GetGLProcAddress('glUniformMatrix3x4dv');
    pointer(glUniformMatrix4x2dv) := GetGLProcAddress('glUniformMatrix4x2dv');
   pointer( glUniformMatrix4x3dv) := GetGLProcAddress('glUniformMatrix4x3dv');
    pointer(glGetUniformdv) := GetGLProcAddress('glGetUniformdv');
    { Ignore presence/absence of functions below.
      See their special definition in
      http://www.opengl.org/registry/specs/ARB/gpu_shader_fp64.txt:
      "All of the following ProgramUniform* functions are supported if and only
      if EXT_direct_state_access is supported." }

    pointer(glProgramUniform1dEXT) := GetGLProcAddress('glProgramUniform1dEXT');
    pointer(glProgramUniform3dEXT) := GetGLProcAddress('glProgramUniform3dEXT');
    pointer(glProgramUniform4dEXT) := GetGLProcAddress('glProgramUniform4dEXT');
    pointer(glProgramUniform1dvEXT) := GetGLProcAddress('glProgramUniform1dvEXT');
    pointer(glProgramUniform2dvEXT) := GetGLProcAddress('glProgramUniform2dvEXT');
    pointer(glProgramUniform3dvEXT) := GetGLProcAddress('glProgramUniform3dvEXT');
    pointer(glProgramUniform4dvEXT) := GetGLProcAddress('glProgramUniform4dvEXT');
    pointer(glProgramUniformMatrix2dvEXT) := GetGLProcAddress('glProgramUniformMatrix2dvEXT');
    pointer(glProgramUniformMatrix3dvEXT) := GetGLProcAddress('glProgramUniformMatrix3dvEXT');
    pointer(glProgramUniformMatrix4dvEXT) := GetGLProcAddress('glProgramUniformMatrix4dvEXT');
    pointer(glProgramUniformMatrix2x3dvEXT) := GetGLProcAddress('glProgramUniformMatrix2x3dvEXT');
    pointer(glProgramUniformMatrix2x4dvEXT) := GetGLProcAddress('glProgramUniformMatrix2x4dvEXT');
    pointer(glProgramUniformMatrix3x2dvEXT) := GetGLProcAddress('glProgramUniformMatrix3x2dvEXT');
    pointer(glProgramUniformMatrix3x4dvEXT) := GetGLProcAddress('glProgramUniformMatrix3x4dvEXT');
    pointer(glProgramUniformMatrix4x2dvEXT) := GetGLProcAddress('glProgramUniformMatrix4x2dvEXT');
    pointer(glProgramUniformMatrix4x3dvEXT) := GetGLProcAddress('glProgramUniformMatrix4x3dvEXT');
    Result := True;
  end;
end;

function Load_GL_ARB_shader_subroutine(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_shader_subroutine', extstring) then
  begin
    pointer(glGetSubroutineUniformLocation) := GetGLProcAddress('glGetSubroutineUniformLocation');
    pointer(glGetSubroutineIndex) := GetGLProcAddress('glGetSubroutineIndex');
    pointer(glGetActiveSubroutineUniformiv) := GetGLProcAddress('glGetActiveSubroutineUniformiv');
    pointer(glGetActiveSubroutineUniformName) := GetGLProcAddress('glGetActiveSubroutineUniformName');
    pointer(glGetActiveSubroutineName) := GetGLProcAddress('glGetActiveSubroutineName');
    pointer(glUniformSubroutinesuiv) := GetGLProcAddress('glUniformSubroutinesuiv');
    pointer(glGetUniformSubroutineuiv) := GetGLProcAddress('glGetUniformSubroutineuiv');
    pointer(glGetProgramStageiv) := GetGLProcAddress('glGetProgramStageiv');
    Result := True;
  end;
end;

function Load_GL_ARB_tessellation_shader(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_tessellation_shader', extstring) then
  begin
    pointer(glPatchParameteri) := GetGLProcAddress('glPatchParameteri');
    pointer(glPatchParameterfv) := GetGLProcAddress('glPatchParameterfv');
    Result := True;
  end;
end;

function Load_GL_ARB_transform_feedback2(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_transform_feedback2', extstring) then
  begin
    pointer(glBindTransformFeedback) := GetGLProcAddress('glBindTransformFeedback');
    pointer(glDeleteTransformFeedbacks) := GetGLProcAddress('glDeleteTransformFeedbacks');
    pointer(glGenTransformFeedbacks) := GetGLProcAddress('glGenTransformFeedbacks');
    pointer(glIsTransformFeedback) := GetGLProcAddress('glIsTransformFeedback');
    pointer(glPauseTransformFeedback) := GetGLProcAddress('glPauseTransformFeedback');
    pointer(glResumeTransformFeedback) := GetGLProcAddress('glResumeTransformFeedback');
    pointer(glDrawTransformFeedback) := GetGLProcAddress('glDrawTransformFeedback');
    Result := True;
  end;
end;

function Load_GL_ARB_transform_feedback3(LoadAsCore: boolean): Boolean;
var
  extstring: String;
begin
  Result := False;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

  if LoadAsCore or glext_ExtensionSupported('GL_ARB_transform_feedback3', extstring) then
  begin
    pointer(glDrawTransformFeedbackStream) := GetGLProcAddress('glDrawTransformFeedbackStream');
    pointer(glBeginQueryIndexed) := GetGLProcAddress('glBeginQueryIndexed');
    pointer(glEndQueryIndexed) := GetGLProcAddress('glEndQueryIndexed');
    pointer(glGetQueryIndexediv) := GetGLProcAddress('glGetQueryIndexediv');
    Result := True;
  end;
end;

procedure Load_Basic_GL_1_2;
begin
  pointer( glAccum ) := GetGLProcAddress( 'glAccum');
  pointer( glAlphaFunc ) := GetGLProcAddress( 'glAlphaFunc');
  pointer( glAreTexturesResident ) := GetGLProcAddress( 'glAreTexturesResident');
  pointer( glArrayElement ) := GetGLProcAddress( 'glArrayElement');
  pointer( glBegin ) := GetGLProcAddress( 'glBegin');
  pointer( glBindTexture ) := GetGLProcAddress( 'glBindTexture');
  pointer( glBitmap ) := GetGLProcAddress( 'glBitmap');
  pointer( glBlendFunc ) := GetGLProcAddress( 'glBlendFunc');
  pointer( glCallList ) := GetGLProcAddress( 'glCallList');
  pointer( glCallLists ) := GetGLProcAddress( 'glCallLists');
  pointer( glClear ) := GetGLProcAddress( 'glClear');
  pointer( glClearAccum ) := GetGLProcAddress( 'glClearAccum');
  pointer( glClearColor ) := GetGLProcAddress( 'glClearColor');
  pointer( glClearDepth ) := GetGLProcAddress( 'glClearDepth');
  pointer( glClearIndex ) := GetGLProcAddress( 'glClearIndex');
  pointer( glClearStencil ) := GetGLProcAddress( 'glClearStencil');
  pointer( glClipPlane ) := GetGLProcAddress( 'glClipPlane');
  pointer( glColor3b ) := GetGLProcAddress( 'glColor3b');
  pointer( glColor3bv ) := GetGLProcAddress( 'glColor3bv');
  pointer( glColor3d ) := GetGLProcAddress( 'glColor3d');
  pointer( glColor3dv ) := GetGLProcAddress( 'glColor3dv');
  pointer( glColor3f ) := GetGLProcAddress( 'glColor3f');
  pointer( glColor3fv ) := GetGLProcAddress( 'glColor3fv');
  pointer( glColor3i ) := GetGLProcAddress( 'glColor3i');
  pointer( glColor3iv ) := GetGLProcAddress( 'glColor3iv');
  pointer( glColor3s ) := GetGLProcAddress( 'glColor3s');
  pointer( glColor3sv ) := GetGLProcAddress( 'glColor3sv');
  pointer( glColor3ub ) := GetGLProcAddress( 'glColor3ub');
  pointer( glColor3ubv ) := GetGLProcAddress( 'glColor3ubv');
  pointer( glColor3ui ) := GetGLProcAddress( 'glColor3ui');
  pointer( glColor3uiv ) := GetGLProcAddress( 'glColor3uiv');
  pointer( glColor3us ) := GetGLProcAddress( 'glColor3us');
  pointer( glColor3usv ) := GetGLProcAddress( 'glColor3usv');
  pointer( glColor4b ) := GetGLProcAddress( 'glColor4b');
  pointer( glColor4bv ) := GetGLProcAddress( 'glColor4bv');
  pointer( glColor4d ) := GetGLProcAddress( 'glColor4d');
  pointer( glColor4dv ) := GetGLProcAddress( 'glColor4dv');
  pointer( glColor4f ) := GetGLProcAddress( 'glColor4f');
  pointer( glColor4fv ) := GetGLProcAddress( 'glColor4fv');
  pointer( glColor4i ) := GetGLProcAddress( 'glColor4i');
  pointer( glColor4iv ) := GetGLProcAddress( 'glColor4iv');
  pointer( glColor4s ) := GetGLProcAddress( 'glColor4s');
  pointer( glColor4sv ) := GetGLProcAddress( 'glColor4sv');
  pointer( glColor4ub ) := GetGLProcAddress( 'glColor4ub');
  pointer( glColor4ubv ) := GetGLProcAddress( 'glColor4ubv');
  pointer( glColor4ui ) := GetGLProcAddress( 'glColor4ui');
  pointer( glColor4uiv ) := GetGLProcAddress( 'glColor4uiv');
  pointer( glColor4us ) := GetGLProcAddress( 'glColor4us');
  pointer( glColor4usv ) := GetGLProcAddress( 'glColor4usv');
  pointer( glColorMask ) := GetGLProcAddress( 'glColorMask');
  pointer( glColorMaterial ) := GetGLProcAddress( 'glColorMaterial');
  pointer( glColorPointer ) := GetGLProcAddress( 'glColorPointer');
  pointer( glCopyPixels ) := GetGLProcAddress( 'glCopyPixels');
  pointer( glCopyTexImage1D ) := GetGLProcAddress( 'glCopyTexImage1D');
  pointer( glCopyTexImage2D ) := GetGLProcAddress( 'glCopyTexImage2D');
  pointer( glCopyTexSubImage1D ) := GetGLProcAddress( 'glCopyTexSubImage1D');
  pointer( glCopyTexSubImage2D ) := GetGLProcAddress( 'glCopyTexSubImage2D');
  pointer( glCullFace ) := GetGLProcAddress( 'glCullFace');
  pointer( glDeleteLists ) := GetGLProcAddress( 'glDeleteLists');
  pointer( glDeleteTextures ) := GetGLProcAddress( 'glDeleteTextures');
  pointer( glDepthFunc ) := GetGLProcAddress( 'glDepthFunc');
  pointer( glDepthMask ) := GetGLProcAddress( 'glDepthMask');
  pointer( glDepthRange ) := GetGLProcAddress( 'glDepthRange');
  pointer( glDisable ) := GetGLProcAddress( 'glDisable');
  pointer( glDisableClientState ) := GetGLProcAddress( 'glDisableClientState');
  pointer( glDrawArrays ) := GetGLProcAddress( 'glDrawArrays');
  pointer( glDrawBuffer ) := GetGLProcAddress( 'glDrawBuffer');
  pointer( glDrawElements ) := GetGLProcAddress( 'glDrawElements');
  pointer( glDrawPixels ) := GetGLProcAddress( 'glDrawPixels');
  pointer( glEdgeFlag ) := GetGLProcAddress( 'glEdgeFlag');
  pointer( glEdgeFlagPointer ) := GetGLProcAddress( 'glEdgeFlagPointer');
  pointer( glEdgeFlagv ) := GetGLProcAddress( 'glEdgeFlagv');
  pointer( glEnable ) := GetGLProcAddress( 'glEnable');
  pointer( glEnableClientState ) := GetGLProcAddress( 'glEnableClientState');
  pointer( glEnd ) := GetGLProcAddress( 'glEnd');
  pointer( glEndList ) := GetGLProcAddress( 'glEndList');
  pointer( glEvalCoord1d ) := GetGLProcAddress( 'glEvalCoord1d');
  pointer( glEvalCoord1dv ) := GetGLProcAddress( 'glEvalCoord1dv');
  pointer( glEvalCoord1f ) := GetGLProcAddress( 'glEvalCoord1f');
  pointer( glEvalCoord1fv ) := GetGLProcAddress( 'glEvalCoord1fv');
  pointer( glEvalCoord2d ) := GetGLProcAddress( 'glEvalCoord2d');
  pointer( glEvalCoord2dv ) := GetGLProcAddress( 'glEvalCoord2dv');
  pointer( glEvalCoord2f ) := GetGLProcAddress( 'glEvalCoord2f');
  pointer( glEvalCoord2fv ) := GetGLProcAddress( 'glEvalCoord2fv');
  pointer( glEvalMesh1 ) := GetGLProcAddress( 'glEvalMesh1');
  pointer( glEvalMesh2 ) := GetGLProcAddress( 'glEvalMesh2');
  pointer( glEvalPoint1 ) := GetGLProcAddress( 'glEvalPoint1');
  pointer( glEvalPoint2 ) := GetGLProcAddress( 'glEvalPoint2');
  pointer( glFeedbackBuffer ) := GetGLProcAddress( 'glFeedbackBuffer');
  pointer( glFinish ) := GetGLProcAddress( 'glFinish');
  pointer( glFlush ) := GetGLProcAddress( 'glFlush');
  pointer( glFogf ) := GetGLProcAddress( 'glFogf');
  pointer( glFogfv ) := GetGLProcAddress( 'glFogfv');
  pointer( glFogi ) := GetGLProcAddress( 'glFogi');
  pointer( glFogiv ) := GetGLProcAddress( 'glFogiv');
  pointer( glFrontFace ) := GetGLProcAddress( 'glFrontFace');
  pointer( glFrustum ) := GetGLProcAddress( 'glFrustum');
  pointer( glGenLists ) := GetGLProcAddress( 'glGenLists');
  pointer( glGenTextures ) := GetGLProcAddress( 'glGenTextures');
  pointer( glGetBooleanv ) := GetGLProcAddress( 'glGetBooleanv');
  pointer( glGetClipPlane ) := GetGLProcAddress( 'glGetClipPlane');
  pointer( glGetDoublev ) := GetGLProcAddress( 'glGetDoublev');
  pointer( glGetError ) := GetGLProcAddress( 'glGetError');
  pointer( glGetFloatv ) := GetGLProcAddress( 'glGetFloatv');
  pointer( glGetIntegerv ) := GetGLProcAddress( 'glGetIntegerv');
  pointer( glGetLightfv ) := GetGLProcAddress( 'glGetLightfv');
  pointer( glGetLightiv ) := GetGLProcAddress( 'glGetLightiv');
  pointer( glGetMapdv ) := GetGLProcAddress( 'glGetMapdv');
  pointer( glGetMapfv ) := GetGLProcAddress( 'glGetMapfv');
  pointer( glGetMapiv ) := GetGLProcAddress( 'glGetMapiv');
  pointer( glGetMaterialfv ) := GetGLProcAddress( 'glGetMaterialfv');
  pointer( glGetMaterialiv ) := GetGLProcAddress( 'glGetMaterialiv');
  pointer( glGetPixelMapfv ) := GetGLProcAddress( 'glGetPixelMapfv');
  pointer( glGetPixelMapuiv ) := GetGLProcAddress( 'glGetPixelMapuiv');
  pointer( glGetPixelMapusv ) := GetGLProcAddress( 'glGetPixelMapusv');
  pointer( glGetPointerv ) := GetGLProcAddress( 'glGetPointerv');
  pointer( glGetPolygonStipple ) := GetGLProcAddress( 'glGetPolygonStipple');
  pointer( glGetString ) := GetGLProcAddress( 'glGetString');
  pointer( glGetTexEnvfv ) := GetGLProcAddress( 'glGetTexEnvfv');
  pointer( glGetTexEnviv ) := GetGLProcAddress( 'glGetTexEnviv');
  pointer( glGetTexGendv ) := GetGLProcAddress( 'glGetTexGendv');
  pointer( glGetTexGenfv ) := GetGLProcAddress( 'glGetTexGenfv');
  pointer( glGetTexGeniv ) := GetGLProcAddress( 'glGetTexGeniv');
  pointer( glGetTexImage ) := GetGLProcAddress( 'glGetTexImage');
  pointer( glGetTexLevelParameterfv ) := GetGLProcAddress( 'glGetTexLevelParameterfv');
  pointer( glGetTexLevelParameteriv ) := GetGLProcAddress( 'glGetTexLevelParameteriv');
  pointer( glGetTexParameterfv ) := GetGLProcAddress( 'glGetTexParameterfv');
  pointer( glGetTexParameteriv ) := GetGLProcAddress( 'glGetTexParameteriv');
  pointer( glHint ) := GetGLProcAddress( 'glHint');
  pointer( glIndexMask ) := GetGLProcAddress( 'glIndexMask');
  pointer( glIndexPointer ) := GetGLProcAddress( 'glIndexPointer');
  pointer( glIndexd ) := GetGLProcAddress( 'glIndexd');
  pointer( glIndexdv ) := GetGLProcAddress( 'glIndexdv');
  pointer( glIndexf ) := GetGLProcAddress( 'glIndexf');
  pointer( glIndexfv ) := GetGLProcAddress( 'glIndexfv');
  pointer( glIndexi ) := GetGLProcAddress( 'glIndexi');
  pointer( glIndexiv ) := GetGLProcAddress( 'glIndexiv');
  pointer( glIndexs ) := GetGLProcAddress( 'glIndexs');
  pointer( glIndexsv ) := GetGLProcAddress( 'glIndexsv');
  pointer( glIndexub ) := GetGLProcAddress( 'glIndexub');
  pointer( glIndexubv ) := GetGLProcAddress( 'glIndexubv');
  pointer( glInitNames ) := GetGLProcAddress( 'glInitNames');
  pointer( glInterleavedArrays ) := GetGLProcAddress( 'glInterleavedArrays');
  pointer( glIsEnabled ) := GetGLProcAddress( 'glIsEnabled');
  pointer( glIsList ) := GetGLProcAddress( 'glIsList');
  pointer( glIsTexture ) := GetGLProcAddress( 'glIsTexture');
  pointer( glLightModelf ) := GetGLProcAddress( 'glLightModelf');
  pointer( glLightModelfv ) := GetGLProcAddress( 'glLightModelfv');
  pointer( glLightModeli ) := GetGLProcAddress( 'glLightModeli');
  pointer( glLightModeliv ) := GetGLProcAddress( 'glLightModeliv');
  pointer( glLightf ) := GetGLProcAddress( 'glLightf');
  pointer( glLightfv ) := GetGLProcAddress( 'glLightfv');
  pointer( glLighti ) := GetGLProcAddress( 'glLighti');
  pointer( glLightiv ) := GetGLProcAddress( 'glLightiv');
  pointer( glLineStipple ) := GetGLProcAddress( 'glLineStipple');
  pointer( glLineWidth ) := GetGLProcAddress( 'glLineWidth');
  pointer( glListBase ) := GetGLProcAddress( 'glListBase');
  pointer( glLoadIdentity ) := GetGLProcAddress( 'glLoadIdentity');
  pointer( glLoadMatrixd ) := GetGLProcAddress( 'glLoadMatrixd');
  pointer( glLoadMatrixf ) := GetGLProcAddress( 'glLoadMatrixf');
  pointer( glLoadName ) := GetGLProcAddress( 'glLoadName');
  pointer( glLogicOp ) := GetGLProcAddress( 'glLogicOp');
  pointer( glMap1d ) := GetGLProcAddress( 'glMap1d');
  pointer( glMap1f ) := GetGLProcAddress( 'glMap1f');
  pointer( glMap2d ) := GetGLProcAddress( 'glMap2d');
  pointer( glMap2f ) := GetGLProcAddress( 'glMap2f');
  pointer( glMapGrid1d ) := GetGLProcAddress( 'glMapGrid1d');
  pointer( glMapGrid1f ) := GetGLProcAddress( 'glMapGrid1f');
  pointer( glMapGrid2d ) := GetGLProcAddress( 'glMapGrid2d');
  pointer( glMapGrid2f ) := GetGLProcAddress( 'glMapGrid2f');
  pointer( glMaterialf ) := GetGLProcAddress( 'glMaterialf');
  pointer( glMaterialfv ) := GetGLProcAddress( 'glMaterialfv');
  pointer( glMateriali ) := GetGLProcAddress( 'glMateriali');
  pointer( glMaterialiv ) := GetGLProcAddress( 'glMaterialiv');
  pointer( glMatrixMode ) := GetGLProcAddress( 'glMatrixMode');
  pointer( glMultMatrixd ) := GetGLProcAddress( 'glMultMatrixd');
  pointer( glMultMatrixf ) := GetGLProcAddress( 'glMultMatrixf');
  pointer( glNewList ) := GetGLProcAddress( 'glNewList');
  pointer( glNormal3b ) := GetGLProcAddress( 'glNormal3b');
  pointer( glNormal3bv ) := GetGLProcAddress( 'glNormal3bv');
  pointer( glNormal3d ) := GetGLProcAddress( 'glNormal3d');
  pointer( glNormal3dv ) := GetGLProcAddress( 'glNormal3dv');
  pointer( glNormal3f ) := GetGLProcAddress( 'glNormal3f');
  pointer( glNormal3fv ) := GetGLProcAddress( 'glNormal3fv');
  pointer( glNormal3i ) := GetGLProcAddress( 'glNormal3i');
  pointer( glNormal3iv ) := GetGLProcAddress( 'glNormal3iv');
  pointer( glNormal3s ) := GetGLProcAddress( 'glNormal3s');
  pointer( glNormal3sv ) := GetGLProcAddress( 'glNormal3sv');
  pointer( glNormalPointer ) := GetGLProcAddress( 'glNormalPointer');
  pointer( glOrtho ) := GetGLProcAddress( 'glOrtho');
  pointer( glPassThrough ) := GetGLProcAddress( 'glPassThrough');
  pointer( glPixelMapfv ) := GetGLProcAddress( 'glPixelMapfv');
  pointer( glPixelMapuiv ) := GetGLProcAddress( 'glPixelMapuiv');
  pointer( glPixelMapusv ) := GetGLProcAddress( 'glPixelMapusv');
  pointer( glPixelStoref ) := GetGLProcAddress( 'glPixelStoref');
  pointer( glPixelStorei ) := GetGLProcAddress( 'glPixelStorei');
  pointer( glPixelTransferf ) := GetGLProcAddress( 'glPixelTransferf');
  pointer( glPixelTransferi ) := GetGLProcAddress( 'glPixelTransferi');
  pointer( glPixelZoom ) := GetGLProcAddress( 'glPixelZoom');
  pointer( glPointSize ) := GetGLProcAddress( 'glPointSize');
  pointer( glPolygonMode ) := GetGLProcAddress( 'glPolygonMode');
  pointer( glPolygonOffset ) := GetGLProcAddress( 'glPolygonOffset');
  pointer( glPolygonStipple ) := GetGLProcAddress( 'glPolygonStipple');
  pointer( glPopAttrib ) := GetGLProcAddress( 'glPopAttrib');
  pointer( glPopClientAttrib ) := GetGLProcAddress( 'glPopClientAttrib');
  pointer( glPopMatrix ) := GetGLProcAddress( 'glPopMatrix');
  pointer( glPopName ) := GetGLProcAddress( 'glPopName');
  pointer( glPrioritizeTextures ) := GetGLProcAddress( 'glPrioritizeTextures');
  pointer( glPushAttrib ) := GetGLProcAddress( 'glPushAttrib');
  pointer( glPushClientAttrib ) := GetGLProcAddress( 'glPushClientAttrib');
  pointer( glPushMatrix ) := GetGLProcAddress( 'glPushMatrix');
  pointer( glPushName ) := GetGLProcAddress( 'glPushName');
  pointer( glRasterPos2d ) := GetGLProcAddress( 'glRasterPos2d');
  pointer( glRasterPos2dv ) := GetGLProcAddress( 'glRasterPos2dv');
  pointer( glRasterPos2f ) := GetGLProcAddress( 'glRasterPos2f');
  pointer( glRasterPos2fv ) := GetGLProcAddress( 'glRasterPos2fv');
  pointer( glRasterPos2i ) := GetGLProcAddress( 'glRasterPos2i');
  pointer( glRasterPos2iv ) := GetGLProcAddress( 'glRasterPos2iv');
  pointer( glRasterPos2s ) := GetGLProcAddress( 'glRasterPos2s');
  pointer( glRasterPos2sv ) := GetGLProcAddress( 'glRasterPos2sv');
  pointer( glRasterPos3d ) := GetGLProcAddress( 'glRasterPos3d');
  pointer( glRasterPos3dv ) := GetGLProcAddress( 'glRasterPos3dv');
  pointer( glRasterPos3f ) := GetGLProcAddress( 'glRasterPos3f');
  pointer( glRasterPos3fv ) := GetGLProcAddress( 'glRasterPos3fv');
  pointer( glRasterPos3i ) := GetGLProcAddress( 'glRasterPos3i');
  pointer( glRasterPos3iv ) := GetGLProcAddress( 'glRasterPos3iv');
  pointer( glRasterPos3s ) := GetGLProcAddress( 'glRasterPos3s');
  pointer( glRasterPos3sv ) := GetGLProcAddress( 'glRasterPos3sv');
  pointer( glRasterPos4d ) := GetGLProcAddress( 'glRasterPos4d');
  pointer( glRasterPos4dv ) := GetGLProcAddress( 'glRasterPos4dv');
  pointer( glRasterPos4f ) := GetGLProcAddress( 'glRasterPos4f');
  pointer( glRasterPos4fv ) := GetGLProcAddress( 'glRasterPos4fv');
  pointer( glRasterPos4i ) := GetGLProcAddress( 'glRasterPos4i');
  pointer( glRasterPos4iv ) := GetGLProcAddress( 'glRasterPos4iv');
  pointer( glRasterPos4s ) := GetGLProcAddress( 'glRasterPos4s');
  pointer( glRasterPos4sv ) := GetGLProcAddress( 'glRasterPos4sv');
  pointer( glReadBuffer ) := GetGLProcAddress( 'glReadBuffer');
  pointer( glReadPixels ) := GetGLProcAddress( 'glReadPixels');
  pointer( glRectd ) := GetGLProcAddress( 'glRectd');
  pointer( glRectdv ) := GetGLProcAddress( 'glRectdv');
  pointer( glRectf ) := GetGLProcAddress( 'glRectf');
  pointer( glRectfv ) := GetGLProcAddress( 'glRectfv');
  pointer( glRecti ) := GetGLProcAddress( 'glRecti');
  pointer( glRectiv ) := GetGLProcAddress( 'glRectiv');
  pointer( glRects ) := GetGLProcAddress( 'glRects');
  pointer( glRectsv ) := GetGLProcAddress( 'glRectsv');
  pointer( glRenderMode ) := GetGLProcAddress( 'glRenderMode');
  pointer( glRotated ) := GetGLProcAddress( 'glRotated');
  pointer( glRotatef ) := GetGLProcAddress( 'glRotatef');
  pointer( glScaled ) := GetGLProcAddress( 'glScaled');
  pointer( glScalef ) := GetGLProcAddress( 'glScalef');
  pointer( glScissor ) := GetGLProcAddress( 'glScissor');
  pointer( glSelectBuffer ) := GetGLProcAddress( 'glSelectBuffer');
  pointer( glShadeModel ) := GetGLProcAddress( 'glShadeModel');
  pointer( glStencilFunc ) := GetGLProcAddress( 'glStencilFunc');
  pointer( glStencilMask ) := GetGLProcAddress( 'glStencilMask');
  pointer( glStencilOp ) := GetGLProcAddress( 'glStencilOp');
  pointer( glTexCoord1d ) := GetGLProcAddress( 'glTexCoord1d');
  pointer( glTexCoord1dv ) := GetGLProcAddress( 'glTexCoord1dv');
  pointer( glTexCoord1f ) := GetGLProcAddress( 'glTexCoord1f');
  pointer( glTexCoord1fv ) := GetGLProcAddress( 'glTexCoord1fv');
  pointer( glTexCoord1i ) := GetGLProcAddress( 'glTexCoord1i');
  pointer( glTexCoord1iv ) := GetGLProcAddress( 'glTexCoord1iv');
  pointer( glTexCoord1s ) := GetGLProcAddress( 'glTexCoord1s');
  pointer( glTexCoord1sv ) := GetGLProcAddress( 'glTexCoord1sv');
  pointer( glTexCoord2d ) := GetGLProcAddress( 'glTexCoord2d');
  pointer( glTexCoord2dv ) := GetGLProcAddress( 'glTexCoord2dv');
  pointer( glTexCoord2f ) := GetGLProcAddress( 'glTexCoord2f');
  pointer( glTexCoord2fv ) := GetGLProcAddress( 'glTexCoord2fv');
  pointer( glTexCoord2i ) := GetGLProcAddress( 'glTexCoord2i');
  pointer( glTexCoord2iv ) := GetGLProcAddress( 'glTexCoord2iv');
  pointer( glTexCoord2s ) := GetGLProcAddress( 'glTexCoord2s');
  pointer( glTexCoord2sv ) := GetGLProcAddress( 'glTexCoord2sv');
  pointer( glTexCoord3d ) := GetGLProcAddress( 'glTexCoord3d');
  pointer( glTexCoord3dv ) := GetGLProcAddress( 'glTexCoord3dv');
  pointer( glTexCoord3f ) := GetGLProcAddress( 'glTexCoord3f');
  pointer( glTexCoord3fv ) := GetGLProcAddress( 'glTexCoord3fv');
  pointer( glTexCoord3i ) := GetGLProcAddress( 'glTexCoord3i');
  pointer( glTexCoord3iv ) := GetGLProcAddress( 'glTexCoord3iv');
  pointer( glTexCoord3s ) := GetGLProcAddress( 'glTexCoord3s');
  pointer( glTexCoord3sv ) := GetGLProcAddress( 'glTexCoord3sv');
  pointer( glTexCoord4d ) := GetGLProcAddress( 'glTexCoord4d');
  pointer( glTexCoord4dv ) := GetGLProcAddress( 'glTexCoord4dv');
  pointer( glTexCoord4f ) := GetGLProcAddress( 'glTexCoord4f');
  pointer( glTexCoord4fv ) := GetGLProcAddress( 'glTexCoord4fv');
  pointer( glTexCoord4i ) := GetGLProcAddress( 'glTexCoord4i');
  pointer( glTexCoord4iv ) := GetGLProcAddress( 'glTexCoord4iv');
  pointer( glTexCoord4s ) := GetGLProcAddress( 'glTexCoord4s');
  pointer( glTexCoord4sv ) := GetGLProcAddress( 'glTexCoord4sv');
  pointer( glTexCoordPointer ) := GetGLProcAddress( 'glTexCoordPointer');
  pointer( glTexEnvf ) := GetGLProcAddress( 'glTexEnvf');
  pointer( glTexEnvfv ) := GetGLProcAddress( 'glTexEnvfv');
  pointer( glTexEnvi ) := GetGLProcAddress( 'glTexEnvi');
  pointer( glTexEnviv ) := GetGLProcAddress( 'glTexEnviv');
  pointer( glTexGend ) := GetGLProcAddress( 'glTexGend');
  pointer( glTexGendv ) := GetGLProcAddress( 'glTexGendv');
  pointer( glTexGenf ) := GetGLProcAddress( 'glTexGenf');
  pointer( glTexGenfv ) := GetGLProcAddress( 'glTexGenfv');
  pointer( glTexGeni ) := GetGLProcAddress( 'glTexGeni');
  pointer( glTexGeniv ) := GetGLProcAddress( 'glTexGeniv');
  pointer( glTexImage1D ) := GetGLProcAddress( 'glTexImage1D');
  pointer( glTexImage2D ) := GetGLProcAddress( 'glTexImage2D');
  pointer( glTexParameterf ) := GetGLProcAddress( 'glTexParameterf');
  pointer( glTexParameterfv ) := GetGLProcAddress( 'glTexParameterfv');
  pointer( glTexParameteri ) := GetGLProcAddress( 'glTexParameteri');
  pointer( glTexParameteriv ) := GetGLProcAddress( 'glTexParameteriv');
  pointer( glTexSubImage1D ) := GetGLProcAddress( 'glTexSubImage1D');
  pointer( glTexSubImage2D ) := GetGLProcAddress( 'glTexSubImage2D');
  pointer( glTranslated ) := GetGLProcAddress( 'glTranslated');
  pointer( glTranslatef ) := GetGLProcAddress( 'glTranslatef');
  pointer( glVertex2d ) := GetGLProcAddress( 'glVertex2d');
  pointer( glVertex2dv ) := GetGLProcAddress( 'glVertex2dv');
  pointer( glVertex2f ) := GetGLProcAddress( 'glVertex2f');
  pointer( glVertex2fv ) := GetGLProcAddress( 'glVertex2fv');
  pointer( glVertex2i ) := GetGLProcAddress( 'glVertex2i');
  pointer( glVertex2iv ) := GetGLProcAddress( 'glVertex2iv');
  pointer( glVertex2s ) := GetGLProcAddress( 'glVertex2s');
  pointer( glVertex2sv ) := GetGLProcAddress( 'glVertex2sv');
  pointer( glVertex3d ) := GetGLProcAddress( 'glVertex3d');
  pointer( glVertex3dv ) := GetGLProcAddress( 'glVertex3dv');
  pointer( glVertex3f ) := GetGLProcAddress( 'glVertex3f');
  pointer( glVertex3fv ) := GetGLProcAddress( 'glVertex3fv');
  pointer( glVertex3i ) := GetGLProcAddress( 'glVertex3i');
  pointer( glVertex3iv ) := GetGLProcAddress( 'glVertex3iv');
  pointer( glVertex3s ) := GetGLProcAddress( 'glVertex3s');
  pointer( glVertex3sv ) := GetGLProcAddress( 'glVertex3sv');
  pointer( glVertex4d ) := GetGLProcAddress( 'glVertex4d');
  pointer( glVertex4dv ) := GetGLProcAddress( 'glVertex4dv');
  pointer( glVertex4f ) := GetGLProcAddress( 'glVertex4f');
  pointer( glVertex4fv ) := GetGLProcAddress( 'glVertex4fv');
  pointer( glVertex4i ) := GetGLProcAddress( 'glVertex4i');
  pointer( glVertex4iv ) := GetGLProcAddress( 'glVertex4iv');
  pointer( glVertex4s ) := GetGLProcAddress( 'glVertex4s');
  pointer( glVertex4sv ) := GetGLProcAddress( 'glVertex4sv');
  pointer( glVertexPointer ) := GetGLProcAddress( 'glVertexPointer');
  pointer( glViewport ) := GetGLProcAddress( 'glViewport');

end;

function Load_GL_version_1_4: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

    pointer(glBlendFuncSeparate) := GetGLProcAddress('glBlendFuncSeparate');
    pointer(glFogCoordf) := GetGLProcAddress('glFogCoordf');
    pointer(glFogCoordfv) := GetGLProcAddress('glFogCoordfv');
    pointer(glFogCoordd) := GetGLProcAddress('glFogCoordd');
    pointer(glFogCoorddv) := GetGLProcAddress('glFogCoorddv');
    pointer(glFogCoordPointer) := GetGLProcAddress('glFogCoordPointer');
    pointer(glMultiDrawArrays) := GetGLProcAddress('glMultiDrawArrays');
    pointer(glMultiDrawElements) := GetGLProcAddress('glMultiDrawElements');
    pointer(glPointParameterf) := GetGLProcAddress('glPointParameterf');
    pointer(glPointParameterfv) := GetGLProcAddress('glPointParameterfv');
    pointer(glPointParameteri) := GetGLProcAddress('glPointParameteri');
    pointer(glPointParameteriv) := GetGLProcAddress('glPointParameteriv');
    pointer(glSecondaryColor3b) := GetGLProcAddress('glSecondaryColor3b');
   pointer( glSecondaryColor3bv) := GetGLProcAddress('glSecondaryColor3bv');
    pointer(glSecondaryColor3d) := GetGLProcAddress('glSecondaryColor3d');
    pointer(glSecondaryColor3dv) := GetGLProcAddress('glSecondaryColor3dv');
    pointer(glSecondaryColor3f) := GetGLProcAddress('glSecondaryColor3f');
    pointer(glSecondaryColor3fv) := GetGLProcAddress('glSecondaryColor3fv');
    pointer(glSecondaryColor3i) := GetGLProcAddress('glSecondaryColor3i');
    pointer(glSecondaryColor3iv) := GetGLProcAddress('glSecondaryColor3iv');
    pointer(glSecondaryColor3s) := GetGLProcAddress('glSecondaryColor3s');
    pointer(glSecondaryColor3sv) := GetGLProcAddress('glSecondaryColor3sv');
    pointer(glSecondaryColor3ub) := GetGLProcAddress('glSecondaryColor3ub');
    pointer(glSecondaryColor3ubv) := GetGLProcAddress('glSecondaryColor3ubv');
    pointer(glSecondaryColor3ui) := GetGLProcAddress('glSecondaryColor3ui');
    pointer(glSecondaryColor3uiv) := GetGLProcAddress('glSecondaryColor3uiv');
    pointer(glSecondaryColor3us) := GetGLProcAddress('glSecondaryColor3us');
    pointer(glSecondaryColor3usv) := GetGLProcAddress('glSecondaryColor3usv');
    pointer(glSecondaryColorPointer) := GetGLProcAddress('glSecondaryColorPointer');
    pointer(glWindowPos2d) := GetGLProcAddress('glWindowPos2d');
    pointer(glWindowPos2dv) := GetGLProcAddress('glWindowPos2dv');
    pointer(glWindowPos2f) := GetGLProcAddress('glWindowPos2f');
    pointer(glWindowPos2fv) := GetGLProcAddress('glWindowPos2fv');
    pointer(glWindowPos2i) := GetGLProcAddress('glWindowPos2i');
    pointer(glWindowPos2iv) := GetGLProcAddress('glWindowPos2iv');
    pointer(glWindowPos2s) := GetGLProcAddress('glWindowPos2s');
    pointer(glWindowPos2sv) := GetGLProcAddress('glWindowPos2sv');
    pointer(glWindowPos3d) := GetGLProcAddress('glWindowPos3d');
    pointer(glWindowPos3dv) := GetGLProcAddress('glWindowPos3dv');
    pointer(glWindowPos3f) := GetGLProcAddress('glWindowPos3f');
    pointer(glWindowPos3fv) := GetGLProcAddress('glWindowPos3fv');
    pointer(glWindowPos3i) := GetGLProcAddress('glWindowPos3i');
    pointer(glWindowPos3iv) := GetGLProcAddress('glWindowPos3iv');
   pointer( glWindowPos3s) := GetGLProcAddress('glWindowPos3s');
    pointer(glWindowPos3sv) := GetGLProcAddress('glWindowPos3sv');
    Result := Load_GL_version_1_3;

end;

function Load_GL_version_1_5: Boolean;
var
  extstring: String;
begin

  Result := FALSE;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));

    pointer(glGenQueries) := GetGLProcAddress('glGenQueries');
    pointer(glDeleteQueries) := GetGLProcAddress('glDeleteQueries');
    pointer(glIsQuery) := GetGLProcAddress('glIsQuery');
    pointer(glBeginQuery) := GetGLProcAddress('glBeginQuery');
    pointer(glEndQuery) := GetGLProcAddress('glEndQuery');
    pointer(glGetQueryiv) := GetGLProcAddress('glGetQueryiv');
    pointer(glGetQueryObjectiv) := GetGLProcAddress('glGetQueryObjectiv');
    pointer(glGetQueryObjectuiv) := GetGLProcAddress('glGetQueryObjectuiv');
    pointer(glBindBuffer) := GetGLProcAddress('glBindBuffer');
    pointer(glDeleteBuffers) := GetGLProcAddress('glDeleteBuffers');
    pointer(glGenBuffers) := GetGLProcAddress('glGenBuffers');
    pointer(glIsBuffer) := GetGLProcAddress('glIsBuffer');
    pointer(glBufferData) := GetGLProcAddress('glBufferData');
    pointer(glBufferSubData) := GetGLProcAddress('glBufferSubData');
    pointer(glGetBufferSubData) := GetGLProcAddress('glGetBufferSubData');
    pointer(glMapBuffer) := GetGLProcAddress('glMapBuffer');
    pointer(glUnmapBuffer) := GetGLProcAddress('glUnmapBuffer');
    pointer(glGetBufferParameteriv) := GetGLProcAddress('glGetBufferParameteriv');
    pointer(glGetBufferPointerv) := GetGLProcAddress('glGetBufferPointerv');
    Result := Load_GL_version_1_4;

end;

function Load_GL_version_2_0: Boolean;
var
  extstring: String;
begin

  Result:= false;
  extstring := String(PAnsiChar(glGetString(GL_EXTENSIONS)));
  pointer(glBlendEquationSeparate) := GetGLProcAddress('glBlendEquationSeparate');
    pointer(glDrawBuffers) := GetGLProcAddress('glDrawBuffers');
    pointer(glStencilOpSeparate) := GetGLProcAddress('glStencilOpSeparate');
    pointer(glStencilFuncSeparate) := GetGLProcAddress('glStencilFuncSeparate');
    pointer(glStencilMaskSeparate) := GetGLProcAddress('glStencilMaskSeparate');
    pointer(glAttachShader) := GetGLProcAddress('glAttachShader');
    pointer(glBindAttribLocation) := GetGLProcAddress('glBindAttribLocation');
    pointer(glCompileShader) := GetGLProcAddress('glCompileShader');
    pointer(glCreateProgram) := GetGLProcAddress('glCreateProgram');
    pointer(glCreateShader) := GetGLProcAddress('glCreateShader');
    pointer(glDeleteProgram) := GetGLProcAddress('glDeleteProgram');
    pointer(glDeleteShader) := GetGLProcAddress('glDeleteShader');
    pointer(glDetachShader) := GetGLProcAddress('glDetachShader');
    pointer(glDisableVertexAttribArray) := GetGLProcAddress('glDisableVertexAttribArray');
    pointer(glEnableVertexAttribArray) := GetGLProcAddress('glEnableVertexAttribArray');
    pointer(glGetActiveAttrib) := GetGLProcAddress('glGetActiveAttrib');
    pointer(glGetActiveUniform) := GetGLProcAddress('glGetActiveUniform');
    pointer(glGetAttachedShaders) := GetGLProcAddress('glGetAttachedShaders');
    pointer(glGetAttribLocation) := GetGLProcAddress('glGetAttribLocation');
    pointer(glGetProgramiv) := GetGLProcAddress('glGetProgramiv');
    pointer(glGetProgramInfoLog) := GetGLProcAddress('glGetProgramInfoLog');
    pointer(glGetShaderiv) := GetGLProcAddress('glGetShaderiv');
    pointer(glGetShaderInfoLog) := GetGLProcAddress('glGetShaderInfoLog');
    pointer(glGetShaderSource) := GetGLProcAddress('glGetShaderSource');
    pointer(glGetUniformLocation) := GetGLProcAddress('glGetUniformLocation');
    pointer(glGetUniformfv) := GetGLProcAddress('glGetUniformfv');
    pointer(glGetUniformiv) := GetGLProcAddress('glGetUniformiv');
    pointer(glGetVertexAttribdv) := GetGLProcAddress('glGetVertexAttribdv');
    pointer(glGetVertexAttribfv) := GetGLProcAddress('glGetVertexAttribfv');
    pointer(glGetVertexAttribiv) := GetGLProcAddress('glGetVertexAttribiv');
    pointer(glGetVertexAttribPointerv) := GetGLProcAddress('glGetVertexAttribPointerv');
    pointer(glIsProgram) := GetGLProcAddress('glIsProgram');
   pointer( glIsShader) := GetGLProcAddress('glIsShader');
    pointer(glLinkProgram) := GetGLProcAddress('glLinkProgram');
    pointer(glShaderSource) := GetGLProcAddress('glShaderSource');
    pointer(glUseProgram) := GetGLProcAddress('glUseProgram');
    pointer(glUniform1f) := GetGLProcAddress('glUniform1f');
    pointer(glUniform2f) := GetGLProcAddress('glUniform2f');
    pointer(glUniform3f) := GetGLProcAddress('glUniform3f');
    pointer(glUniform4f) := GetGLProcAddress('glUniform4f');
    pointer(glUniform1i) := GetGLProcAddress('glUniform1i');
    pointer(glUniform2i) := GetGLProcAddress('glUniform2i');
    pointer(glUniform3i) := GetGLProcAddress('glUniform3i');
    pointer(glUniform4i) := GetGLProcAddress('glUniform4i');
    pointer(glUniform1fv) := GetGLProcAddress('glUniform1fv');
    pointer(glUniform2fv) := GetGLProcAddress('glUniform2fv');
    pointer(glUniform3fv) := GetGLProcAddress('glUniform3fv');
    pointer(glUniform4fv) := GetGLProcAddress('glUniform4fv');
    pointer(glUniform1iv) := GetGLProcAddress('glUniform1iv');
    pointer(glUniform2iv) := GetGLProcAddress('glUniform2iv');
    pointer(glUniform3iv) := GetGLProcAddress('glUniform3iv');
    pointer(glUniform4iv) := GetGLProcAddress('glUniform4iv');
    pointer(glUniformMatrix2fv) := GetGLProcAddress('glUniformMatrix2fv');
    pointer(glUniformMatrix3fv) := GetGLProcAddress('glUniformMatrix3fv');
    pointer(glUniformMatrix4fv) := GetGLProcAddress('glUniformMatrix4fv');
    pointer(glValidateProgram) := GetGLProcAddress('glValidateProgram');
    pointer(glVertexAttrib1d) := GetGLProcAddress('glVertexAttrib1d');
    pointer(glVertexAttrib1dv) := GetGLProcAddress('glVertexAttrib1dv');
   pointer( glVertexAttrib1f) := GetGLProcAddress('glVertexAttrib1f');
    pointer(glVertexAttrib1fv) := GetGLProcAddress('glVertexAttrib1fv');
    pointer(glVertexAttrib1s) := GetGLProcAddress('glVertexAttrib1s');
    pointer(glVertexAttrib1sv) := GetGLProcAddress('glVertexAttrib1sv');
    pointer(glVertexAttrib2d) := GetGLProcAddress('glVertexAttrib2d');
    pointer(glVertexAttrib2dv) := GetGLProcAddress('glVertexAttrib2dv');
    pointer(glVertexAttrib2f) := GetGLProcAddress('glVertexAttrib2f');
    pointer(glVertexAttrib2fv) := GetGLProcAddress('glVertexAttrib2fv');
    pointer(glVertexAttrib2s) := GetGLProcAddress('glVertexAttrib2s');
    pointer(glVertexAttrib2sv) := GetGLProcAddress('glVertexAttrib2sv');
    pointer(glVertexAttrib3d) := GetGLProcAddress('glVertexAttrib3d');
    pointer(glVertexAttrib3dv) := GetGLProcAddress('glVertexAttrib3dv');
    pointer(glVertexAttrib3f) := GetGLProcAddress('glVertexAttrib3f');
    pointer(glVertexAttrib3fv) := GetGLProcAddress('glVertexAttrib3fv');
    pointer(glVertexAttrib3s) := GetGLProcAddress('glVertexAttrib3s');
    pointer(glVertexAttrib3sv) := GetGLProcAddress('glVertexAttrib3sv');
    pointer(glVertexAttrib4Nbv) := GetGLProcAddress('glVertexAttrib4Nbv');
    pointer(glVertexAttrib4Niv) := GetGLProcAddress('glVertexAttrib4Niv');
    pointer(glVertexAttrib4Nsv) := GetGLProcAddress('glVertexAttrib4Nsv');
    pointer(glVertexAttrib4Nub) := GetGLProcAddress('glVertexAttrib4Nub');
    pointer(glVertexAttrib4Nubv) := GetGLProcAddress('glVertexAttrib4Nubv');
    pointer(glVertexAttrib4Nuiv) := GetGLProcAddress('glVertexAttrib4Nuiv');
    pointer(glVertexAttrib4Nusv) := GetGLProcAddress('glVertexAttrib4Nusv');
    pointer(glVertexAttrib4bv) := GetGLProcAddress('glVertexAttrib4bv');
    pointer(glVertexAttrib4d) := GetGLProcAddress('glVertexAttrib4d');
    pointer(glVertexAttrib4dv) := GetGLProcAddress('glVertexAttrib4dv');
    pointer(glVertexAttrib4f) := GetGLProcAddress('glVertexAttrib4f');
    pointer(glVertexAttrib4fv) := GetGLProcAddress('glVertexAttrib4fv');
    pointer(glVertexAttrib4iv) := GetGLProcAddress('glVertexAttrib4iv');
    pointer(glVertexAttrib4s) := GetGLProcAddress('glVertexAttrib4s');
    pointer(glVertexAttrib4sv) := GetGLProcAddress('glVertexAttrib4sv');
    pointer(glVertexAttrib4ubv) := GetGLProcAddress('glVertexAttrib4ubv');
    pointer(glVertexAttrib4uiv) := GetGLProcAddress('glVertexAttrib4uiv');
    pointer(glVertexAttrib4usv) := GetGLProcAddress('glVertexAttrib4usv');
    pointer(glVertexAttribPointer) := GetGLProcAddress('glVertexAttribPointer');



      Result := Load_GL_version_1_5;


end;

function LoadExtension(ext: String): Boolean;
begin

  if Mother^.Debug.Verbose then AddLog('Loading OpenGL extension ' + ext);

  Result := FALSE;
  try
    if ext = 'GL_version_1_2' then Result := Load_GL_version_1_2
    else if ext = 'GL_ARB_imaging' then Result := Load_GL_ARB_imaging
    else if ext = 'GL_version_1_3' then Result := Load_GL_version_1_3
    else if ext = 'GL_ARB_multitexture' then Result := Load_GL_ARB_multitexture
    else if ext = 'GL_ARB_transpose_matrix' then Result := Load_GL_ARB_transpose_matrix
    else if ext = 'GL_ARB_multisample' then Result := Load_GL_ARB_multisample
    else if ext = 'GL_ARB_texture_env_add' then Result := Load_GL_ARB_texture_env_add
  {$IFDEF Windows}
    else if ext = 'WGL_ARB_extensions_string' then Result := Load_WGL_ARB_extensions_string
    else if ext = 'WGL_ARB_buffer_region' then Result := Load_WGL_ARB_buffer_region
  {$ENDIF}
    else if ext = 'GL_ARB_texture_cube_map' then Result := Load_GL_ARB_texture_cube_map
    else if ext = 'GL_ARB_depth_texture' then Result := Load_GL_ARB_depth_texture
    else if ext = 'GL_ARB_point_parameters' then Result := Load_GL_ARB_point_parameters
    else if ext = 'GL_ARB_shadow' then Result := Load_GL_ARB_shadow
    else if ext = 'GL_ARB_shadow_ambient' then Result := Load_GL_ARB_shadow_ambient
    else if ext = 'GL_ARB_texture_border_clamp' then Result := Load_GL_ARB_texture_border_clamp
    else if ext = 'GL_ARB_texture_compression' then Result := Load_GL_ARB_texture_compression
    else if ext = 'GL_ARB_texture_env_combine' then Result := Load_GL_ARB_texture_env_combine
    else if ext = 'GL_ARB_texture_env_crossbar' then Result := Load_GL_ARB_texture_env_crossbar
    else if ext = 'GL_ARB_texture_env_dot3' then Result := Load_GL_ARB_texture_env_dot3
    else if ext = 'GL_ARB_texture_mirrored_repeat' then Result := Load_GL_ARB_texture_mirrored_repeat
    else if ext = 'GL_ARB_vertex_blend' then Result := Load_GL_ARB_vertex_blend
    else if ext = 'GL_ARB_vertex_program' then Result := Load_GL_ARB_vertex_program
    else if ext = 'GL_ARB_window_pos' then Result := Load_GL_ARB_window_pos
    else if ext = 'GL_EXT_422_pixels' then Result := Load_GL_EXT_422_pixels
    else if ext = 'GL_EXT_abgr' then Result := Load_GL_EXT_abgr
    else if ext = 'GL_EXT_bgra' then Result := Load_GL_EXT_bgra
    else if ext = 'GL_EXT_blend_color' then Result := Load_GL_EXT_blend_color
    else if ext = 'GL_EXT_blend_func_separate' then Result := Load_GL_EXT_blend_func_separate
    else if ext = 'GL_EXT_blend_logic_op' then Result := Load_GL_EXT_blend_logic_op
    else if ext = 'GL_EXT_blend_minmax' then Result := Load_GL_EXT_blend_minmax
    else if ext = 'GL_EXT_blend_subtract' then Result := Load_GL_EXT_blend_subtract
    else if ext = 'GL_EXT_clip_volume_hint' then Result := Load_GL_EXT_clip_volume_hint
    else if ext = 'GL_EXT_color_subtable' then Result := Load_GL_EXT_color_subtable
    else if ext = 'GL_EXT_compiled_vertex_array' then Result := Load_GL_EXT_compiled_vertex_array
    else if ext = 'GL_EXT_convolution' then Result := Load_GL_EXT_convolution
    else if ext = 'GL_EXT_fog_coord' then Result := Load_GL_EXT_fog_coord
    else if ext = 'GL_EXT_histogram' then Result := Load_GL_EXT_histogram
    else if ext = 'GL_EXT_multi_draw_arrays' then Result := Load_GL_EXT_multi_draw_arrays
    else if ext = 'GL_EXT_packed_pixels' then Result := Load_GL_EXT_packed_pixels
    else if ext = 'GL_EXT_paletted_texture' then Result := Load_GL_EXT_paletted_texture
    else if ext = 'GL_EXT_point_parameters' then Result := Load_GL_EXT_point_parameters
    else if ext = 'GL_EXT_polygon_offset' then Result := Load_GL_EXT_polygon_offset
    else if ext = 'GL_EXT_secondary_color' then Result := Load_GL_EXT_secondary_color
    else if ext = 'GL_EXT_separate_specular_color' then Result := Load_GL_EXT_separate_specular_color
    else if ext = 'GL_EXT_shadow_funcs' then Result := Load_GL_EXT_shadow_funcs
    else if ext = 'GL_EXT_shared_texture_palette' then Result := Load_GL_EXT_shared_texture_palette
    else if ext = 'GL_EXT_stencil_two_side' then Result := Load_GL_EXT_stencil_two_side
    else if ext = 'GL_EXT_stencil_wrap' then Result := Load_GL_EXT_stencil_wrap
    else if ext = 'GL_EXT_subtexture' then Result := Load_GL_EXT_subtexture
    else if ext = 'GL_EXT_texture3D' then Result := Load_GL_EXT_texture3D
    else if ext = 'GL_EXT_texture_compression_s3tc' then Result := Load_GL_EXT_texture_compression_s3tc
    else if ext = 'GL_EXT_texture_env_add' then Result := Load_GL_EXT_texture_env_add
    else if ext = 'GL_EXT_texture_env_combine' then Result := Load_GL_EXT_texture_env_combine
    else if ext = 'GL_EXT_texture_env_dot3' then Result := Load_GL_EXT_texture_env_dot3
    else if ext = 'GL_EXT_texture_filter_anisotropic' then Result := Load_GL_EXT_texture_filter_anisotropic
    else if ext = 'GL_EXT_texture_lod_bias' then Result := Load_GL_EXT_texture_lod_bias
    else if ext = 'GL_EXT_texture_object' then Result := Load_GL_EXT_texture_object
    else if ext = 'GL_EXT_vertex_array' then Result := Load_GL_EXT_vertex_array
    else if ext = 'GL_EXT_vertex_shader' then Result := Load_GL_EXT_vertex_shader
    else if ext = 'GL_EXT_vertex_weighting' then Result := Load_GL_EXT_vertex_weighting
    else if ext = 'GL_HP_occlusion_test' then Result := Load_GL_HP_occlusion_test
    else if ext = 'GL_NV_blend_square' then Result := Load_GL_NV_blend_square
    else if ext = 'GL_NV_copy_depth_to_color' then Result := Load_GL_NV_copy_depth_to_color
    else if ext = 'GL_NV_depth_clamp' then Result := Load_GL_NV_depth_clamp
    else if ext = 'GL_NV_evaluators' then Result := Load_GL_NV_evaluators
    else if ext = 'GL_NV_fence' then Result := Load_GL_NV_fence
    else if ext = 'GL_NV_fog_distance' then Result := Load_GL_NV_fog_distance
    else if ext = 'GL_NV_light_max_exponent' then Result := Load_GL_NV_light_max_exponent
    else if ext = 'GL_NV_multisample_filter_hint' then Result := Load_GL_NV_multisample_filter_hint
    else if ext = 'GL_NV_occlusion_query' then Result := Load_GL_NV_occlusion_query
    else if ext = 'GL_NV_packed_depth_stencil' then Result := Load_GL_NV_packed_depth_stencil
    else if ext = 'GL_NV_point_sprite' then Result := Load_GL_NV_point_sprite
    else if ext = 'GL_NV_register_combiners' then Result := Load_GL_NV_register_combiners
    else if ext = 'GL_NV_register_combiners2' then Result := Load_GL_NV_register_combiners2
    else if ext = 'GL_NV_texgen_emboss' then Result := Load_GL_NV_texgen_emboss
    else if ext = 'GL_NV_texgen_reflection' then Result := Load_GL_NV_texgen_reflection
    else if ext = 'GL_NV_texture_compression_vtc' then Result := Load_GL_NV_texture_compression_vtc
    else if ext = 'GL_NV_texture_env_combine4' then Result := Load_GL_NV_texture_env_combine4
    else if ext = 'GL_NV_texture_rectangle' then Result := Load_GL_NV_texture_rectangle
    else if ext = 'GL_NV_texture_shader' then Result := Load_GL_NV_texture_shader
    else if ext = 'GL_NV_texture_shader2' then Result := Load_GL_NV_texture_shader2
    else if ext = 'GL_NV_texture_shader3' then Result := Load_GL_NV_texture_shader3
    else if ext = 'GL_NV_vertex_array_range' then Result := Load_GL_NV_vertex_array_range
    else if ext = 'GL_NV_vertex_array_range2' then Result := Load_GL_NV_vertex_array_range2
    else if ext = 'GL_NV_vertex_program' then Result := Load_GL_NV_vertex_program
    else if ext = 'GL_NV_vertex_program1_1' then Result := Load_GL_NV_vertex_program1_1
    else if ext = 'GL_ATI_element_array' then Result := Load_GL_ATI_element_array
    else if ext = 'GL_ATI_envmap_bumpmap' then Result := Load_GL_ATI_envmap_bumpmap
    else if ext = 'GL_ATI_fragment_shader' then Result := Load_GL_ATI_fragment_shader
    else if ext = 'GL_ATI_pn_triangles' then Result := Load_GL_ATI_pn_triangles
    else if ext = 'GL_ATI_texture_mirror_once' then Result := Load_GL_ATI_texture_mirror_once
    else if ext = 'GL_ATI_vertex_array_object' then Result := Load_GL_ATI_vertex_array_object
    else if ext = 'GL_ATI_vertex_streams' then Result := Load_GL_ATI_vertex_streams
  {$IFDEF Windows}
    else if ext = 'WGL_I3D_image_buffer' then Result := Load_WGL_I3D_image_buffer
    else if ext = 'WGL_I3D_swap_frame_lock' then Result := Load_WGL_I3D_swap_frame_lock
    else if ext = 'WGL_I3D_swap_frame_usage' then Result := Load_WGL_I3D_swap_frame_usage
  {$ENDIF}
    else if ext = 'GL_3DFX_texture_compression_FXT1' then Result := Load_GL_3DFX_texture_compression_FXT1
    else if ext = 'GL_IBM_cull_vertex' then Result := Load_GL_IBM_cull_vertex
    else if ext = 'GL_IBM_multimode_draw_arrays' then Result := Load_GL_IBM_multimode_draw_arrays
    else if ext = 'GL_IBM_raster_pos_clip' then Result := Load_GL_IBM_raster_pos_clip
    else if ext = 'GL_IBM_texture_mirrored_repeat' then Result := Load_GL_IBM_texture_mirrored_repeat
    else if ext = 'GL_IBM_vertex_array_lists' then Result := Load_GL_IBM_vertex_array_lists
    else if ext = 'GL_MESA_resize_buffers' then Result := Load_GL_MESA_resize_buffers
    else if ext = 'GL_MESA_window_pos' then Result := Load_GL_MESA_window_pos
    else if ext = 'GL_OML_interlace' then Result := Load_GL_OML_interlace
    else if ext = 'GL_OML_resample' then Result := Load_GL_OML_resample
    else if ext = 'GL_OML_subsample' then Result := Load_GL_OML_subsample
    else if ext = 'GL_SGIS_generate_mipmap' then Result := Load_GL_SGIS_generate_mipmap
    else if ext = 'GL_SGIS_multisample' then Result := Load_GL_SGIS_multisample
    else if ext = 'GL_SGIS_pixel_texture' then Result := Load_GL_SGIS_pixel_texture
    else if ext = 'GL_SGIS_texture_border_clamp' then Result := Load_GL_SGIS_texture_border_clamp
    else if ext = 'GL_SGIS_texture_color_mask' then Result := Load_GL_SGIS_texture_color_mask
    else if ext = 'GL_SGIS_texture_edge_clamp' then Result := Load_GL_SGIS_texture_edge_clamp
    else if ext = 'GL_SGIS_texture_lod' then Result := Load_GL_SGIS_texture_lod
    else if ext = 'GL_SGIS_depth_texture' then Result := Load_GL_SGIS_depth_texture
    else if ext = 'GL_SGIX_fog_offset' then Result := Load_GL_SGIX_fog_offset
    else if ext = 'GL_SGIX_interlace' then Result := Load_GL_SGIX_interlace
    else if ext = 'GL_SGIX_shadow_ambient' then Result := Load_GL_SGIX_shadow_ambient
    else if ext = 'GL_SGI_color_matrix' then Result := Load_GL_SGI_color_matrix
    else if ext = 'GL_SGI_color_table' then Result := Load_GL_SGI_color_table
    else if ext = 'GL_SGI_texture_color_table' then Result := Load_GL_SGI_texture_color_table
    else if ext = 'GL_SUN_vertex' then Result := Load_GL_SUN_vertex
    else if ext = 'GL_ARB_fragment_program' then Result := Load_GL_ARB_fragment_program
    else if ext = 'GL_ATI_text_fragment_shader' then Result := Load_GL_ATI_text_fragment_shader
    else if ext = 'GL_APPLE_client_storage' then Result := Load_GL_APPLE_client_storage
    else if ext = 'GL_APPLE_element_array' then Result := Load_GL_APPLE_element_array
    else if ext = 'GL_APPLE_fence' then Result := Load_GL_APPLE_fence
    else if ext = 'GL_APPLE_vertex_array_object' then Result := Load_GL_APPLE_vertex_array_object
    else if ext = 'GL_APPLE_vertex_array_range' then Result := Load_GL_APPLE_vertex_array_range
  {$IFDEF Windows}
    else if ext = 'WGL_ARB_pixel_format' then Result := Load_WGL_ARB_pixel_format
    else if ext = 'WGL_ARB_make_current_read' then Result := Load_WGL_ARB_make_current_read
    else if ext = 'WGL_ARB_pbuffer' then Result := Load_WGL_ARB_pbuffer
    else if ext = 'WGL_EXT_swap_control' then Result := Load_WGL_EXT_swap_control
    else if ext = 'WGL_ARB_render_texture' then Result := Load_WGL_ARB_render_texture
    else if ext = 'WGL_EXT_extensions_string' then Result := Load_WGL_EXT_extensions_string
    else if ext = 'WGL_EXT_make_current_read' then Result := Load_WGL_EXT_make_current_read
    else if ext = 'WGL_EXT_pbuffer' then Result := Load_WGL_EXT_pbuffer
    else if ext = 'WGL_EXT_pixel_format' then Result := Load_WGL_EXT_pixel_format
    else if ext = 'WGL_I3D_digital_video_control' then Result := Load_WGL_I3D_digital_video_control
    else if ext = 'WGL_I3D_gamma' then Result := Load_WGL_I3D_gamma
    else if ext = 'WGL_I3D_genlock' then Result := Load_WGL_I3D_genlock
  {$ENDIF}
    else if ext = 'GL_ARB_matrix_palette' then Result := Load_GL_ARB_matrix_palette
    else if ext = 'GL_NV_element_array' then Result := Load_GL_NV_element_array
    else if ext = 'GL_NV_float_buffer' then Result := Load_GL_NV_float_buffer
    else if ext = 'GL_NV_fragment_program' then Result := Load_GL_NV_fragment_program
    else if ext = 'GL_NV_primitive_restart' then Result := Load_GL_NV_primitive_restart
    else if ext = 'GL_NV_vertex_program2' then Result := Load_GL_NV_vertex_program2
    {$IFDEF Windows}
    else if ext = 'WGL_NV_render_texture_rectangle' then Result := Load_WGL_NV_render_texture_rectangle
    {$ENDIF}
    else if ext = 'GL_NV_pixel_data_range' then Result := Load_GL_NV_pixel_data_range
    else if ext = 'GL_EXT_texture_rectangle' then Result := Load_GL_EXT_texture_rectangle
    else if ext = 'GL_S3_s3tc' then Result := Load_GL_S3_s3tc
    else if ext = 'GL_ATI_draw_buffers' then Result := Load_GL_ATI_draw_buffers
    {$IFDEF Windows}
    else if ext = 'WGL_ATI_pixel_format_float' then Result := Load_WGL_ATI_pixel_format_float
    {$ENDIF}
    else if ext = 'GL_ATI_texture_env_combine3' then Result := Load_GL_ATI_texture_env_combine3
    else if ext = 'GL_ATI_texture_float' then Result := Load_GL_ATI_texture_float
    else if ext = 'GL_NV_texture_expand_normal' then Result := Load_GL_NV_texture_expand_normal
    else if ext = 'GL_NV_half_float' then Result := Load_GL_NV_half_float
    else if ext = 'GL_ATI_map_object_buffer' then Result := Load_GL_ATI_map_object_buffer
    else if ext = 'GL_ATI_separate_stencil' then Result := Load_GL_ATI_separate_stencil
    else if ext = 'GL_ATI_vertex_attrib_array_object' then Result := Load_GL_ATI_vertex_attrib_array_object
    else if ext = 'GL_ARB_vertex_buffer_object' then Result := Load_GL_ARB_vertex_buffer_object
    else if ext = 'GL_ARB_occlusion_query' then Result := Load_GL_ARB_occlusion_query
    else if ext = 'GL_ARB_shader_objects' then Result := Load_GL_ARB_shader_objects
    else if ext = 'GL_ARB_vertex_shader' then Result := Load_GL_ARB_vertex_shader
    else if ext = 'GL_ARB_fragment_shader' then Result := Load_GL_ARB_fragment_shader
    else if ext = 'GL_ARB_shading_language_100' then Result := Load_GL_ARB_shading_language_100
    else if ext = 'GL_ARB_texture_non_power_of_two' then Result := Load_GL_ARB_texture_non_power_of_two
    else if ext = 'GL_ARB_point_sprite' then Result := Load_GL_ARB_point_sprite
    else if ext = 'GL_EXT_depth_bounds_test' then Result := Load_GL_EXT_depth_bounds_test
    else if ext = 'GL_EXT_texture_mirror_clamp' then Result := Load_GL_EXT_texture_mirror_clamp
    else if ext = 'GL_EXT_blend_equation_separate' then Result := Load_GL_EXT_blend_equation_separate
    else if ext = 'GL_MESA_pack_invert' then Result := Load_GL_MESA_pack_invert
    else if ext = 'GL_MESA_ycbcr_texture' then Result := Load_GL_MESA_ycbcr_texture
    else if ext = 'GL_ARB_fragment_program_shadow' then Result := Load_GL_ARB_fragment_program_shadow
    else if ext = 'GL_NV_fragment_program_option' then Result := Load_GL_NV_fragment_program_option
    else if ext = 'GL_EXT_pixel_buffer_object' then Result := Load_GL_EXT_pixel_buffer_object
    else if ext = 'GL_NV_fragment_program2' then Result := Load_GL_NV_fragment_program2
    else if ext = 'GL_NV_vertex_program2_option' then Result := Load_GL_NV_vertex_program2_option
    else if ext = 'GL_NV_vertex_program3' then Result := Load_GL_NV_vertex_program3
    else if ext = 'GL_ARB_draw_buffers' then Result := Load_GL_ARB_draw_buffers
    else if ext = 'GL_ARB_texture_rectangle' then Result := Load_GL_ARB_texture_rectangle
    else if ext = 'GL_ARB_color_buffer_float' then Result := Load_GL_ARB_color_buffer_float
    else if ext = 'GL_ARB_half_float_pixel' then Result := Load_GL_ARB_half_float_pixel
    else if ext = 'GL_ARB_texture_float' then Result := Load_GL_ARB_texture_float
    else if ext = 'GL_EXT_texture_compression_dxt1' then Result := Load_GL_EXT_texture_compression_dxt1
    else if ext = 'GL_ARB_pixel_buffer_object' then Result := Load_GL_ARB_pixel_buffer_object
    else if ext = 'GL_EXT_framebuffer_object' then Result := Load_GL_EXT_framebuffer_object
    else if ext = 'GL_version_1_4' then Result := Load_GL_version_1_4
    else if ext = 'GL_version_1_5' then Result := Load_GL_version_1_5
    else if ext = 'GL_version_2_0' then Result := Load_GL_version_2_0
    else if ext = 'GL_version_2_1' then Result := Load_GL_VERSION_2_1
    else if ext = 'GL_ARB_framebuffer_object' then Result := Load_GL_ARB_framebuffer_object
    else if ext = 'GL_ARB_shader_objects' then Result := Load_GL_ARB_shader_objects
    else Die(RuEn('Неизвестное расширение OpenGL, "%0"','Unknown OpenGL extension "%0"'),[ext]);
  except
    Die (RuEn(
      'Не удалось загрузить расширение OpenGL "%0"',
      'Failed to load OpenGL extension "%0"'
      ), [ext]);
  end;
end;

function Load_GL_VERSION_2_1(): Boolean;
begin
  Result := False;
  pointer(glUniformMatrix2x3fv) := GetGLProcAddress('glUniformMatrix2x3fv');
  pointer(glUniformMatrix3x2fv) := GetGLProcAddress('glUniformMatrix3x2fv');
  pointer(glUniformMatrix2x4fv) := GetGLProcAddress('glUniformMatrix2x4fv');
  pointer(glUniformMatrix4x2fv) := GetGLProcAddress('glUniformMatrix4x2fv');
  pointer(glUniformMatrix3x4fv) := GetGLProcAddress('glUniformMatrix3x4fv');
  pointer(glUniformMatrix4x3fv) := GetGLProcAddress('glUniformMatrix4x3fv');
  Result := Load_GL_VERSION_2_0();
end;

function Load_GL_VERSION_3_0(): Boolean;
begin
  Result := False;
  pointer(glColorMaski) := GetGLProcAddress('glColorMaski');
  pointer(glGetBooleani_v) := GetGLProcAddress('glGetBooleani_v');
  pointer(glGetIntegeri_v) := GetGLProcAddress('glGetIntegeri_v');
  pointer(glEnablei) := GetGLProcAddress('glEnablei');
  pointer(glDisablei) := GetGLProcAddress('glDisablei');
  pointer(glIsEnabledi) := GetGLProcAddress('glIsEnabledi');
  pointer(glBeginTransformFeedback) := GetGLProcAddress('glBeginTransformFeedback');
  pointer(glEndTransformFeedback) := GetGLProcAddress('glEndTransformFeedback');
  pointer(glBindBufferRange) := GetGLProcAddress('glBindBufferRange');
  pointer(glBindBufferBase) := GetGLProcAddress('glBindBufferBase');
  pointer(glTransformFeedbackVaryings) := GetGLProcAddress('glTransformFeedbackVaryings');
  pointer(glGetTransformFeedbackVarying) := GetGLProcAddress('glGetTransformFeedbackVarying');
  pointer(glClampColor) := GetGLProcAddress('glClampColor');
  pointer(glBeginConditionalRender) := GetGLProcAddress('glBeginConditionalRender');
  pointer(glEndConditionalRender) := GetGLProcAddress('glEndConditionalRender');
  pointer(glVertexAttribIPointer) := GetGLProcAddress('glVertexAttribIPointer');
  pointer(glGetVertexAttribIiv) := GetGLProcAddress('glGetVertexAttribIiv');
  pointer(glGetVertexAttribIuiv) := GetGLProcAddress('glGetVertexAttribIuiv');
  pointer(glVertexAttribI1i) := GetGLProcAddress('glVertexAttribI1i');
  pointer(glVertexAttribI2i) := GetGLProcAddress('glVertexAttribI2i');
  pointer(glVertexAttribI3i) := GetGLProcAddress('glVertexAttribI3i');
  pointer(glVertexAttribI4i) := GetGLProcAddress('glVertexAttribI4i');
  pointer(glVertexAttribI1ui) := GetGLProcAddress('glVertexAttribI1ui');
  pointer(glVertexAttribI2ui) := GetGLProcAddress('glVertexAttribI2ui');
  pointer(glVertexAttribI3ui) := GetGLProcAddress('glVertexAttribI3ui');
  pointer(glVertexAttribI4ui) := GetGLProcAddress('glVertexAttribI4ui');
  pointer(glVertexAttribI1iv) := GetGLProcAddress('glVertexAttribI1iv');
  pointer(glVertexAttribI2iv) := GetGLProcAddress('glVertexAttribI2iv');
  pointer(glVertexAttribI3iv) := GetGLProcAddress('glVertexAttribI3iv');
  pointer(glVertexAttribI4iv) := GetGLProcAddress('glVertexAttribI4iv');
  pointer(glVertexAttribI1uiv) := GetGLProcAddress('glVertexAttribI1uiv');
  pointer(glVertexAttribI2uiv) := GetGLProcAddress('glVertexAttribI2uiv');
  pointer(glVertexAttribI3uiv) := GetGLProcAddress('glVertexAttribI3uiv');
  pointer(glVertexAttribI4uiv) := GetGLProcAddress('glVertexAttribI4uiv');
  pointer(glVertexAttribI4bv) := GetGLProcAddress('glVertexAttribI4bv');
  pointer(glVertexAttribI4sv) := GetGLProcAddress('glVertexAttribI4sv');
  pointer(glVertexAttribI4ubv) := GetGLProcAddress('glVertexAttribI4ubv');
  pointer(glVertexAttribI4usv) := GetGLProcAddress('glVertexAttribI4usv');
  pointer(glGetUniformuiv) := GetGLProcAddress('glGetUniformuiv');
  pointer(glBindFragDataLocation) := GetGLProcAddress('glBindFragDataLocation');
  pointer(glGetFragDataLocation) := GetGLProcAddress('glGetFragDataLocation');
  pointer(glUniform1ui) := GetGLProcAddress('glUniform1ui');
  pointer(glUniform2ui) := GetGLProcAddress('glUniform2ui');
  pointer(glUniform3ui) := GetGLProcAddress('glUniform3ui');
  pointer(glUniform4ui) := GetGLProcAddress('glUniform4ui');
  pointer(glUniform1uiv) := GetGLProcAddress('glUniform1uiv');
  pointer(glUniform2uiv) := GetGLProcAddress('glUniform2uiv');
  pointer(glUniform3uiv) := GetGLProcAddress('glUniform3uiv');
  pointer(glUniform4uiv) := GetGLProcAddress('glUniform4uiv');
  pointer(glTexParameterIiv) := GetGLProcAddress('glTexParameterIiv');
  pointer(glTexParameterIuiv) := GetGLProcAddress('glTexParameterIuiv');
  pointer(glGetTexParameterIiv) := GetGLProcAddress('glGetTexParameterIiv');
  pointer(glGetTexParameterIuiv) := GetGLProcAddress('glGetTexParameterIuiv');
  pointer(glClearBufferiv) := GetGLProcAddress('glClearBufferiv');
  pointer(glClearBufferuiv) := GetGLProcAddress('glClearBufferuiv');
  pointer(glClearBufferfv) := GetGLProcAddress('glClearBufferfv');
  pointer(glClearBufferfi) := GetGLProcAddress('glClearBufferfi');
  pointer(glGetStringi) := GetGLProcAddress('glGetStringi');
  if not Load_GL_ARB_framebuffer_object(true) then Exit;
  if not Load_GL_ARB_map_buffer_range(true) then Exit;
  if not Load_GL_ARB_vertex_array_object(true) then Exit;
  Result := Load_GL_VERSION_2_1();
end;

function Load_GL_VERSION_3_1(): Boolean;
begin
  Result := False;
  pointer(glDrawArraysInstanced) := GetGLProcAddress('glDrawArraysInstanced');
  pointer(glDrawElementsInstanced) := GetGLProcAddress('glDrawElementsInstanced');
  pointer(glTexBuffer) := GetGLProcAddress('glTexBuffer');
  pointer(glPrimitiveRestartIndex) := GetGLProcAddress('glPrimitiveRestartIndex');
  if not Load_GL_ARB_copy_buffer(true) then Exit;
  if not Load_GL_ARB_uniform_buffer_object(true) then Exit;
  Result := Load_GL_VERSION_3_0();
end;

function Load_GL_VERSION_3_2(): Boolean;
begin
  Result := False;
  pointer(glGetInteger64i_v) := GetGLProcAddress('glGetInteger64i_v');
  pointer(glGetBufferParameteri64v) := GetGLProcAddress('glGetBufferParameteri64v');
  pointer(glProgramParameteri) := GetGLProcAddress('glProgramParameteri');
  pointer(glFramebufferTexture) := GetGLProcAddress('glFramebufferTexture');
  if not Load_GL_ARB_draw_elements_base_vertex(true) then Exit;
  if not Load_GL_ARB_provoking_vertex(true) then Exit;
  if not Load_GL_ARB_sync(true) then Exit;
  if not Load_GL_ARB_texture_multisample(true) then Exit;
  Result := Load_GL_VERSION_3_1();
end;

function Load_GL_VERSION_3_3(): Boolean;
begin
  Result := False;
  if not Load_GL_ARB_blend_func_extended(true) then Exit;
  if not Load_GL_ARB_sampler_objects(true) then Exit;
  if not Load_GL_ARB_timer_query(true) then Exit;
  if not Load_GL_ARB_vertex_type_2_10_10_10_rev(true) then Exit;
  Result := Load_GL_VERSION_3_2();
end;

function Load_GL_VERSION_4_0(): Boolean;
begin
  Result := False;
  if not Load_GL_ARB_gpu_shader_fp64(true) then Exit;
  if not Load_GL_ARB_shader_subroutine(true) then Exit;
  if not Load_GL_ARB_tessellation_shader(true) then Exit;
  if not Load_GL_ARB_transform_feedback2(true) then Exit;
  if not Load_GL_ARB_transform_feedback3(true) then Exit;
  Result := Load_GL_VERSION_3_3();
end;
